#include <iostream>
#include <array>

struct Node {
	int left;
	int right;

	int rotations; // from root
	int accessable; // leafs from this
};

int n, q, k;
std::array<Node, 200'100> nodes;

void input_data() noexcept {
	std::cin >> n >> k >> q;
	for (int i = 0; i < n; ++i) {
		int t;
		std::cin >> t;

		if (t == 0)
			nodes[i].left = nodes[i].right = -1;
		else {
			std::cin >> nodes[i].left >> nodes[i].right;
			--nodes[i].left;
			--nodes[i].right;
		}
	}
}

void precompute_rotations(int i = 0, int prev_side = 0, int rotations = 0) noexcept {
	nodes[i].rotations = rotations;
	if (nodes[i].left != -1) {
		precompute_rotations(nodes[i].left, -1, rotations + (prev_side == 1 ? 1 : 0));
		precompute_rotations(nodes[i].right, 1, rotations + (prev_side == -1 ? 1 : 0));
	}
}

int precompute_accessable(int i = 0) noexcept {
	if (nodes[i].left == -1)
		if (nodes[i].rotations <= k)
			return nodes[i].accessable = 1;
		else
			return nodes[i].accessable = 0;

	return nodes[i].accessable = precompute_accessable(nodes[i].left) + precompute_accessable(nodes[i].right);
}

int solve(int u) noexcept {
	return nodes[u].accessable;
}

void process_queries() noexcept {
	for (int j = 0; j < q; ++j) {
		int u;
		std::cin >> u;
		--u;

		std::cout << solve(u) << '\n';
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	input_data();

	precompute_rotations();
	precompute_accessable();

	process_queries();
}
