#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <cmath>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }

const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

bool dfsk(ll v, vector<vector<ll>>& g, vector<ll>& used, ll now, vector<ll>& par) {
	used[v] = now;
	for (ll u : g[v]) {
		if (par[u] == -1) {
			par[u] = v;
			return 1;
		}
	}
	for (ll u : g[v]) {
		if (used[par[u]] < now) {
			if (dfsk(par[u], g, used, now, par)) {
				par[u] = v;
				return 1;
			}
		}
	}
}

vector<ll> khun(vector<vector<ll>>& g) {
	ll n = g.size();
	vector<ll> used(n, -1), par(n, -1);
	for (ll v = 0; v < n; v++) {
		dfsk(v, g, used, v, par);
	}
	return par;
}

int main() {
	fastio();
	vector<vector<ll>> g(8), rg(8);
	for (ll n = 2; n < 8; n++) {
		g[n].resize((1LL << n));
		rg[n].resize((1LL << n), -1);
		vector<vector<ll>> gr((1LL << n));
		for (ll mask = 0; mask < (1LL << n); mask++){
			ll cnt = 0;
			for (ll i = 0; i < n; i++) cnt += ((mask >> i) & 1);
			g[n][mask] = cnt;
		}
		for (ll mask = 0; mask < (1LL << n); mask++) {
			for (ll mask1 = 0; mask1 < (1LL << n); mask1++) {
				if (g[n][mask] == g[n][mask1] && (mask & mask1) == 0) {
					gr[mask].push_back(mask1);
				}
			}
		}
		g[n] = khun(gr);
		for (ll i = 0; i < (1LL << n); i++) {
			if (g[n][i] >= 0) {
				rg[n][g[n][i]] = i;
			}
		}
	}
	ll z;
	cin >> z;
	ll t;
	cin >> t;
	while (t--) {
		ll n, k;
		cin >> n >> k;
		vector<ll> a(k);
		for (ll i = 0; i < k; i++) {
			cin >> a[i];
			a[i]--;
		}
		//sort(all(a));
		if (z == 1) {
			vector<ll> ans;
			ll mask = 0;
			for (ll i = 0; i < k; i++) mask |= (1LL << a[i]);
			ll res = g[n][mask];
			for (ll i = 0; i < n; i++) {
				if ((res >> i) & 1) ans.push_back(i);
			}
			sort(all(ans));
			for (ll x : ans) cout << x + 1 << " ";
			cout << endl;
		}
		else {
			vector<ll> ans;
			ll mask = 0;
			for (ll i = 0; i < k; i++) mask |= (1LL << a[i]);
			ll res = rg[n][mask];
			for (ll i = 0; i < n; i++) {
				if ((res >> i) & 1) ans.push_back(i);
			}
			sort(all(ans));
			for (ll x : ans) cout << x + 1 << " ";
			cout << endl;
		}
	}
	return 0;
}
