#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <cmath>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }

const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		vector<vector<ll>> dp(n + 2, vector<ll>(n + 2, -INF));
		dp[n + 1][0] = 0;
		for (ll x : a) {
			vector<vector<ll>> ndp(n + 2, vector<ll>(n + 2, -INF));
			for (ll i = 0; i <= n + 1; i++) {
				for (ll j = 0; j <= n + 1; j++) {
					if (i <= x || j >= x) ndp[i][j] = dp[i][j];
				}
			}
			for (ll i = 0; i <= n + 1; i++) {
				ll f = -INF;
				for (ll j = 0; j < x; j++) f = max(f, dp[i][j]);
				ndp[i][x] = max(ndp[i][x], f + 1);
			}
			for (ll j = 0; j <= n + 1; j++) {
				ll f = -INF;
				for (ll i = x + 1; i <= n + 1; i++) {
					f = max(f, dp[i][j]);
				}
				ndp[x][j] = max(ndp[x][j], f + 1);
			}
			dp.swap(ndp);
		}
		ll ans = 0;
		for (ll i = 0; i <= n; i++) {
			for (ll j = 0; j <= n; j++) {
				ans = max(ans, dp[i][j]);
			}
		}
		cout << ans << "\n";
	}
	return 0;
}