#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <cmath>
#include <queue>

using namespace std;
typedef int ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }

const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

struct Node {
	ll x;
	Node* prev;
	Node(ll x, Node* p) : x(x), prev(p) {}
};

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> a(n);
		for (ll i = 0; i < n; i++) {
			cin >> a[i];
		}
		vector<ll> dp(n + 1, INF);
		vector<Node*> p(n + 1, nullptr);
		dp[0] = 0;
		for (ll i = 0; i < n; i++) {
			ll j = upper_bound(all(dp), a[i]) - dp.begin();
			dp[j] = a[i];
			p[j] = new Node(i, p[j - 1]);
		}
		ll ans = 0;
		for (ll i = 0; i <= n; i++) {
			if (dp[i] < INF) ans = i;
		}
		vector<ll> ind;
		Node* v = p[ans];
		while (v != nullptr) {
			ind.push_back(v->x);
			v = v->prev;
		}
		vector<bool> used(n);
		for (ll i = 0; i < ind.size(); i++) {
			used[ind[i]] = 1;
		}
		bool voz = 1;
		ll prev = 0;
		for (ll i = 0; i < n; i++) {
			if (!used[i]) {
				voz &= (prev < a[i]);
				prev = a[i];
			}
		}
		cout << min(n, ans + 1 + (!voz));
	}
	return 0;
}