#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }
#define all(a) a.begin(), a.end()
const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

struct O {
	ll l, r, i;
	bool operator<(const O& a) const {
		if (r != a.r) return r < a.r;
		return i < a.i;
	}
};

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<O> a(n);
		for (ll i = 0; i < n; i++) {
			a[i].i = i;
			cin >> a[i].l >> a[i].r;
		}
		auto b = a;
		sort(all(a), [](const O& a, const O& b) {
			return a.l < b.l;
			});
		set<O> st;
		for (ll i = 0; i < n; i++) {
			st.insert(a[i]);
		}
		vector<ll> res;
		ll j = 0;
		while (st.size() > 0) {
			ll rr = st.begin()->r;
			res.push_back(st.begin()->i);
			for (; j < n; j++) {
				if (a[j].l <= rr) st.erase(a[j]);
				else break;
			}
		}
		ll m = res.size();
		vector<vector<ll>> pok(m);
		for (ll i = 0; i < n; i++) {
			if (i == 4) {
				ll AWQOUIB = 0;
			}
			ll l = -1, r = m;
			while (l + 1 < r) {
				ll mid = (l + r) / 2;
				if (b[res[mid]].r < b[i].l) l = mid;
				else r = mid;
			}
			ll fl = l;
			l = -1, r = m;
			while (l + 1 < r) {
				ll mid = (l + r) / 2;
				if (b[res[mid]].r <= b[i].r) l = mid;
				else r = mid;
			}
			ll fr = l;
			if (fl + 1 == fr) {
				pok[fr].push_back(i);
			}
		}
		ll sm1 = 0, sm2 = 0;
		for (ll i = 0; i < m; i++) {
			if (i % 2 == 0) sm1 += pok[i].size();
			else sm2 += pok[i].size();
		}
		vector<bool> used(n), nused(n);
		ll ost = 0;
		if (sm1 < sm2) {
			ost = n / 2 - sm1;
			for (ll i = 0; i < m; i++) {
				if (i % 2 == 0) {
					for (ll x : pok[i]) used[x] = 1;
				}
				else {
					nused[res[i]] = 1;
				}
			}
		}
		else {
			ost = n / 2 - sm2;
			for (ll i = 0; i < m; i++) {
				if (i % 2 == 1) {
					for (ll x : pok[i]) used[x] = 1;
				}
				else {
					nused[res[i]] = 1;
				}
			}
		}
		for (ll j = 0; j < n; j++) {
			if (ost > 0 && !used[j] && !nused[j]) {
				used[j] = 1;
				ost--;
			}
		}
		for (ll j = 0; j < n; j++) {
			if (!used[j]) {
				cout << j + 1 << " ";
			}
		}
		cout << "\n";
	}
	return 0;
}