#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <random>
#include <bitset>
using namespace std;
typedef long long ll;
typedef long double ld;
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }
#define all(a) a.begin(), a.end()
const long long INF = 2e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;


ll n, q;
ll x, y, m;
vector<vector<ll>> g;
vector<ll> l, r;

vector<vector<ll>> dp; // 0 - ne vzl, 1 - vozm vzl

void dfsmx(ll v, ll p){
    dp[v][1] = r[v];
    dp[v][0] = 0;
    for (ll u : g[v]){
        if (u != p) {
            dfsmx(u, v);
            dp[v][0] += dp[u][1];
            dp[v][1] += dp[u][0];
        }
    }
    dp[v][1] = max(dp[v][1], dp[v][0]);
}

void dfsmn(ll v, ll p){
    dp[v][1] = l[v];
    dp[v][0] = 0;
    for (ll u : g[v]){
        if (u != p) {
            dfsmn(u, v);
            dp[v][0] += dp[u][1];
            dp[v][1] += dp[u][0];
        }
    }
    dp[v][1] = max(dp[v][1], dp[v][0]);
}

int main() {
	fastio();
    ll t;
    cin >> t;
    while(t--){
        cin >> n >> q;
        cin >> x >> y >> m;
        g.assign(n, {});
        for (ll i = 0;i<n-1;i++){
            ll u, v;
            cin >> u >> v;
            g[u-1].push_back(v-1);
            g[v-1].push_back(u-1);
        }
        l.assign(n, 0);
        r.assign(n, 0);
        for (ll i = 0;i<n;i++) cin >> l[i] >> r[i];
        dp.assign(n, {0, 0});
        dfsmn(0, -1);
        ll sml = dp[0][1];
        dp.assign(n, {0, 0});
        dfsmx(0, -1);
        ll smr = dp[0][1];
        vector<ll> v(q);
        ll k = 0;
        for (ll i = 0;i<n;i++){
            k^=(x * (i+1) + y * l[i] % m * l[i])%m;
        }
        for (ll i = 0;i<q;i++){
            cin >> v[i];
            if (sml <= v[i] && v[i] <= smr){
                cout << k << " ";
            }else{
                cout << "-1 ";
            }
        }
        cout << endl;
        ll i;
        while(cin >> i && i != 0){
            i--;
            if (sml <= v[i] && v[i] <= smr){
                for (ll x : l) cout << x << " ";
                cout << endl;
            }else{
                cout << "-1" << endl;
            }
        }
    }
	return 0;
}