#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <random>
#include <bitset>
using namespace std;
typedef long long ll;
typedef long double ld;
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }
#define all(a) a.begin(), a.end()
const long long INF = 2e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;


ll n, q;
ll x, y, m;
vector<vector<ll>> g;
vector<ll> l, r;

vector<vector<ll>> dp; // 0 - ne vzl, 1 - vozm vzl
vector<ll> is;

void dfs(ll v, ll p){
    dp[v][1] = r[v];
    dp[v][0] = 0;
    for (ll u : g[v]){
        if (u != p) {
            dfs(u, v);
            dp[v][0] += dp[u][1];
            dp[v][1] += dp[u][0];
        }
    }
    if (dp[v][0] > dp[v][1]){
        is[v] = 0;
    }
    dp[v][1] = max(dp[v][1], dp[v][0]);
}

void vos(ll v, ll p, ll j, vector<ll>& ans){
    if (is[v] && j) ans.push_back(v);
    if (j == 1) j = is[v];
    for (ll u : g[v]){
        if (u != p){
            if (j == 1) vos(u, v, 0, ans);
            else vos(u, v, 1, ans);
        }
    }
}

int main() {
	fastio();
    ll t;
    cin >> t;
    while(t--){
        cin >> n >> q;
        cin >> x >> y >> m;
        g.assign(n, {});
        for (ll i = 0;i<n-1;i++){
            ll u, v;
            cin >> u >> v;
            g[u-1].push_back(v-1);
            g[v-1].push_back(u-1);
        }
        l.assign(n, 0);
        r.assign(n, 0);
        for (ll i = 0;i<n;i++) cin >> l[i] >> r[i];
        dp.assign(n, {0, 0});
        is.assign(n, 1);
        dfs(0, -1);
        vector<ll> res;
        vos(0, -1, 1, res);
        ll w = res.size();
        vector<ll> v(q);
        vector<ll> k(w+1, 0), sum(w+1, 0);
        for (ll i = 0;i<n;i++) k[0] ^= (x * (i+1))%m;
        for (ll i = 0;i<w;i++){
            k[i+1] = k[i] ^
                    (x * (res[i] + 1) % m) ^
                    ((x * (res[i] + 1) + y * r[res[i]] % m * r[res[i]]) % m);
            sum[i+1] = sum[i] + r[res[i]];
        }
        for (ll i = 0;i<q;i++){
            cin >> v[i];
            if (v[i] <= sum.back()){
                ll u = lower_bound(all(sum), v[i]) - sum.begin();
                if (u == 0) {
                    cout << k[0] << " ";
                }else{
                    ll dob = v[i] - sum[u-1];
                    ll ans = k[u-1] ^
                            (x * (res[u-1] + 1) % m) ^
                            ((x * (res[u-1] + 1) + y * dob % m * dob) % m);
                    cout << ans << " ";
                }
            }else{
                cout << "-1 ";
            }
        }
        cout << endl;
        ll i;
        while(cin >> i && i != 0){
            i--;
            if (v[i] <= sum.back()) {
                ll u = lower_bound(all(sum), v[i]) - sum.begin();
                vector<ll> ans(n, 0);
                for (ll i = 0; i < u; i++) {
                    ans[res[i]] = r[res[i]];
                }
                if (u > 0) ans[res[u-1]] = v[i] - sum[u-1];
                for (ll x : ans) cout << x << " ";
                cout << endl;
            }else{
                cout << "-1" << endl;
            }
        }
    }
	return 0;
}