#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Event {
    ll x, type, ind;
};

bool cmp(Event a, Event b) {
    if (a.x == b.x) {
        return a.type > b.type;
    }
    return a.x < b.x;
}

bool cmp1(pair<ll, vector<ll>> &a, pair<ll, vector<ll>> &b) {
    return a.second.size() < b.second.size();
}

void solve() {
    ll n;
    cin >> n;
    vector<Event> e;
    vector<ll> l(n), r(n);
    for (ll i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        e.push_back({l[i], 1, i});
        e.push_back({r[i], -1, i});
    }
    sort(e.begin(), e.end(), cmp);
    vector<ll> a;
    ll cur = -1;
    for (auto &i: e) {
        if (i.type == 1) {
            if (cur == -1) {
                cur = i.ind;
            }
        } else {
            if (i.ind == cur) {
                a.push_back(cur);
                cur = -1;
            } else if (cur != -1 && i.x <= r[cur] && l[cur] <= l[i.ind]) {
                cur = i.ind;
                a.push_back(cur);
                cur = -1;
            }
        }
    }
    ll m = (ll) a.size();
    vector<bool> active(n, true);
    vector<pair<ll, vector<ll>>> g(m);
    vector<ll> ar(m);
    for (ll i = 0; i < m; i++) {
        g[i].first = a[i];
        active[a[i]] = false;
        ar[i] = r[a[i]];
    }
    for (ll i = 0; i < n; i++) {
        if (!active[i]) {
            continue;
        }
        ll lb = lower_bound(ar.begin(), ar.end(), l[i]) - ar.begin();
        g[lb].second.push_back(i);
    }
    sort(g.begin(), g.end(), cmp1);
    for (ll i = 0; i < m / 2; i++) {
        for (ll j: g[i].second) {
            active[j] = false;
        }
    }
    ll sum = 0;
    for (ll i = 0; i < n; i++) {
        if (active[i]) {
            sum++;
        }
    }
    for (ll i = 0; i < n; i++) {
        if (active[i] && sum > (n - m) / 2) {
            active[i] = false;
            sum--;
        }
    }
    for (ll i = m / 2; i < m; i++) {
        active[g[i].first] = true;
    }
    vector<ll> ans;
    for (ll i = 0; i < n; i++) {
        if (active[i]) {
            ans.push_back(i);
        }
    }
    for (auto &i: ans) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
