#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(),(x).end()

using pii = pair<int, int>;
const int MAXN = 2e5 + 5;
pii seg[MAXN], gr[MAXN];
int turn[MAXN];
vector<int> a;

void dfs(int v, int mn) {
  //  cout << v + 1 << ' ' << turn[v] << '\n';
    seg[v].first = sz(a);
    if (gr[v] == pii{-1, -1}) {
        a.push_back(turn[v]);
    } else {
        auto [l, r] = gr[v];
        if (mn == 1) {
            turn[l] = turn[v] + 1;
            turn[r] = turn[v];
        } else {
            turn[l] = turn[v];
            turn[r] = turn[v] + 1;
        }
        dfs(l, 0);
        dfs(r, 1);
    }
    seg[v].second = sz(a);
}

const int T = 1 << 20;
vector<int> t[MAXN * 4];

void build(int v, int l, int r) {
    if (r - l == 1) {
        t[v] = {a[l]};
        return;
    }
    int mid = (l + r) >> 1;
    build(v * 2 + 1, l, mid);
    build(v * 2 + 2, mid, r);
    t[v].resize(sz(t[v * 2 + 1]) + sz(t[v * 2 + 2]));
    merge(all(t[v * 2 + 1]), all(t[v * 2 + 2]), t[v].begin());
}

int ask(int v, int l, int r, int ql, int qr, int k) {
    if (ql >= r || l >= qr)return 0;
    if (ql <= l && r <= qr) return upper_bound(all(t[v]), k) - t[v].begin();
    int mid = (l + r) >> 1;
    return ask(v * 2 + 1, l, mid, ql, qr, k) + ask(v * 2 + 2, mid, r, ql, qr, k);
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;

    fill(gr, gr + n, pii{-1, -1});

    for (int i = 0; i < n; i++) {
        int u, v, tp;
        cin >> tp;
        if (tp == 2) {
            cin >> u >> v;
            v--;
            u--;
            gr[i] = {u, v};
        }
    }

    auto [l, r] = gr[0];
    dfs(l, 0);
    dfs(r, 1);
    int N = sz(a);
    build(0, 0, N);
    seg[0] = {0, N};
    for (int _ = 0; _ < q; _++) {
        int u;
        cin >> u;
        u--;
        if (turn[u] > k) {
            cout << "0\n";
        } else {
            auto [L, R] = seg[u];
            cout << ask(0, 0, N, L, R, k) << '\n';
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
    return 0;
}
