#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

using ll = long long;

ll n, k;
vector<ll> a;

void solve1_1() {
	cout << (a[0] < n ? a[0] + 1 : 1) << endl;
}

void solve1_2() {
	cout << (a[0] == 1 ? n : a[0] - 1) << endl;
}

void solve2_1() {
	vector<ll> res;
	if (a[1] - a[0] == 1) {
		res = { (a[0] - 2 <= 0 ? a[0] + n - 2 : a[0] - 2), (a[1] - 2 <= 0 ? a[1] + n - 2 : a[1] - 2) };
	} else if (a[0] == 1 && a[1] == n) {
		res = { n - 2, n - 1 };
	} else {
		res = { (a[0] - 1 <= 0 ? a[0] + n - 1 : a[0] - 1), (a[1] - 1 <= 0 ? a[1] + n - 1 : a[1] - 1) };
	}
	sort(res.begin(), res.end());
	cout << res[0] << " " << res[1] << endl;
}

void solve2_2() {
	vector<ll> res;
	if (a[1] - a[0] == 1) {
		res = { (a[0] + 2 > n ? a[0] - n + 2 : a[0] + 2), (a[1] + 2 > n ? a[1] - n + 2 : a[1] + 2) };
	}
	else if (a[0] == 1 && a[1] == n) {
		res = { 2, 3 };
	}
	else {
		res = { (a[0] + 1 > n ? a[0] - n + 1 : a[0] + 1), (a[1] + 1 > n ? a[1] - n + 1 : a[1] + 1) };
	}
	sort(res.begin(), res.end());
	cout << res[0] << " " << res[1] << endl;
}

void solve3_1() {
	set<ll> st;
	for (auto el : a)
		st.insert(el);
	vector<ll> res;
	for (int i = 1; i <= n; ++i) {
		if (!st.count(i)) {
			res.push_back(i);
		}
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

void solve5_1() {
	vector<ll> res;
	for (auto el : a) {
		res.push_back(el + 1);
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

void solve5_2() {
	vector<ll> res;
	for (auto el : a) {
		res.push_back(el - 1);
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

ll nadd(ll x, ll d, ll n) {
	ll res = x + d;
	if (res <= 0)
		res += n;
	if (res > n)
		res -= n;
	return res;
}

void solve6_1() {
	vector<ll> res;
	for (auto el : a) {
		res.push_back(nadd(el, n / 2, n));
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

void solve6_2() {
	vector<ll> res;
	for (auto el : a) {
		res.push_back(nadd(el, -(n / 2), n));
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

void solve7_1() {
	vector<ll> res = { a.back() + 1 };
	for (int i = a.size() - 2; i >= 0; --i) {
		if (a[i] == a[i + 1] - 1) {
			res.push_back(n - i);
		}
		else {
			res.push_back(a[i] + 1);
		}
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

void solve7_2() {
	vector<ll> t1, t2;
	t1 = a;
	while (t1.back() > n - k) {
		t2.push_back(n - t1.back());
		t1.pop_back();
	}
	sort(t2.begin(), t2.end());
	vector<ll> res;
	int left = k;
	while (left > 0) {
		left--;
		if (t2.back() == left) {
			res.push_back(res.back() - 1);
			t2.pop_back();
		}
		else {
			res.push_back(t1.back() - 1);
			t1.pop_back();
		}
	}
	sort(res.begin(), res.end());
	for (auto el : res)
		cout << el << " ";
	cout << endl;
}

int main() {
	// ios_base::sync_with_stdio(false);
	// cin.tie(nullptr);

	int t;
	cin >> t;
	int m;
	cin >> m;
	while (m--) {
		cin >> n >> k;
		a.resize(k);
		for (int i = 0; i < k; ++i) {
			cin >> a[i];
		}
		if (t == 1) {
			solve7_1();
		}
		else {
			solve7_2();
		}
	}
}
