#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

ll n;
vector<ll> a;

void solve2() {
	// dp[i][j] = answer if last record is a[i], antirecord is a[j] in 1-numeration
	vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, -INF));
	dp[0][0] = 0;
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j) {
			for (int x = max(i, j) + 1; x <= n; ++x) {
				if (i == 0 || a[i - 1] < a[x - 1])
					dp[x][j] = max(dp[x][j], dp[i][j] + 1);
			}
			for (int y = max(i, j) + 1; y <= n; ++y) {
				if (j == 0 || a[j - 1] > a[y - 1])
					dp[i][y] = max(dp[i][y], dp[i][j] + 1);
			}
		}
	}
	ll answer = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			answer = max(answer, dp[i][j]);
		}
	}
	cout << answer << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		solve2();
	}
}
