#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

struct Segment {
	int l, r, ind;
};

int n;
vector<Segment> a;

int get_m(const vector<Segment>& t) {
	vector<ll> dp(t.size(), 0);
	dp[0] = 1;
	for (int i = 1; i < t.size(); ++i) {
		dp[i] = 1;
		for (int j = 0; j < i; ++j) {
			if (t[j].r < t[i].l) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
		}
	}
	return *max_element(dp.begin(), dp.end());
}

void solve2() {
	sort(a.begin(), a.end(), [](const Segment& a, const Segment& b) {if (a.l != b.l) return a.l < b.l; if (a.r != b.r) return a.r < b.r; return a.ind < b.ind; });
	int m = get_m(a);
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<Segment> t;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				t.push_back(a[i]);
			}
		}
		if (t.size() != n / 2)
			continue;
		int cm = get_m(t);
		if (cm == m / 2) {
			for (auto el : t) {
				cout << el.ind + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}
}

void solve1() {
	for (int i = 0; i < n / 2; ++i) {
		cout << i + 1 << " ";
	}
	cout << "\n";
}

void solve4() {
	vector<bool> t(n, true);
	vector<vector<int>> covers(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (a[i].l == a[j].l && a[i].r == a[j].r && i > j) {
				continue;
			}
			if (i != j && a[i].l <= a[j].l && a[j].r <= a[i].r) {
				t[i] = false;
				covers[j].push_back(i);
			}
		}
	}
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		cnt += t[i];
	}
	vector<bool> used(n, false);
	int left = cnt / 2, cleft = n / 2 - (cnt / 2);
	set<int> curcovers;
	while (cleft > 0) {
		bool flag = false;
		for (int i = 0; i < n; ++i) {
			if (!used[i] && curcovers.count(i)) {
				used[i] = true;
				cleft--;
				flag = true;
				break;
			}
		}
		if (flag)
			continue;
		int ri = -1, rd = 0;
		for (int i = 0; i < n; ++i) {
			if (!t[i] || used[i]) {
				continue;
			}
			int ccnt = 0;
			for (auto j : covers[i]) {
				if (!used[j])
					ccnt++;
			}
			if (ccnt > rd) {
				ri = i;
				rd = ccnt;
			}
		}
		used[ri] = true;
		for (auto j : covers[ri]) {
			curcovers.insert(j);
		}
		left--;
	}
	if (left > 0) {
		for (int i = 0; i < n; ++i) {
			if (left <= 0)
				break;
			if (!used[i] && t[i]) {
				used[i] = true;
				left--;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}

vector<vector<int>> g5(n);

struct Ev {
	int t, type, dsort, ind;
	bool operator<(const Ev& other) {
		if (t != other.t) {
			return t < other.t;
		}
		if (type != other.type) {
			return type < other.type;
		}
		if (dsort != other.dsort)
			return dsort > other.dsort;
		return ind < other.ind;
	}
};

vector<bool> vis;
vector<int> maxdepth;
void depthdfs5(int v) {
	vis[v] = true;
	maxdepth[v] = 1;
	for (auto u : g5[v]) {
		depthdfs5(u);
		maxdepth[v] = max(maxdepth[v], maxdepth[u] + 1);
	}
}

vector<bool> leaves;
vector<vector<int>> inpath;
void dfs5(int v, vector<int>& cpath) {
	vis[v] = true;
	if (g5[v].size() == 0) {
		leaves[v] = true;
		inpath[v] = cpath;
		return;
	}
	cpath.push_back(v);
	int ri = -1, rs = 0;
	for (auto u : g5[v]) {
		if (maxdepth[u] > rs) {
			ri = u;
			rs = maxdepth[u];
		}
	}
	dfs5(ri, cpath);
	for (auto u : g5[v]) {
		if (u != ri) {
			vector<int> npath;
			dfs5(u, npath);
		}
	}
}

void solve5() {
	sort(a.begin(), a.end(), [](const Segment& a, const Segment& b) {if (a.l != b.l) return a.l < b.l; if (a.r != b.r) return a.r < b.r; return a.ind < b.ind; });
	vector<Ev> events;
	for (int i = 0; i < a.size(); ++i) {
		auto [l, r, ind] = a[i];
		events.push_back({ l, 1, r, ind });
		events.push_back({ r, -1, l, ind });
	}
	sort(events.begin(), events.end());
	g5.assign(n, vector<int>());
	vector<int> st;
	for (auto [t, type, _, ind] : events) {
		if (type == -1) {
			st.pop_back();
			if (!st.empty()) {
				g5[st.back()].push_back(ind);
			}
		}
		else {
			st.push_back(ind);
		}
	}
	maxdepth.assign(n, 0);
	leaves.assign(n, false);
	inpath.assign(n, vector<int>());

	vis.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!vis[i]) {
			depthdfs5(i);
		}
	}

	vis.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!vis[i]) {
			vector<int> cp;
			dfs5(i, cp);
		}
	}

	vector<int> lleaves;
	for (int i = 0; i < n; ++i) {
		if (leaves[i]) {
			lleaves.push_back(i);
		}
	}

	sort(lleaves.begin(), lleaves.end(), [](int x, int y) {return inpath[x].size() > inpath[y].size(); });
	vector<int> res, free;
	for (int i = 0; i < lleaves.size() / 2; ++i) {
		res.push_back(lleaves[i]);
		for (auto el : inpath[lleaves[i]]) {
			free.push_back(el);
		}
	}
	while (res.size() < n / 2) {
		res.push_back(free.back());
		free.pop_back();
	}
	for (auto el : res) {
		cout << el + 1 << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		cin >> n;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].l >> a[i].r;
			a[i].ind = i;
		}
		solve5();
	}
}
