#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

struct Segment {
	int l, r, ind;
};

int n;
vector<Segment> a;

int get_m(const vector<Segment>& t) {
	vector<ll> dp(t.size(), 0);
	dp[0] = 1;
	for (int i = 1; i < t.size(); ++i) {
		dp[i] = 1;
		for (int j = 0; j < i; ++j) {
			if (t[j].r < t[i].l) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
		}
	}
	return *max_element(dp.begin(), dp.end());
}

void solve2() {
	sort(a.begin(), a.end(), [](const Segment& a, const Segment& b) {if (a.l != b.l) return a.l < b.l; if (a.r != b.r) return a.r < b.r; return a.ind < b.ind; });
	int m = get_m(a);
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<Segment> t;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				t.push_back(a[i]);
			}
		}
		if (t.size() != n / 2)
			continue;
		int cm = get_m(t);
		if (cm == m / 2) {
			for (auto el : t) {
				cout << el.ind + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}
}

void solve1() {
	for (int i = 0; i < n / 2; ++i) {
		cout << i + 1 << " ";
	}
	cout << "\n";
}

void solve4() {
	vector<bool> t(n, true);
	vector<vector<int>> covers(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (a[i].l == a[j].l && a[i].r == a[j].r && i > j) {
				continue;
			}
			if (i != j && a[i].l <= a[j].l && a[j].r <= a[i].r) {
				t[i] = false;
				covers[j].push_back(i);
			}
		}
	}
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		cnt += t[i];
	}
	vector<bool> used(n, false);
	int left = cnt / 2, cleft = n / 2 - (cnt / 2);
	set<int> curcovers;
	while (cleft > 0) {
		bool flag = false;
		for (int i = 0; i < n; ++i) {
			if (!used[i] && curcovers.count(i)) {
				used[i] = true;
				cleft--;
				flag = true;
				break;
			}
		}
		if (flag)
			continue;
		int ri = -1, rd = 0;
		for (int i = 0; i < n; ++i) {
			if (!t[i] || used[i]) {
				continue;
			}
			int ccnt = 0;
			for (auto j : covers[i]) {
				if (!used[j])
					ccnt++;
			}
			if (ccnt > rd) {
				ri = i;
				rd = ccnt;
			}
		}
		used[ri] = true;
		for (auto j : covers[ri]) {
			curcovers.insert(j);
		}
		left--;
	}
	if (left > 0) {
		for (int i = 0; i < n; ++i) {
			if (left <= 0)
				break;
			if (!used[i] && t[i]) {
				used[i] = true;
				left--;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		cin >> n;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].l >> a[i].r;
			a[i].ind = i;
		}
		solve4();
	}
}
