#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

int n, q;
ll x, y, m;
vector<vector<int>> g;
vector<pair<ll, ll>> a;

vector<pair<ll, ll>> dp;
void dfs1(int v, int p) {
	dp[v].first = 0;
	dp[v].second = a[v].first;
	for (auto u : g[v]) {
		if (u == p)
			continue;
		dfs1(u, v);
		dp[v].first += max(dp[u].first, dp[u].second);
		dp[v].second += dp[u].first;
	}
}

void solve1() {
	dp.resize(n);
	dfs1(0, -1);
	ll v = max(dp[0].first, dp[0].second);
	ll k = 0;
	for (ll j = 0; j < n; ++j) {
		k = k ^ (((x * (j + 1)) % m + (y * ((a[j].first * a[j].first) % m)) % m) % m);
	}
	vector<ll> cert(q);
	for (int i = 0; i < q; ++i) {
		ll qv;
		cin >> qv;
		if (qv != v)
			cert[i] = -1;
		else
			cert[i] = k;
	}
	for (auto el : cert)
		cout << el << " ";
	cout << endl;
	while (true) {
		ll i;
		cin >> i;
		i--;
		if (i == -1)
			break;
		if (cert[i] == -1)
			cout << "-1" << endl;
		else {
			for (auto el : a) {
				cout << el.first << " ";
			}
			cout << endl;
		}
	}
}

vector<pair<ll, ll>> dpl2;
vector<pair<ll, ll>> dpr2;
void dfs2(int v, int p) {
	dpl2[v].first = 0;
	dpl2[v].second = a[v].first;
	dpr2[v].first = 0;
	dpr2[v].second = a[v].second;
	for (auto u : g[v]) {
		if (u == p)
			continue;
		dfs2(u, v);
		dpl2[v].first += max(dpl2[u].first, dpl2[u].second);
		dpr2[v].first += max(dpr2[u].first, dpr2[u].second);
		dpl2[v].second += dpl2[u].first;
		dpr2[v].second += dpr2[u].first;
	}
}

void solve2() {
	dpl2.resize(n);
	dpr2.resize(n);
	dfs2(0, -1);
	ll vmin = max(dpl2[0].first, dpl2[0].second);
	ll vmax = max(dpr2[0].first, dpr2[0].second);
	vector<ll> cert(q);
	for (int i = 0; i < q; ++i) {
		ll qv;
		cin >> qv;
		if (qv < vmin || vmax < qv)
			cert[i] = -1;
		else
			cert[i] = 1;
	}
	for (auto el : cert)
		cout << el << " ";
	cout << endl;
	while (true) {
		ll i;
		cin >> i;
		i--;
		if (i == -1)
			break;
		else {
			cout << "Thanks to Andrew Stankevich" << endl;
		}
	}
}

int main() {
	// ios_base::sync_with_stdio(false);
	// cin.tie(nullptr);
	int t = 1;
	cin >> t;
	while (t--) {
		cin >> n >> q >> x >> y >> m;
		g.assign(n, vector<int>());
		for (int i = 0; i < n - 1; ++i) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].first >> a[i].second;
		}
		solve2();
	}
}
