#include <iostream>
#include <set>
#include <vector>
#include <algorithm>

#define int int64_t
#define ALL(v) v.begin(), v.end()

using namespace std;

int n, m;
set<pair<int, int>> a;
void mini(int& x, int y) {
    x = min(x, y);
}

void maxi(int& x, int y) {
    x = max(x, y);
}

int getSquare(int r, int c) {
    int mni = 4e9;
    int mxi = -1;
    int mnj = 4e9;
    int mxj = -1;
    for (auto [i, j] : a) {
        if (r <= i && i < r + n &&
                c <= j && j < c + m) {
            mini(mni, i);
            maxi(mxi, i);
            mini(mnj, j);
            maxi(mxj, j);
        }
    }

    int ans = (mxj - mnj + 1) * (mxi - mni + 1);
    // cout << r << ' ' << c << ' ' << ans << '\n';
    // cout << r << ' ' << c << ' ' << mni << ' ' << mxi << ' ' << mnj << ' ' << mxj << ' ' << ans << '\n';
    return ans;
}

int getMoves(int i, int j) {
    return abs(n - i) + abs(m - j);
}

signed main() {
    int K;
    cin >> n >> m >> K;

    if (K == 1) {
        cout << 1 << ' ' << 0 << '\n';
        return 0;
    }

    vector<int> is;
    vector<int> js;
    is.reserve(K);
    js.reserve(K);
    for (int k = 0; k < K; ++k) {
        int r, c;
        cin >> r >> c;
        --r;
        --c;
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                a.insert({r + n * i, c + m * j});
                is.push_back(min(2 * n, r + n * i));
                js.push_back(min(2 * m, c + n * j));
            }
        }
    }
    sort(ALL(is));
    sort(ALL(js));
    is.resize(unique(ALL(is)) - is.begin());
    js.resize(unique(ALL(js)) - js.begin());


    int besti = 0;
    int bestj = 0;
    int best = getSquare(0, 0);
    for (int r : is) {
        for (int c : js) {
            // cout << r << ' ' << c << '\n';
            int sq = getSquare(r, c);
            // cout << r + 1 << ' ' << c + 1 << ' ' << sq << '\n';
            if (sq < best || (sq == best && getMoves(r, c) < getMoves(besti, bestj))) {
                best = sq;
                besti = r;
                bestj = c;
            }
        }
    }

    cout << best << ' ' << getMoves(besti, bestj) << '\n';
}
