#include <iostream>
#include <vector>
#include <algorithm>
  
#define ALL(v) v.begin(), v.end()
#define int int64_t
  
using namespace std;
 
void unique_(vector<int>& v) {
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
}
 
void mn_(int& x, int y) {
    x = min(x, y);
}
 
void mx_(int& x, int y) {
    x = max(x, y);
}
 
// finds >=
int getLeft(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] < x) {
            l = m;
        } else {
            r = m;
        }
    }
    return a[r];
}
 
// finds <=
int getRight(const vector<int>& a, int x) {
    int l = -1;
    int r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return a[l];
}
 
int getSforF(const vector<int>& a, int n, int f) {
    int left = getLeft(a, f); 
    int right = getRight(a, f + n - 1);
    int ans = right - left + 1;
    return ans;
}
 
// @return s, k
pair<int, int> solveProj(const vector<int>& proj, int n) {
    vector<int> a;
    vector<int> fs;
    fs.push_back(n);
    for (int i = 0; i < 3; ++i) {
        for (int x : proj) {
            int X = x + i * n;
            a.push_back(X);
            if (X + n - 1 < 3 * n) {
                fs.push_back(X);
            }
            if (X - n + 1 >= 0) {
                fs.push_back(X - n + 1);
            }
        }
    }
 
    int bestS = 2e9;
    int bestK = 2e9;
    for (int f : fs) {
        int s = getSforF(a, n, f);
        int k = abs(f - n);
        if (s < bestS || (s == bestS && k < bestK)) {
            bestS = s;
            bestK = k;
        }
    }
    return {bestS, bestK};
}
 
signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> iProj;
    vector<int> jProj;
    iProj.reserve(k);
    jProj.reserve(k);
    for (int l = 0; l < k; ++l) {
        int i, j;
        cin >> i >> j;
        --i;
        --j;
        iProj.push_back(i);
        jProj.push_back(j);
    }
    unique_(iProj);
    unique_(jProj);
 
    auto [si, ki] = solveProj(iProj, n); 
    auto [sj, kj] = solveProj(jProj, m); 
    cout << si * 1ll * sj << ' ' << ki + kj << '\n';
}
