#include <vector>
#include <iostream>

#define ALL(v) v.begin(), v.end()

// #ifndef LOCAL
#define cerr if(0) cerr
// #endif

using namespace std;

void dfs(const vector<vector<int>>& g, vector<int>& leaves, int k, int u, int uType, int turns) {
    if (g[u].empty()) {
        if (turns <= k) {
            leaves[u] = 1;
            cerr << u + 1 << " is GOOD leave\n";
        } else {
            leaves[u] = 0;
            cerr << u + 1 << " is BAD leave\n";
        }
    } else {
        dfs(g, leaves, k, g[u][0], 0, turns + (uType != 0));
        dfs(g, leaves, k, g[u][1], 1, turns + (uType != 1));
        leaves[u] = leaves[g[u][0]] + leaves[g[u][1]];
        cerr << leaves[u] << " leaves in " << u + 1 << '\n';
    }
}

signed main() {
    int n, k, q;
    cin >> n >> k >> q;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            --x;
            g[i].push_back(x);
        }
    }

    vector<int> leaves(n);
    // XXX root has no leaves
    dfs(g, leaves, k, 0, 2, -1);

    for (int i = 0; i < n; ++i) {
        cerr << i + 1 << ' ' << leaves[i] << '\n';
    }

    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        --u;
        cout << leaves[u] << '\n';
    }
}
