#include <iostream>
#include <string>
#include <map>
#include <set>
#include <algorithm>
using namespace std;

typedef long long ll;

int k;
ll h, w;

typedef pair<ll, ll> pii;

struct segset
{
	set<pii> st;
	ll w;
	segset(ll w) : w(w)
	{
		st.emplace(0, w);
	}
	void remove(ll i)
	{
		auto iter = st.upper_bound({ i, w + 1 });
		if (iter == st.begin())
			return;
		iter--;
		pii val = *iter;
		if (val.second <= i)
			return;
		st.erase(iter);
		if (val.first == i)
		{
			if (val.second > i + 1)
				st.emplace(i + 1, val.second);
		}
		else
		{
			st.emplace(val.first, i);
			if (val.second > i + 1)
				st.emplace(i + 1, val.second);
		}
	}
	pii finalmax()
	{
		pii ans(0, 0);
		if (st.empty())
			return ans;
		auto beg = st.begin();
		if (beg->first == 0 && st.rbegin()->second == w)
		{
			pii val = *beg;
			st.erase(beg);
			auto riter = st.end();
			riter--;
			pii rval = *riter;
			st.erase(riter);
			ans.first = val.second - val.first + rval.second - rval.first;
		}
		for (auto& p : st)
		{
			pii cur(p.second - p.first, min(w - p.second, p.first));
			if (cur.first > ans.first || (cur.first == ans.first && cur.second < ans.second))
				ans = cur;
		}
		return ans;
	}
};

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> h >> w >> k;
	segset vert(h), horz(w);
	for (int i = 0; i < k; i++)
	{
		int r, c; cin >> r >> c;
		vert.remove(r - 1);
		horz.remove(c - 1);
	}
	pii vans = vert.finalmax(), hans = horz.finalmax();
	cout << (h - vans.first) * (w - hans.first) << ' ' << vans.second + hans.second;
}