#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


ll h, w, n;


pair<ll, ll> fnL(const vector<ll>& v, const ll n) {
	pair<ll, ll> res = make_pair(v.back() - v.front() + 1, 0);


	ll steps = 0;
	for (ll i = v.size() - 2; i >= 0; --i) {
		steps += n - (v[i + 1] + steps);
		res = min(res, make_pair(v[i] + steps - 0 + 1, steps));
	}
	return res;
}


pair<ll, ll> fnR(const vector<ll>& v, const ll n) {
	pair<ll, ll> res = make_pair(v.back() - v.front() + 1, 0);


	ll steps = 0;
	for (ll i = 1; i < v.size(); ++i) {
		steps += v[i - 1] - steps + 1;
		res = min(res, make_pair(n - (v[i] - steps), steps));
	}
	return res;
}


void solve(istream& cin, ostream& cout) {
	cin >> h >> w >> n;
	vector<ll> x(n), y(n);
	for (ll i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
		--x[i], --y[i];
	}
	sort(x.begin(), x.end());
	sort(y.begin(), y.end());


	auto [res_x, cnt_x] = min(fnL(x, h), fnR(x, h));
	auto [res_y, cnt_y] = min(fnL(y, w), fnR(y, w));

	cout << res_x * res_y << ' ' << cnt_x + cnt_y << '\n';
}