#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


class SegTree {
private:
	vector<ll> v;
	size_t _size = 0;

public:
	SegTree() = default;
	SegTree(const SegTree&) = default;
	SegTree(size_t sz) {
		for (_size = 1; _size < sz; _size *= 2);
		v.resize(_size * 2, 0);
	}


	void write(ll iter, const ll val) {
		iter += _size;
		v[iter] = val;
		iter /= 2;
		for (; iter > 0; iter /= 2)
			v[iter] = max(v[iter * 2], v[iter * 2 + 1]);
	}


	ll operator()(ll first, ll last) const {
		first += _size;
		last += _size;
		ll res = 0;
		for (; first < last; first /= 2, last /= 2) {
			if (first % 2 == 1)
				res = max(res, v[first++]);
			if (last % 2 == 1)
				res = max(res, v[--last]);
		}
		return res;
	}

	ll operator[](const ll iter) const {
		return v[iter + _size];
	}
};


void solve(istream& cin, ostream& cout) {
	ll n;
	cin >> n;
	vector<ll> p(n);
	for (auto& t : p)
		cin >> t;

	SegTree st(n + 5);
	st.write(p[0], 1);

	for (ll i = 1; i < n; ++i) {
		ll buf = st(0, p[i]);
		if (buf + 1 > st[p[i]])
			st.write(p[i], buf + 1);
	}

	cout << min(n, st(0, n + 5) + 1) << '\n';
}