#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ld EPS = 1e-9L;


void init(istream& cin, ostream& cout);
void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	init(cin, cout);


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


template<typename ty, typename st>
ty binPow(ty a, st base) {
	ty res = 1;
	while (base > 0) {
		if (base % 2 == 1)
			res = res * a;
		a = a * a;
		base /= 2;
	}
	return res;
}


ll MOD;


struct mint {
	ll x = 0;

	mint() = default;
	mint(const ll val) :x((val + MOD) % MOD) {}


	mint operator+(const mint val) const {
		return mint(x + val.x);
	}
	mint operator-(const mint val) const {
		return mint(x - val.x);
	}
	mint operator*(const mint val) const {
		return mint(x * val.x);
	}
	mint operator/(const mint val) const {
		return (*this) * binPow(val, MOD - 2);
	}
};


vector<mint> fct;
constexpr ll N = (1ll << 18);

void init(istream& cin, ostream& cout) {
	cin >> MOD;
	fct.emplace_back(1);
	for (ll i = 1; i < N; ++i)
		fct.emplace_back(fct.back() * mint(i));
}


mint C(const ll n, const ll m) {
	return fct[n] / (fct[m] * fct[n - m]);
}


void solve(istream& cin, ostream& cout) {
	ll k, n, p;
	cin >> k >> n >> p;

	ll x = 0;
	for (; x <= k + 1; ++x)
		if (p == (1ll << x))
			break;
	if (x == k + 1) {
		cout << "0\n";
		return;
	}
	if (n < p) {
		cout << "0\n";
		return;
	}
	if (x == k) {
		if (n == p)
			cout << "1\n";
		else
			cout << "0\n";
		return;
	}


	cout << ">>> ";
	cout << C((1ll << k) - p - 1, n - p).x << '\n';
}