#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


mt19937 rnd(45329843);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	int n;
	cin >> n;
	vector<pair<int, int>> v(n);
	for (auto& [l, r] : v)
		cin >> l >> r;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i)
		a[i] = b[i] = i;
	sort(a.begin(), a.end(), [&](const int x, const int y) {
		if (v[x].first == v[y].first)
			return v[x].second < v[y].second;
		return v[x].first < v[y].first;
		}
	);
	sort(b.begin(), b.end(), [&](const int x, const int y) {
		if (v[x].second == v[y].second)
			return v[x].first > v[y].first;
		return v[x].second < v[y].second;
		}
	);
	auto isCross = [&](const int i, const int j) {
		return !(v[i].second < v[j].first || v[j].second < v[i].first);
	};


	vector<bool> mask(n);
	auto ar = a;
	auto br = b;
	reverse(ar.begin(), ar.end());
	reverse(br.begin(), br.end());


	auto fn = [&](vector<pair<int, ll>>& dp, const vector<int>& a, const vector<int>& b) {

		fill(dp.begin(), dp.end(), make_pair(-1, -1));
		pair<int, ll> max_dp = { 0,1 };
		int t = 0;

		for (auto& i : a) {
			if (mask[i])
				continue;
			for (; t < b.size(); ++t) {
				int j = b[t];
				if (mask[j])
					continue;
				if (isCross(i, j))
					break;


				if (max_dp.first == dp[j].first)
					max_dp.second += dp[j].second;
				else
					max_dp = max(max_dp, dp[j]);
			}

			dp[i] = max_dp;
			dp[i].first++;
		}

		/*fill(dp.begin(), dp.end(), make_pair(1, 1));
		for (auto& i : a) {
			if (mask.find(i) != mask.end())
				continue;
			for (auto& j : b) {
				if (mask.find(j) != mask.end())
					continue;
				if (isCross(i, j))
					break;

				if (dp[i].first == dp[j].first + 1)
					dp[i].second += dp[j].second;
				dp[i] = max(dp[i], make_pair(dp[j].first + 1, dp[j].second));
			}
		}*/
	};


	vector<pair<int, ll>> dpL(n), dpR(n), dp(n);
	auto ffn = [&]() {
		fn(dpL, a, b);
		fn(dpR, br, ar);
		for (int i = 0; i < n; ++i) {
			dp[i].first = dpL[i].first + dpR[i].first;
			dp[i].second = dpL[i].second * dpR[i].second;
		}
		int res = 0;
		for (int i = 0; i < dpL.size(); ++i)
			res = max(res, dpL[i].first);
		return res;
	};


	int m = ffn();
	int new_m = m;
	ll cnt = n;
	bool recalc = true;
	ll buf = 0;
	while (cnt > n / 2) {
		if (new_m > m / 2) {
			int t = 0;
			for (int i = 0; i < n; ++i) {
				if (dp[i] > dp[t])
					t = i;
			}
			if (!recalc && dp[t].first != buf) {
				new_m = ffn();
				recalc = true;
				continue;
			}
			mask[t] = true;
			--cnt;
			buf = dp[t].first;
			recalc = false;
		}
		else {
			int t = 0;
			for (int i = 0; i < n; ++i) {
				if (mask[i])
					continue;
				if (mask[t] || dp[i] < dp[t])
					t = i;
			}
			if (!recalc && dp[t].first > m / 2) {
				new_m = ffn();
				recalc = true;
				continue;
			}
			mask[t] = true;
			--cnt;
			recalc = false;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (!mask[i])
			cout << i + 1 << ' ';
	}
	cout << '\n';
}