#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


mt19937 rnd(45329843);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n;
	cin >> n;
	vector<pair<ll, ll>> v(n);
	for (auto& [l, r] : v)
		cin >> l >> r;
	vector<ll> a(n), b(n);
	for (ll i = 0; i < n; ++i)
		a[i] = b[i] = i;

	sort(a.begin(), a.end(), [&](const ll x, const ll y) {
		if (v[x].first == v[y].first)
			return v[x].second < v[y].second;
		return v[x].first < v[y].first;
		}
	);
	sort(b.begin(), b.end(), [&](const ll x, const ll y) {
		if (v[x].second == v[y].second)
			return v[x].first < v[y].first;
		return v[x].second < v[y].second;
		}
	);


	auto isCross = [&](const ll i, const ll j) {
		return !(v[i].second < v[j].first || v[j].second < v[i].first);
	};
	auto inAns = [](const ll v, const ll mask) {
		return ((mask >> v) & 1);
	};
	auto ok = [&](const ll mask) {
		vector<ll> dp(n, 1);

		ll max_dp = 0;

		ll t = 0;
		for (auto& i : a) {
			if (!inAns(i, mask))
				continue;
			for (; t < b.size(); ++t) {
				if (!inAns(b[t], mask))
					continue;
				if (isCross(i, b[t]))
					break;
				max_dp = max(max_dp, dp[b[t]]);
			}
			dp[i] = max(dp[i], max_dp + 1);
		}

		ll res = 0;
		for (auto& t : dp)
			res = max(t, res);
		return res;
	};


	ll m = ok((1ll << n) - 1);


	for (ll ww = 0; ww < 1000; ++ww) {
		ll mask = rnd() % (1ll << n);
		ll cnt = 0;
		for (ll i = 0; i < n; ++i) {
			if ((mask >> i) & 1)
				++cnt;
		}
		if (cnt != n / 2)
			continue;

		if (ok(mask) != m / 2)
			continue;

		for (ll i = 0; i < n; ++i) {
			if ((mask >> i) & 1)
				cout << i + 1 << ' ';
		}
		cout << '\n';
		return;
	}
	exit(-1);
}