#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


mt19937 rnd(45329843);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (auto& t : w)
		cin >> t;
	sort(w.begin(), w.end());
	ll z;
	cin >> z;


	vector<vector<ll>> dp(5001, vector<ll>(5001, INF));
	dp[0][0] = -1;
	set<tuple<ll, ll, ll>> bq;
	bq.emplace(1, 0, 0);
	bq.emplace(0, 1, 0);
	while (!bq.empty()) {
		auto [i, a, b] = *bq.begin();
		bq.erase(bq.begin());
		if (a >= dp.size() || b >= dp.size() || i >= n)
			continue;

		if (a > 0 && dp[a - 1][b] > i)
			continue;
		if (b > 0 && dp[a][b - 1] > i)
			continue;

		if ((a >= w[i] && dp[a - w[i]][b] < i) ||
			(b >= w[i] && dp[a][b - w[i]] < i)) {
			dp[a][b] = i;
			bq.emplace(i + 1, a + 1, b);
			bq.emplace(i + 1, a, b + 1);
		}
	}


	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;


		if (dp[a][b] != INF)
			cout << "YES\n";
		else
			cout << "NO\n";
	}
}