#include <bits/stdc++.h>
 
 
using namespace std;
 
 
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
 
 
mt19937 rnd(23223);
const ll inf = 1e7;
 

void print(const vector<ll> &a){
    for(auto x: a){
        cout << x << " ";
    }
    cout << endl;
}

 
struct SGT{
    int rn;
    int n;
    vector<int> d;
    vector<int> t;


    inline void apply(int v, int x){
        d[v] += x;
        t[v] += x;
    }


    inline void push(int v){
        apply(v + v, d[v]);
        apply(v + v + 1, d[v]);
        d[v] = 0;
    }


    inline void upd(int v){
        t[v] = max(t[v + v], t[v + v + 1]);
    }


    void build(int _n){
        rn = _n;
        n = 1;
        while(n < _n){
            n *= 2;
        }
        t.assign(n + n, 0);
        d.assign(n + n, 0);
    }


    void add(int v, int tl, int tr, int l, int r, int x){
        if(tr < l || r < tl){
            return;
        }
        if(l <= tl && tr <= r){
            apply(v, x);
            return;
        }
        int tm = (tl + tr) / 2;
        push(v);
        add(v + v, tl, tm, l, r, x);
        add(v + v + 1, tm + 1, tr, l, r, x);
        upd(v);
    }

    void add(int l, int r, int x){
        add(1, 0, n - 1, l, r, x);
    }


    int get(int v, int tl, int tr, int l, int r){
        if(tr < l || r < tl){
            return 0;
        }
        if(l <= tl && tr <= r){
            return t[v];
        }
        int tm = (tl + tr) / 2;
        push(v);
        return max(get(v + v, tl, tm, l, r), get(v + v + 1, tm + 1, tr, l, r));
    }


    int get(int l, int r){
        return get(1, 0, n - 1, l, r);
    }

    int find_frst_bgr(int v, int tl, int tr, int l, int r, int x){
        if(tr < l || r < tl || t[v] <= x){
            return -1;
        }
        if(tl == tr){
            return tl;
        }
        int tm = (tl + tr) / 2;
        push(v);
        int rs = find_frst_bgr(v + v, tl, tm, l, r, x);
        if(rs == -1){
            rs = find_frst_bgr(v + v + 1, tm + 1, tr, l, r, x);
        }
        return rs;
    }

    int find_frst_bgr(int l, int r, int x){
        int rs = find_frst_bgr(1, 0, n - 1, l, r, x);
        if(rs == -1){
            rs = r + 1;
        }
        return rs;
    }


    int find_lst_bgr(int v, int tl, int tr, int l, int r, int x){
        if(tr < l || r < tl || t[v] <= x){
            return -1;
        }
        if(tl == tr){
            return tl;
        }
        int tm = (tl + tr) / 2;
        push(v);
        int rs = find_lst_bgr(v + v + 1, tm + 1, tr, l, r, x);
        if(rs == -1){
            rs = find_lst_bgr(v + v, tl, tm, l, r, x);
        }
        return rs;
    }

    int find_lst_bgr(int l, int r, int x){
        int rs = find_lst_bgr(1, 0, n - 1, l, r, x);
        if(rs == -1){
            rs = l - 1;
        }
        return rs;
    }


    vector<ll> get_all(){
        vector<ll> rs(rn);
        for(int i = 0; i < rn; i += 1){
            rs[i] = get(i, i);
        }
        return rs;
    }
};


int n;
vector<int> p;
 
 
ll solve_slow(){
    SGT dpup, dpdown;
    dpup.build(n + 2);
    dpdown.build(n + 2);
    vector<pair<ll, ll>> sgmnts_up(n), sgmnts_down(n);
    for(int i = n - 1; i >= 0; i -= 1){
        int t = p[i];
        {
            ll x = dpup.get(t + 1, t + 1);
            int l = dpup.find_lst_bgr(0, t, x) + 1;
            int r = t;
            dpup.add(l, r, 1);
            sgmnts_up[i] = make_pair(l, r);
        }
        {   
            ll x = dpdown.get(t - 1, t - 1);
            int r = dpdown.find_frst_bgr(t, n + 1, x) - 1;
            int l = t;
            dpdown.add(l, r, 1);
            sgmnts_down[i] = make_pair(l, r);
        }
        // print(dpup.get_all());
        /*
        for(int j = 1; j <= n + 1; j += 1){
            dpdown[i][j] = max(dpdown[i + 1][j], dpdown[i][j - 1]);
            if(j == t){
                dpdown[i][j] = dpdown[i + 1][j - 1] + 1;
            }
        }
        for(int j = n; j >= 0; j -= 1){
            dpup[i][j] = max(dpup[i + 1][j], dpup[i][j + 1]);
            if(j == t){
                dpup[i][j] = dpup[i + 1][j + 1] + 1;
            }
        }
        */
    }

    vector<int> dp(n + 2, -inf);
    dpup.add(1, n, -inf);
    dpdown.add(1, n, -inf);
    dp[0] = 0;
    set<int> f = {0, n + 1};
    int rs = 0;
    for(int i = 0; i < n; i += 1){
        int t = p[i];
        auto it = upper_bound(all(f), t);
        int l = *prev(it);
        int r = *it;
        f.insert(t);
        
        dpup.add(t, t, inf + dp[l] + 1);
        dpup.add(l, l, 1);

        dpdown.add(t, t, inf + dp[l] + 1);
        dpdown.add(r, r, 1);

        dp[t] = dp[l] + 1;
        dp[l] = dp[l] + 1;

        {
            rs = max(rs, dpup.get(t, t) - dp[t] + dpdown.get(0, l));
            rs = max(rs, dpdown.get(t, t) - dp[t] + dpup.get(r, n + 1));
        }

        {
            auto [l, r] = sgmnts_up[i];
            dpup.add(l, r, -1);
        }
        {
            auto [l, r] = sgmnts_down[i];
            dpdown.add(l, r, -1);
        }
    }
    for(auto x: f){
        rs = max(rs, dp[x]);
    }
    return rs;
}
 
 
int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    while(t--){
        cin >> n;
        p.resize(n);
        for(int i = 0; i < n; i += 1){
            cin >> p[i];
        }
        cout << solve_slow() << "\n";
    }
    return 0;
}
 
/*
1
5
4 1 2 3 5
 

1
10
3 8 10 4 1 2 7 9 5 6

*/