#include <bits/stdc++.h>


using namespace std;

#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll inf = 1e18;
mt19937 rnd(23424);

int n;
vector<ll> l, r;
vector<int> rs;
int sz;
vector<ll> cmprs;
vector<vector<pair<int, int>>> g;
vector<int> is_fxd;
vector<int> dp;
int m;


bool try_to_solve(int l, int r, bool bg){
    vector<int> fxd, nt_fxd;
    fxd.reserve(m / 2);
    nt_fxd.reserve(n / 2);
    for(int u = 0; u < sz; u += 1){
        for(auto [to, num]: g[u]){
            bool is_ok = false;
            if(bg){
                is_ok = (to < l) || (u <= r);
            } else{
                is_ok = (r < u) || (l <= to);
            }
            if(is_ok){
                if(is_fxd[num] && (l <= to && u <= r)){
                    fxd.push_back(num);
                } else{
                    nt_fxd.push_back(num);
                }
            }
        }
    }
    assert((int)fxd.size() == m / 2);
    if((int)fxd.size() + (int)nt_fxd.size() < n / 2){
        return false;
    }
    rs = fxd;
    for(int i = 0; i < (int)nt_fxd.size() && (int)rs.size() < n / 2; i += 1){
        rs.push_back(nt_fxd[i]);
    }
    return true;
}


void solve(){
    rs.clear();
    rs.reserve(n / 2);
    cmprs.clear();
    cmprs.reserve(n + n);
    for(int i = 0; i < n; i += 1){
        cmprs.push_back(l[i]);
        cmprs.push_back(r[i] + 1);
    }
    sort(all(cmprs));
    cmprs.resize(unique(all(cmprs)) - cmprs.begin());
    sz = cmprs.size();
    g.assign(sz, {});
    is_fxd.assign(n, false);
    for(int i = 0; i < n; i += 1){
        int u = lower_bound(all(cmprs), l[i]) - cmprs.begin();
        int v = lower_bound(all(cmprs), r[i] + 1) - cmprs.begin();
        g[v].push_back(make_pair(u, i));
    }
    dp.assign(sz, 0);
    for(int i = 1; i < sz; i += 1){
        dp[i] = dp[i - 1];
        for(auto [to, num]: g[i]){
            if(dp[to] + 1 > dp[i]){
                dp[i] = dp[to] + 1;
                is_fxd[num] = true;
            }
        }
    }
    m = dp.back();
    int l = -1;
    int r = -1;
    for(int i = 0; i < sz; i += 1){
        if(dp[i] == m / 2){
            if(l == -1){
                l = i;
            }
            r = i;
        }
    }
    if(try_to_solve(l, r, true)){
        return;
    }
    try_to_solve(l, r, false);
}


template<class T>
void print(const vector<T> &a, T d){
    for(auto x: a){
        cout << x + d << " ";
    }
    cout << "\n";
}


int get_aboba(vector<int> t){
    int f = t.size();
    int rs = 0;
    for(int mask = 1; mask < (1ll << f); mask += 1){
        vector<pair<ll, ll>> biba;
        for(int i = 0; i < f; i += 1){
            if((mask >> i) & 1){
                biba.push_back(make_pair(l[t[i]], r[t[i]]));
            }
        }
        sort(all(biba));
        int cnt = (int)biba.size();
        bool ok = true;
        for(int i = 0; i + 1 < cnt; i += 1){
            if(biba[i].second >= biba[i + 1].first){
                ok = false;
                break;
            }
        }
        if(ok){
            rs = max(rs, cnt);
        }
    }
    return rs;
}


bool check_ans(){
    if((int)rs.size() != n / 2){
        return false;
    }
    vector<int> f(n);
    for(int i = 0; i < n; i += 1){
        f[i] = i;
    }
    int rm = get_aboba(f);
    int rsm = get_aboba(rs);
    if(rsm * 2 != rm){
        return false;
    }
    return true;
}


void print_test(){
    cout << 1 << "\n";
    cout << n << "\n";
    for(int i = 0; i < n; i += 1){
        cout << l[i] << " " << r[i] << "\n";
    }
}


void gen_test(int mxn, int mxc){
    while(1){
        n = rnd() % mxn + 1;
        if(n % 2 != 0){
            continue;
        }
        l.resize(n);
        r.resize(n);
        vector<int> f(n);
        for(int i = 0; i < n; i += 1){
            f[i] = i;
            int u = rnd() % mxc;
            int v = rnd() % mxc;
            if(u > v){
                swap(u, v);
            }
            v += 1;
            l[i] = u;
            r[i] = v;
        }
        int rm = get_aboba(f);
        if(rm % 2 != 0){
            continue;
        }
        break;
    }
}


void stress(){
    int c = 0;
    while(1){
        cout << ++c << "\n";
        gen_test(15, 10);
        solve();
        if(!check_ans()){
            print_test();
            break;
        }
    }
}

int32_t main(){
    // stress();
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    while(t--){
        cin >> n;
        l.resize(n);
        r.resize(n);
        for(int i = 0; i < n; i += 1){
            cin >> l[i] >> r[i];
        }
        solve();
        print(rs, 1ll);
    }
    return 0;
}