#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,fma")
#endif

#include <bits/stdc++.h>


using namespace std;


#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll inf = 1e18;
mt19937 rnd(23424);

template<class T>
void print(const vector<T> &a, T d){
    for(auto x: a){
        cout << x + d << " ";
    }
    cout << endl;
}


int n, q;
vector<vector<int>> g;
vector<ll> l, r;
ll x, y, m;
vector<ll> asks;
vector<int> f;
ll mn_sm, mx_sm;
ll rl_sm;


void dfs0(int v, int p, vector<vector<ll>> &dp, const vector<ll> &cost){
    dp[v][1] = cost[v];
    for(auto to: g[v]){
        if(to == p){
            continue;
        }
        dfs0(to, v, dp, cost);
        dp[v][0] += dp[to][1];
        dp[v][1] += dp[to][0];
    }
    dp[v][1] = max(dp[v][1], dp[v][0]);
}


void dfs1(int v, int p, int t, vector<vector<ll>> &dp, const vector<ll> &cost, vector<int> &rs){
    if(t == 1 && dp[v][0] == dp[v][1]){
        t = 0;
    }
    if(t == 1){
        rs.push_back(v);
    }
    for(auto to: g[v]){
        if(to == p){
            continue;
        }
        dfs1(to, v, (t ^ 1), dp, cost, rs);
    }
}


pair<ll, vector<int>> get_max(const vector<ll> &cost, bool need_rs = true){
    vector<vector<ll>> dp(n, vector<ll>(2, 0));
    dfs0(0, -1, dp, cost);
    if(!need_rs){
        return make_pair(dp[0][1], vector<int>());
    }
    vector<int> rs;
    rs.reserve(n);
    dfs1(0, -1, 1, dp, cost, rs);
    // sort(all(rs));
    return make_pair(dp[0][1], rs);
}


void build(){
    ll _mn_sm = get_max(l).first;
    auto [_mx_sm, _f] = get_max(r);
    mn_sm = _mn_sm;
    mx_sm = _mx_sm;
    f = _f;
    rl_sm = 0;
    for(auto t: f){
        rl_sm += l[t];
    }
}





pair<ll, vector<ll>> get_ans(ll vi, bool restore_ans = true){
    if(!(mn_sm <= vi && vi <= mx_sm)){
        return make_pair(-1, vector<ll>({}));
    }
    // return make_pair(0, vector<ll>({}));
    ll tr = vi - rl_sm + 1;
    ll tl = vi - mn_sm - 1;
    while(tl + 1 < tr){
        ll dbg = (tl + tr) / 2;
        ll d = dbg;
        vector<ll> a(n);
        for(int i = 0; i < n; i += 1){
            a[i] = l[i];
        }
        for(int i = 0; i < (int)f.size(); i += 1){
            ll dd = r[f[i]] - l[f[i]];
            if(dd >= d){
                a[f[i]] += d;
                d = 0;
                break;
            }
            a[f[i]] = r[f[i]];
            d -= dd;
        }
        ll mx = get_max(a, false).first;
        if(vi == mx){
            ll hsh = 0;
            for(int i = 0; i < n; i += 1){
                ll dhsh = (x * (i + 1) % m + y * a[i] % m * a[i] % m) % m;
                hsh = (hsh ^ dhsh);
            }
            return make_pair(hsh, a);
        }
        if(mx < vi){
            tl = dbg;
        } else{
            tr = dbg;
        }
    }
    return make_pair(0, vector<ll>());
}


void stress(){
    int c = 0;
    while(1){
        cout << ++c << "\n";
        n = rnd() % 4 + 1;
        q = rnd() % 4 + 1;
        g.assign(n, vector<int>());
        for(int v = 1; v < n; v += 1){
            int u = rnd() % v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        l.resize(n);
        r.resize(n);
        for(int i = 0; i < n; i += 1){
            l[i] = rnd() % 4;
            r[i] = rnd() % 4;
            if(l[i] > r[i]){
                swap(l[i], r[i]);
            }
        }
        x = 1;
        y = 1;
        m = 10;
        build();
        asks.resize(q);
        for(int i = 0; i < q; i += 1){
            asks[i] = rnd() % 20;
        }
        for(int i = 0; i < q; i += 1){
            get_ans(asks[i]);
        }
    }
}


int32_t main(){
    // stress();
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    while(t--){
        cin >> n >> q;
        cin >> x >> y >> m;
        g.assign(n, {});
        for(int i = 0; i < n - 1; i += 1){
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        l.resize(n);
        r.resize(n);
        for(int i = 0; i < n; i += 1){
            cin >> l[i] >> r[i];
        }
        

        build();

        asks.resize(q);
        for(int i = 0; i < q; i += 1){
            cin >> asks[i];
        }
        vector<pair<ll, vector<ll>>> answrs(q);
        for(int i = 0; i < q; i += 1){
            answrs[i] = get_ans(asks[i]);
            cout << answrs[i].first << " ";
        }
        cout << endl;
        while(1){
            int i;
            cin >> i;
            i -= 1;
            if(i == -1){
                break;
            }
            auto [rshsh, rs] = answrs[i];
            if(rshsh == -1){
                cout << -1 << endl;
                continue;
            }
            print(rs, 0ll);
        }
    }
    return 0;
}

/*
1
4 6
1 2 11
1 2
2 3
3 4
0 2
1 1
1 1
1 2
0 1 2 3 4 5

*/