#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f(n) for(int i = 0; i < n; ++i)
#define pb push_back
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef vector<int> vei;

struct sob {
    int x, t, ind;  //t = 0 open, t = 1 close
};

bool cmpx(sob a, sob b) {
    if(a.x == b.x) return a.t < b.t;
    return a.x < b.x;
}


struct DSU {
    vector<int> p, sz;

    DSU(int n) {
        p.resize(n);
        f(n) p[i] = i;
        sz.resize(n, 1);
    }

    int get_anc(int a) {
        if(p[a] == a) return a;
        p[a] = get_anc(a);
        return p[a];
    }

    void unite(int a, int b) {
        a = get_anc(a);
        b = get_anc(b);
        if(a==b) return;
        if(sz[a] > sz[b]) {
            sz[a] += sz[b];
            p[b] = a;
        }
        else {
            sz[b] += sz[a];
            p[a] = b;
        }
    }
};



void solve() {
    int n;
    cin>>n;
    vector<pair<int, int>> au(n);
    vector<sob> au2;
    vector<int> ls(n), rs(n);
    f(n) {
        int l, r;
        cin>>l>>r;
        ls[i] = l;
        rs[i] = r;
        au2.pb({l, 0, i});
        au2.pb({r, 1, i});
    }
    vector<vector<int>> bck(n);
    vector<int> ct(n);
    vector<int> mnn(n, -1);
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(i==j) continue;
            if(ls[i] <= ls[j] && rs[i] >= rs[j]) {
                bck[j].pb(i);
                ct[i]++;
            }
        }
    }
    for(int i = 0; i < n; ++i) {
        if(!bck[i].size()) continue;
        mnn[i] = bck[i][0];
        for(int j = 1; j < bck[i].size(); ++j) {
            if(ct[mnn[i]] > ct[bck[i][j]]) mnn[i] = bck[i][j];
        }
    }
    int m = 0;
    for(auto e : ct) if(!e) m++;
    int ctt = m / 2;
    vector<bool> used(n);
    while(ctt) {
        int mnind = -1;
        for(int i = 0; i < n; ++i) {
            if(used[i]) continue;
            if(mnind == -1) mnind = i;
            if(ct[i] < ct[mnind]) mnind = i;
            if(ct[i] == ct[mnind] && bck[i].size() < bck[mnind].size()) mnind = i;
        }
        used[mnind] = 1;
        ctt++;
        for(auto e : bck[mnind]) {
            ct[e]--;
            if(ct[e]==0) ctt++;
        }
    }
    ctt = (n - m) / 2;
    for(int i = 0; i < n; ++i) {
        if(!ctt) break;
        if(used[i]) continue;
        if(ct[i]) {
            ctt--;
            used[i] = 1;
        }
    }
    f(n) {
        if(!used[i]) cout<<i+1<<' ';
    }
    cout<<'\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    cin >> tc;
    for(int i = 0; i < tc; ++i) solve();
}