#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(57);

struct Node {
    Node *l, *r;
    int y;
    long long len, val, add, sum;
    int sz;

    Node(long long _len, long long _val) {
        l = r = nullptr;
        y = rnd();
        sum = len = _len, val = _val, add = 0;
        sz = 1;
    }
};

int sz(Node *root) {
    if (root) {
        return root->sz;
    }
    return 0;
}

long long sum(Node *root) {
    if (root) {
        return root->sum;
    }
    return 0;
}

void push(Node *root) {
    if (root) {
        if (root->add) {
            if (root->l) {
                root->l->val += root->add;
                root->l->add += root->add;
            }
            if (root->r) {
                root->r->val += root->add;
                root->r->add += root->add;
            }
        }
        root->add = 0;
    }
}

void relax(Node *root) {
    root->sz = sz(root->l) + 1 + sz(root->r);
    root->sum = sum(root->l) + root->len + sum(root->r);
}

Node *merge(Node *root1, Node *root2) {
    push(root1);
    push(root2);
    if (!root1) {
        return root2;
    }
    if (!root2) {
        return root1;
    }
    if (root1->y > root2->y) {
        root1->r = merge(root1->r, root2);
        relax(root1);
        return root1;
    } else {
        root2->l = merge(root1, root2->l);
        relax(root2);
        return root2;
    }
}

pair<Node*, Node*> split_by_key(Node *root, long long key) {
    if (!root) {
        return {nullptr, nullptr};
    }
    push(root);
    if (root->val > key) {
        auto [res1, res2] = split_by_key(root->l, key);
        root->l = res2;
        relax(root);
        return {res1, res2};
    } else {
        auto [res1, res2] = split_by_key(root->r, key);
        root->r = res1;
        relax(root);
        return {root, res2};
    }
}

pair<Node*, Node*> split_by_sz(Node *root, int sz_left) {
    if (!root) {
        return {nullptr, nullptr};
    }
    push(root);
    if (sz(root->l) >= sz_left) {
        auto [res1, res2] = split_by_sz(root->l, sz_left);
        root->l = res2;
        relax(root);
        return {res1, res2};
    } else {
        auto [res1, res2] = split_by_sz(root->r, sz_left - sz(root->l) - 1);
        root->r = res1;
        relax(root);
        return {root, res2};
    }
}

const int maxn = 5e3, maxv = 5e3;

// bool dp[maxn][maxv][maxv];
long long dp[maxn][maxv];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<long long> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w.begin(), w.end());
    // Node *root dp = 
    dp[0][0] = 0;
    for (int a = 1; a < maxv; ++a) {
        dp[0][a] = -1;
    }
    for (int i = 0; i < n; ++i) {
        for (int a = 0; a < maxv; ++a) {
            dp[i + 1][a] = dp[i][a];
        }
        for (int a = 0; a < maxv; ++a) {
            if (dp[i][a] != -1 && w[i] <= dp[i][a] + 1) {
                dp[i + 1][a] = max(dp[i + 1][a], dp[i][a] + w[i]);
            }
            if (dp[i][a] != -1 && a + w[i] < maxv) {
                dp[i + 1][a + w[i]] = max(dp[i + 1][a + w[i]], dp[i][a]);
            }
        }
        for (int a = 1; a < maxv; ++a) {
            dp[i + 1][a] = min(dp[i + 1][a], dp[i + 1][a - 1]);
        }
        for (int a = 1; a + 1 < maxv; ++a) {
            if (dp[i + 1][a - 1] - dp[i + 1][a] < dp[i + 1][a] - dp[i + 1][a - 1]) {
                exit(1);
            }
        }
    }
    int z;
    cin >> z;
    while (q--) {
        long long j, c, d;
        cin >> j >> c >> d;
        int pos = upper_bound(w.begin(), w.end(), j) - w.begin();
        if (c > d) {
            swap(c, d);
        }
        if (dp[pos][c] >= d) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
