#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
#define xyi long long

std::vector<std::pair<int, int>> g;
std::vector<bool> is_leaf;
std::vector<int> dp;
int k;

int dfuck(int node, int d = 0, int prev_type = -1) {
    if (d > k) {
        return 0;
    }
    if (is_leaf[node]) {
        return dp[node] = 1;
    }
    if (prev_type == -1) {
        return dp[node] = dfuck(g[node].first, d, 0) + dfuck(g[node].second, d, 1);
    }
    if (prev_type == 0) {
        return dp[node] = dfuck(g[node].first, d, 0) + dfuck(g[node].second, d + 1, 1);
    }
    if (prev_type == 1) {
        return dp[node] = dfuck(g[node].first, d + 1, 0) + dfuck(g[node].second, d, 1);
    }
}

int main() {
    int n, q;
    std::cin >> n >> k >> q;
    g.resize(n);
    is_leaf.resize(n, false);
    for (int i = 0; i < n; i++) {
        int t;
        std::cin >> t;
        is_leaf[i] = !t;
        if (t == 2) {
            int u, v;
            std::cin >> u >> v;
            u--; v--;
            g[i] = {u, v};
        }
    }
    dp.resize(n);
    dfuck(0);
    for (int i = 0; i < q; i++) {
        int u;
        std::cin >> u;
        u--;
        std::cout << dp[u] << '\n';
    }
    return 0;
}
