#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#define ll long long
#define xyi long long

void slave() {
    int n;
    std::cin >> n;
    std::vector<std::pair<int, int>> seg(n);
    for (auto &[l, r] : seg) {
        std::cin >> l >> r;
    }
    auto get([&](std::vector<std::pair<int, int>> &s){
        std::set<std::pair<int, int>> set;
        std::sort(s.begin(), s.end());
        std::vector<int> dp(seg.size(), 0);
        int max = 0;
        int ans = 0;
        for (int i = 0; i < s.size(); i++) {
            auto [l, r] = s[i];
            while (!set.empty() && set.begin()->first < l) {
                max = std::max(max, set.begin()->second);
                set.erase(set.begin());
            }
            dp[i] = max + 1;
            set.insert({r, dp[i]});
            ans = std::max(ans, dp[i]);
        }
        return ans;
    });
    auto s = seg;
    int m = get(s);
    for (int mask = 0; mask < (1 << n); mask++) {
        int cnt = 0;
        s.clear();
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                cnt++;
                s.push_back(seg[i]);
            }
        }
        if (cnt != n / 2) {
            continue;
        }
        if (get(s) == m / 2) {
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    std::cout << i + 1 << ' ';
                }
            }
            std::cout << '\n';
            break;
        }
    }
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        slave();
    }
}