#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#else
#define _GLIBCXX_DEBUG
#endif
using namespace std;
typedef long long ll;

struct Point {
    ll x, y;
};
ll h, v, k;
vector<Point> pts_x, pts_y;
ll u, d, l, r;

bool srt_x(Point p1, Point p2) {
    if (p1.x == p2.x) {
        return p1.y < p2.y;
    }
    return p1.x < p2.x;
}

bool srt_y(Point p1, Point p2) {
    if (p1.y == p2.y) {
        return p1.x < p2.x;
    }
    return p1.y < p2.y;
}

ll inside() {
    ll y_min = 1e9, y_max = -1e9;
    for (auto &p: pts_x) {
        y_max = max(y_max, p.y);
        y_min = min(y_min, p.y);
    }
    u = pts_x[0].x;
    d = pts_x.back().x;
    l = y_min;
    r = y_max;
    return (pts_x.back().x - pts_x[0].x + 1) * (y_max - y_min + 1);
}

ll horizontal_cut() {
    ll y_min = 1e9, y_max = -1e9;
    for (auto &p: pts_x) {
        y_max = max(y_max, p.y);
        y_min = min(y_min, p.y);
    }
    l = y_min;
    r = y_max;
    ll ans = 1e18;
    for (int i = 0; i < pts_x.size() - 1; i++) {
        ll calc = (y_max - y_min + 1) * (pts_x[i].x + (h - pts_x[i + 1].x) + 1);
        if (ans > calc) {
            ans = calc;
            d = pts_x[i].x;
            u = pts_x[i + 1].x;
        }
    }
    return ans;
}

ll vertical_cut() {
    ll x_min = 1e9, x_max = -1e9;
    for (auto &p: pts_y) {
        x_max = max(x_max, p.x);
        x_min = min(x_min, p.x);
    }
    d = x_max;
    u = x_min;
    ll ans = 1e18;
    for (int i = 0; i < pts_y.size() - 1; i++) {
        ll calc = (x_max - x_min + 1) * (pts_y[i].y + (v - pts_y[i + 1].y) + 1);
        if (ans > calc) {
            ans = calc;
            l = pts_y[i + 1].y;
            r = pts_y[i].y;
        }
    }
    return ans;
}

ll separated() {
    ll ans = 1e18;
    for (int i = 0; i < pts_x.size() - 1; i++) {
        for (int j = 0; j < pts_y.size() - 1; j++) {
            ll height = (pts_x[i].x + h - pts_x[i + 1].x);
            ll width = (pts_y[j].y + v - pts_y[j + 1].y);
            ll calc = (height + 1) * (width + 1);
            if (ans > calc) {
                ans = calc;
                d = pts_x[i].x;
                u = pts_x[i + 1].x;
                l = pts_y[j + 1].y;
                r = pts_y[j].y;
            }
        }
    }
    return ans;
}

void solve() {
    cin >> h >> v >> k;
    pts_x.resize(k);
    for (auto &p: pts_x) {
        cin >> p.x >> p.y;
        pts_y.push_back(p);
    }
    sort(pts_x.begin(), pts_x.end(), srt_x);
    sort(pts_y.begin(), pts_y.end(), srt_y);
    ll ans = 1e18, l1, r1, u1, d1;
    ll calc = inside();
    if (calc < ans) {
        ans = calc;
        r1 = r;
        u1 = u;
        l1 = l;
        d1 = d;
    }
    calc = horizontal_cut();
    if (calc < ans) {
        ans = calc;
        r1 = r;
        u1 = u;
        l1 = l;
        d1 = d;
    }

    calc = vertical_cut();
    if (calc < ans) {
        ans = calc;
        r1 = r;
        u1 = u;
        l1 = l;
        d1 = d;
    }
    calc = separated();
    if (calc < ans) {
        ans = calc;
        r1 = r;
        u1 = u;
        l1 = l;
        d1 = d;
    }
    cout << ans << " ";
    ll moves = 0;
    if (r1 < l1) {
        moves += min(r1, (v - l1 + 1));
    }
    if (u1 > d1) {
        moves += min(d1, (h - u1 + 1));
    }
    cout << moves;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}