#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#else
#define _GLIBCXX_DEBUG
#endif
using namespace std;
typedef long long ll;

struct Point {
    ll x, y;
};
ll h, v, k;
vector<Point> pts_x, pts_y;

bool srt_x(Point p1, Point p2) {
    if (p1.x == p2.x) {
        return p1.y < p2.y;
    }
    return p1.x < p2.x;
}

bool srt_y(Point p1, Point p2) {
    if (p1.y == p2.y) {
        return p1.x < p2.x;
    }
    return p1.y < p2.y;
}

pair<ll, ll> inside() {
    ll y_min = 1e9, y_max = -1e9;
    for (auto &p: pts_x) {
        y_max = max(y_max, p.y);
        y_min = min(y_min, p.y);
    }
    return {(pts_x.back().x - pts_x[0].x + 1) * (y_max - y_min + 1), 0};
}

pair<ll, ll> horizontal_cut() {
    ll y_min = 1e9, y_max = -1e9;
    for (auto &p: pts_x) {
        y_max = max(y_max, p.y);
        y_min = min(y_min, p.y);
    }
    ll d, u;
    ll ans = 1e18;
    for (int i = 0; i < k - 1; i++) {
        ll calc = (y_max - y_min + 1) * (pts_x[i].x + (h - pts_x[i + 1].x) + 1);
        if (ans > calc) {
            ans = calc;
            d = pts_x[i].x;
            u = pts_x[i + 1].x;
        }
    }
    return {ans, min(d, (h - u + 1))};
}

pair<ll, ll> vertical_cut() {
    ll x_min = 1e9, x_max = -1e9;
    for (auto &p: pts_y) {
        x_max = max(x_max, p.x);
        x_min = min(x_min, p.x);
    }
    ll l, r;
    ll ans = 1e18;
    for (int i = 0; i < k - 1; i++) {
        ll calc = (x_max - x_min + 1) * (pts_y[i].y + (v - pts_y[i + 1].y) + 1);
        if (ans > calc) {
            ans = calc;
            l = pts_y[i + 1].y;
            r = pts_y[i].y;
        }
    }
    return {ans, min(r, (v - l + 1))};
}

pair<ll, ll> separated() {
    ll ans = 1e18;
    ll l, d, u, r;
    for (int i = 0; i < k - 1; i++) {
        for (int j = 0; j < k - 1; j++) {
            ll height = (pts_x[i].x + h - pts_x[i + 1].x);
            ll width = (pts_y[j].y + v - pts_y[j + 1].y);
            ll calc = (height + 1) * (width + 1);
            if (ans > calc) {
                ans = calc;
                d = pts_x[i].x;
                u = pts_x[i + 1].x;
                l = pts_y[j + 1].y;
                r = pts_y[j].y;
            }
        }
    }
    return {ans, min(r, (v - l + 1)) + min(d, (h - u + 1))};
}

void h_1() {
    ll ans = 1e18;
    ll l = -1, r = -1;
    for (int i = 0; i < k; k++) {
        ll calc = (pts_y[i].y + (v - pts_y[i + 1].y) + 1);
        if (calc < ans) {
            ans = calc;
            l = pts_y[i + 1].y;
            r = pts_y[i].y;
        }
    }
    cout << ans << " ";
}

void solve() {
    cin >> h >> v >> k;
    pts_x.resize(k);
    for (auto &p: pts_x) {
        cin >> p.x >> p.y;
        pts_y.push_back(p);
    }
    sort(pts_x.begin(), pts_x.end(), srt_x);
    sort(pts_y.begin(), pts_y.end(), srt_y);
    vector<pair<ll, ll>> cand = {inside(), horizontal_cut(), vertical_cut(), separated()};
    sort(cand.begin(), cand.end());
    cout << cand[0].first << " " << cand[0].second;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}