#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9+7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector < ll >&a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

ll n, k, q;
vector < ll > l, r;
vector < bool > is_list;

vector < ll > cnt;

void dfs(ll v, ll can, bool fl) { // 0-left, 1-right;
    if (is_list[v]) {
        cnt[v] = 1;
        return;
    }
    if (can || !fl) dfs(l[v], can - fl, 0);
    if (can || fl) dfs(r[v], can - (!fl), 1);
    cnt[v] = cnt[l[v]] + cnt[r[v]];
}

void solve() {
    cin >> n >> k >> q;
    r.resize(n, -1);
    l.resize(n, -1);
    cnt.resize(n, 0);
    is_list.resize(n, true);
    for (ll i = 0; i < n; i++) {
        ll x;
        cin >> x;
        if (x == 0) continue;
        is_list[i] = false;
        cin >> l[i];
        cin >> r[i];
        l[i]--;
        r[i]--;
    }

    if (!is_list[0]) {
        dfs(l[0], k, 0);
        dfs(r[0], k, 1);
        cnt[0] = cnt[r[0]] + cnt[l[0]];
    }
    else cnt[0] = 1;

    while (q--) {
        ll x;
        cin >> x;
        x--;
        cout << cnt[x] << '\n';
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
