#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9 + 7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector<ll> &a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

struct point {
    ll x, fl, id;

    bool operator<(const point &other) {
        if (x == other.x) return fl < other.fl;
        return x < other.x;
    }
};

map<ll, vector<ll >> good;

bool comp(ll a, ll b) {
    return good[a].size() < good[b].size();
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll >> a(n);
    forall(i, a) cin >> i.first >> i.second;

    sort(all(a));
    ll m = 0;
    for (ll mask = 0; mask < (1ll << n); mask++) {
        ll cnt = 0;
        for (ll i = 0; i < n; i++) if (mask & (1ll << i)) cnt++;
        bool fl = true;
        vector < ll > now;
        for (ll i = 0; i < n; i++) if (mask & (1ll << i)) now.push_back(i);
        for (ll i = 0; i < cnt - 1; i++) {
            if (a[now[i]].second >= a[now[i + 1]].first || a[now[i]].first == a[now[i + 1]].first) fl = false;
        }
        if (fl ) m = max(m, cnt);
    }


    for (ll mask = 0; mask < (1ll << n); mask++) {
        ll cnt = 0;
        for (ll i = 0; i < n; i++) if (mask & (1ll << i)) cnt++;
        if (cnt != n / 2) continue;

        vector<ll> now;
        for (ll i = 0; i < n; i++) if (mask & (1ll << i)) now.push_back(i);

        ll ansnow = 0;
        for (ll mask1 = 0; mask1 < (1ll << cnt); mask1++) {
            ll cnt1 = 0;
            for (ll i = 0; i < cnt; i++) if (mask1 & (1ll << i)) cnt1++;

            bool fl = true;
            vector < ll > now1;
            for (ll i = 0; i < cnt; i++) if (mask1 & (1ll << i)) now1.push_back(now[i]);
            for (ll i = 0; i < cnt1 - 1; i++) {
                if (a[now1[i]].second >= a[now1[i + 1]].first || a[now1[i]].first == a[now1[i + 1]].first) fl = false;
            }
            if (fl ) ansnow = max(ansnow, cnt1);
        }

        if (ansnow == m / 2) {
            forall(i, now) cout << i + 1 << ' ';
            cout << '\n';
            return;
        }
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
