#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9 + 7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector<ll> &a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

struct p{
    ll x, y, id;

    bool operator<(p& other) {
        if (y != other.y) return y < other.y;
        return x < other.x;
    }
};

void solve() {
    ll n, q, k;
    bool fl = true;
    cin >> n >> q;
    vector < ll > a(n);
    vector < vector < ll >> need(q, vector < ll > (3));
    forall(i, a) cin >> i;
    cin >> k;
    forall(i, need) {
        cin >> i[0] >> i[1] >> i[2];
        if (i[2]) fl = false;
    }
    sort(all(a));

    if (fl) {
        ll s = 0;
        forall(i, a) {
            if (s >= i - 1) s += i;
            else break;
        }

        vector < ll > pref(n + 1, 0);
        for (ll i = 0; i < n; i++) pref[i + 1] = pref[i] + a[i];

        ll mx = s;
        for (ll i = 0; i < q; i++) {
            ll x=need[i][0], y=need[i][1], z=need[i][2];
//            cin >> x >> y >> z;
            if (min(mx, pref[upper_bound(all(a), x) - a.begin()]) >= y) cout << "Yes\n";
            else cout << "No\n";
        }
        return;
    }

    if (n <= 10 && q <= 10) {
        forall(now, need) {
            ll kk = -1;
            while (kk < n - 1 && a[kk + 1] <= now[0]) kk++;
            kk++;

            set<pair<ll, ll >> s;

            for (ll mask = 0; mask < (1ll << kk); mask++) {
                vector<ll> vv;
                for (ll i = 0; i < kk; i++) if (mask & (1ll << i)) vv.push_back(a[i]);
                ll kk1 = vv.size();

                for (ll mask1 = 0; mask1 < (1ll << kk1); mask1++) {
                    ll s1 = 0, s2 = 0;
                    for (ll i = 0; i < kk1; i++) {
                        if (mask1 & (1ll << i)) s1 += vv[i];
                        else s2 += vv[i];
                    }
                    s.insert({s1, s2});
                }
            }

            fl = true;
            for (ll i = 0; i <= now[1]; i++) {
                for (ll j = 0; j <= now[2]; j++) {
                    if (s.find({i, j}) == s.end()) fl = false;
//                if (!fl) cout << i << ' ' << j << endl;
                    if (!fl) break;
                }
                if (!fl) break;
            }
            if (fl) cout << "Yes\n";
            else cout << "No\n";
        }
        return;
    }

    set < pair < ll, ll >> s;
    s.insert({0, 0});
    forall(i, a) {
        set < pair < ll, ll >> now = s;
        forall(j, now) {
            if (j.first + i <= 1000) s.insert({j.first + i, j.second});
            if ( j.second + i <= 1000) s.insert({j.first, j.second + i});
        }
    }
    vector < vector < bool >> can(1001, vector < bool > (1001, false));

    for (ll i = 0; i <= 1000; i++) {
        for (ll j = 0; j <= 1000; j++) {
            can[i][j] = true;
            if (i && !can[i - 1][j]) can[i][j] = false;
            if (j && !can[i][j - 1]) can[i][j] = false;
            if (s.find({i, j}) == s.end()) can[i][j] = false;
        }
    }

    forall(i, need) {
        if (can[i[1]][i[2]]) cout << "Yes\n";
        else cout << "No\n";
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}