#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

struct Event {
    int l, r, id;
};

struct SegTree {
    int n;
    vector<pii> tree;

    SegTree() = default;
    SegTree(int n) : n(n), tree(2 * n, {0, -1}) {}

    void update(int i, int val, int id) {
        i += n;
        if (tree[i].first > val) {
            return;
        }
        tree[i] = {val, id};
        i /= 2;
        while (i > 0) {
            tree[i] = max(tree[2 * i], tree[2 * i + 1]);
            i /= 2;
        }
    }

    pii get(int l, int r) {
        l += n;
        r += n;
        pii ans = {0, -1};
        while (l < r) {
            if (l & 1) {
                ans = max(ans, tree[l++]);
            }
            if (r & 1) {
                ans = max(ans, tree[--r]);
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<Event> a(n), A;
    vector<int> b;
    b.reserve(2 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].id = i;
        b.emplace_back(a[i].l);
        b.emplace_back(a[i].r);
    }
    A = a;
    b.emplace_back(-1);
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    for (auto &[l, r, id] : a) {
        l = (int)(lower_bound(all(b), l) - b.begin());
        r = (int)(lower_bound(all(b), r) - b.begin());
    }
    sort(all(a), [](Event lhs, Event rhs) {
        return (lhs.r < rhs.r);
    });

    int m = 0;

    vector<int> used(n, 0);
    {
        vector<int> par(n, -1);
        SegTree tr(sz(b));
        for (auto &[l, r, id] : a) {
            auto p = tr.get(0, l);
            int cur = 1 + p.first;
            par[id] = p.second;
            tr.update(r, cur, id);
        }
        auto p = tr.get(0, sz(b));
        m = p.first;
        int k = p.second;
        while (k != -1) {
            used[k] = 1;
            k = par[k];
        }
    }

    vector<int> in, out;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            in.emplace_back(i);
        } else {
            out.emplace_back(i);
        }
    }

    sort(all(in), [&](int lhs, int rhs) {
        return A[lhs].r - A[lhs].l > A[rhs].r - A[rhs].l;
    });
    sort(all(out), [&](int lhs, int rhs) {
        return A[lhs].r - A[lhs].l < A[rhs].r - A[rhs].l;
    });

    int x = n / 2, y = m / 2, k = x - y;
    for (int i = y; i < sz(in); ++i) {
        cout << in[i] + 1 << ' ';
    }
    for (int i = k; i < sz(out); ++i) {
        cout << out[i] + 1 << ' ';
    }
    cout << en;

//    cerr << m << endl;

//    for (int mask = 0; mask < (1 << n); ++mask) {
//        int cnt = 0;
//        for (int i = 0; i < n; ++i) {
//            if (mask & (1 << i)) {
//                ++cnt;
//            }
//        }
//        if (cnt != n / 2) {
//            continue;
//        }
//        vector<Event> c;
//        for (int i = 0; i < n; ++i) {
//            if (mask & (1 << i)) {
//                c.emplace_back(a[i]);
//            }
//        }
//        SegTree tr(sz(b));
//        for (auto &[l, r, id] : c) {
//            int cur = 1 + tr.get(0, l).first;
//            tr.update(r, cur, id);
//        }
//        int mm = tr.get(0, sz(b)).first;
//        if (mm * 2 == m) {
//            for (int i = 0; i < n; ++i) {
//                if (mask & (1 << i)) {
//                    cout << a[i].id + 1 << ' ';
//                }
//            }
//            cout << en;
//            return;
//        }
//    }
//    assert(0);
}

void stupid() {
    int n;
    cin >> n;
    vector<Event> a(n);
    vector<int> b;
    b.reserve(2 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].id = i;
        b.emplace_back(a[i].l);
        b.emplace_back(a[i].r);
    }
    b.emplace_back(-1);
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    for (auto &[l, r, id] : a) {
        l = (int)(lower_bound(all(b), l) - b.begin());
        r = (int)(lower_bound(all(b), r) - b.begin());
    }
    sort(all(a), [](Event lhs, Event rhs) {
        return (lhs.r < rhs.r);
    });

    int m = 0;

    {
        SegTree tr(sz(b));
        for (auto &[l, r, id] : a) {
            int cur = 1 + tr.get(0, l).first;
            tr.update(r, cur, id);
        }
        m = tr.get(0, sz(b)).first;
    }
//    cerr << m << endl;

    for (int mask = 0; mask < (1 << n); ++mask) {
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                ++cnt;
            }
        }
        if (cnt != n / 2) {
            continue;
        }
        vector<Event> c;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                c.emplace_back(a[i]);
            }
        }
        SegTree tr(sz(b));
        for (auto &[l, r, id] : c) {
            int cur = 1 + tr.get(0, l).first;
            tr.update(r, cur, id);
        }
        int mm = tr.get(0, sz(b)).first;
        if (mm * 2 == m) {
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    cout << a[i].id + 1 << ' ';
                }
            }
            cout << en;
            return;
        }
    }
    assert(0);
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
