#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(666);

struct Event {
    int l, r, id;
};

struct SegTree {
    int n;
    vector<int> tree;

    SegTree() = default;
    SegTree(int n) : n(n), tree(2 * n) {}

    void update(int i, int val) {
        i += n;
        if (tree[i] > val) {
            return;
        }
        tree[i] = val;
        i /= 2;
        while (i > 0) {
            tree[i] = max(tree[2 * i], tree[2 * i + 1]);
            i /= 2;
        }
    }

    int get(int l, int r) {
        l += n;
        r += n;
        int ans = 0;
        while (l < r) {
            if (l & 1) {
                ans = max(ans, tree[l++]);
            }
            if (r & 1) {
                ans = max(ans, tree[--r]);
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<Event> a(n), A;
    vector<int> b;
    b.reserve(2 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].id = i;
        b.emplace_back(a[i].l);
        b.emplace_back(a[i].r);
    }
    A = a;
    b.emplace_back(-1);
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    for (auto &[l, r, id] : a) {
        l = (int)(lower_bound(all(b), l) - b.begin());
        r = (int)(lower_bound(all(b), r) - b.begin());
    }
    sort(all(a), [](Event lhs, Event rhs) {
        return (lhs.r < rhs.r);
    });

    int m = 0;

    {
        SegTree tr(sz(b));
        for (auto &[l, r, id] : a) {
            int cur = 1 + tr.get(0, l);
            tr.update(r, cur);
        }
        m = tr.get(0, sz(b));
    }

//    cerr << m << endl;

    vector<vector<int>> adds(sz(b));
    vector<vector<int>> dels(sz(b));
    for (int i = 0; i < n; ++i) {
        adds[a[i].l].emplace_back(a[i].id);
        dels[a[i].r].emplace_back(a[i].id);
    }
//    tree.resize(n);
    vector<int> par(n, -1);
    vector<int> cnt(n, 0);
    vector<int> in(n);
    vector<int> out(n);
//    set<pii> cur;
    vector<int> st = {-1};
    vector<set<int>> tree(n);
    for (int t = 1; t < sz(b); ++t) {
        sort(all(adds[t]), [&](int i, int j) {
            return A[i].r - A[i].l > A[j].r - A[j].l;
        });
        for (auto i : adds[t]) {
            par[i] = st.back();
            if (par[i] != -1) {
                ++cnt[par[i]];
                tree[par[i]].emplace(i);
            }
            st.emplace_back(i);
        }
        for (auto i : dels[t]) {
            assert(i == st.back());
            st.pop_back();
        }
    }
    int x = m / 2, y = n / 2;
    set<pii> cur;
    for (int i = 0; i < n; ++i) {
        if (cnt[i] == 0) {
            int flag = 0;
            if (par[i] != -1) {
                flag = cnt[par[i]] == 1;
            }
            cur.emplace(flag, i);
        }
    }
    vector<int> take(n, 1);
    while (x > 0 || y > 0) {
        pii p;
        if (x != y) {
            p = *cur.rbegin();

        } else {
            p = *cur.begin();
        }
        int v = p.second;
        cur.erase(p);
        --x;
        y -= (p.first == 0);
        take[v] = 0;
        int u = par[v];
        if (u != -1) {
            --cnt[u];
            tree[u].erase(v);
            if (cnt[u] == 0) {
                int flag = 0;
                if (par[u] != -1) {
                    flag = cnt[par[u]] == 1;
                }
                cur.emplace(flag, u);
            }
            if (cnt[u] == 1) {
                int nxt = *tree[u].begin();
                cur.erase({0, nxt});
                cur.emplace(1, nxt);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (take[i]) {
            cout << i + 1 << ' ';
        }
    }
    cout << en;
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
