#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "unordered_set"
#include "algorithm"

#define int long long
#define all(x) (x).begin(), (x).end()

using namespace std;

struct ver {
    int num, l, r;
    int ls = -1, rs = -1;
};

vector<ver> tree;

const int MAXN = 3e5;

int free_lft(int v, int x) {
    if (tree[v].r - tree[v].l == tree[v].num) return -1;
    if (tree[v].r - tree[v].l == 1) return tree[v].l;
    int md = (tree[v].l + tree[v].r) / 2;
    if (x < md) {
        if (tree[v].ls == -1) return x;
        return free_lft(tree[v].ls, x);
    } else {
        if (tree[v].rs == -1) return x;
        int tr = free_lft(tree[v].rs, x);
        if (tr == -1) {
            if (tree[v].ls == -1) return md - 1;
            return free_lft(tree[v].ls, md - 1);
        }
        return tr;
    }
}

int free_rght(int v, int x) {
    if (tree[v].r - tree[v].l == tree[v].num) return -1;
    if (tree[v].r - tree[v].l == 1) return tree[v].l;
    int md = (tree[v].l + tree[v].r) / 2;
    if (x >= md) {
        if (tree[v].rs == -1) return x;
        return free_rght(tree[v].rs, x);
    } else {
        if (tree[v].ls == -1) return x;
        int tr = free_rght(tree[v].ls, x);
        if (tr == -1) {
            if (tree[v].rs == -1) return md;
            return free_rght(tree[v].rs, md);
        }
        return tr;
    }
}

void add(int v, int x) {
    tree[v].num++;
    if (tree[v].r - tree[v].l == 1) return;
    int md = (tree[v].l + tree[v].r) / 2;
    if (x < md) {
        if (tree[v].ls == -1) {
            tree[v].ls = tree.size();
            tree.push_back({0, tree[v].l, md});
        }
        add(tree[v].ls, x);
    } else {
        if (tree[v].rs == -1) {
            tree[v].rs = tree.size();
            tree.push_back({0, md, tree[v].r});
        }
        add(tree[v].rs, x);
    }
}

void solve1() {
    int n, k; cin >> n >> k;
    int sz = 1;
    while (sz < MAXN) sz *= 2;
    tree.push_back({0, 0, sz});
    vector<int> inp;
    for (int i = 0; i < k; ++i) {
        int x; cin >> x;
        inp.push_back(x);
        add(0, x);
    }
    vector<int> outp;
    for (int i = 0; i < k; ++i) {
        int tr = free_rght(0, inp[i]);
        if (tr == n + 1) tr = free_rght(0, 1);
        outp.push_back(tr);
        add(0, tr);
    }
    sort(all(outp));
    for (auto el: outp) {
        cout << el << " ";
    }
    cout << endl;
}

void solve2() {
    int n, k; cin >> n >> k;
    int sz = 1;
    while (sz < MAXN) sz *= 2;
    tree.push_back({0, 0, sz});
    vector<int> inp;
    for (int i = 0; i < k; ++i) {
        int x; cin >> x;
        inp.push_back(x);
        add(0, x);
    }
    vector<int> outp;
    for (int i = 0; i < k; ++i) {
        int tr = free_lft(0, inp[i]);
        if (tr == 0) tr = free_lft(0, n);
        outp.push_back(tr);
        add(0, tr);
    }
    sort(all(outp));
    for (auto el: outp) {
        cout << el << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int casee; cin >> casee;
    int test; cin >> test;
    while (test--) {
        tree.clear();
        if (casee == 1) {
            solve1();
        } else {
            solve2();
        }
    }
}