#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "unordered_set"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

ll M;
int num;
int k, n, p;

int mex(vector<int> &a) {
    if (a[0] != 0) return 0;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] + 1 != a[i + 1]) return a[i] + 1;
    }
    return a.back() + 1;
}

const ll MOD = 1791791791, K = 1e5 + 7;

ll get_hash(vector<int> &a) {
    ll h = 0;
    for (auto el: a) {
        h *= K;
        h %= MOD;
        h += el;
        h %= MOD;
    }
    return h;
}

const int LIM = 1e4;

bool ok(vector<int> &a) {
    set<ll> hashs;
    int m = mex(a);
    hashs.insert(get_hash(a));
    int opers = 0;
    while (opers < LIM) {
        for (int i = 0; i < n; ++i) {
            a[i] = a[i] ^ (m - 1);
        }
        sort(all(a));
        m = mex(a);
        ll h = get_hash(a);
        if (hashs.find(h) == hashs.end()) {
            hashs.insert(h);
        } else {
            return m == p;
        }
        opers++;
    }
    return false;
}

void solve() {
    cin >> k >> n >> p;
    num = (1 << k) - 1;
    ll ans = 0;
    for (int i = 0; i < (1 << num); ++i) {
        int ones = 0;
        for (int j = 0; j < num; ++j) {
            ones += (i >> j) % 2;
        }
        if (ones != n - 1) continue;
        vector<int> a = {0};
        for (int j = 0; j < num; ++j) {
            if ((i >> j) % 2) {
                a.push_back(j + 1);
            }
        }
        if (ok(a)) {
            ans++;
            ans %= M;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> M;
    int test; cin >> test;
    while (test--) {
        solve();
    }
}
