#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "unordered_set"
#include "algorithm"
#include "map"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

ll M;
int num;
int k, n, p;

map<pair<int, int>, ll> mp = {
        {{1, 1}, 1},
        {{2, 1}, 14},
        {{2, 2}, 1},
        {{3, 1}, 93},
        {{3, 2}, 12},
        {{4, 1}, 388},
        {{4, 2}, 66},
        {{4, 4}, 1},
        {{5, 1}, 1135},
        {{5, 2}, 220},
        {{5, 4}, 10},
        {{6, 1}, 2461},
        {{6, 2}, 497},
        {{6, 4}, 45},
        {{7, 1}, 4077},
        {{7, 2}, 808},
        {{7, 4}, 120},
        {{8, 1}, 5244},
        {{8, 2}, 980},
        {{8, 4}, 210},
        {{8, 8}, 1},
        {{9, 1}, 5273},
        {{9, 2}, 904},
        {{9, 4}, 252},
        {{9, 8}, 6},
        {{10, 1}, 4143},
        {{10, 2}, 637},
        {{10, 4}, 210},
        {{10, 8}, 15},
        {{11, 1}, 2524},
        {{11, 2}, 339},
        {{11, 4}, 120},
        {{11, 8}, 20},
        {{12, 1}, 1172},
        {{12, 2}, 131},
        {{12, 4}, 47},
        {{12, 8}, 15},
        {{13, 1}, 402},
        {{13, 2}, 33},
        {{13, 4}, 14},
        {{13, 8}, 6},
        {{14, 1}, 94},
        {{14, 2}, 7},
        {{14, 4}, 3},
        {{14, 8}, 1},
        {{15, 1}, 15},
        {{16, 16}, 1},
};

int mex(vector<int> &a) {
    if (a[0] != 0) return 0;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] + 1 != a[i + 1]) return a[i] + 1;
    }
    return a.back() + 1;
}

const ll MOD = 1791791791, K = 1e5 + 7;

ll get_hash(vector<int> &a) {
    ll h = 0;
    for (auto el: a) {
        h *= K;
        h %= MOD;
        h += el;
        h %= MOD;
    }
    return h;
}

const int LIM = 1e4;

bool ok(vector<int> &a) {
    set<ll> hashs;
    int m = mex(a);
    hashs.insert(get_hash(a));
    int opers = 0;
    while (opers < LIM) {
        for (int i = 0; i < n; ++i) {
            a[i] = a[i] ^ (m - 1);
        }
        sort(all(a));
        m = mex(a);
        ll h = get_hash(a);
        if (hashs.find(h) == hashs.end()) {
            hashs.insert(h);
        } else {
            return m == p;
        }
        opers++;
    }
    return false;
}

void mysolve() {
    num = (1 << k) - 1;
    ll ans = 0;
    for (int i = 0; i < (1 << num); ++i) {
        int ones = 0;
        for (int j = 0; j < num; ++j) {
            ones += (i >> j) % 2;
        }
        if (ones != n - 1) continue;
        vector<int> a = {0};
        for (int j = 0; j < num; ++j) {
            if ((i >> j) % 2) {
                a.push_back(j + 1);
            }
        }
        if (ok(a)) {
            ans++;
            ans %= M;
        }
    }
    cout << ans << '\n';
}

void solve() {
    cin >> k >> n >> p;
    if (k <= 3) {
        mysolve();
        return;
    }
    cout << mp[{n, p}] % M << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> M;
    int test; cin >> test;
    while (test--) {
        solve();
    }
}