#include <iostream>
#include "vector"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

struct seg {
    int l, r;
};

bool cmp(seg a, seg b) {
    if (a.r == b.r) {
        return a.l > b.l;
    }
    return a.r < b.r;
}

vector<bool> used;

int calc(vector<seg> &segs) {
    int m = 0, last = -1;
    for (int i = 0; i < segs.size(); i++) {
        if (used[i]) continue;
        if (segs[i].l > last) {
            last = segs[i].r;
            m++;
        }
    }
    return m;
}

void solve() {
    int n; cin >> n;
    vector<seg> segs(n);
    for (int i = 0; i < n; ++i) {
        cin >> segs[i].l >> segs[i].r;
    }
    sort(all(segs), cmp);
    used.assign(n, false);
    int m = calc(segs);
    for (int i = 0; i < (1 << n); ++i) {
        int ones = 0;
        for (int j = 0; j < n; ++j) {
            if ((i >> j) % 2) {
                ones++;
                used[j] = false;
            } else {
                used[j] = true;
            }
        }
        if (ones * 2 != n) continue;
        int m1 = calc(segs);
        if (m1 * 2 == m) {
            for (int j = 0; j < n; ++j) {
                if ((i >> j) % 2) {
                    cout << j + 1 << " ";
                }
            }
            cout << '\n';
            break;
        }
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}
