#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;

#define len(a) (ll) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;

ll n, k, Q;
vector <ll> l, r, dp, ans;
vector <vector <ll>> good;

void dfs(ll v, ll nap) { // l = 0, r = 1
    if (l[v] != -1 && r[v] != -1) {
        dp[l[v]] = dp[r[v]] = dp[v];
        if (nap == 0)
            dp[r[v]]++;
        else if (nap == 1)
            dp[l[v]]++;
        dfs(l[v], 0);
        dfs(r[v], 1);
    }
}

void find(ll v) {
    if (l[v] != -1 && r[v] != -1) {
        find(l[v]);
        find(r[v]);
        ans[v] = ans[l[v]] + ans[r[v]];
    } else if (dp[v] <= k) {
        ans[v]++;
    }
}

void solve() {
    cin >> n >> k >> Q;
    l.resize(n, -1), r.resize(n, -1), dp.resize(n, INF);
    ans.resize(n), good.resize(n);
    dp[0] = 0;
    for (ll i = 0; i < n; i++) {
        ll t; cin >> t;
        if (t == 2) {
            cin >> l[i] >> r[i];
            l[i]--, r[i]--;
        }
    }
    dfs(0, -1);
    find(0);
    for (ll i = 0; i < Q; i++) {
        ll u; cin >> u; u--;
        cout << ans[u] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
