#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

struct segtree {

	segtree() {}
	segtree(int n) : n(n) {
		v.resize(n * 4, 0);
		pb.resize(n * 4, -2);
	}

	void set(int l, int r, int x) {
		set(l, r, x, 0, 0, n - 1);
	}

	int get(int l, int r) {
		return get(l, r, 0, 0, n - 1);
	}

	int get(int x) {
		int pos = 0, tl = 0, tr = n - 1;
		while (tl != tr) {
			if (pb[pos] != -2) return pb[pos];
			int m = (tl + tr) / 2;
			if (x <= m) pos = pos * 2 + 1, tr = m;
			else pos = pos * 2 + 2, tl = m + 1;
		}
		return v[pos];
	}

	void push(int pos) {
		if (pb[pos] == -2) return;
		v[pos * 2 + 1] = pb[pos * 2 + 1] = v[pos * 2 + 2] = pb[pos * 2 + 2] = pb[pos];
		pb[pos] = -2;
	}

	void set(int l, int r, int x, int pos, int tl, int tr) {
		if (tr < l || r < tl) return;
		if (l <= tl && tr <= r) {
			v[pos] = pb[pos] = x;
			return;
		}
		push(pos);

		int m = (tl + tr) / 2;
		set(l, r, x, pos * 2 + 1, tl, m);
		set(l, r, x, pos * 2 + 2, m + 1, tr);
		v[pos] = max(v[pos * 2 + 1], v[pos * 2 + 2]);
	}

	int get(int l, int r, int pos, int tl, int tr) {
		if (tr < l || r < tl) return -1;
		if (l <= tl && tr <= r) return v[pos];
		push(pos);

		int m = (tl + tr) / 2;
		return max(get(l, r, pos * 2 + 1, tl, m), get(l, r, pos * 2 + 2, m + 1, tr));
	}

	int n;
	vector<int> v, pb;

};

void solve() {

	int n;
	cin >> n;
	vector<int> v(n);
	for (int& x : v) {
		cin >> x;
		x--;
	}

	vector<int> dp(n + 1, 1e9), from(n + 1, -1);
	dp[0] = -1;
	for (int i = 0; i < n; i++) {
		int p = lower_bound(all(dp), v[i]) - dp.begin() - 1;
		if (dp[p + 1] > v[i]) {
			dp[p + 1] = v[i];
			from[p + 1] = i;
		}
	}

	int l = lower_bound(all(dp), 1e9) - dp.begin() - 1;
	vector<int> used(n);
	for (int i = l; i > 0; i--) {
		used[from[i]] = 1;
	}

	vector<int> t;
	for (int i = 0; i < n; i++) {
		if (!used[i]) t.push_back(i);
	}
	
	int ans = l;
	for (int i = 0; i + 1 < t.size(); i++) {
		if (t[i] > t[i + 1]) ans++;
	}

	cout << ans << "\n";

}
//1
//5
//2 1 5 4 3

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int t;
	cin >> t;
	while (t--) solve();

}
