#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

struct segtree {

	segtree() {}
	segtree(int n) : n(n) {
		v.resize(n * 4, -1);
		pb.resize(n * 4, -2);
	}

	void set(int l, int r, int x) {
		set(l, r, x, 0, 0, n - 1);
	}

	int get(int l, int r) {
		return get(l, r, 0, 0, n - 1);
	}

	void push(int pos) {
		if (pb[pos] == -2) return;
		v[pos * 2 + 1] = pb[pos * 2 + 1] = v[pos * 2 + 2] = pb[pos * 2 + 2] = pb[pos];
		pb[pos] = -2;
	}

	void set(int l, int r, int x, int pos, int tl, int tr) {
		if (tr < l || r < tl) return;
		if (l <= tl && tr <= r) {
			v[pos] = pb[pos] = x;
			return;
		}
		push(pos);

		int m = (tl + tr) / 2;
		set(l, r, x, pos * 2 + 1, tl, m);
		set(l, r, x, pos * 2 + 2, m + 1, tr);
		v[pos] = max(v[pos * 2 + 1], v[pos * 2 + 2]);
	}

	int get(int l, int r, int pos, int tl, int tr) {
		if (tr < l || r < tl) return -1;
		if (l <= tl && tr <= r) return v[pos];
		push(pos);

		int m = (tl + tr) / 2;
		return max(get(l, r, pos * 2 + 1, tl, m), get(l, r, pos * 2 + 2, m + 1, tr));
	}

	int n;
	vector<int> v, pb;

};

void solve() {

	int n;
	cin >> n;
	vector<int> v(n);
	for (int& x : v) {
		cin >> x;
		x--;
	}

	vector<segtree> dph(n + 1, segtree(n + 1)), dpw(n + 1, segtree(n + 1)); // mx, mn
	dph[n].set(n, n, 0);
	dpw[n].set(n, n, 0);

	for (int id = 0; id < n; id++) {
		int x = v[id];

		vector<int> a(n + 1, -1), b(n + 1, -1);
		for (int j = 0; j <= n; j++) {
			int t = max(dpw[j].get(0, x), dpw[j].get(n, n));
			if (t != -1) a[j] = t + 1;
		}
		for (int i = 0; i <= n; i++) {
			int t = dph[i].get(x, n);
			if (t != -1) b[i] = t + 1;
		}

		for (int j = 0; j <= n; j++) {
			int t = a[j];
			if (j == x) t = max(t, b[x]);
			dph[x].set(j, j, t);
			dpw[j].set(x, x, t);
		}
		for (int i = 0; i <= n; i++) {
			int t = b[i];
			if (i == x) t = max(t, a[x]);
			dph[i].set(x, x, t);
			dpw[x].set(i, i, t);
		}

		for (int j = x + 1; j <= n; j++) {
			dpw[j].set(0, x - 1, -1);
		}
		for (int i = 0; i < x; i++) {
			dph[i].set(x + 1, n, -1);
		}
	}

	int mx = 0;
	for (int i = 0; i <= n; i++) mx = max(mx, dph[i].get(0, n));

	cout << mx << "\n";

}
//1
//5
//2 1 5 4 3

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int t;
	cin >> t;
	while (t--) solve();

}
