#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()

bool cmp_horizontal(pll &p1, pll &p2) {
    return p1.second < p2.second || (p1.second == p2.second && p1.first < p2.first);
}

bool cmp_vertial(pll &p1, pll &p2) {
    return p1.first < p2.first || (p1.first == p2.first && p1.second < p2.second);
}

int main() {
    ll ans = 0;

    ll height, width, k, hd, vd;
    cin >> height >> width >> k;
    vector<pll> points(k);
    for (ll i = 0; i < k; ++i) {
        ll r, c;
        cin >> r >> c;
        --r, --c;
        points[i] = {r, c};
    }
    sort(all(points), cmp_horizontal);
    ll total_delta = 0;
    // горизонтально оптимизируем
    while (true) {
        ll most_left = points[0].second + total_delta;
        ll most_right = points[k - 1].second + total_delta;
        ll currentDistance = most_right - most_left - 1;
        ll newDistance = most_left + width - 1 - most_right;
        if (newDistance < currentDistance) {
            // можем оптимизировать
            // смотрим, в какую сторону выгоднее сдвигать
            ll shift1 = most_left + 1;
            ll shift2 = width - most_right;
            // сдвигаем
            ll previous_delta = total_delta;
            if (shift1 < shift2) {
                // выгоднее сдвигать влево
                // все точки на этой координате тоже сдвигаем
                total_delta -= shift1;
                while (points[0].second + previous_delta == most_left) {
                    pll most_left_point = points[0];
                    points.erase(points.begin());
                    most_left_point.second = width - 1 - total_delta;
                    points.push_back(most_left_point);
                }
            } else {
                // выгоднее сдвигать вправо
                total_delta += shift2;
                while (points[k - 1].second + previous_delta == most_right) {
                    pll most_right_point = points[k - 1];
                    points.pop_back();
                    most_right_point.second = 0 - total_delta;
                    points.emplace(points.begin(), most_right_point);
                }
            }
        } else {
            break;
        }
    }
    ans += abs(total_delta);
    // применяем totral_delta
    if (total_delta != 0) {
        for (ll i = 0; i < k; ++i) {
            points[i].second += total_delta;
        }
    }
    hd = points[k - 1].second - points[0].second + 1;
    // оптимизируем вертикально
    sort(all(points), cmp_vertial);
    total_delta = 0;
    // горизонтально оптимизируем
    while (true) {
        ll most_left = points[0].first + total_delta;
        ll most_right = points[k - 1].first + total_delta;
        ll currentDistance = most_right - most_left - 1;
        ll newDistance = most_left + (height - 1 - most_right);
        if (newDistance < currentDistance) {
            // можем оптимизировать
            // смотрим, в какую сторону выгоднее сдвигать
            ll shift1 = most_left + 1;
            ll shift2 = height - 1 - most_right + 1;
            // сдвигаем
            ll previous_delta = total_delta;
            if (shift1 < shift2) {
                // выгоднее сдвигать влево
                // все точки на этой координате тоже сдвигаем
                total_delta -= shift1;
                while (points[0].first + previous_delta == most_left) {
                    pll most_left_point = points[0];
                    points.erase(points.begin());
                    most_left_point.first = width - 1 - total_delta;
                    points.push_back(most_left_point);
                }
            } else {
                // выгоднее сдвигать вправо
                total_delta += shift2;
                while (points[k - 1].first + previous_delta == most_right) {
                    pll most_right_point = points[k - 1];
                    points.pop_back();
                    most_right_point.first = 0 - total_delta;
                    points.emplace(points.begin(), most_right_point);
                }
            }
        } else {
            break;
        }
    }
    ans += abs(total_delta);
    // применяем totral_delta
    if (total_delta != 0) {
        for (ll i = 0; i < k; ++i) {
            points[i].first += total_delta;
        }
    }
    vd = points[k - 1].first - points[0].first + 1;
    // находим площадь
    ll pl = hd * vd;
    cout << pl << ' ' << ans << endl;
}
