#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()
ll total_delta = 0;
ll height, width, k, hd, vd;
vector<pll> points;
vector<pll> source_points;
const ll INF = std::numeric_limits<ll>::max();
ll moved_cells_count = 0;

bool cmp_horizontal(pll &p1, pll &p2) {
    return p1.second < p2.second || (p1.second == p2.second && p1.first < p2.first);
}

bool cmp_vertical(pll &p1, pll &p2) {
    return p1.first < p2.first || (p1.first == p2.first && p1.second < p2.second);
}

void move_left() {
    ll previous_delta = total_delta;
    ll most_left = points[0].second + total_delta;
    ll shift1 = most_left + 1;
    // все точки на этой координате тоже сдвигаем
    total_delta -= shift1;
    while (points[0].second + previous_delta == most_left) {
        ++moved_cells_count;
        pll most_left_point = points[0];
        points.erase(points.begin());
        most_left_point.second = width - 1 - total_delta;
        points.push_back(most_left_point);
    }
}

void move_right() {
    ll previous_delta = total_delta;
    ll most_right = points[k - 1].second + total_delta;
    ll shift2 = width - most_right;
    total_delta += shift2;
    while (points[k - 1].second + previous_delta == most_right) {
        ++moved_cells_count;
        pll most_right_point = points[k - 1];
        points.pop_back();
        most_right_point.second = 0 - total_delta;
        points.emplace(points.begin(), most_right_point);
    }
}

void move_top() {
    ll most_left = points[0].first + total_delta;
    // можем оптимизировать
    ll shift1 = most_left + 1;
    // сдвигаем
    ll previous_delta = total_delta;
    // выгоднее сдвигать влево
    // все точки на этой координате тоже сдвигаем
    total_delta -= shift1;
    while (points[0].first + previous_delta == most_left) {
        ++moved_cells_count;
        pll most_left_point = points[0];
        points.erase(points.begin());
        most_left_point.first = height - 1 - total_delta;
        points.push_back(most_left_point);
    }
}

void move_bottom() {
    ll most_right = points[k - 1].first + total_delta;
    // можем оптимизировать
    // смотрим, в какую сторону выгоднее сдвигать
    ll shift2 = height - 1 - most_right + 1;
    // сдвигаем
    ll previous_delta = total_delta;

    // выгоднее сдвигать вправо
    total_delta += shift2;
    while (points[k - 1].first + previous_delta == most_right) {
        ++moved_cells_count;
        pll most_right_point = points[k - 1];
        points.pop_back();
        most_right_point.first = 0 - total_delta;
        points.emplace(points.begin(), most_right_point);
    }
}

ll get_hd() {
    return points[k - 1].second - points[0].second + 1;
}

ll get_vd() {
    return points[k - 1].first - points[0].first + 1;
}


int main() {
    ll ans = 0;
    cin >> height >> width >> k;
    points.resize(k);
    for (ll i = 0; i < k; ++i) {
        ll r, c;
        cin >> r >> c;
        --r, --c;
        points[i] = {r, c};
    }
    sort(all(points), cmp_horizontal);
    source_points = points;
    total_delta = 0;
    // сдвигаем влево, пока не попробуем сдвинуть все точки
    ll left_moves_count = 0;
    ll mc = 0;
    ll right_moves_count = 0;
    ll left_hd = get_hd();
    ll right_hd = get_hd();
    while (moved_cells_count < k) {
        move_left();
        ++mc;
        ll current_hd = get_hd();
        if (current_hd < left_hd) {
            left_hd = current_hd;
            left_moves_count = mc;
        }
    }
    points = source_points;
    total_delta = 0;
    mc = 0;
    moved_cells_count = 0;
    while (moved_cells_count < k) {
        move_right();
        ++mc;
        ll cur_hd = get_hd();
        if (cur_hd < right_hd) {
            right_hd = cur_hd;
            right_moves_count = mc;
        }
    }
    points = source_points;
    total_delta = 0;

    ll horiz_moves_count = 0;
    ll hd = 0;
    if (left_hd < right_hd || (left_hd == right_hd && left_moves_count < right_moves_count)) {
        for (ll i = 0; i < left_moves_count; ++i) {
            move_left();
        }
        horiz_moves_count = left_moves_count;
        hd = left_hd;
    } else {
        for (ll i = 0; i < right_moves_count; ++i) {
            move_right();
        }
        horiz_moves_count = right_moves_count;
        hd = right_hd;
    }
    for (ll i = 0; i < k; ++i) {
        points[i].second += total_delta;
    }

    sort(all(points), cmp_vertical);
    source_points = points;
    total_delta = 0;
    ll top_moves_count = 0;
    ll bottom_moves_count = 0;
    mc = 0;
    ll top_vd = get_vd();
    ll bottom_vd = get_vd();
    moved_cells_count = 0;
    while (moved_cells_count < k) {
        move_top();
        ++mc;
        ll current_vd = get_vd();
        if (current_vd < top_vd) {
            top_vd = current_vd;
            top_moves_count = mc;
        }
    }
    points = source_points;
    total_delta = 0;
    moved_cells_count = 0;
    mc = 0;
    while (moved_cells_count < k) {
        move_bottom();
        ++mc;
        ll current_vd = get_vd();
        if (current_vd < bottom_vd) {
            bottom_vd = current_vd;
            bottom_moves_count = mc;
        }
    }
    ll vert_moves_count = 0;
    ll vd = 0;
    if (top_vd < bottom_vd || (top_vd == bottom_vd && top_moves_count < bottom_moves_count)) {
        for (ll i = 0; i < top_moves_count; ++i) {
            move_top();
        }
        vert_moves_count = top_moves_count;
        vd = top_vd;
    } else {
        for (ll i = 0; i < bottom_moves_count; ++i) {
            move_bottom();
        }
        vert_moves_count = bottom_moves_count;
        vd = bottom_vd;
    }
    cout << hd * vd << ' ' << (horiz_moves_count + vert_moves_count) << endl;
}
