#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>
#include <deque>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()
ll total_delta = 0;
ll height, width, k, hd, vd;
vector<pll> points_vector;
deque<pll> points;
const ll INF = std::numeric_limits<ll>::max();
ll moved_cells_count = 0;

bool cmp_horizontal(pll &p1, pll &p2) {
    return p1.second < p2.second || (p1.second == p2.second && p1.first < p2.first);
}

bool cmp_vertical(pll &p1, pll &p2) {
    return p1.first < p2.first || (p1.first == p2.first && p1.second < p2.second);
}

ll move_left() {
    ll previous_delta = total_delta;
    ll most_left = points[0].second + total_delta;
    ll shift1 = most_left + 1;
    // все точки на этой координате тоже сдвигаем
    total_delta -= shift1;
    while (points[0].second + previous_delta == most_left) {
        ++moved_cells_count;
        pll most_left_point = points.front();
        points.pop_front();
        most_left_point.second = width - 1 - total_delta;
        points.push_back(most_left_point);
    }
    return shift1;
}

ll move_right() {
    ll previous_delta = total_delta;
    ll most_right = points[k - 1].second + total_delta;
    ll shift2 = width - 1 - most_right + 1;
    total_delta += shift2;
    while (points[k - 1].second + previous_delta == most_right) {
        ++moved_cells_count;
        pll most_right_point = points.back();
        points.pop_back();
        most_right_point.second = 0 - total_delta;
        points.push_front(most_right_point);
    }
    return shift2;
}

ll move_top() {
    ll most_left = points[0].first + total_delta;
    // можем оптимизировать
    ll shift1 = most_left + 1;
    // сдвигаем
    ll previous_delta = total_delta;
    // выгоднее сдвигать влево
    // все точки на этой координате тоже сдвигаем
    total_delta -= shift1;
    while (points[0].first + previous_delta == most_left) {
        ++moved_cells_count;
        pll most_left_point = points.front();
        points.pop_front();
        most_left_point.first = height - 1 - total_delta;
        points.push_back(most_left_point);
    }
    return shift1;
}

ll move_bottom() {
    ll most_right = points[k - 1].first + total_delta;
    // можем оптимизировать
    // смотрим, в какую сторону выгоднее сдвигать
    ll shift2 = height - 1 - most_right + 1;
    // сдвигаем
    ll previous_delta = total_delta;

    // выгоднее сдвигать вправо
    total_delta += shift2;
    while (points[k - 1].first + previous_delta == most_right) {
        ++moved_cells_count;
        pll most_right_point = points.back();
        points.pop_back();
        most_right_point.first = 0 - total_delta;
        points.push_front(most_right_point);
    }
    return shift2;
}

ll get_hd() {
    return points[k - 1].second - points[0].second + 1;
}

ll get_vd() {
    return points[k - 1].first - points[0].first + 1;
}

inline deque<pll> make_deque() {
    deque<pll> res;
    for (ll i = 0; i < k; ++i) {
        res.push_back(points_vector[i]);
    }
    return res;
}


int main() {
    ll ans = 0;
    cin >> height >> width >> k;
    points_vector.resize(k);
    for (ll i = 0; i < k; ++i) {
        ll r, c;
        cin >> r >> c;
        --r, --c;
        points_vector[i] = {r, c};
    }
    sort(all(points_vector), cmp_horizontal);
    points = make_deque();

    total_delta = 0;
    // сдвигаем влево, пока не попробуем сдвинуть все точки
    ll left_moves_count = 0;
    ll right_moves_count = 0;
    ll left_hd = get_hd();
    ll right_hd = get_hd();
    ll mc = 0;
    moved_cells_count = 0;
    total_delta = 0;
    while (moved_cells_count < k) {
        mc += move_left();
        ll current_hd = get_hd();
        if (current_hd < left_hd) {
            left_hd = current_hd;
            left_moves_count = mc;
        }
    }
    points = make_deque();
    mc = 0;
    moved_cells_count = 0;
    total_delta = 0;
    while (moved_cells_count < k) {
        mc += move_right();
        ll cur_hd = get_hd();
        if (cur_hd < right_hd) {
            right_hd = cur_hd;
            right_moves_count = mc;
        }
    }

    ll horiz_moves_count = 0;
    ll hd = 0;
    if (left_hd < right_hd || (left_hd == right_hd && left_moves_count < right_moves_count)) {
        horiz_moves_count = left_moves_count;
        hd = left_hd;
    } else {
        horiz_moves_count = right_moves_count;
        hd = right_hd;
    }

    sort(all(points_vector), cmp_vertical);
    points = make_deque();

    ll top_moves_count = 0;
    ll bottom_moves_count = 0;
    ll top_vd = get_vd();
    ll bottom_vd = get_vd();
    mc = 0;
    moved_cells_count = 0;
    total_delta = 0;
    while (moved_cells_count < k) {
        mc += move_top();
        ll current_vd = get_vd();
        if (current_vd < top_vd) {
            top_vd = current_vd;
            top_moves_count = mc;
        }
    }
    points = make_deque();
    mc = 0;
    moved_cells_count = 0;
    total_delta = 0;
    while (moved_cells_count < k) {
        mc += move_bottom();
        ll current_vd = get_vd();
        if (current_vd < bottom_vd) {
            bottom_vd = current_vd;
            bottom_moves_count = mc;
        }
    }
    ll vert_moves_count = 0;
    ll vd = 0;
    if (top_vd < bottom_vd || (top_vd == bottom_vd && top_moves_count < bottom_moves_count)) {
        vert_moves_count = top_moves_count;
        vd = top_vd;
    } else {
        vert_moves_count = bottom_moves_count;
        vd = bottom_vd;
    }
    cout << hd * vd << ' ' << (horiz_moves_count + vert_moves_count) << endl;
}