#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;

ll n, k, q;
vector<pll> tree;
vector<ll> ans;

const ll LEFT = 1;
const ll RIGHT = 2;
const ll UNKNOWN = -1;

ll dfs(ll v, ll rotates, ll last_direction) {
    ll reached_leaves_count = 0;
    auto &[l, r] = tree[v];
    if (l == -1 && r == -1) {
        if (rotates <= k) {
            reached_leaves_count += 1;
        }
    }
    if (l != -1) {
        if (last_direction == LEFT) {
            reached_leaves_count += dfs(l, rotates, LEFT);
        } else {
            reached_leaves_count += dfs(l, rotates + 1, LEFT);
        }
    }
    if (r != -1) {
        if (last_direction == RIGHT) {
            reached_leaves_count += dfs(r, rotates, RIGHT);
        } else {
            reached_leaves_count += dfs(r, rotates + 1, RIGHT);
        }
    }
    ans[v] = reached_leaves_count;
    return reached_leaves_count;
}

int main() {
    cin >> n >> k >> q;
    ++k;
    tree.resize(n, {-1, -1});
    ans.resize(n, 0);
    for (ll i = 0; i < n; ++i) {
        ll t;
        cin >> t;
        if (t == 2) {
            ll l, r;
            cin >> l >> r;
            --l, --r;
            tree[i] = {l, r};
        }
    }
    dfs(0, 0, UNKNOWN);
    for (ll tn = 0; tn < q; ++tn) {
        ll u;
        cin >> u;
        --u;
        cout << ans[u] << endl;
    }
}