#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

bool try_kuhn(const vector<vi> &g, vector<bool> &used, vi &btoa, int u) {
    if (used[u]) return false;
    used[u] = true;

    for (auto v: g[u]) {
        if (btoa[v] == -1 || try_kuhn(g, used, btoa, btoa[v])) {
            btoa[v] = u;
            return true;
        }
    }
    return false;
}

vi encode(int n, const vi &a) {
    int shift = a.back() - a[0] + 1;

    vi ans;
    transform(all(a), back_inserter(ans), [&](int x) {
        return (x + shift) % n;
    });
    return ans;
}

vi decode(int n, const vi &a) {
    int shift = 0, nxt = sz(a) - 1;
    rep(i, 0, sz(a)) {
        if ((a[nxt] - a[i] + n) % n < n / 2) {
            shift = (a[nxt] - a[i] + n) % n + 1;
            break;
        }
        nxt = (nxt + 1) % sz(a);
    }

    vi ans;
    transform(all(a), back_inserter(ans), [&](int x) {
        return (x - shift + n) % n;
    });
    return ans;
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    vector<vi> inv, forw;
    for (int n = 2; n <= 7; n++) {
        vector<vi> g(1 << n);
        vi btoa(1 << n, -1);
        vector<bool> used(1 << n);
        rep(mask, 1, 1 << n) {
            rep(oth, 0, 1 << n) {
                if ((mask & oth) == 0 && __builtin_popcount(mask) == __builtin_popcount(oth)) {
                    g[mask].push_back(oth);
                }
            }
        }

        for (int i = 1; i < 1 << n; i++) {
            std::fill(used.begin(), used.end(), false);
            try_kuhn(g, used, btoa, i);
        }

        vi atob(1 << n, -1);
        rep(i, 1, 1 << n) {
            if (btoa[i] != -1) {
                atob[btoa[i]] = i;
            }
        }
        forw.push_back(atob);
        inv.push_back(btoa);
    }

    int type;
    cin >> type;

    int q;
    cin >> q;
    while (q--) {
        int n, k;
        cin >> n >> k;

        int mask = 0;
        rep(i, 0, k) {
            int x;
            cin >> x;

            mask |= 1 << (x - 1);
        }

        int new_mask = (type == 1 ? forw[n - 2] : inv[n - 2])[mask];
        rep(i, 0, n) {
            if ((new_mask >> i) & 1) {
                cout << i + 1 << ' ';
            }
        }
        cout << '\n';
    }
}