#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

bool try_kuhn(const vector<vi> &g, vector<bool> &used, vi &btoa, int u) {
    if (used[u]) return false;
    used[u] = true;

    for (auto v: g[u]) {
        if (btoa[v] == -1 || try_kuhn(g, used, btoa, v)) {
            btoa[v] = u;
            return true;
        }
    }
    return false;
}

const int MUL = 239;

int mul(int a, int b, int mod) {
    return 1LL * a * b % mod;
}

int modpow(int b, int e, int mod) {
    int ans = 1;
    while (e > 0) {
        if (e & 1) { ans = mul(ans, b, mod); }
        b = mul(b, b, mod);
        e >>= 1;
    }
    return ans;
}

vi encode(int n, const vi &a) {
    return {((a[0] + 1) * MUL) % n, ((a[1] + 1) * MUL) % n};
}

vi decode(int n, const vi &a) {
    return {(modpow(a[0], n - 2, n) - 1 + n) % n, (modpow(a[1], n - 2, n) - 1 + n) % n};
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int type;
    cin >> type;

    int q;
    cin >> q;
    while (q--) {
        int n, k;
        cin >> n >> k;

        vi a(k);
        for (auto &el: a) cin >> el, --el;
        for (auto el: (type == 1 ? encode(n, a) : decode(n, a))) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    }
}