#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

bool try_kuhn(const vector<vi> &g, vector<bool> &used, vi &btoa, int u) {
    if (used[u]) return false;
    used[u] = true;

    for (auto v: g[u]) {
        if (btoa[v] == -1 || try_kuhn(g, used, btoa, v)) {
            btoa[v] = u;
            return true;
        }
    }
    return false;
}

const int SEED = 2;

vi encode(int n, const vi &a) {
    mt19937 rng(SEED);
    int shift = rng() % n + 1;

    vi ans;
    transform(all(a), back_inserter(ans), [&](int x) {
        return (x + shift) % n;
    });
    return ans;
}

vi decode(int n, const vi &a) {
    mt19937 rng(SEED);
    int shift = rng() % n + 1;

    vi ans;
    transform(all(a), back_inserter(ans), [&](int x) {
        return (x - shift + n) % n;
    });
    return ans;
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int type;
    cin >> type;

    int q;
    cin >> q;
    while (q--) {
        int n, k;
        cin >> n >> k;

        vi a(k);
        for (auto &el: a) cin >> el, --el;
        for (auto el: (type == 1 ? encode(n, a) : decode(n, a))) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    }
}