#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

vector<bool> encode(vector<bool> mask) {
	int n = mask.size();
	vector<bool> busy = mask, res(n, false);
	for (int i = n - 1; i >= 0; --i) {
		if (!mask[i]) continue;
		int j = i;
		while (busy[j]) j = (j + 1) % n;
		res[j] = busy[j] = true;
	}
	return res;
}
vector<bool> decode(vector<bool> mask) {
	int n = mask.size();
	vector<bool> busy = mask, res(n, false);
	for (int i = 0; i < n; ++i) {
		if (!mask[i]) continue;
		int j = i;
		while (busy[j]) j = (j + n - 1) % n;
		res[j] = busy[j] = true;
	}
	return res;
}

int main() {

	int a;
	cin >> a;
	int m, n, k;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		cin >> n >> k;
		vector<bool> mask(n, false);
		for (int i = 0; i < k; ++i) {
			int b;
			cin >> b;
			mask[b - 1] = true;
		}
		vector<bool> res;
		if (a == 1) res = encode(mask);
		else res = decode(mask);
		for (int i = 0; i < n; ++i) {
			if (res[i]) cout << i + 1 << " ";
		}
		cout << "\n";
	}
	cout << endl;

	return 0;
}