#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

set<pair<int, int>> segs;
void assign(int k) {
	int l = k, r = k;
	auto it = segs.lower_bound({ k, -1 });
	bool ldel = false;
	if (it != segs.begin()) {
		--it;
		ldel = (it->second == k - 1);
		++it;
	}
	bool rdel = (it != segs.end() and it->first == k + 1);
	if (ldel and rdel) {
		r = it->second;
		l = (--it)->first;
		segs.erase(segs.erase(it));
	}
	else if (ldel) {
		r = k;
		l = (--it)->first;
		segs.erase(it);
	}
	else if (rdel) {
		l = k;
		r = it->second;
		segs.erase(it);
	}
	segs.insert(pair<int, int>(l, r));
}
int next(int k) {
	auto it = segs.lower_bound({ k + 1, -1 });
	if (it == segs.begin()) return k;
	--it;
	if (it->first <= k and k <= it->second) return it->second + 1;
	return k;
}
void init() {
	segs.clear();
}

void encode(vector<int>& from, set<int>& to, int n) {
	init();
	int k = from.size();
	for (int i = 0; i < k; ++i) assign(from[i]);
	for (int i = k - 1; i >= 0; --i) {
		int nxt = next(from[i]);
		if (nxt == n) nxt = next(0);
		//cout << nxt << "_\n";
		to.insert(nxt);
		assign(nxt);
	}
}
void decode(vector<int>& from, set<int>& to, int n) {
	init();
	int k = from.size();
	for (int i = 0; i < k; ++i) assign(n - 1 - from[i]);
	for (int i = 0; i < k; ++i) {
		int nxt = next(n - 1 - from[i]);
		if (nxt == n) nxt = next(0);
		//cout << nxt << "_\n";
		to.insert(n - 1 - nxt);
		assign(nxt);
	}
}

int main() {

	int a;
	cin >> a;
	int m, n, k;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		cin >> n >> k;
		vector<int> nums(k);
		for (int i = 0; i < k; ++i) {
			cin >> nums[i];
			--nums[i];
		}
		set<int> res;
		if (a == 1) encode(nums, res, n);
		else decode(nums, res, n);
		for (int el : res) cout << el + 1 << " ";
		cout << "\n";
	}
	cout << endl;

	return 0;
}