#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <ctime>
using namespace std;
using Seg = pair<int, int>;
using ll = long long;

void logvec(vector<int> a, string s) {
	for (int el : a) cout << el << s;
	cout << "\n";
}

bool comp(Seg a, Seg b) {
	return a.second < b.second;
}
bool cmp(pair<Seg, int> a, pair<Seg, int> b) {
	return comp(a.first, b.first);
}

Seg randseg() {
	int l = rand(), r = rand();
	if (l > r) swap(l, r);
	return { l,r };
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(nullptr));

	int t = 100;
	cin >> t;

	while (t--) {
		int n = 2*(rand() % 20 + 1);
		cin >> n;
		//cout << "\n\n";
		//cout << n << "\n";
		vector<pair<Seg, int>> init(n);
		for (int i = 0; i < n; ++i) {
			//init[i].first = randseg();
			cin >> init[i].first.first >> init[i].first.second;
			/*cout <<
				init[i].first.first << " "  << init[i].first.second << "\n";*/
			init[i].second = i;
		}
		//cout << "\n\n";
		sort(init.begin(), init.end(), cmp);
		vector<Seg> segs(n);
		for (int i = 0; i < n; ++i) {
			segs[i] = init[i].first;
		}
		vector<int> prev(n, -1), dp(n, -1), del(n, -1);
		vector<ll> su(n);
		dp[0] = 1;
		del[0] = 0;
		su[0] = segs[0].second;
		for (int i = 1; i < n; ++i) {
			prev[i] = lower_bound(segs.begin(), segs.end(),
				Seg(0,segs[i].first), comp) - segs.begin() - 1;
			if (prev[i] == -1 or dp[prev[i]] + 1 < dp[i - 1]
				or (dp[prev[i]] + 1 == dp[i - 1] and
					su[i - 1] <= su[prev[i]] + segs[i].second)) {
				dp[i] = dp[i - 1];
				del[i] = del[i - 1];
				su[i] = su[i - 1];
			}
			else {
				dp[i] = dp[i - 1] + 1;
				del[i] = i;
				su[i] = su[prev[i]] + segs[i].second;
			}
		}

		//logvec(dp, "..");
		//logvec(del, "..");
		
		vector<int> opt;
		int j = n - 1;
		while (j != -1) {
			opt.emplace_back(del[j]);
			j = prev[del[j]];
		}
		reverse(opt.begin(), opt.end());
		//logvec(hole, "..");

		int m = opt.size(), mid = m/2;
		vector<int> hole(m);
		for (int i = 0; i < m; ++i) {
			hole[i] = segs[opt[i]].second;
		}
		/*for (int i = 0; i < n; ++i) {
			bool bad = true;
			for (int j = 0; j < m; ++j) {
				if (segs[i].first <= hole[j]
					and hole[j] <= segs[i].second) bad = false;
			}
			if (bad) {
				cout << "STO!!!\n";
				return 0;
			}
		}*/
		//logvec(hole, "___");

		int count = 0, half = n / 2;
		for (int i = 0; i < n; ++i) {
			count += (segs[i].second < hole[mid]);
		}
		int cur;
		vector<int> state(n, -1);
		if (count <= half) {//throw out first m/2
			count = 0;
			for (int i = 0; i < n; ++i) {
				if (segs[i].second < hole[mid]) {
					state[i] = 0;
					++count;
				}
			}
			for (int i = mid; i < m; ++i) {
				state[opt[i]] = 1;
			}
			for (int i = 0; i < n; ++i) {
				if (state[i] == -1) {
					if (count < n / 2) {
						++count;
						state[i] = 0;
					}
					else state[i] = 1;
				}
			}
		}
		else {//throw out last m/2
			count = 0;
			for (int i = 0; i < n; ++i) {
				if (segs[i].first > hole[mid - 1]) {
					state[i] = 0;
					++count;
				}
			}
			for (int i = 0; i < mid; ++i) {
				state[opt[i]] = 1;
			}
			for (int i = 0; i < n; ++i) {
				if (state[i] == -1) {
					if (count < n / 2) {
						++count;
						state[i] = 0;
					}
					else state[i] = 1;
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			if (state[i] == 1) {
				cout << init[i].second + 1 << " ";
			}
		}
		cout << "\n";
	}

	return 0;
}