#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <ctime>
#include <unordered_map>
using namespace std;
using Seg = pair<int, int>;
using ll = long long;
const int B = 400;

void logvec(vector<int> a, string s) {
	for (int el : a) cout << el << s;
	cout << "\n";
}

vector<ll> w;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(nullptr));

	int n, Q;
	cin >> n >> Q;
	w.assign(n, 0);
	for (int i = 0; i < n; ++i) cin >> w[i];
	sort(w.begin(), w.end());

	vector<vector<int>> dp(B + 1, vector<int>(B + 1, n));
	dp[0][0] = -1;
	for (int a = 0; a <= B; ++a) {
		for (int b = 0; b <= B; ++b) {
			for (int k = dp[a][b] + 1; k < n and a + w[k] <= B; ++k) {
				dp[a + w[k]][b] = min(dp[a + w[k]][b], k);
			}
			for (int k = dp[a][b] + 1; k < n and b + w[k] <= B; ++k) {
				dp[a][b + w[k]] = min(dp[a][b + w[k]], k);
			}
			/*if (a == 0 and b == 0) continue;
			dp[a][b] = n;
			for (int k = 0; k < n; ++k) {
				if ((w[k] <= a and dp[a - w[k]][b] < k) or
					(w[k] <= b and dp[a][b - w[k]] < k)) {
					dp[a][b] = k;
					break;
				}
			}*/
		}
	}
	vector<vector<int>> pref(B + 2, vector<int>(B + 2, -1));
	for (int a = 1; a <= B + 1; ++a) {
		for (int b = 1; b <= B + 1; ++b) {
			pref[a][b] = max({ dp[a - 1][b - 1],
				pref[a - 1][b], pref[a][b - 1] });
		}
	}
	//cout << "PRe\n";

	ll z;
	cin >> z;
	ll k, a, b,
		j, c, d;
	ll sum = 0;
	bool correct;
	for(int q = 1; q <= Q; ++q) {
		cin >> j >> c >> d;
		k = j - z * sum;
		a = c - z * sum;
		b = d - z * sum;

		//cout << "___" << pref[a + 1][b + 1] << "____\n";
		correct = (pref[a + 1][b + 1] == -1 or
			(pref[a + 1][b + 1] != n and w[pref[a + 1][b + 1]] <= k));

		if (correct) {
			cout << "Yes\n";
			sum += q;
		}
		else {
			cout << "No\n";
		}
	}

	return 0;
}