#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <ctime>
using namespace std;
using Seg = pair<int, int>;
using ll = long long;

void logvec(vector<int> a, string s) {
	for (int el : a) cout << el << s;
	cout << "\n";
}

vector<ll> w;
bool solve(int k, ll a, ll b) {//first k el's
	if (k == 0) return (a == 0 and b == 0);
	bool ans = false;
	for (int i = 0; i < k; ++i) {
		ans = (ans or solve(i, a - w[i], b) or solve(i, a, b - w[i]));
	}
	return ans;
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(nullptr));

	int n, Q;
	cin >> n >> Q;
	w.assign(n, 0);
	for (int i = 0; i < n; ++i) cin >> w[i];
	sort(w.begin(), w.end());

	ll mex = 1;
	for (int i = 0; i < n; ++i) {
		if (w[i] > mex) break;
		mex += w[i];
	}

	ll z;
	cin >> z;
	ll k, a, b,
		j, c, d;
	ll sum = 0;
	bool correct;
	for(int q = 1; q <= Q; ++q) {
		cin >> j >> c >> d;
		k = j - z * sum;
		a = c - z * sum;
		b = d - z * sum;
		correct = solve(
			(upper_bound(w.begin(), w.end(), k) - w.begin()),
			a, b);

		if (correct) {
			cout << "Yes\n";
			sum += q;
		}
		else {
			cout << "No\n";
		}
	}

	return 0;
}