#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <ctime>
#include <unordered_map>
using namespace std;
using Seg = pair<int, int>;
using ll = long long;

void logvec(vector<int> a, string s) {
	for (int el : a) cout << el << s;
	cout << "\n";
}

vector<ll> w;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(nullptr));

	int n, Q;
	cin >> n >> Q;
	w.assign(n, 0);
	for (int i = 0; i < n; ++i) cin >> w[i];
	sort(w.begin(), w.end());

	unordered_map<ll, unordered_map<ll,int>> all;
	all.insert_or_assign(0, unordered_map<ll, int>());
	all[0].insert_or_assign(0, -1);
	int deg = 1;
	for (int i = 0; i < n; ++i) deg *= 3;
	for (int i = 1; i < deg; ++i) {
		int j = i;
		vector<int> mask;
		while (j != 0) {
			mask.emplace_back(j % 3);
			j /= 3;
		}
		while (mask.size() < n) mask.emplace_back(0);
		ll a = 0, b = 0;
		for (int i = 0; i < n; ++i) {
			if (mask[i] == 1) a += w[i];
			else if (mask[i] == 2) b += w[i];
		}
		if (all.find(a) == all.end()) all.insert_or_assign(a,
			unordered_map<ll,int>());
		if (all[a].find(b) == all[a].end()) all[a].insert_or_assign(b, 1e9);
		int last = -1;
		for (int i = 0; i < n; ++i) {
			if (mask[i] != 0) {
				last = i;
			}
		}
		all[a][b] = min(all[a][b], last);
	}
	//cout << "ALL MADE\n";
	int mex = 0;
	while (all.find(mex) != all.end()) ++mex;
	vector<int> me(mex, 0);
	for (int i = 0; i < mex; ++i) {
		while (all[i].find(me[i]) != all[i].end()) ++me[i];
	}
	//cout << "ME PRECOUNT\n";
	vector<vector<int>> pref(mex);
	for (int i = 0; i < mex; ++i) {
		pref[i] = {-1};
		for (int j = 1; j <= me[i]; ++j) {
			pref[i].emplace_back(max(pref[i][j - 1], all[i][(ll)j - 1]));
		}
	}
	//cout << "LA\n";

	ll z;
	cin >> z;
	ll k, a, b,
		j, c, d;
	ll sum = 0;
	bool correct;
	for(int q = 1; q <= Q; ++q) {
		cin >> j >> c >> d;
		k = j - z * sum;
		a = c - z * sum;
		b = d - z * sum;

		correct = (a < mex);
		if (correct) {
			for (ll a1 = 0; a1 <= a; ++a1) {
				correct = correct and b < me[a1] and
				(pref[a1][b + 1] == -1 or w[pref[a1][b + 1]] <= k);
			}
		}

		if (correct) {
			cout << "Yes\n";
			sum += q;
		}
		else {
			cout << "No\n";
		}
	}

	return 0;
}