#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//#define int long long
#define pb push_back
#define ff first
#define ss second
#define ll long long

const int inf = 2e9;

struct SegTree {
    int n;
    vector<int> a;
    vector<int> t;
    vector<int> push;

    SegTree(vector<int> data) {
        n = (int) data.size();
        a = data;
        t.resize(4 * n);
        push.assign(4 * n, 0);
        build(1, 0, n);
    }

    int op(int _x, int _y) {
        return max(_x, _y);
    }

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v] = op(t[v * 2], t[v * 2 + 1]);
    }

    void Push(int v, int l, int r) {
        if (l + 1 != r && push[v]) {
            t[v * 2] += push[v];
            t[v * 2 + 1] += push[v];
            push[v * 2] += push[v];
            push[v * 2 + 1] += push[v];
        }
        push[v] = 0;
    }

    int get(int v, int l, int r, int lq, int rq) {
        Push(v, l, r);
        if (lq >= r || l >= rq) return -inf;
        if (lq <= l && r <= rq) return t[v];
        int m = (l + r) / 2;
        return op(get(v * 2, l, m, lq, rq), get(v * 2 + 1, m, r, lq, rq));
    }

    void upd(int v, int l, int r, int lq, int rq, int val) {
        Push(v, l, r);
        if (lq >= r || l >= rq) return;
        if (lq <= l && r <= rq) {
            t[v] += val;
            push[v] += val;
            return;
        }
        int m = (l + r) / 2;
        upd(v * 2, l, m, lq, rq, val);
        upd(v * 2, m, r, lq, rq, val);
        t[v] = op(t[v * 2], t[v * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void upd(int l, int r, int val) {
        upd(1, 0, n, l, r, val);
    }
};

int k;

pair<int, int> get(vector<int> a, int m) {
    sort(a.begin(), a.end());
    pair<int, int> ans = {a.back() - a[0], 0}, now;
    for (int i = 1; i < k; i++) {
        if (a[i] > a[i - 1]) {
            now = {max(a[i - 1] + m - a[i], a.back() - a[i]), min(i + 1, k - i)};
            ans = min(ans, now);
        }
    }
    for (auto &i: a) i = m - i - 1;
    reverse(a.begin(), a.end());
    a = min(a, {a.back() - a[0], 0});
    for (int i = 1; i < k; i++) {
        if (a[i] > a[i - 1]) {
            now = {max(a[i - 1] + m - a[i], a.back() - a[i]), min(i + 1, k - i)};
            if (now.ff < ans.ff) ans = now;
            else if (now.ff == ans.ff) ans.ss = min(ans.ss, now.ss);
        }
    }
    ans.ff++;
    return ans;
}

void solve() {
    int h, w;
    cin >> h >> w >> k;
    vector<int> x(k), y(k);
    for (int i = 0; i < k; i++) cin >> x[i] >> y[i], x[i]--, y[i]--;
    auto res1 = get(x, h), res2 = get(y, w);
//    cout << res1.ff << ' ' << res1.ss << endl;
//    cout << res2.ff << ' ' << res2.ss << endl;
    cout << 1ll * res1.ff * res2.ff << ' ' << res1.ss + res2.ss;
}

signed main() {
#ifndef Bebra1488
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
#ifdef Bebra1488
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
    while (tests--) solve();
}
