#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <fstream>

typedef long long ll;

std::pair<ll, int> solve(int h, std::vector<int>& x) {
	int n = x.size();
	std::sort(x.begin(), x.end());
	int min_x, min_dx = 0;
	min_x = x.back() - x[0] + 1;
	for (int i = 0; i < n - 1; ++i) {
		if (x[i] == x[i + 1]) continue;
		int lx = h - (x[i + 1] - x[i] - 1);
		if (lx < min_x) {
			min_x = lx;
			min_dx = std::min(x[i], h - x[i + 1] + 1);
		}
		else if (lx == min_x) {
			min_dx = std::min(std::min(x[i], h - x[i + 1] + 1), min_dx);
		}
	}
	return { min_x, min_dx };
}
int main() {
	int h, w, n;
	std::cin >> h >> w >> n;
	std::vector<int> x(n), y(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> x[i] >> y[i];

	}
	auto p = solve(h, x), q = solve(w, y);
	std::cout << p.first * q.first << ' ' << p.second + q.second;
}