#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <fstream>

void incode() {
	int n, k;
	std::cin >> n >> k;
	std::vector<int> a(k);
	std::vector<bool> used(n, 0);
	for (int& i : a) {
		std::cin >> i;
		used[i - 1] = 1;
	}
	std::vector<int> ans;
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			++cnt;
		}
		else if (cnt > 0) {
			--cnt;
			used[i] = 1;
			ans.push_back(i + 1);
		}
	}
	std::vector<int> prev;
	for (int i = 0; i < n && cnt > 0; ++i) {
		if (!used[i]) {
			prev.push_back(i + 1);
			--cnt;
		}
	}
	int l = 0, r = 0;
	while (l < ans.size() && r < prev.size()) {
		if (ans[l] < prev[r]) {
			std::cout << ans[l] << ' ';
			++l;
		}
		else {
			std::cout << prev[r] << ' ';
			++r;
		}
	}
	while (l < ans.size()) {
		std::cout << ans[l] << ' ';
		++l;
	}
	while (r < prev.size()) {
		std::cout << prev[r] << ' ';
		++r;
	}
	std::cout << std::endl;
}
void decode() {
	int n, k;
	std::cin >> n >> k;
	std::vector<bool> used(n);
	for (int i = 0; i < k; ++i) {
		int p;
		std::cin >> p;
		used[p - 1] = 1;
	}
	int cnt = 0;
	std::vector<int> ans;
	for (int i = n - 1; i >= 0; --i) {
		if (used[i]) {
			++cnt;
		}
		else if(cnt > 0){
			--cnt;
			ans.push_back(i + 1);
			used[i] = 1;
		}
	}
	std::vector<int> prev;
	for (int i = n - 1; i >= 0 && cnt > 0; --i) {
		if (!used[i]) {
			prev.push_back(i + 1);
			--cnt;
		}
	}

	int l = ans.size() - 1, r = prev.size() - 1;
	while (l >= 0 && r >= 0) {
		if (ans[l] < prev[r]) {
			std::cout << ans[l] << ' ';
			--l;
		}
		else {
			std::cout << prev[r] << ' ';
			--r;
		}
	}
	while (l >= 0) {
		std::cout << ans[l] << ' ';
		--l;
	}
	while (r >= 0) {
		std::cout << prev[r] << ' ';
		--r;
	}
	std::cout << std::endl;
}
int main() {
	/*
	std::cout << "1 64\n";
	for (int mask = 1; mask < (1 << 6); ++mask) {
		std::vector<int> a;
		for (int i = 0; i < 6; ++i) {
			if ((mask >> i) & 1) {
				a.push_back(i + 1);
			}
		}
		if (a.size() <= 3) {
			std::cout << "6 " << a.size() << '\n';
			for (int i : a) {
				std::cout << i << ' ';
			}
			std::cout << '\n';
		}
	}
	*/
	int a;
	int t;
	std::cin >> a >> t;
	if (a == 1) {
		while (t--) {
			incode();
		}
	}
	else {
		while (t--) {
			decode();
		}
	}
	std::cout << std::endl;
}