#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <fstream>

void incode() {
	int n, k;
	std::cin >> n >> k;
	std::vector<int> a(k);
	for (int& i : a) {
		std::cin >> i;
	}
	int cnt = 1;
	std::vector<int> ans;
	for (int i = 1; i < k; ++i) {
		int p = a[i - 1] + 1;
		while (p < a[i] && cnt > 0) {
			ans.push_back(p);
			--cnt;
			++p;
		}
		++cnt;
	}
	int p = a.back() + 1;
	while (p <= n && cnt > 0) {
		ans.push_back(p);
		--cnt;
		++p;
	}
	int l = 0, r = 0, i = 1;
	while (cnt > 0) {
		if (l < a.size() && a[l] == i) {
			++l;
		}
		else if (r < ans.size() && ans[r] == i) {
			++r;
			std::cout << i << ' ';
		}
		else {
			std::cout << i << ' ';
			--cnt;
		}
		++i;
	}
	while (r < ans.size()) {
		std::cout << ans[r] << ' ';
		++r;
	}
	std::cout << '\n';
}
void decode() {
	int n, k;
	std::cin >> n >> k;
	if (n <= 6e5) {
		std::vector<bool> used(n);
		for (int i = 0; i < k; ++i) {
			int p;
			std::cin >> p;
			used[p - 1] = 1;
		}
		int cnt = 0;
		std::vector<int> ans;
		for (int i = n - 1; i >= 0; --i) {
			if (used[i]) {
				++cnt;
			}
			else if (cnt > 0) {
				--cnt;
				ans.push_back(i + 1);
				used[i] = 1;
			}
		}
		std::vector<int> prev;
		for (int i = n - 1; i >= 0 && cnt > 0; --i) {
			if (!used[i]) {
				prev.push_back(i + 1);
				--cnt;
			}
		}

		int l = ans.size() - 1, r = prev.size() - 1;
		while (l >= 0 && r >= 0) {
			if (ans[l] < prev[r]) {
				std::cout << ans[l] << ' ';
				--l;
			}
			else {
				std::cout << prev[r] << ' ';
				--r;
			}
		}
		while (l >= 0) {
			std::cout << ans[l] << ' ';
			--l;
		}
		while (r >= 0) {
			std::cout << prev[r] << ' ';
			--r;
		}
		std::cout << '\n';
	}
	else {
		std::vector<int> a(k);
		for (int& i : a) {
			std::cin >> i;
		}
		int cnt = 1;
		std::vector<int> ans;
		for (int i = k - 2; i >= 0; --i) {
			int p = a[i + 1] - 1;
			while (p > a[i] && cnt > 0) {
				ans.push_back(p);
				--cnt;
				++p;
			}
			++cnt;
		}
		int p = a[0] - 1;
		while (p > 0 && cnt > 0) {
			ans.push_back(p);
			--cnt;
			++p;
		}
		int l = k - 1, r = ans.size() - 1, i = n;
		std::vector<int> answer;
		while (cnt > 0) {
			if (l >= 0 && a[l] == i) {
				--l;
			}
			else if (r >= 0 && ans[r] == i) {
				--r;
				answer.push_back(i);
			}
			else {
				--cnt;
				answer.push_back(i);
			}
			--i;
		}
		for (int i = answer.size() - 1; i >= 0; --i) {
			std::cout << answer[i] << ' ';
		}
		std::cout << std::endl;
	}
}
int main() {
	/*
	std::cout << "1 64\n";
	for (int mask = 1; mask < (1 << 6); ++mask) {
		std::vector<int> a;
		for (int i = 0; i < 6; ++i) {
			if ((mask >> i) & 1) {
				a.push_back(i + 1);
			}
		}
		if (a.size() <= 3) {
			std::cout << "6 " << a.size() << '\n';
			for (int i : a) {
				std::cout << i << ' ';
			}
			std::cout << '\n';
		}
	}
	*/
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	int a;
	int t;
	std::cin >> a >> t;
	if (a == 1) {
		while (t--) {
			incode();
		}
	}
	else {
		while (t--) {
			decode();
		}
	}
	std::cout << std::endl;
}