#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cmath>

typedef long long ll;
std::vector<std::vector<int>> g;
std::vector<ll> a;
std::vector<int> ans;
std::vector<std::pair<ll, ll>> dp;
void dfs(int v, int last) {
	dp[v].first = a[v];
	dp[v].second = 0;
	for (int to : g[v]) {
		if (to != last) {
			dfs(to, v);
			dp[v].second += std::max(dp[to].first, dp[to].second);
			dp[v].first += dp[to].second;
		}
	}
}
void make_ans(int v, int last, bool must) {
	if (must || dp[v].first < dp[v].second) {
		for (int to : g[v]) {
			if (to != last) {
				make_ans(to, v, 0);
			}
		}
	}
	else {
		ans.push_back(v);
		for (int to : g[v]) {
			if (to != last) {
				make_ans(to, v, 1);
			}
		}
	}
}
void solve() {
	int n, q;
	std::cin >> n >> q;
	ll x, y, m;
	std::cin >> x >> y >> m;
	g.assign(n, {});
	a.assign(n, 0);
	ans.clear();
	dp.assign(n, { 0, 0 });
	for (int i = 0; i < n - 1; ++i) {
		int s, f;
		std::cin >> s >> f;
		--s;
		--f;
		g[s].push_back(f);
		g[f].push_back(s);
	}
	ll xr = 0;
	for (int i = 0; i < n; ++i) {
		std::cin >> a[i] >> a[i];
		xr ^= (x * (i + 1) % m + y * (a[i] * a[i] % m) % m) % m;
	}
	dfs(0, -1);
	make_ans(0, -1, 0);
	ll answer = 0;
	for (int i : ans) {
		answer += a[i];
	}
	std::vector<bool> used(q, 0);
	for (int i = 0; i < q; ++i) {
		int v;
		std::cin >> v;
		if (v != answer) {
			std::cout << "-1 ";
		}
		else {
			used[i] = 1;
			std::cout << xr << ' ';
		}
	}
	std::cout << std::endl;
	int c;
	std::cin >> c;
	while (c != 0) {
		if (used[c - 1]) {
			for (int i : a) {
				std::cout << i << ' ';
			}
		}
		else {
			std::cout << -1;
		}
		std::cout << std::endl;
	}
}
int main() {
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}