#include <bits/stdc++.h>
#include <ext/pb_ds/exception.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN
void dbg(vector<int> &a) {for (auto i : a) cout << i << " "; cout << "\n";}
void dbg(int a, int b = -1e9 - 10, int c = -1e9 - 10, int d = -1e9 - 10, int e = -1e9 - 10) {
    cout << a << " ";
    if (b != -1e9 - 10) cout << b << " ";
    if (c != -1e9 - 10) cout << c << " ";
    if (d != -1e9 - 10) cout << d << " ";
    if (e != -1e9 - 10) cout << e << " ";
    cout << "\n";
}
void dbg(string s) {cout << s << "\n";}
#else
#define dbg(...)
#endif

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

vector<vector<int>> g;
vector<int> d;

struct segtree {
    vector<vector<int>> tree;
    int n = 1;


    void build(int x, int lx, int rx, vector<int> & a) {
        if (rx - lx == 1) {
            if (a[lx] != 1e9) tree[x] = {a[lx]};
        } else {
            int mid = (lx + rx) / 2;
            build(2 * x + 1, lx, mid, a);
            build(2 * x + 2, mid, rx, a);
            tree[x].resize(tree[2 * x + 1].size() + tree[2 * x + 2].size());
            merge(all(tree[2 * x + 1]), all(tree[2 * x + 2]), tree[x].begin());
        }
    }
    void build(vector<int> & a) {
        n = a.size();
        tree.resize(4 * n);
        build(0, 0, n, a);
    }

    int get(int x, int lx, int rx, int l, int r, int v) {
        if (lx >= r || rx <= l) return 0;
        if (l <= lx && rx <= r) {
            return (upper_bound(all(tree[x]), v) - tree[x].begin());
        }
        int mid = (lx + rx) / 2;
        return get(2 * x + 1, lx, mid, l, r, v) + get(2 * x + 2, mid, rx, l, r, v);
    }
    int get(int l, int r, int v) {
        r++;
        return get(0, 0, n, l, r, v);
    }
};
void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    g.resize(n);
    d.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        while (t--) {
            int u;
            cin >> u;
            u--;
            g[i].push_back(u);
        }
    }
    vector<int> tin(n), tout(n);
    int timer = 0;
    function<void(int, int)> dfs = [&](int u, int last) {
        dbg(u, last);
        tin[u] = timer++;
        if (!g[u].empty()) {
            for (int i = 0; i < 2; i++){
                int v = g[u][i];
                d[v] = d[u] + (i != last && last != -1);
                dfs(v, i);
            }
        }
        tout[u] = timer;
    };
    dfs(0, -1);
    vector<int> b(n, 1e9);
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) {
            b[i] = d[i];
        }
    }
    segtree st;
    st.build(b);
    while (q--) {
        int u;
        cin >> u;
        u--;
//        dbg("next");
        if (d[u] > k) {
            cout << "0\n";
            continue;
        }
        cout << st.get(tin[u], tout[u], k - d[u]) << "\n";
    }
}

int32_t main() {
#ifdef CLOWN
    freopen("C://work//ezwin//input.txt", "r", stdin);
    freopen("C://work//ezwin//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
