#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 35;
const ll INF = 1e18;

struct node {
    ll idx, l, r;
};

bool comp(node a, node b) {
    if (a.r == b.r) {
        return a.l < b.l;
    }
    return a.r < b.r;
}

bool inter(node a, node b) {
    return b.l <= a.r;
}

void solve() {
    ll n; cin >> n;
    vector<node> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].r;
        a[i].idx = i;
    }

    sort(a.begin(), a.end(), comp);

    ll st = 0;
    ll cur_r = -1;
    for (auto seg : a) {
        if (seg.l > cur_r) {
            cur_r = seg.r;
            st++;
        }
    }

    vector<vector<ll>> cross(n + 1, vector<ll>(n + 1, 0));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            for (int h = i + 1; h < j; h++) {
                if (inter(a[i - 1], a[h - 1]) || inter(a[h - 1], a[j - 1])) {
                    cross[i][j]++;
                }
                // cout << i << " " << j << " " << cross[i][j] << '\n';
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if ((inter(a[j], a[i]) && a[j].r <= a[i].r) || (inter(a[i], a[j]) && a[i].r <= a[j].r)) {
                cross[0][i]++;
            }
        }
    }

    vector<vector<ll>> dp(n + 1, vector<ll> (n + 1, -INF));
    vector<vector<ll>> p(n + 1, vector<ll> (n + 1, 0));

    dp[0][0] = 0;

    for (int i = 1; i <= n; i++) {
        for (int mx = 1; mx <= i; mx++) {

            for (int j = i - 1; j >= 0; j--) {
                if (mx > 0 && dp[j][mx - 1] + cross[j][i] > dp[i][mx]) {
                    dp[i][mx] = dp[j][mx - 1] + cross[j][i];
                    p[i][mx] = j;
                }
            }

            // cout << i << " " << mx << "   " << dp[i][mx] << '\n';
        }
    }
    ll lst = 0;
    for (int i = 1; i <= n; i++) {
        if (dp[i][st / 2] > dp[lst][st / 2]) {
            lst = i;
        }
    }
    assert(dp[lst][st / 2] + ans.size() >= n / 2);
    set<ll> has;
    vector<ll> ans;
    ll pref = lst, res = st / 2;
    while (res > 0) {
        ans.push_back(pref - 1);
        has.insert(pref - 1);
        pref = p[pref][res];
        res--;
    }
    vector<ll> gen = {ans};
    for (int i = 0; i < n && gen.size() < n / 2; i++) {
        if (has.find(i) != has.end()) continue;
        bool ch = false;
        for (auto j : ans) {
            if ((inter(a[j], a[i]) && a[j].r <= a[i].r) || (inter(a[i], a[j]) && a[i].r <= a[j].r)) {
                ch = true;
            }
        }
        if (ch) {
            gen.push_back(i);
        }
    }
    for (auto i : gen) cout << a[i].idx + 1 << " ";
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }
}