#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
const int SZ = 3e5;
mt19937 rd(100232103);

void tests(int n, int q, vector<ll> w, ll max_a, ll max_b) {
	vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
	vector<vector<vector<bool>>> ans(n + 1, vector<vector<bool>>(max_a, vector<bool>(max_b, 0)));
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		for (ll a = 0; a < max_a; a++) {
			for (ll b = 0; b < max_b; b++) {
				dp[i][a][b] = dp[i - 1][a][b];
				if (a >= w[i])
					dp[i][a][b] = dp[i][a][b] | dp[i - 1][a - w[i]][b];
				if (b >= w[i])
					dp[i][a][b] = dp[i][a][b] | dp[i - 1][a][b - w[i]];
			}
		}
	}
	ans[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		ans[i][0][0] = 1;
		for (int j = 1; j < max_a; j++) {
			ans[i][j][0] = ans[i][j - 1][0] & dp[i][j][0];
		}
		for (int j = 1; j < max_b; j++) {
			ans[i][0][j] = ans[i][0][j - 1] & dp[i][0][j];
		}
		for (int a = 1; a < max_a; a++) {
			for (int b = 1; b < max_b; b++)
				ans[i][a][b] = dp[i][a][b] & ans[i][a - 1][b] & ans[i][a][b - 1];
		}
	}

	ll z, v = 0;
	cin >> z;
	for (int i = 0; i < q; i++) {
		ll j, k, a, b, c, d;
		cin >> j >> c >> d;
		k = j - v * z;
		a = c - v * z;
		b = d - v * z;

		int l = 0, r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (w[mid] <= k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (a < max_a && b < max_b && ans[l][a][b]) {
			v++;
			cout << "Yes" << endl;
		}
		else {
			cout << "No" << endl;
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int n, q;
	cin >> n >> q;
	vector<ll> w(n + 1, 0);
	for (int i = 1; i <= n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());
	if (n <= 10) {
		tests(n, q, w, (1 << 10) + 2, (1 << 10) + 2);
		return 0;
	} 
	if (w.back() > 300) {
		tests(n, q, w, w.back() + 1, 1);
		return 0;
	}
	tests(n, q, w, 300 + 1, 300 + 1);
}
