#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>

using namespace std;

typedef pair<int, int> pii;

#define All(x) (x).begin(), (x).end()
#define X first
#define Y second

const int N = 100 + 1;
const int A = 300 + 1, B = 300 + 1;

bool dp[N][A][B];

void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	sort(All(w));
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		int x = w[i-1];
		for (int a = 0; a < A; a++) {
			for (int b = 0; b < B; b++) {
				dp[i][a][b] |= dp[i - 1][a][b];
				if (a - x >= 0)
					dp[i][a][b] |= dp[i - 1][a - x][b];
				if (b - x >= 0)
					dp[i][a][b] |= dp[i - 1][a][b - x];
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int a = 0; a < A; a++) {
			for (int b = 0; b < B; b++) {
				dp[i][a][b] &= (a == 0 || dp[i][a - 1][b]);
				dp[i][a][b] &= (b == 0 || dp[i][a][b - 1]);
			}
		}
	}
	int z; cin >> z;
	while (q--) {
		int k, a, b;
		cin >> k >> a >> b;
		int i = upper_bound(All(w), k) - w.begin() - 1;
		cout << (dp[i + 1][a][b] ? "YES" : "NO") << '\n';
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	solve();
}