#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define All(x) (x).begin(), (x).end()
#define X first
#define Y second

const int N = 100 + 5;
const int A = 300 + 5, B = 300 + 5;

bool dp[N][A][B];

void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	int r = 0;
	for (int i = 0; i < n; i++) {
		if (w[i] <= r + 1) {
			r += w[i];
		}
		else
			break;
	}
	sort(All(w));
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		int x = w[i-1];
		for (int a = 0; a < A; a++) {
			for (int b = 0; b < B; b++) {
				dp[i][a][b] |= dp[i - 1][a][b];
				if (a - x >= 0)
					dp[i][a][b] |= dp[i - 1][a - x][b];
				if (b - x >= 0)
					dp[i][a][b] |= dp[i - 1][a][b - x];
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int a = 0; a < A; a++) {
			for (int b = 0; b < B; b++) {
				dp[i][a][b] &= (a == 0 || dp[i][a - 1][b]);
				dp[i][a][b] &= (b == 0 || dp[i][a][b - 1]);
			}
		}
	}
	int z; cin >> z;
	while (q--) {
		int a, b;
		ll k;
		cin >> k >> a >> b;
		if (b == 0) {
			cout << (a <= r ? "YES" : "NO") << '\n';
		}
		else {
			int i = upper_bound(All(w), k) - w.begin() - 1;
			cout << (dp[i + 1][a][b] ? "Yes" : "No") << '\n';
		}
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	solve();
}