#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

#define All(x) (x).begin(), (x).end()
#define X first
#define Y second

vector<vector<ll>> gr, dp;
vector<ll> l, r;

void dfs(ll v, ll p = -1) {
	dp[v][0] = 0;
	dp[v][1] = r[v];
	for (ll u : gr[v]) {
		if (u == p) continue;
		dfs(u, v);
		dp[v][0] += max(dp[u][0], dp[u][1]);
		dp[v][1] += dp[u][0];
	}
}

vector<ll> ans;

void restore(ll v, ll st, ll p = -1) {
	if (st == 0 || (st == 1 && dp[v][0] > dp[v][1])) {
		for (ll u : gr[v]) {
			if (u == p) continue;
			restore(u, 1, v);
		}
	}
	else {
		ans.push_back(v);
		for (ll u : gr[v]) {
			if (u == p) continue;
			restore(u, 0, v);
		}
	}
}

ll mod;

ll mul(ll a, ll b) {
	return (1ll * a * b) % mod;
}

void solve() {
	ll n, q, v, u;
	cin >> n >> q;
	ll x, y;
	cin >> x >> y >> mod;
	
	gr.resize(n);
	l.resize(n);
	r.resize(n);
	dp.assign(n, vector<ll>(2));
	
	for (ll i = 0; i < n - 1; i++) {
		cin >> v >> u;
		v--, u--;
		gr[v].push_back(u);
		gr[u].push_back(v);
	}
	bool lr = 1;
	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
		lr &= (l[i] == r[i]);
	}
	dfs(0);
	ll opt = max(dp[0][0], dp[0][1]);
	restore(0, 1, -1);
	vector<pii> plans(q), init;
	for (ll i = 0; i < q; i++) {
		cin >> plans[i].X;
		plans[i].Y = i;
	}
	init = plans;
	sort(All(plans));
	vector<ll> qr_ans(q);
	ll pref = 0, ptr = 0, have = 0, silent = 0;
	for (ll v = 0; v < n; v++) {
		silent ^= mul(v + 1, x);
	}
	for(ll i = 0; i < q; i++){
		ll val = plans[i].X, id = plans[i].Y;
		if (lr) {
			if (val != opt)
				qr_ans[id] = -1;
			else {
				ll hash = 0;
				for (ll j = 0; j < n; j++) {
					hash ^= (((mul(x, j + 1) + mul(y, mul(r[j], r[j])))) % mod);
				}
				qr_ans[id] = hash;
			}
		}
		else {
			if (val > opt)
				qr_ans[id] = -1;
			else {
				while (have < val) {
					ll v = ans[ptr];
					if (r[v] + have < val) {
						have += r[v];
						silent ^= mul(v + 1, x);
						pref ^= (((mul(v + 1, x) + mul(y, mul(r[v], r[v]))) % mod));
						ptr++;
					}
					else
						break;
				}
				ll extra = val - have;
				ll hash = (pref ^ silent);
				if (extra > 0) {
					ll v = ans[ptr];
					hash ^= mul(v + 1, x);
					hash ^= (((mul(v + 1, x) + mul(y, mul(extra, extra))) % mod));
				}
				qr_ans[id] = hash;
			}
		}
	}
	for (ll i = 0; i < q; i++)
		cout << qr_ans[i] << ' ';
	cout << '\n';
	cout << endl;
	while (1) {
		ll i;
		cin >> i;
		i--;
		if (i == -1) return;
		if (lr) {
			if (init[i].X == opt) {
				for (ll v = 0; v < n; v++)
					cout << r[v] << ' ';
				cout << endl;
			}
			else
				cout << -1 << endl;
		}
		else {
			if (init[i].X > opt)
				cout << -1 << endl;
			else {
				vector<ll> a(n, 0);
				ll ptr = 0, have = 0, val = init[i].X;
				while (have < val) {
					ll v = ans[ptr];
					if (r[v] + have < val) {
						have += r[v];
						a[v] += r[v];
						ptr++;
					}
					else
						break;
				}
				ll extra = val - have;
				if (extra > 0) {
					ll v = ans[ptr];
					a[v] += extra;
				}
				ll hash = 0;
				for (int v = 0; v < n; v++) {
					hash ^= ((mul(v + 1, x) + mul(y, mul(a[v], a[v])) % mod));
				}
				//cerr << hash << '\n';
				for (ll x : a)
					cout << x << ' ';
				cout << endl;
			}
		}
	}
	cout << endl;
}

void init() {
	gr.clear();
	ans.clear();
	dp.clear();
	l.clear();
	r.clear();
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		init();
		solve();
	}
}