#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define All(x) (x).begin(), (x).end()
#define X first
#define Y second

vector<vector<int>> gr, dp;
vector<int> l, r;

void dfs(int v, int p = -1) {
	dp[v][0] = 0;
	dp[v][1] = r[v];
	for (int u : gr[v]) {
		if (u == p) continue;
		dfs(u, v);
		dp[v][0] += max(dp[u][0], dp[u][1]);
		dp[v][1] += dp[u][0];
	}
}

vector<int> ans;

void restore(int v, int st, int p = -1) {
	if (st == 0 || (st == 1 && dp[v][0] > dp[v][1])) {
		for (int u : gr[v]) {
			if (u == p) continue;
			restore(u, 1, v);
		}
	}
	else {
		ans.push_back(v);
		for (int u : gr[v]) {
			if (u == p) continue;
			restore(u, 0, v);
		}
	}
}

int mod;

int mul(int a, int b) {
	return (1ll * a * b) % mod;
}

void solve() {
	int n, q, v, u;
	cin >> n >> q;
	int x, y;
	cin >> x >> y >> mod;
	
	gr.resize(n);
	l.resize(n);
	r.resize(n);
	dp.assign(n, vector<int>(2));
	
	for (int i = 0; i < n - 1; i++) {
		cin >> v >> u;
		v--, u--;
		gr[v].push_back(u);
		gr[u].push_back(v);
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	dfs(0);
	int opt = max(dp[0][0], dp[0][1]);
	restore(0, 1, -1);
	vector<int> plans;
	while (q--) {
		int val;
		cin >> val;
		plans.push_back(val);
		if (val != opt)
			cout << -1 << endl;
		else {
			int hash = 0;
			for (int j = 0; j < n; j++) {
				hash ^= ((mul(x, j + 1) + mul(y, mul(r[j], r[j]))) % mod);
			}
			cout << hash << endl;
		}
	}
	cout << endl;
	while (1) {
		int i;
		cin >> i;
		i--;
		if (i == -1) return;
		if (plans[i] == opt) {
			for (int v = 0; v < n; v++)
				cout << r[v] << ' ';
			cout << endl;
		}
	}
	cout << endl;
}

void init() {
	gr.clear();
	ans.clear();
	dp.clear();
	l.clear();
	r.clear();
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		init();
		solve();
	}
}