#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;

int norm(int x, int n) {
    int f = (x % n + n) % n + 1;
    return f;
}

vector<int> get(const vector<int> &a, const int &n) {
    int k = (int)a.size();
    set<int> Q;
    for (int i = 1; i <= n; i++) {
        Q.insert(i);
        Q.insert(i + n);
    }
    for (int i = 0; i < k; i++) {
        int x = a[i];
        Q.erase(x);
        Q.erase(x + n);
    }
    vector<int> ans;
    for (int i = 0; i < k; i++) {
        int x;
        if (*prev(Q.end()) < a[i]) {
            x = *Q.begin();
        } else {
            x = *Q.lower_bound(a[i]);
        }
        ans.push_back((x - 1) % n + 1);
        Q.erase(x);
    }
    sort(ans.begin(), ans.end());
    return ans;
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> a;
    set<int> Q;
    for (int i = 1; i <= n; i++) {
        Q.insert(i);
        Q.insert(i + n);
    }
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        a.push_back(x);
        Q.erase(x);
        Q.erase(x + n);
    }
    vector<int> ans = get(a, n);
    for (int i = 0; i < k; i++) {
        cout << ans[i] << " \n"[i == k - 1];
    }
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
    }
    for (int j = 0; j < k; j++) {
        vector<int> b;
        vector<bool> used(2 * n + 1);
        for (int i = j + 1; i < k; i++) {
            b.push_back(a[i]);
            used[a[i]] = true;
        }
        for (int i = 0; i <= j; i++) {
            b.push_back(a[i] + n);
            used[a[i] + n] = true;
        }
        vector<int> res;
        for (int i = 2 * n; i >= 1; i--) {
            if (!used[i] && !b.empty() && b.back() > i) {
                res.push_back((i - 1) % n + 1);
                b.pop_back();
            }
        }
        sort(res.begin(), res.end());
        if (get (res, n) == a) {
            for(int i = 0; i < k; i++) {
                cout << res[i] << " \n"[i == k - 1];
            }
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    int m;
    cin >> m;
    while (m--) {
        if (t == 1) {
            solve1();
        } else {
            solve2();
        }
    }
    return 0;
}