#include <bits/stdc++.h>
using namespace std;

vector<int> ask(const deque<pair<int, int>> &S) {
    int n = (int)S.size();
    vector<int> dp(n + 1);
    vector<int> opt(n + 1, -1);
    for (int j = 0, i = 1; i <= n; i++) {
        while (j < n && S[j].second < S[i - 1].first) {
            j++;
        }
        dp[i] = dp[i - 1];
        if (dp[i] < dp[j] + 1) {
            dp[i] = dp[j] + 1;
            opt[i] = j;
        }
    }
    vector<int> res;
    for (int i = n; i > 0;) {
        if (opt[i] == -1) {
            i--;
        } else {
            res.push_back(i);
            i = opt[i];
        }
    }
    reverse(res.begin(), res.end());
    return res;
}

void solve() {
    int n;
    cin >> n;
    deque<pair<int, int>> S(n);
    map<pair<int, int>, vector<int>> ind;
    for (int num = 0; auto &[l, r] : S) {
        cin >> l >> r;
        ind[make_pair(l, r)].push_back(num);
        num++;
    }
    sort(S.begin(), S.end(), [](const auto &A, const auto &B) {
        return A.second < B.second;
    });
    auto Q = ask(S);
    vector<bool> mark(n);
    int m = Q.size();
    for (int i : Q) {
        mark[i] = true;
    }
    {
        deque<int> A;
        deque<int> B;
        for (int i = 0; i < n; i++) {
            if (mark[i]) A.push_back(i);
            else B.push_back(i);
        }
        while (A.size() > m / 2) {
            A.pop_front();
            if (!B.empty() && (A.empty() || S[B.front()].second < S[A.front()].second)) {
                A.push_front(B.front());
                B.pop_front();
            }
        }

        while (A.size() + B.size() > n / 2) {
            B.pop_back();
        }

        if (A.size() + B.size() == n / 2) {
            for (int i : A) {
                cout << ind[S[i]].back() + 1 << " ";
                ind[S[i]].pop_back();
            }
            for (int i : B) {
                cout << ind[S[i]].back() + 1 << " ";
                ind[S[i]].pop_back();
            }
            cout << "\n";
            return;
        }
    }
    {
        deque<int> A;
        deque<int> B;
        for (int i = 0; i < n; i++) {
            if (mark[i]) A.push_back(i);
            else B.push_back(i);
        }
        sort(A.begin(), A.end(), [&](int i, int j) {
            return S[i].first < S[j].first;
        });
        sort(B.begin(), B.end(), [&](int i, int j) {
            return S[i].first < S[j].first;
        });
        while (A.size() > m / 2) {
            A.pop_back();
            if (!B.empty() && (A.empty() || S[B.back()].first > S[A.back()].first)) {
                A.push_back(B.back());
                B.pop_back();
            }
        }

        while (A.size() + B.size() > n / 2) {
            B.pop_back();
        }

        if (A.size() + B.size() == n / 2) {
            for (int i : A) {
                cout << ind[S[i]].back() + 1 << " ";
                ind[S[i]].pop_back();
            }
            for (int i : B) {
                cout << ind[S[i]].back() + 1 << " ";
                ind[S[i]].pop_back();
            }
            cout << "\n";
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}