#include <bits/stdc++.h>
#define int long long
using namespace std;

void dp_on_graph(const vector<int> &a, const vector<vector<int>> &g, vector<vector<int>> &dp, int u = 0, int p = -1) {
    dp[u][0] = 0;
    dp[u][1] = a[u];
    for (int v : g[u]) {
        if (v != p) {
            dp_on_graph(a, g, dp, v, u);
            dp[u][0] += max(dp[v][0], dp[v][1]);
            dp[u][1] += dp[v][0];
        }
    }
}

void come_back(vector<int> &out, const vector<vector<int>> &dp, const vector<vector<int>> &g, int u = 0, int p = -1, bool can = true) {
    if (!can || dp[u][0] > dp[u][1]) {
        for (int v : g[u]) {
            if (v != p) {
                come_back(out, dp, g, v, u);
            }
        }
    } else {
        out.push_back(u);
        for (int v : g[u]) {
            if (v != p) {
                come_back(out, dp, g, v, u, false);
            }
        }
    }
}

int cerf(const vector<int> &a, const int &x, const int &y, const int &m) {
    int n = (int)a.size();
    int res = 0;
    for (int i = 0; i < n; i++) {
        res ^= (x * (i + 1) + y * a[i] % m * a[i]) % m;
    }
    return res;
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> l(n);
    vector<int> r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }

    vector<int> out;
    {
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = r[i];
        }
        vector<vector<int>> dp(n, vector<int>(2));
        dp_on_graph(a, g, dp);
        come_back(out, dp, g);
        for (int i = 0; i < (int)out.size();) {
            if (r[out[i]] == 0) {
                swap(out[i], out.back());
                out.pop_back();
            } else {
                i++;
            }
        }
    }

    vector<int> val(out.size() + 1);
    vector<int> sum(out.size() + 1);
    val[0] = 0;
    for (int i = 1; i <= n; i++) {
        val[0] ^= x * i % m;
    }
    for (int i = 1; i <= (int)out.size(); i++) {
        val[i] = val[i - 1] ^ (x * (out[i - 1] + 1)) % m ^ (x * (out[i - 1] + 1) + y * r[out[i - 1]]) % m;
        sum[i] = sum[i - 1] + r[i];
    }

    vector<int> u(q);
    for (int i = 0; i < q; i++) {
        cin >> u[i];
        if (u[i] > sum.back()) {
            cout << -1;
        } else if (u[i] == sum.back()) {
            cout << val.back();
        } else {
            int j = prev(upper_bound(sum.begin(), sum.end(), u[i])) - sum.begin();
            cout << (val[j] ^ (x * (out[j] + 1)) % m ^ (x * (out[j] + 1) + y * (u[i] - sum[j])) % m);
        }
        cout << " \n"[i == q - 1];
    }
    cout.flush();

    int i;
    while (true) {
        cin >> i;
        if (i == 0) {
            break;
        }
        i--;
        if (u[i] > (int)out.size()) {
            cout << -1 << endl;
        } else if (u[i] == sum.back()) {
            vector<int> a(n);
            for (int j : out) {
                a[j] = r[j];
            }
            for (int j = 0; j < n; j++) {
                cout << a[j] << " \n"[j == n - 1];
            }
            cout.flush();
        } else {
            vector<int> a(n);
            int t = prev(upper_bound(sum.begin(), sum.end(), u[i])) - sum.begin();
            for (int j = 0; j < t; j++) {
                a[out[j]] = r[out[j]];
            }
            a[out[t]] = u[i] - sum[t];
            for (int j = 0; j < n; j++) {
                cout << a[j] << " \n"[j == n - 1];
            }
            cerr << cerf(a, x, y, m) << endl;
            cout.flush();
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}