#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <string>

using ll = long long;
using ld = long double;
using std::cin;
using std::cout;
using std::vector;
using std::string;
#define all(x) x.begin(),x.end()

struct el
{
	ll l = -1, r = -1;
};

vector<vector<ll>> ms;
vector<el> vc;

void merge(vector<ll>& r, vector<ll>& a, vector<ll>& b)
{
	ll ai = 0;
	ll bi = 0;
	while (ai < a.size() || bi < b.size())
	{
		if (ai < a.size() && (bi >= b.size() || a[ai] < b[bi]))
		{
			r.push_back(a[ai]);
			++ai;
		}
		else
		{
			r.push_back(b[bi]);
			++bi;
		}
	}
}

//p == 0 - лево
//p == 1 - право
void bd(ll t, ll p, ll c)
{
	if (vc[t].l == -1 && vc[t].r == -1)
	{
		ms[t] = { c };
		return;
	}

	bd(vc[t].l, 0, c + (p == 1));
	bd(vc[t].r, 1, c + (p == 0));
	merge(ms[t], ms[vc[t].l], ms[vc[t].r]);
}

ll f(ll t, ll k)
{
	return std::upper_bound(all(ms[t]), k) - ms[t].begin();
}

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, k, q; cin >> n >> k >> q;
	vc.resize(n);
	ms.resize(n);
	for (ll i = 0; i < n; ++i)
	{
		ll u; cin >> u;
		if (u == 0)continue;
		ll l, r; cin >> l >> r; --l; --r;
		vc[i] = { l,r };
	}

	bd(0, -1, 0);

	while (q--)
	{
		ll u; cin >> u; --u;
		//cout << '\t';
		cout << f(u, k);
		cout << '\n';
	}
}