#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void solve() {
	int h, w, n;
	cin >> h >> w >> n;
	vector<int> xs(n), ys(n);
	for (int i = 0; i < n; ++i) {
		cin >> xs[i] >> ys[i];
	}
	sort(xs.begin(), xs.end());
	xs.erase(unique(xs.begin(), xs.end()), xs.end());
	sort(ys.begin(), ys.end());
	ys.erase(unique(ys.begin(), ys.end()), ys.end());
	pair<int, int> ansX = make_pair(xs.back() - xs.front(), 0);
	pair<int, int> ansY = make_pair(ys.back() - ys.front(), 0);
	for (int i = 0; i + 1 < (int) xs.size(); ++i) {
		ckmin(ansX, make_pair(h - (xs[i + 1] - xs[i]), min(xs[i], h - xs[i])));
		ckmin(ansX, make_pair(h - (xs[i + 1] - xs[i]), min(xs[i + 1] - 1, h - (xs[i + 1] - 1))));
	}
	for (int i = 0; i + 1 < (int) ys.size(); ++i) {
		ckmin(ansY, make_pair(w - (ys[i + 1] - ys[i]), min(ys[i], w - ys[i])));
		ckmin(ansY, make_pair(w - (ys[i + 1] - ys[i]), min(ys[i + 1] - 1, w - (ys[i + 1] - 1))));
	}
	cout << (ansX.first + 1) * (ansY.first + 1) << " " << ansX.second + ansY.second << endl;
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
