#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<int>> dp(n + 2, vector<int>(n + 2, (int) -1e9));
	dp[0][n + 1] = 0;
	for (int i = 0; i < n; ++i) {
		auto ndp = dp;
		for (int j = 0; j < a[i]; ++j) {
			for (int k = 0; k <= n + 1; ++k) {
				ckmax(ndp[a[i]][k], dp[j][k] + 1);
			}
		}
		for (int j = a[i] + 1; j <= n + 1; ++j) {
			for (int k = 0; k <= n + 1; ++k) {
				ckmax(ndp[k][a[i]], dp[k][j] + 1);
			}
		}
		dp = ndp;
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			ckmax(ans, dp[i][j]);
		}
	}
	cout << ans << endl;
}

int32_t main() {
	int T = 1;
	cin >> T;
#ifdef LOCAL
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
