#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

int n, k, m;
vector<vector<int>> g;
vector<int> d, dp, dp2;

void dfs(int u) {
	dp2[u] = (g[u].empty() && dp[u] <= k);
	for (const int &v : g[u]) {
		dfs(v);
		dp2[u] += dp2[v];
	}
}

void solve() {
	g.clear();
	cin >> n >> k >> m;
	g.resize(n);
	d.resize(n);
	d[0] = -1;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		for (int j = 0; j < t; ++j) {
			int x;
			cin >> x;
			--x;
			g[i].push_back(x);
			d[x] = j;
		}
	}
	dp.resize(n);
	dp[0] = 0;
	{
		queue<int> q;
		q.push(0);
		while (!q.empty()) {
			int u = q.front();
			q.pop();
			for (const int &v : g[u]) {
				dp[v] = dp[u] + (u && d[u] != d[v]);
				q.push(v);
			}
		}
	}
	dp2.resize(n);
	dfs(0);
	for (int i = 0; i < m; ++i) {
		int u;
		cin >> u;
		--u;
		cout << dp2[u] << endl;
	}
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
