#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

void solve() {
	int n;
	cin >> n;
	vector<int> coords;
	vector<tuple<int, int, int>> events;
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		coords.push_back(l);
		coords.push_back(r);
		events.emplace_back(l, r, i);
	}
	sort(coords.begin(), coords.end());
	coords.erase(unique(coords.begin(), coords.end()), coords.end());
	for (int i = 0; i < n; ++i) {
		//get<0>(events[i]) = lower_bound(coords.begin(), coords.end(), get<0>(events[i])) - coords.begin();
		//get<1>(events[i]) = lower_bound(coords.begin(), coords.end(), get<1>(events[i])) - coords.begin();
	}
	sort(events.begin(), events.end());
	int m = 0;
	{
		vector<int> dp(n, 1);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < i - 1; ++j) {
				if (get<1>(events[j]) < get<0>(events[i])) {
					ckmax(dp[i], dp[j] + 1);
				}
			}
			ckmax(m, dp[i]);
		}
		assert(m % 2 == 0);
	}
	for (int mask = 0; mask < (1 << n); ++mask) {
		if (__builtin_popcountll(mask) != n / 2) {
			continue;
		}
		vector<int> dp(n, 1);
		for (int i = 0; i < n; ++i) {
			if (!bit_i(mask, i)) {
				continue;
			}
			for (int j = 0; j < i - 1; ++j) {
				if (!bit_i(mask, j)) {
					continue;
				}
				if (get<1>(events[j]) < get<0>(events[i])) {
					ckmax(dp[i], dp[j] + 1);
				}
			}
		}
		int ans = *max_element(dp.begin(), dp.end());
		if (ans == m / 2) {
			for (int i = 0; i < n; ++i) {
				if (bit_i(mask, i)) {
					cout << get<2>(events[i]) + 1 << " ";
				}
			}
			cout << endl;
			return;
		}
	}
	assert(0);
}

int32_t main() {
	int T = 1;
	cin >> T;
#ifdef LOCAL
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
