#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

void solve() {
	int n;
	cin >> n;
	vector<tuple<int, int, int>> events;
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		events.emplace_back(l, -r, i);
	}
	sort(events.begin(), events.end());
	for (int i = 0; i < n; ++i) {
		get<1>(events[i]) *= -1;
	}
	vector<int> pr(n);
	vector<int> st;
	st.push_back(-1);
	for (int i = 0; i < n; ++i) {
		while (st.back() != -1 && get<1>(events[st.back()]) < get<0>(events[i])) {
			st.pop_back();
		}
		if (st.back() != -1) {
			assert(get<0>(events[st.back()]) <= get<0>(events[i]));
			assert(get<1>(events[i]) <= get<1>(events[st.back()]));
		}
		pr[i] = st.back();
		st.push_back(i);
	}
	vector<int> cnt(n, 0);
	for (int i = 0; i < n; ++i) {
		if (pr[i] != -1) {
			++cnt[pr[i]];
		}
	}
	int m = 0;
	for (int i = 0; i < n; ++i) {
		if (cnt[i] == 0) {
			++m;
		}
	}
	assert(m % 2 == 0);
	set<pair<int, int>> q;
	for (int i = 0; i < n; ++i) {
		q.insert(make_pair(cnt[i], i));
	}
	vector<int> used(n, 1);
	int k = m;
	for (int i = 0; i < n / 2; ++i) {
		int u = q.begin()->second;
		q.erase(q.begin());
		if (k == m / 2) {
			if (cnt[u] == 0) {
				if (pr[u] != 1) {
					cnt[pr[u]] = -1;
				}
			} else {
				used[u] = 0;
			}
		} else {
			assert(cnt[u] == 0);
			used[u] = 0;
			--k;
		}
		if (pr[u] != -1) {
			q.erase(make_pair(cnt[pr[u]], pr[u]));
			--cnt[pr[u]];
			q.insert(make_pair(cnt[pr[u]], pr[u]));
			if (cnt[pr[u]] == 0) {
				++k;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			cout << get<2>(events[i]) + 1 << " ";
		}
	}
	cout << endl;
}

int32_t main() {
	int T = 1;
	cin >> T;
#ifdef LOCAL
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
