#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	{
		int z;
		cin >> z;
		assert(z == 0);
	}
	sort(a.begin(), a.end());
	vector<vector<tuple<int, int, int>>> Q(n + 1);
	for (int i = 0; i < m; ++i) {
		int k, x, y;
		cin >> k >> x >> y;
		int j = upper_bound(a.begin(), a.end(), k) - a.begin();
		Q[j].emplace_back(x, y, i);
	}
	set<pair<int, int>> q;
	q.insert(make_pair(0, 0));
	set<pair<int, int>> q2;
	q2.insert(make_pair(0, 0));
	vector<int> ans(m, 0);
	for (const tuple<int, int, int> &e : Q[0]) {
		if (get<0>(e) == 0 && get<1>(e) == 0) {
			ans[get<2>(e)] = 1;
		}
	}
	for (int i = 0; i < n; ++i) {
		vector<pair<int, int>> qn;
		for (const pair<int, int> &e : q) {
			qn.emplace_back(e.first + a[i], e.second);
			qn.emplace_back(e.first, e.second + a[i]);
		}
		for (const pair<int, int> &e : qn) {
			q.insert(e);
			if (e.first == 0) {
				if (q2.find(make_pair(0, e.second - 1)) != q2.end()) {
					q2.insert(e);
				}
			} else if (e.second == 0) {
				if (q2.find(make_pair(e.first - 1, e.second)) != q2.end()) {
					q2.insert(e);
				}
			} else if (q2.find(make_pair(e.first - 1, e.second)) != q2.end() && q2.find(make_pair(e.first, e.second - 1)) != q2.end()) {
				q2.insert(e);
			}
		}
		for (const tuple<int, int, int> &e : Q[i + 1]) {
			if (q2.find(make_pair(get<0>(e), get<1>(e))) != q2.end()) {
				ans[get<2>(e)] = 1;
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		if (ans[i]) {
			cout << "Yes" << endl;
		} else {
			cout << "No" << endl;
		}
	}
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
