#include <vector>
#include <iostream>
#include <algorithm>
#include <chrono>
#include <deque>

using namespace std;
typedef long long ll;
#define cout_ cout << "-------------------------\n";
#pragma region prints
void print(vector<ll>& vec)
{
	for (int i = 0; i < vec.size(); i++)
		cout << vec[i] << " ";
	cout << endl;
}

void print(vector<pair<ll, ll>>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].first << " " << vec[i].second << endl;
	}
}
#pragma endregion


void dfs(vector<pair<ll, ll>>& g, ll v, vector<pair<ll, ll>>& turns)
{
	//cout << v << endl;
	if (g[v].first != -1 && g[v].second != -1)
	{
		turns[g[v].first] = { (turns[v].second != 1 ? turns[v].first : turns[v].first + 1), -1 };
		turns[g[v].second] = { (turns[v].second != -1 ? turns[v].first : turns[v].first + 1), 1 };
		dfs(g, g[v].first, turns);
		dfs(g, g[v].second, turns);
	}
}


ll dfs2(vector<pair<ll, ll>>& g, ll v, vector<bool>& isgodlist, vector<ll>& ans)
{
	if (g[v].first == -1 && g[v].second == -1)
	{
		return isgodlist[v];
	}
	else
	{
		ll sum = dfs2(g, g[v].first, isgodlist, ans) + dfs2(g, g[v].second, isgodlist, ans);
		ans[v] = sum;
		return sum;
	}
}


int main()
{
	ll n, k, q;
	cin >> n >> k >> q;
	vector<pair<ll, ll>> g(n);
	vector<bool> islist(n, false);
	vector<ll> p(n, -1);
	for (int i = 0; i < n; i++)
	{
		ll t;
		cin >> t;
		if (t == 2)
		{
			ll l, r;
			cin >> l >> r;
			l--; r--;
			g[i] = { l, r };
			p[l] = i;
			p[r] = i;
		}
		else
		{
			islist[i] = true;
			g[i] = { -1, -1 };
		}
	}
	//cout_;
	//print(g);
	//cout_;
	vector<pair<ll, ll>> turns(n, {0, 0}); // -1 left 1 right;
	dfs(g, 0, turns);



	vector<bool> isgodlist(n, false);
	for (int i = 0; i < n; i++)
	{
		if (islist[i] && turns[i].first <= k)
			isgodlist[i] = true;
	}
	//print(turns);
	//cout_;



	//print(p);
	//return 0;
	vector<ll> ans(n);
	dfs2(g, 0, isgodlist, ans);
	
	//cout_;
	//print(ans);
	


	while (q--)
	{
		ll u;
		cin >> u;
		u--;
		cout << ans[u] << endl;
	}
}
