#include <bits/stdc++.h>
using namespace std;
const int inf = 1e9;

struct SegTree {
    int n, N;
    vector<int> st;
    SegTree() {}
    SegTree(int _n) {
        n = _n;
        N = 1;
        while (N < n) {
            N *= 2;
        }
        st.resize(2 * N, -inf);
    }
    void maxEq(int i, int val) {
        int v = i + N;
        while (v > 0) {
            st[v] = max(st[v], val);
            v >>= 1;
        }
    }
    int getMax(int l, int r) {
        int vl = l + N, vr = r + N;
        int res = 0;
        while (vl < vr) {
            if (vl & 1) {
                res = max(res, st[vl]);
            }
            vl = ((vl + 1) >> 1);
            if ((vr ^ 1) & 1) {
                res = max(res, st[vr]);
            }
            vr = ((vr - 1) >> 1);
        }
        if (vl == vr) {
            res = max(res, st[vl]);
        }
        return res;
    }
    ~SegTree() {}
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<SegTree> stqr(n + 2, SegTree(n + 2)), strq(n + 2, SegTree(n + 2));
    vector<vector<int>> dpqr(n + 2, vector<int>(n + 2, -inf));
    vector<vector<int>> dprq(n + 2, vector<int>(n + 2, -inf));
    dpqr[0][n + 1] = 0;
    stqr[0].maxEq(n + 1, 0);
    dprq[n + 1][0] = 0;
    strq[n + 1].maxEq(0, 0);
    vector<pair<int, int>> updQ, updR;
    vector<int> metQ = {0, n + 1}, metR = {0, n + 1};
    for (int iter = 0; iter < n; ++iter) {
        // cerr << "iter: " << iter << '\n';
        int x = a[iter];
        // cerr << "x: " << x << '\n';
        // q
        for (const int& j : metQ) {
            int val = strq[j].getMax(0, x - 1);
            if (val != -inf) {
                // cerr << "mn: " << j << ", val: " << val << '\n';
                ++val;
                // [mx = x][mn belongs to met] -> val
                updQ.emplace_back(j, val);
            }
        }
        // r
        for (const int& i : metR) {
            int val = stqr[i].getMax(x + 1, n + 1);
            if (val != -inf) {
                ++val;
                // cerr << "mx: " << i << ", val: " << val << '\n';
                // [mx belongs to met][mn = x] -> val
                updR.emplace_back(i, val);
            }
        }
        while (!updQ.empty()) {
            auto [j, val] = updQ.back();
            updQ.pop_back();
            dpqr[x][j] = max(dpqr[x][j], val);
            stqr[x].maxEq(j, val);
            dprq[j][x] = max(dprq[j][x], val);
            strq[j].maxEq(x, val);
        }
        while (!updR.empty()) {
            auto [i, val] = updR.back();
            updR.pop_back();
            dpqr[i][x] = max(dpqr[i][x], val);
            stqr[i].maxEq(x, val);
            dprq[x][i] = max(dprq[x][i], val);
            strq[x].maxEq(i, val);
        }
        metQ.emplace_back(x);
        metR.emplace_back(x);
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n + 1; ++j) {
            ans = max(ans, dpqr[i][j]);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
