#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

struct Seg {
	ll l, r, ind;
};

bool operator<(Seg a, Seg b) {
	if (a.r != b.r)
		return a.r < b.r;
	return a.l < b.l;
}

vector<ll> cost;

bool cmp(ll i, ll j) {
	return cost[i] > cost[j];
}

ll f(vector<Seg>& segs) {
	ll n = segs.size();
	vector<ll> dp(n + 1, 0);
	for (ll i = 0; i < n; i++) {
		ll l = -1, r = n, mid, ind;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			if (segs[mid].r < segs[i].l) { // отрезок хороший, можно брать
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ind = l;
		dp[i + 1] = max(dp[i], dp[ind + 1] + 1);
	}
	return dp[n];
}

void solve() {
	ll n, m;
	cin >> n;
	vector<Seg> segs(n);
	for (ll i = 0; i < n; i++) {
		cin >> segs[i].l >> segs[i].r;
		segs[i].ind = i;
	}
	sort(segs.begin(), segs.end());
	m = f(segs);
	for (ll mask = 0; mask < (1 << n); mask++) {
		vector<Seg> Cur;
		for (ll i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				Cur.push_back(segs[i]);
			}
		}
		if (Cur.size() == n / 2) {
			if (f(Cur) == m / 2) {
				for (Seg elem : Cur) {
					cout << elem.ind + 1 << " ";
				}
				cout << "\n";
				return;
			}
		}
	}
}

int main() {
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}