#include <bits/stdc++.h>

using namespace std;

#define int long long

/* consts */
const int inf = 1LL << 60;
const int mod = 100000007;

random_device rd;

/* output */
template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1,T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T& x : a) s << x << " ";
    s << endl;
    return s;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& s, map<T1,T2>& m) {
    for (auto [k, v] : m) {
        s << k << " -> " << m << endl;
    }
    return s;
}

/* do */
struct node {
    int x = 0;
    int delta = 0;
};

void update(vector<node>& tree, int i, int l, int r) {
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    tree[i].x = tree[i1].x + tree[i2].x;
}

void build_tree(vector<node>& tree, vector<int>& a, int i, int l, int r) {
    if (r - l == 1) {
        tree[i].x = a[l];
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    build_tree(tree, a, i1, l, m);
    build_tree(tree, a, i2, m, r);
    update(tree, i, l, r);
}

void build_tree(vector<node>& tree, vector<int>& a) {
    build_tree(tree, a, 0, 0, a.size());
}

int get(vector<node>& tree, int i_c, int i, int l, int r) {
    if (r - l == 1) return tree[i].x + tree[i].delta;
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    if (i_c < m)
        return tree[i].delta + get(tree, i_c, i1, l, m);
    else
        return tree[i].delta + get(tree, i_c, i2, m, r);
}

int get(vector<node>& tree, int i_c, int n) {
    return get(tree, i_c, 0, 0, n);
}

int get_i(vector<node>& tree, int l_c, int r_c, int i, int l, int r, int delta) {
    delta += tree[i].delta;
    if (l_c >= r || r_c <= l) return 0;
    if (l >= l_c && r <= r_c) {
        return delta * (r - l) + tree[i].x;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    return get_i(tree, l_c, r_c, i1, l, m, delta) + get_i(tree, l_c, r_c, i2, m, r, delta);
}

int get_i(vector<node>& tree, int l_c, int r_c, int n) {
    return get_i(tree, l_c, r_c, 0, 0, n, 0);
}

void inc(vector<node>& tree, int i_c, int x, int i, int l, int r) {
    if (r - l == 1) {
        tree[i].x += x;
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    if (i_c < m)
        inc(tree, i_c, x, i1, l, m);
    else
        inc(tree, i_c, x, i2, m, r);
    update(tree, i, l, r);
}

void inc(vector<node>& tree, int i_c, int x, int n) {
    inc(tree, i_c, x, 0, 0, n);
}

void inc_i(vector<node>& tree, int l_c, int r_c, int x, int i, int l, int r) {
    cout << "inc_i " << l_c << " " << r_c << " " << i << " " << l << " " << r << endl;
    if (l_c >= r || r_c <= l) return;
    if (l >= l_c && r <= r_c) {
        tree[i].delta += x;
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    inc_i(tree, l_c, r_c, x, i1, l, m);
    inc_i(tree, l_c, r_c, x, i2, m, r);
}

void inc_i(vector<node>& tree, int l_c, int r_c, int x, int n) {
    inc_i(tree, l_c, r_c, x, 0, 0, n);
}

pair<int,int> find_a(vector<pair<int,int>>& a, int w) {
    int n = a.size();
    sort(a.begin(), a.end());
    //cout << a;
    int max_w = -inf, max_btn = -inf;
    for (int i = n - 1; i >= 0; i--) {
        int j = (i + 1) % n;
        int tmp;
        if (j == 0)
            tmp = w - a[i].first + a[j].first - 1;
        else
            tmp = a[j].first - a[i].first - 1;
        tmp = max(0LL, tmp);
        int buttons = 0;
        if (j != 0) {
            buttons = min(a[i].first + 1, w - a[i + 1].first);
        }
        if (tmp > max_w || (tmp == max_w && buttons < max_btn)) {
            max_w = tmp;
            max_btn = buttons;
        }
    }
    //cout << max_w << " " << max_w_i << " " << buttons << endl;
    return {w - max_w, max_btn};
}

pair<int,int> solve(int h, int w, vector<pair<int,int>> a) {
    int n = a.size();
    pair<int,int> res1 = find_a(a, h);
    for (int i = 0; i < n; i++) {
        int tmp = a[i].first;
        a[i].first = a[i].second;
        a[i].second = tmp;
    }
    pair<int,int> res2 = find_a(a, w);
    return {res1.first * res2.first,res1.second + res2.second};
}

int max(vector<int>& a) {
    int ans = -inf;
    for (int x : a) ans = max(x, ans);
    return ans;
}

int min(vector<int>& a) {
    int ans = inf;
    for (int x : a) ans = min(x, ans);
    return ans;
}

pair<int,int> stupid(int h, int w, vector<pair<int,int>> a) {
    int n = a.size();
    vector<int> b(n);
    for (int i = 0; i < n; i++) b[i] = a[i].second;
    int min_c = max(b) - min(b) + 1, min_b = 0;
    vector<int> b1 = b;
    //cout << b1;
    for (int i = 1; i <= w; i++) {
        for (int j = 0; j < n; j++)
            b1[j] = (b1[j] + 1) % w;
        int c = max(b1) - min(b1) + 1;
        if (c < min_c || (c == min_c && i < min_b)) {
            min_c = c;
            min_b = i;
        }
    }
    for (int i = 1; i <= w; i++) {
        for (int j = 0; j < n; j++)
            b1[j] = (b1[j] - 1 + w) % w;
        int c = max(b1) - min(b1) + 1;
        //cout << b1 << "  " << c << endl;
        if (c < min_c || (c == min_c && i < min_b)) {
            min_c = c;
            min_b = i;
        }
    }
    return {min_c, min_b};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);


    int h,w,n;
    cin >> h >> w >> n;
    vector<pair<int,int>> a;
    for (int i = 0; i < n; i++) {
        int c,d;
        cin >> c >> d;
        a.emplace_back(c - 1, d - 1);
    }
    pair<int,int> answer = solve(h, w, a);
    cout << answer.first << " " << answer.second;

    /*
    int w = 10;
    int test = 1;
    while (true) {
        cout << "Test " << test << endl;
        test++;
        int n = rd() % w + 1;
        vector<pair<int,int>> a(n);
        for (int i = 0; i < n; i++) a[i] = {0, rd() % w};
        sort(a.begin(), a.end());
        a.resize(unique(a.begin(), a.end()) - a.begin());
        n = a.size();
        pair<int,int> ans_st = stupid(1, w, a), ans_sm = solve(1, w, a);
        if (ans_st != ans_sm) {
            cout << "INCORRECT\n\ntest:\n1 " << w << " " << n << endl;
            for (int i = 0; i < n; i++) {
                cout << a[i].first + 1 << " " << a[i].second + 1 << endl;
            }
            cout << endl << "correct:\n" << ans_st << "\nsmart:\n" << ans_sm << endl;
            break;
        }
    }
     */
}
