// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstring>

using namespace std;
using ll=long long;

#define allv(x) x.begin(),x.end()

const int MAXN = 200000;
int l[MAXN], r[MAXN];
vector <size_t> g[MAXN];
long long best[MAXN][2];

void dfs_calc(int v, int p)
{
	best[v][1] = r[v];
	for (auto& i : g[v])
	{
		if (i == p)
			continue;
		dfs_calc(i, v);
		best[v][0] += max(best[i][1], best[i][0]);
		best[v][1] += best[i][0];
	}
}

void dfs_rec(int v, int p, bool t, vector <int>&ans)
{
	if (t)
	{
		if (best[v][0] > best[v][1])
			return dfs_rec(v, p, 0, ans);
		ans.push_back(v);
		for (auto& i : g[v])
		{
			if (i != p)
				dfs_rec(i, v, 0, ans);
		}
	}
	else
	{
		for (auto& i : g[v])
		{
			if (i != p)
				dfs_rec(i, v, 1, ans);
		}
	}
}

void clear_data()
{
	for (size_t i = 0; i < MAXN; i++)
	{
		g[i].clear();
	}
	memset(l, 0, sizeof(l));
	memset(r, 0, sizeof(r));
	memset(best, 0, sizeof(best));
}

void solve()
{
	clear_data();
	ll n, q;
	cin >> n >> q;
	ll x, y, m;
	cin >> x >> y >> m;
	for (size_t i = 1; i < n; i++)
	{
		size_t s, f;
		cin >> s >> f;
		s--; f--;
		g[s].push_back(f);
		g[f].push_back(s);
	}
	for (size_t i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}
	int gid = (1ll << 13) - 1;
	{
		// group1
		for (size_t i = 0; i < n; i++)
		{
			if (l[i] != r[i])
				gid &= (int)(~(size_t)2);
		}
	}
	{
		// group3
		for (size_t i = 0; i < n; i++)
		{
			if (l[i] != 0 || r[i] > 1)
				gid &= (int)(~(size_t)8);
		}
	}

	//if (gid & 2)
	{
		dfs_calc(0, 0);
		ll bq = max(best[0][1], best[0][0]);
		ll k = 0;
		for (size_t i = 0; i < n; i++)
		{
			k ^= ((x * (i + 1ll) + y * ((ll)r[i] * r[i] % m)) % m);
		}
		vector <ll> plan(q);
		for (size_t i = 0; i < q; i++)
		{
			ll tq;
			cin >> tq;
			plan[i] = tq;
			if (tq != bq)
				cout << -1 << ' ';
			else
				cout << k << ' ';
		}
		cout << endl;
		ll in;
		cin >> in;
		while (in)
		{
			in--;
			ll val = plan[in];
			if (val != bq)
				cout << -1 << endl;
			else
			{
				for (size_t i = 0; i < n; i++)
				{
					cout << r[i] << ' ';                                         
				}
				cout << endl;
			}
			cin >> in;
		}
		return;
	}
	exit(-1);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	ll t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
