#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define ll long long

using namespace std;

const ll inf = 1e18;

ll n;
vector<pair<ll, ll>> seg;
vector<ll> dp;

ll ans() {
	ll m = (ll)seg.size() - 1;
	dp = vector<ll>(m + 1, 0);
	for (ll i = 1; i <= m; i++) {
		ll L = seg[i].second, R = seg[i].first;
		dp[i] = dp[i - 1];
		for (ll j = i - 1; j >= 0; j--) {
			ll l = seg[j].second, r = seg[j].first;
			if (r < L) {
				dp[i] = max(dp[i], dp[j] + 1);
				break;
			} 
		}
	}
	return dp[m];
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<pair<ll, ll>> s(n);
		for (ll i = 0; i < n; i++) {
			cin >> s[i].first >> s[i].second;
		}
		seg.push_back({ 0, 0 });
		for (ll i = 0; i < n; i++) {
			seg.push_back({s[i].second, s[i].first});
		}
		sort(seg.begin(), seg.end());
		ll m = ans();
		for (ll mask = 0; mask < (1ll << n); mask++) {
			ll sum = 0;
			for (ll i = 0; i < n; i++) {
				if ((1ll << i) & mask) {
					sum++;
				}
			}
			if (sum != n / 2) continue;
			seg.clear();
			seg.push_back({ 0, 0 });
			for (ll i = 0; i < n; i++) {
				if ((1ll << i) & mask) {
					seg.push_back({s[i].second, s[i].first});
				}
			}
			sort(seg.begin(), seg.end());
			if (ans() == m / 2) {
				for (ll i = 0; i < n; i++) {
					if ((1ll << i) & mask) {
						cout << i + 1 << ' ';
					}
				}
				break;
			}
		}
		cout << "\n";
	}

	return 0;
}