#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
const int inf = (1 << 31) - 1;

struct segtree {
    vector<pair<int, int>> tree;
    int size = 1;

    segtree(int n) {
        while (size < n) size <<= 1;
        tree = vector<pair<int, int>> (size * 2 - 1, {0, inf});
    }

    void put(int i, int k, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = {k, k};
            return;
        }
        int m = (rx + lx) / 2;
        if (i < m) {
            put(i, k, x * 2 + 1, lx, m);
        } else {
            put(i, k, x  *2 + 2, m, rx);
        }
        tree[x].first = max(tree[x * 2 + 1].first, tree[x * 2 + 2].first);
        tree[x].second = min(tree[x * 2 + 1].second, tree[x * 2 + 2].second);
    }

    void put(int i, int k) {
        put(i, k, 0, 0, size);
    }

    int mim(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return inf;
        }
        if (l <= lx && rx <= r) {
            return tree[x].second;
        }
        int m = (rx + lx) / 2;
        int x1 = mim(l, r, x * 2 + 1, lx, m);
        int x2 = mim(l, r, x * 2 + 2, m, rx);
        return min(x1, x2);
    }

    int mim(int l, int r) {
        return mim(l, r, 0, 0, size);
    }

    int mam(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x].first;
        }
        int m = (rx + lx) / 2;
        int x1 = mam(l, r, x * 2 + 1, lx, m);
        int x2 = mam(l, r, x * 2 + 2, m, rx);
        return max(x1, x2);
    }

    int mam(int l, int r) {
        return mam(l, r, 0, 0, size);
    }
};

void solve() {
    int n;
    cin >> n;
    segtree t1(n), t2(n);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> dp(n);
    int ma = 0;
    for (int i = 0; i < n; i++) {
        int x = t1.mam(0, a[i]);
        dp[i] = x + 1;
        ma = max(ma, dp[i]);
        t1.put(a[i] - 1, x + 1);
    }
    vector<int> b(n + 1, 0);
    int l = inf;

    for (int i = n - 1; i >= 0; i--) {
        if (dp[i] == ma && a[i] < l) {
            b[a[i]] = 1;
            ma--;
            l = a[i];
        }
    }
    vector<int> an;
    for (int i = 0; i < n; i++) {
        if (!b[a[i]]) {
            an.push_back(a[i]);
        }
    }
    swap(a, an);
    ma = 0;
    for (int i = 0; i < a.size(); i++) {
        int x = t2.mam(a[i], n);
        ma = max(ma, x + 1);
        t2.put(a[i] - 1, x + 1);
    }
    int s = 0;
    for (int i : b) {
        s += i;
    }
    cout << ma + s << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
