#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double dl;

pair <ll, ll> cnt(ll l, ll r, ll mi, vector <ll>& a)
{
	ll cnt = 0;
	for (ll j = l; j <= r; j++)
	{
		if (a[j] < mi)
		{
			mi = a[j];
			cnt++;
		}
	}
	return { mi, cnt };
}
ll fast(ll n, vector <ll>& a)
{
	ll ans = 0;
	vector <map <ll, map <ll, ll>>> dp(n + 1);
	vector <vector <vector <ll>>> ff(n, vector <vector <ll>>(n));
	for (ll i = 0; i < n; i++)
	{
		for (ll j = i; j < n; j++)
		{
			for (ll u = i; u <= j; u++)
			{
				while (!ff[i][j].empty() && ff[i][j].back() > a[u] || ff[i][j].empty())
				{
					ff[i][j].push_back(a[u]);
				}
			}
			reverse(ff[i][j].begin(), ff[i][j].end());
		}
	}
	dp[1][n + 1][a[0]] = 1;
	for (ll i = 2; i <= n; i++)
	{
		auto [mi, cn] = cnt(0, i - 2, 1e18, a);
		dp[i][mi][a[i - 1]] = cn + 1;
		for (ll j = 1; j < i; j++)
		{
			for (auto u : dp[j])
			{
				ll mi = u.first;
				ll mii = ff[j][i - 2][0];
				ll cn = lower_bound(ff[j][i - 2].begin(), ff[j][i - 2].end(), mi) - ff[j][i - 2].begin();
				for (auto y : dp[j][mi])
				{
					ll ma = y.first;
					if (ma < a[i - 1])
					{
						dp[i][mii][a[i - 1]] = max(dp[i][mii][a[i - 1]], y.second + cn + 1);
						ans = max(ans, dp[i][mii][a[i - 1]]);
					}
					else
					{
						dp[i][mii][ma] = max(dp[i][mii][ma], y.second + cn);
						ans = max(ans, dp[i][mii][ma]);
					}
				}
			}
		}
	}
	for (ll j = 1; j <= n; j++)
	{
		for (ll ma = 1; ma <= n; ma++)
		{
			for (ll mi = 1; mi <= n + 1; mi++)
			{
				ans = max(ans, dp[j][mi][ma] + cnt(j, n - 1, mi, a).second);
			}
		}
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	random_device rd;
	mt19937 gen(rd());
	
	/*
	while (1)
	{
		ll n = gen() % 5 + 2;
		vector <ll> a(n);
		for (ll i = 0; i < n; i++) a[i] = i + 1;
		shuffle(a.begin(), a.end(), gen);
		if (slow(n, a) != fast(n, a))
		{
			cout << n << "\n";
			for (auto i : a) cout << i << " ";
			cout << "\n";
			cout << slow(n, a) << " " << fast(n, a) << "\n";
			break;
		}
	}
	*/

	
	ll t;
	cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector <ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		vector <vector <ll>> dp1(n + 1, vector <ll>(n + 2)), dp2(n + 1, vector <ll>(n + 2));
		ll ans = 0;
		cout << fast(n, a) << "\n";
	}
	

	return 0;
}
/*

C

1
6
2 1 4 6 3 5


4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3

*/