#include <bits/stdc++.h>

#define ll long long
using namespace std;
#pragma optimize GCC ("Ofast", "avx2")
const size_t nMax = 2e3 + 228;

void precalc() {

}

struct segTree {
    struct node {
        int val = 0;
        int id = -1;

        node operator+(node oth) {
            if (oth.val > val)return oth;
            else return *this;
        }
    };

    vector<node> t;
    vector<int> pushes;


    void push(int v) {
        t[v * 2 + 1].val += pushes[v];
        t[v * 2 + 2].val += pushes[v];
        pushes[v * 2 + 1] += pushes[v];
        pushes[v * 2 + 2] += pushes[v];
        pushes[v] = 0;
    }

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v].id = l;
            return;
        }
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    node get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr)return t[v];
        if (l >= qr || r <= ql)return node{};
        int m = (l + r) / 2;
        push(v);
        return get(v * 2 + 1, l, m, ql, qr) +
               get(v * 2 + 2, m, r, ql, qr);
    }


    void add(int v, int l, int r, int ql, int qr, int delta) {
        if (l >= ql && r <= qr) {
            pushes[v] += delta;
            t[v].val += delta;
            return;
        }
        if (l >= qr || r <= ql)return;
        int m = (l + r) / 2;
        push(v);
        add(v * 2 + 1, l, m, ql, qr, delta);
        add(v * 2 + 2, m, r, ql, qr, delta);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};

int n;
vector<int> g[nMax];
vector<tuple<int, int, int>> ev;
map<int, int> comp, uncomp;
pair<int, int> bounds[nMax];
int p[nMax];

void dfs1(int v) {
    if (g[v].empty()) {
        comp[v] = comp.size() + 1;
        uncomp[comp[v]] = v;
        bounds[v] = {comp[v], comp[v] + 1};
        return;
    }
    bounds[v] = {INT_MAX, INT_MIN};
    for (auto u: g[v]) {
        p[u] = v;
        dfs1(u);
        bounds[v].first = min(bounds[v].first, bounds[u].first);
        bounds[v].second = max(bounds[v].second, bounds[u].second);
    }
}

int getM2(vector<tuple<int, int, int>> ev) {
    int m = 0;
    for (int i = 0; i < ev.size(); i++) {
        if (g[i].empty())m++;
    }
    return m;
}

void solve() {
    comp.clear();
    uncomp.clear();
    memset(p, 0, sizeof p);
    for (int i = 0; i < nMax; i++)g[i].clear();
    cin >> n;
    ev.clear();
    ev.resize(n);
    int j = 1;
    for (auto &[l, r, i]: ev) {
        cin >> l >> r;
        i = j++;
    }
    ev.emplace_back(INT_MIN, INT_MAX, 0);
    sort(ev.begin(), ev.end(),
         [](auto a, auto b) {
             return get<0>(a) < get<0>(b) ||
                    get<0>(a) == get<0>(b) &&
                    get<1>(a) > get<1>(b);
         });
    vector<int> st = {0};
    for (int i = 1; i < ev.size(); i++) {
        while (get<0>(ev[i]) > get<1>(ev[st.back()]))
            st.pop_back();
        g[st.back()].push_back(i);
        st.push_back(i);
    }
    dfs1(0);
    int tS = n * 2;
    segTree stree;
    stree.pushes.resize(tS * 4);
    stree.t.resize(tS * 4);
    stree.build(0, 0, tS);
    for (int i = 1; i < ev.size(); i++) {
        stree.add(0, 0, tS, bounds[i].first, bounds[i].second, 1);
    }
    stree.add(0, 0, tS, 0, tS, -1);
    auto m = getM2(ev);
    int leftT = n / 2, leftM = m / 2;
    vector<bool> banned(tS);
    banned[0] = true;
    while (leftM > 0) {
        auto got = stree.get(0, 0, tS, 0, tS).id;
        stree.add(0, 0, tS, got, got + 1, -20);
        auto u = uncomp[got];
        cout << get<2>(ev[u]) << ' ';
        leftT--;
        leftM--;
        u = p[u];
        while (leftT > leftM && !banned[u]) {
            cout << get<2>(ev[u]) << ' ';
            stree.add(0, 0, tS, bounds[u].first, bounds[u].second, -1);
            leftT--;
            u = p[u];
        }
    }

}

int main() {
#ifdef VNT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int q = 1;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
        cout << endl;
    }
    return 0;
}
