#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MX = 2e18 + 2;

class Segtree {
public:
    Segtree(const vector<int> &a) : n_(a.size()), a_(a) {
        tree_.resize(4 * n_);
        build();
    }

    void build(int v = 1, int l = 0, int r = -1) {
        changeR(r);
        if(l + 1 == r){
            tree_[v] = a_[l];
            return;
        }
        int mid = (l + r) >> 1;
        build(v + v, l, mid);
        build(v + v+  1, mid, r);
        tree_[v] = min(tree_[v + v], tree_[v + v + 1]);
    }

    int getmin(int x, int v= 1, int l = 0, int r = -1){
        changeR(r);
        if(r - 1 <= x){
            return tree_[v];
        }
        if(l > x)
            return MX;
        int mid = (l + r) >> 1;
        return min(getmin(x, v + v, l, mid), getmin(x, v + v + 1, mid, r));
    }

private:
    inline void changeR(int &r) {
        if (r == -1)
            r = n_;
    }

    int n_;
    vector<int> a_, tree_;
};

signed main() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w.begin(), w.end());
    vector<int> rem_now(1, 1);
    vector<int> rem_l(1, MX);
    int now = 1;

    for (auto u: w) {
        if (now % 2 == 1) {
            int x = now / 2 + 1;
            int delta = u - x;
            if (delta > 0) {
                int l = x - delta + 1;
                rem_l.push_back(l);
            } else
                rem_l.push_back(MX);
        } else {
            int x = now / 2 + 1;
            int delta = u - x;
            if (delta >= 0) {
                int l = x - delta;
                rem_l.push_back(l);
            } else
                rem_l.push_back(MX);
        }
        now += u;
        rem_now.push_back(now);
    }
    int z;
    cin >> z;
    Segtree segtree(rem_l);
    int i = 0, sum = 0;
    while (q--) {
        ++i;
        int j, c, d;
        cin >> j >> c >> d;
        j = j - sum * z;
        c = c - sum * z;
        d = d - sum * z;
        ++c;
        ++d;
        if (c + d == 2) {
            sum += i;
            cout << "Yes\n";
            continue;
        }
        int help = lower_bound(w.begin(), w.end(), j + 1) - w.begin();
        int help2 = lower_bound(rem_now.begin(), rem_now.end(), c + d - 1) - rem_now.begin();
        if(help2 > help){
            cout << "No\n";
            continue;
        }
        int mnl = segtree.getmin(help2);
        if (min(c, d) < mnl) {
            sum += i;
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
