#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

struct Nugget {
	ll r, c;
	Nugget () {}
};

void solve() {
	ll h, w, k;
	cin >> h >> w >> k;

	vector <Nugget> nuggets(k);
	for (auto &x: nuggets) {
		cin >> x.r >> x.c;
	}
	
	ll ans_h, h_move;
	{
		sort(nuggets.begin(), nuggets.end(), [&] (auto lhs, auto rhs) {
			return lhs.r < rhs.r;
		});

		multiset <ll> behind, current;
		for (auto &x: nuggets)
			current.insert(x.r);

		ans_h = (*current.rbegin()) - (*current.begin()) + 1, h_move = 0;
		auto update_answer = [&] (ll move, ll new_h) {
			if (new_h < ans_h) {
				ans_h = new_h;
				h_move = move;
			} else if (new_h == ans_h) {
				h_move = min(h_move, move);
			}
		};

		for (auto &x: nuggets) {
			current.erase(current.find(x.r));
			behind.insert(x.r);

			ll move = min(x.r, h - x.r + 1);
			if (!current.empty()) {
				move = min(move, h - *current.begin() + 1);
			}

			if (current.empty()) {
				update_answer(move, (*behind.rbegin()) - (*behind.begin()) + 1);
			} else if (!behind.empty()) {
				update_answer(move, (*behind.rbegin()) + h - (*current.begin()) + 1);
			}
		}
	}

	ll ans_w, w_move;
	{
		sort(nuggets.begin(), nuggets.end(), [&] (auto lhs, auto rhs) {
			return lhs.c < rhs.c;
		});

		multiset <ll> behind, current;
		for (auto &x: nuggets)
			current.insert(x.c);

		ans_w = (*current.rbegin()) - (*current.begin()) + 1, w_move = 0;
		auto update_answer = [&] (ll move, ll new_h) {
			//cout << new_h << '\n';
			if (new_h < ans_w) {
				ans_w = new_h;
				w_move = move;
			} else if (new_h == ans_w) {
				w_move = min(w_move, move);
			}
		};

		for (auto &x: nuggets) {
			current.erase(current.find(x.c));
			behind.insert(x.c);

			ll move = min(x.c, w - x.c + 1);
			
			if (current.empty()) {
				update_answer(move, (*behind.rbegin()) - (*behind.begin()) + 1);
			} else if (!behind.empty()) {
				move = min(move, w - *current.begin() + 1);
				update_answer(move, (*behind.rbegin()) + w - (*current.begin()) + 1);
			}
		}
	}

	// cout << ans_w << ' ' << w_move << '\n';
	cout << ans_w * ans_h << ' ' << w_move + h_move << '\n';
}	

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	solve();
}