#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

bool intsects(pair <int, int> a, pair <int, int> b) {
	if (a.first == b.first || a.first == b.second)
		return true;

	if (a.second == b.first || a.second == b.second)
		return true;

	return false;
}

void generate_encoding(int n, vector <pair <int, int>> &encoding, vector <pair <int, int>> &order) {
	vector <pair <int, int>> options;
	for (int x = 1; x <= n; x++) {
		for (int y = x + 1; y <= n; y++) {
			options.emplace_back(x, y);
		}
	}

	for (int x = 1; x <= n; x++) {
		for (int y = x + 1; y <= n; y++) {
			order.emplace_back(x, y);

			vector <pair <int, int>> removed;

			while (!options.empty() && intsects(options.back(), order.back())) {
				removed.push_back(options.back());
				options.pop_back();
			}

			assert(!options.empty());
			encoding.push_back(options.back());
			options	.pop_back();

			for (auto x: removed) {
				options.push_back(x);
			}
		}
	}
}

void solve_run_1() {
	int n, k;
	cin >> n >> k;

	vector <int> a(k);
	for (int &x: a) {
		cin >> x;
		cout << x + 1 << ' ';
	}

	cout << '\n';
}	

void solve_run_2() {
	int n, k;
	cin >> n >> k;

	vector <int> a(k);
	for (int &x: a) {
		cin >> x;
		cout << x - 1 << ' ';
	}

	cout << '\n';
}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int run;
	cin >> run;

	int m;
	cin >> m;

	while (m--) {
		if (run == 1) {
			solve_run_1();
		} else {
			solve_run_2();
		}
	}
}