#include <bits/stdc++.h>
#define int long long 

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9;

struct Event {
	int type, x, id;

	Event (int type, int x, int id): type(type), x(x), id(id) {}
};

bool operator<(Event lhs, Event rhs) {
	if (lhs.x == rhs.x) {
		assert(lhs.type == rhs.type);
		if (lhs.type == 1)
			return lhs.id < rhs.id;
		return lhs.id > rhs.id;
	}

	return lhs.x < rhs.x;
}

struct SegmentTree {
	int tree_size;
	vector <pair <int, int>> tree;
	vector <int> push;

	SegmentTree (vector <pair <int ,int>> &a) {
		int n = a.size();
		tree_size = 1;
		while (tree_size < n)
			tree_size <<= 1;

		tree.assign(2 * tree_size, {-INF, -1});
		push.resize(2 * tree_size);

		for (int i = 0; i < n; i++) {
			tree[i + tree_size] = a[i];
		}

		for (int i = tree_size - 1; i > 0; i--) {
			tree[i] = max(tree[2 * i], tree[2 * i + 1]);
		}
	}

	void pushv(int v) {
		tree[2 * v].first += push[v];
		push[2 * v] += push[v];

		tree[2 * v + 1].first += push[v];
		push[2 * v + 1] += push[v];

		push[v] = 0;
	}

	void add(int v, int tl, int tr, int l, int r, int dt) {
		if (tl >= r || tr <= l)
			return;

		if (tl >= l && tr <= r) {
			push[v] += dt;
			tree[v].first += dt;
			return;
		}	

		pushv(v);

		int mid = (tl + tr) / 2;
		add(2 * v, tl, mid, l, r, dt);
		add(2 * v + 1, mid, tr, l, r, dt);

		tree[v] = max(tree[2 * v], tree[2 * v + 1]);
	}

	void add(int l, int r, int dt) {
		add(1, 0, tree_size, l, r, dt);
	}

	pair <int, int> get_max() {
		return tree[1];
	}
};

void dfs(vector <vector <int>> &graph, vector <pair <int, int>> &a, int u, vector <int> &tin, vector <int> &tout, int &t, int depth) {
	if (graph[u].empty()) {
		a.emplace_back(depth, u);
		tin[u] = t++;
		tout[u] = t;
		return;
	}

	tin[u] = t;
	for (int v: graph[u])
		dfs(graph, a, v, tin, tout, t, depth + 1);

	tout[u] = t;
}

void solve() {
	int n;
	cin >> n;

	vector <Event> events;

	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;

		events.emplace_back(0, l, i + 1);
		events.emplace_back(1, r, i + 1);
	}
	
	sort(events.begin(), events.end());

	vector <int> parents = {0};
	vector <vector <int>> graph(n + 1);
	vector <int> p(n + 1);

	for (auto &event: events) {
		if (event.type == 0) {
			p[event.id] = parents.back();
			graph[parents.back()].push_back(event.id);
			parents.push_back(event.id);
		} else if (event.type == 1) {
			parents.pop_back();
		}
	}

	int t = 0;
	vector <pair <int, int>> a;
	vector <int> tin(n + 1), tout(n + 1);
	dfs(graph, a, 0, tin, tout, t, 0);

	SegmentTree tree(a);

	int M = tout[0];
	assert(M % 2 == 0);

	vector <int> answer;
	vector <int> niggers, used(n + 1);

	while (answer.size() < M / 2) {
		auto [depth, i] = tree.get_max();
		assert(depth > 0);

		int j = i;
		while (j != 0 && !used[j]) {
			if (i != j) {
				niggers.push_back(j);
			}

			used[j] = true;
			tree.add(tin[j], tout[j], -1);
			j = p[j];
		}

		answer.push_back(i);
	}

	while (answer.size() < n / 2) {
		assert(!niggers.empty());
		answer.push_back(niggers.back());
		niggers.pop_back();
	}

	for (int x: answer)
		cout << x << ' ';
	cout << '\n';
}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int t;
	cin >> t;

	while (t--)
	solve();
}