#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;


mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;

int l[N], r[N];
vector<int> g[N];

int dp[N][2];

void dfs (int u, int p = -1) {
    dp[u][1] = r[u];
    dp[u][0] = 0;
    for (auto v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        dp[u][0] += max(dp[v][0], dp[v][1]);
        dp[u][1] += dp[v][0];
    }
}

int add (int a, int b, int m) {
    return (a + b) % m;
}

int mul (int a, int b, int m) {
    return (a * b) % m;
}

void print (vector<int> &v) {
    for (auto x : v) {
        cout << x << " ";
    }
    cout << endl;
}

vector<int> z;

void recover (int u, int need, int p = -1) {
    if (need == 1) {
        if (r[u] == 1) z.push_back(u);
    }
    for (auto v : g[u]) {
        if (v == p) continue;
        if (need == 0) {
            if (dp[v][0] < dp[v][1]) {
                recover(v, 1, u);
            } else {
                recover(v, 0, u);
            }
        } else {
            recover(v, 0, u);
        }
    }
}

void done (int n) {
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    z.clear();
}

void solve() {
    int n, q;
    cin >> n >> q;
    done(n);
    int x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    dfs(0);
    vector<int> v(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
    }
    vector<int> ans(q, -1);
    if (dp[0][0] > dp[0][1]) {
        recover(0, 0);
    } else {
        recover(0, 1);
    }
    // получаю вектор z
    sort(all(z));
    vector<int> pref(n + 1, 0);
    int current = 0;
    for (int i = 0; i < n; i++) {
        int now = mul(x, i + 1, m);
        current ^= now;
    }
    for (int i = 0; i < sz(z); i++) {
        pref[i] = current;
        int now = mul(x, z[i] + 1, m);
        current ^= now;
        int was = add(now, y, m);
        current ^= was;
        pref[i + 1] = current;
    }
    for (int i = 0; i < q; i++) {
        if (max(dp[0][0], dp[0][1]) < v[i]) {
            ans[i] = -1;
        } else {
            ans[i] = pref[v[i]];
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << " ";
    }
    cout << endl;
    while (true) {
        int j;
        cin >> j;
        j--;
        if (j == -1) {
            break;
        } else {
            int need = v[j];
            if (v[j] > sz(z)) {
                cout << -1 << endl;
                continue;
            }
            vector<int> b(n, 0);
            for (int d = 0; d < sz(z); d++) {
                need -= r[z[d]];
                b[z[d]]++;
            }
            for (int i = 0; i < n; i++) {
                cout << b[i] << " ";
            }
            cout << endl;
        }
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

// короче план
/*
набираю баллы по CD
come back to B
набираю как можно больше
 */