#include <bits/stdc++.h>

#define endl "\n"
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define ll long long
using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = b1;
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = b1;
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T> &a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

struct Fenwick {
    vector<int> tree;
    int n;

    void add(int a) {
        for (; a < n; a |= a + 1) {
            tree[a]++;
        }
    }

    int get(int a) {
        int res = 0;
        for (; a >= 0; a &= a + 1, a--) {
            res += tree[a];
        }
        return res;
    }

    int get(int l, int r) {
        if (l > r) {
            return 0;
        }
        return get(r) - get(l + 1);
    }

    void init(int n) {
        this->n = n;
        tree.assign(n, 0);
    }
};


void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    cin >> a;

    Fenwick tree;
    tree.init(n + 3);

    int dp[n + 2][n + 2];
    for (int i = 0; i <= n + 1; i++) {
        for (int j = 0; j <= n + 1; j++) {
            dp[i][j] = -1e9;
        }
    }

    dp[0][n + 1] = 0;

    for (int &it : a) {
        vector<int> upd_value(n + 2, -1e9);
        vector<int> upd_value2(n + 2, -1e9);
        for (int j = 0; j <= n + 1; j++) {
            int ma = -1e9;
            for (int i = 0; i < it; i++) {
                if (tree.get(i + 1, j - 1) != 0) {
                    dp[i][j] = -1e9;
                }
                rmax(ma, dp[i][j]);
            }

            if (j == it) {
                continue;
            }

            upd_value[j] = ma + 1;
        }

        for (int j = 0; j <= n + 1; j++) {
            int ma = -1e9;
            if (j == it) {
                continue;
            }
            for (int i = it + 1; i <= n + 1; i++) {
                if (tree.get(j + 1, i - 1) != 0) {
                    dp[i][j] = -1e9;
                }
                rmax(ma, dp[j][i]);
            }

            upd_value2[j] = ma + 1;
        }

        tree.add(it);

        for (int i = 0; i <= n + 1; i++) {
            rmax(dp[it][i], upd_value[i]);
            rmax(dp[i][it], upd_value2[i]);
        }
    }

    int ans = -1e9;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (dp[i][j] < 0) {
                dp[i][j] = 0;
            }
            rmax(ans, dp[i][j]);
        }
    }

    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}