#include <iostream>
#include <vector>
using namespace std;

struct Node {
	int sol;
	int pr;
	int l, r;
	int k, p;
	Node() : l(-1), r(-1), k(-1),
		p(-1), pr(-1), sol(0) {}
};

int k;
vector<Node> tree;
// 1 - l, 2 - r
void dfs(int v) {
	if (tree[v].l == -1 && tree[v].r == -1) {
		tree[v].sol = int(tree[v].k <= k);
		return;
	}

	tree[tree[v].l].k = tree[v].k + (tree[v].p == 2 ? 1 : 0);
	tree[tree[v].l].p = 1;
	dfs(tree[v].l);
	tree[v].sol += tree[tree[v].l].sol;

	tree[tree[v].r].k = tree[v].k + (tree[v].p == 1 ? 1 : 0);
	tree[tree[v].r].p = 2;
	dfs(tree[v].r);
	tree[v].sol += tree[tree[v].r].sol;
	
}

void solve() {
	int n, q;
	cin >> n >> k >> q;
	vector<int> list;
	tree.resize(n);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 2) {
			int l, r;
			cin >> l >> r;
			tree[i].l = l - 1;
			tree[i].r = r - 1;
			tree[tree[i].l].pr = i;
			tree[tree[i].r].pr = i;
		}
	}

	tree[0].k = 0;
	tree[0].p = 0;

	dfs(0);

	for (int i = 0; i < q; ++i) {
		int v;
		cin >> v;
		cout << tree[v - 1].sol << "\n";
	}
}

int main(){
	int T = 1;
	while (T--) solve();
	return 0x0;
}
