#include <bits/stdc++.h>

using namespace std;

bool cmp(tuple<int, int, int> a, tuple<int, int, int> b) {
    auto [l1, r1, i1] = a;
    auto [l2, r2, i2] = b;
    if (r1 != r2) {
        return r1 < r2;
    }
    return l1 > l2;
}

vector<int> calcbest(vector<tuple<int, int, int>> & qs, int mx) {
    sort(qs.begin(), qs.end(), cmp);
    vector<int> left(mx + 1, -1);
    int last = 0;
    int n = 0, idxn = 0;
    for (auto [l, r, idx] : qs) {
        //cout << l << ' ' << r << ' ' << idx << '\n';
        if (r != last) {
            left[r] = idxn;
        }
        n = max(n, idx);
        last = r;
        idxn++;
    }
    //cout << mx << '\n';
    //return {};
    vector<int> dp(mx + 1);
    vector<int> prv(n + 1, -1);
    last = -1;
    for (int i = 1; i <= mx; i++) {
        dp[i] = dp[i - 1];
        if (left[i] != -1) {
            auto [l, r, idx] = qs[left[i]];
            if (dp[i] < dp[l - 1] + 1) {
                prv[idx] = last;
                last = idx;
            }
            dp[i] = max(dp[i], dp[l - 1] + 1);
        }
    }
    vector<int> ans;
    int now = last;
    while (now != -1) {
        ans.push_back(now);
        now = prv[now];
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> coords;
    vector<tuple<int, int, int>> qs;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        qs.push_back({l, r, i + 1});
        coords.push_back(l);
        coords.push_back(r);
    }
    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());
    for (auto & [l, r, idx] : qs) {
        l = lower_bound(coords.begin(), coords.end(), l) - coords.begin() + 1;
        r = lower_bound(coords.begin(), coords.end(), r) - coords.begin() + 1;
    }
    auto mx = calcbest(qs, coords.size());
    int m = mx.size();
    for (int i = 0; i < (1 << n); i++) {
        vector<tuple<int, int, int>> nqs;
        for (int j = 0; j < n; j++) {
            if ((i >> j) & 1) {
                nqs.push_back(qs[j]);
            }
        }
        if ((int)nqs.size() == n / 2) {
            auto ans = calcbest(nqs, coords.size());
            if ((int)ans.size() == m / 2) {
                for (auto [l, r, idx] : nqs) {
                    cout << idx << ' ';
                }
                cout << '\n';
                return;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
