#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;
const ll INF_ll = 1e18;
const int mod = 1e9 + 7;

vector<vector<int> > g;
vector<int> c, val;

struct event{
    int l, r, i;
    event(){};
};

bool cmp(event &a, event &b) {
    if (a.l < b.l) {
        return 1;
    } else if (a.l > b.l) {
        return 0;
    } else {
        return a.r > b.r;
    }
}

void dfs(int v) {
    if (g[v].size() == 0) {
        return;
    }
    val[g[v][0]] = val[v] + 1;
    for (auto to : g[v]) {
        dfs(to);
    }
}

bool upper(event &a, event &b) {
    return a.l <= b.l && b.r <= a.r;
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    val.resize(n);
    c.resize(n);
    vector<event> seg(n);
    for (int i = 0; i < n; i++) {
        cin >> seg[i].l >> seg[i].r;
        seg[i].i = i;
    }
    sort(seg.begin(), seg.end(), cmp);
    vector<int> p(n, -1);
    vector<vector<int> > up(20, vector<int>(n));
    for (int i = 0; i < 20; i++) {
        up[i][0] = -1;
    }
    for (int i = 1; i < n; i++) {
        if (upper(seg[i - 1], seg[i])) {
            g[seg[i - 1].i].push_back(seg[i].i);
            p[seg[i].i] = seg[i - 1].i;
        } else {
            int v = i - 1;
            for (int j = 19; j >= 0; j--) {
                if (up[j][v] == -1) {
                    continue;
                }
                if (!upper(seg[up[j][v]], seg[i])) {
                    v = up[j][v];
                }
            }
            v = up[0][v];
            if (v != -1) {
                g[seg[v].i].push_back(seg[i].i);
                p[seg[i].i] = seg[v].i;
            }
        }
        up[0][i] = p[seg[i].i];
        for (int j = 1; j < 20; j++) {
            if (up[j - 1][i] == -1) {
                up[j][i] = -1;
                continue;
            }
            up[j][i] = up[j - 1][up[j - 1][i]];
        }
    }
    c.resize(n);
    for (int i = 0; i < n; i++) {
        if (p[i] == -1) {
            dfs(i);
        }
    }
    priority_queue<pair<int, int> > q;
    vector<bool> erased(n);
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].size() == 0) {
            m++;
            q.push({-val[i], i});
            c[i] = 1;
        }
    }
    int n_need = n / 2, m_need = m / 2;
    while (m_need) {
        int cnt = q.top().first, v = q.top().second;
        q.pop();
        erased[v] = 1;
        if (cnt == 0) {
            m_need--;
        } else {
            q.push({-val[p[v]], p[v]});
            c[p[v]] = 1;
        }
        n_need--;
    }
    for (int i = 0; i < n; i++) {
        if (n_need && !c[i]) {
            erased[i] = 1;
            n_need--;
        }
    }
    assert(n_need != 0);
    for (int i = 0; i < n; i++) {
        if (!erased[i]) {
            cout << i + 1 << ' ';
        }
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
        g.clear(), c.clear(), val.clear();
    }
    return 0;
}