#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cassert>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 7;
const int LL_INF = 2e18 + 7;

struct Segment {
	int l, r;
	int num;
	Segment() : l(0), r(0), num(0) {}
	Segment(int _l, int _r, int _num) : l(_l), r(_r), num(_num) {}
	bool operator < (const Segment& other) {
		return r < other.r;
	}
};

int main() {
	int t_num;
	cin >> t_num;
	while (t_num--) {
		int n;
		cin >> n;
		vector<Segment> a(n);
		for (int i = 0; i < n; i++) {
			int l, r;
			cin >> l >> r;
			l--;
			r--;
			a[i] = Segment(l, r, i);
		}
		sort(a.begin(), a.end());
		vector<int> dp(n, 1);
		int m = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; a[j].r < a[i].l; j++) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
			m = max(m, dp[i]);
		}
		int cur_m = m;
		for (int it = 0; it < n; it++, n--) {
			int min_seq = 0, max_seq = 0;
			dp.assign(n, 1);
			/*
			vector<int> intersects_with(n);
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (!(a[i].l > a[j].r || a[i].r < a[j].l)) {
						intersects_with[i]++;
					}
				}
			}
			*/
			cur_m = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; a[j].r < a[i].l; j++) {
					dp[i] = max(dp[i], dp[j] + 1);
				}
				if (dp[i] < dp[min_seq]) {
					min_seq = i;
				}
				if (dp[i] > dp[max_seq]) {
					max_seq = i;
				}
				cur_m = max(cur_m, dp[i]);
			}
			if (cur_m > m / 2) {
				a.erase(a.begin() + max_seq);
			}
			else {
				a.erase(a.begin() + min_seq);
			}
		}
		dp.assign(n, 1);
		cur_m = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; a[j].r < a[i].l; j++) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
			cur_m = max(cur_m, dp[i]);
		}
		assert(cur_m == m / 2);
		for (auto& i : a) {
			cout << i.num + 1 << ' ';
		}
		cout << '\n';
	}
}
