#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>

using namespace std;

void solve1(int n, int k, vector<int> &v);
void solve2(int n, int k, vector<int> &v);

void print(vector<int> &v){
    sort(v.begin(), v.end());
    for (auto el : v){
        cout << el + 1 << ' ';
    }
    cout << endl;
}

tuple<int, int, vector<int>> input(){
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i];
        v[i]--;
    }
    sort(v.begin(), v.end());
    return {n, k, v};
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int z;
    int t;
    cin >> z >> t;
    for (int i = 0; i < t; ++i) {
        auto [n, k, v] = input();
        if (z == 1){
            solve1(n, k, v);
        } else{
            solve2(n, k, v);
        }
    }
}

void solve1(int n, int k, vector<int> &v){
    unordered_map<int, bool> used;
    for (int i = 0; i < k; ++i) {
        used[v[i]] = true;
    }
    vector<int> w;
    int bal = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i]){
            bal++;
        } else{
            if (bal){
                bal--;
                used[i] = true;
                w.push_back(i);
            }
        }
    }
    for (int i = 0; w.size() < k; ++i) {
        if (!used[i]) {
            used[i] = true;
            w.push_back(i);
        }
    }
    print(w);
}

void solve2(int n, int k, vector<int> &v){
    unordered_map<int, bool> used;
    for (int i = 0; i < k; ++i) {
        used[v[i]] = true;
    }
    vector<int> w;
    int bal = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (used[i]){
            bal++;
        } else{
            if (bal){
                bal--;
                used[i] = true;
                w.push_back(i);
            }
        }
    }
    for (int i = n - 1; w.size() < k && i >= 0; --i) {
        if (!used[i]) {
            w.push_back(i);
        }
    }
    print(w);
}

