#include <bits/stdc++.h>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ld long double

#define double ld
#define endl '\n'

using namespace std;

const int inf = 1e9;

struct Seg {
    int l, r, i;
};

struct Node {
    Node* left = nullptr, *right = nullptr;
    int sum = 0;
};

int gt(Node* v) {
    return v == nullptr ? 0 : v->sum;
}

Node* add(Node* cur, int l, int r, int q) {
    if (q < l or r <= q)
        return cur;

    Node* v = new Node();
    if (l + 1 == r) {
        v->sum = gt(cur) + 1;
        return v;
    }

    int mid = (l + r) / 2;
    v->left = add(cur->left, l, mid, q);
    v->right = add(cur->right, mid, r, q);
    v->sum = gt(v->left) + gt(v->right);
    return v;
}

int get(Node* u, int l, int r, int ql, int qr) {
    if(qr <= l or r <= ql or u == nullptr)
        return 0;
    if (ql <= l and r <= qr)
        return u->sum;
    int mid = (l + r) / 2;
    return get(u->left, l, mid, ql, qr) + get(u->right, mid, r, ql, qr);
}

void solve() {
    int n;
    cin >> n;
    vector<Seg> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].l >> arr[i].r;
        arr[i].i = i;
    }

    sort(all(arr), [&](auto & a, auto & b) {
        if (a.r != b.r)
            return a.r < b.r;
        return a.l > b.l;
    });

    vector<bool> good(n);
    vector<bool> used(n);

    int tgt = -1;

    int st = 0;

    while (true) {
        vector<int> flex;
        fill(all(good), false);

        for (int i = 0, r = 0; i < n; ++i) {
            if (used[i])
                continue;
            if (arr[i].l > r) {
                good[i] = true;
                r = arr[i].r;
                flex.push_back(i);
            }
        }

        int m = flex.size();

        if (m == tgt)
            break;

        if (tgt == -1)
            tgt = m / 2;

        vector<int> cost(n);

        vector<int> le(n), re(n);

        for (int i = 0; i < m; ++i) {
            int l = 1;
            if (i != 0)
                l = arr[flex[i - 1]].r + 1;

            int r = inf;
            if (i != m - 1)
                r = arr[flex[i + 1]].l - 1;

            le[flex[i]] = l;
            re[flex[i]] = r;

            for (int j = 0; j < n; ++j) {
                if (used[j])
                    continue;

                if (l <= arr[j].l and arr[j].r <= r)
                    ++cost[flex[i]];
            }
        }

        vector<int> tmp = flex;
        sort(all(tmp), [&](int a, int b) {
            return cost[a] < cost[b];
        });

        for (int i = 0; i < m - tgt; ++i) {
            int l = le[tmp[i]];
            int r = re[tmp[i]];

            for (int i = 0; i < n; ++i) {
                if (used[i])
                    continue;
                if (l <= arr[i].l and arr[i].r <= r) {
                    used[i] = true;
                    ++st;
                }
            }
        }
    }

    int j = 0;
    while (st < n / 2) {
        while (good[j] or used[j])
            ++j;
        used[j] = true;
        ++st;
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i])
            cout << arr[i].i + 1 << " ";
    }
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}