#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> encode(int n, int k, vector<int> a) {
    int i = 0;
    int x = a[0];
    int t = 0;
    vector<int> ans;
    while (ans.size() < k) {
        if (a[i] == x) {
            ++t;
            i = (i + 1) % k;
            x = x % n + 1;
        } else if (t > 0) {
            --t;
            ans.push_back(x);
            x = x % n + 1;
        } else {
            x = a[i];
        }
    }
    sort(ans.begin(), ans.end());
    return ans;
}

vector<int> decode(int n, int k, vector<int> a) {
    reverse(a.begin(), a.end());
    int i = 0;
    int x = a[0];
    int t = 0;
    vector<int> ans;
    while (ans.size() < k) {
        if (a[i] == x) {
            ++t;
            i = (i + 1) % k;
            x = (x + n - 2) % n + 1;
        } else if (t > 0) {
            --t;
            ans.push_back(x);
            x = (x + n - 2) % n + 1;
        } else {
            x = a[i];
        }
    }
    sort(ans.begin(), ans.end());
    return ans;
}

signed main() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    vector<vector<int>> ans(m);
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        for (int i = 0; i < k; ++i)
            cin >> a[i];
        if (t == 1)
            ans[i] = encode(n, k, a);
        else
            ans[i] = decode(n, k, a);
    }
    for (auto a : ans) {
        for (auto x : a)
            cout << x << ' ';
        cout << '\n';
    }
    cout.flush();
}
