#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 200809;

int lex_incr(vector<int> v) {
    vector<int> ans = {-MAXN};
    for (auto x : v) {
        auto i = upper_bound(ans.begin(), ans.end(), x);
        if (i == ans.end())
            ans.push_back(x);
        else
            i[0] = x;
    }
    return ans.size() - 1;
}

int p[MAXN];

int brute_force(int n, int i, int a, int b) {
    if (i >= n) {
        if (a == 0 || b == n + 1)
            return -MAXN;
        return 0;
    }
    vector<int> inc;
    vector<int> dec;
    for (int j = i; j < n; ++j) {
        if (p[j] >= b)
            inc.push_back(p[j]);
        if (p[j] <= a)
            dec.push_back(-p[j]);
    }
    int ans = 0;
    if ((inc.size() || a > 0) && (dec.size() || b <= n))
        ans = lex_incr(inc) + lex_incr(dec);
    if (a <= p[i] && p[i] <= b) {
        ans = max(ans, 1 + brute_force(n, i + 1, p[i], b));
        ans = max(ans, 1 + brute_force(n, i + 1, a, p[i]));
    } else {
        ans = max(ans, brute_force(n, i + 1, a, b));
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    cout << brute_force(n, 0, 0, n + 1) << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
