#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
using namespace std;
using ll = long long;

vector<short> get_ndp(vector<short>& dp, int w) {
    int n = dp.size();
    if (w >= n)
        return dp;
    vector<short> ndp = dp;
    bool isok = dp[w - 1] + 1 >= w;
    for (int i = 0; i < n; ++i) {
        if (dp[i] == -1)
            continue;
        if (dp[i] + 1 >= w || isok) {
            ndp[i] = min(dp[i] + w, n - 1);
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        if (dp[i] == -1)
            continue;
        if (i + 1 >= w || isok) {
            int j = min(i + w, n - 1);
            ndp[j] = max(ndp[j], dp[i]);
        }
    }
    for (int i = n - 2; i >= 0; --i)
        ndp[i] = max(ndp[i], ndp[i + 1]);
    // for (int i = 0; i < 10; ++i)
    //    cout << ndp[i] << ' ';
    //cout << endl;
    return ndp;
}

const int MAXN = 3e5 + 123;
vector<short> dp_[MAXN];
vector<short>* dp = dp_ + 1;

signed main() {
    int n, q;
    cin >> n >> q;
    vector<ll> ws(n);
    for (int i = 0; i < n; ++i)
        cin >> ws[i];
    ll z;
    cin >> z;
    sort(ws.begin(), ws.end());
    dp[-1].assign(5001, -1);
    dp[-1][0] = 0;
    for (int i = 0; i < n; ++i) {
        if (ws[i] <= 5000)
            dp[i] = get_ndp(dp[i - 1], ws[i]);
    }
    // cout << dp[n - 1].size() << '\n';
    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;
        int ki = upper_bound(ws.begin(), ws.end(), k) - ws.begin();
        --ki;
        if (b > dp[ki][a])
            cout << "No\n";
        else
            cout << "Yes\n";
    }

}
