#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ofstream debug;

template <typename T>
istream& operator>>(istream& i, vector<T> &v) {
    for (T& e: v) i >> e;
    return i;
}

template <typename T>
ostream& operator<<(ostream& o, vector<T> &v) {
    for (T& e: v) o << e << " ";
    return o;
}

unordered_map<int, bool> used;
unordered_map<int, int> link;

int find_right(int x) {
    if (!used[x]) return x;
    if (link.find(x) != link.end()) {
        link[x] = find_right(link[x]);
    }
    else {
        link[x] = find_right(x+1);
    }
    return link[x];
}

int find_left(int x) {
    if (!used[x]) return x;
    if (link.find(x) != link.end()) {
        link[x] = find_left(link[x]);
    }
    else {
        link[x] = find_left(x-1);
    }
    return link[x];
}

int main() {
#ifdef LOCAL
    debug.open("debug.txt");
#endif
    int run;
    cin >> run;
    vector<int> numbers;
    vector<int> answer;
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        numbers.resize(k);
        cin >> numbers;
        if (run == 1) {
            std::reverse(numbers.begin(), numbers.end());
            for (int x: numbers) {
                used[x] = true;
                int y = find_right(x);
                used[y] = true;
                answer.push_back(y);
            }
            std::sort(answer.begin(), answer.end());
        }
        else {
            for (int x: numbers) {
                used[x] = true;
                int y = find_left(x);
                used[y] = true;
                answer.push_back(y);
            }
            std::sort(answer.begin(), answer.end());
        }
        cout << answer << endl;
        answer.clear();
        numbers.clear();
        used.clear();
        link.clear();
    }
    cout << endl;
    return 0;
}
