#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/hash_policy.hpp>

using namespace std;
using ll = long long;
using ld = long double;
ofstream debug;

template <typename T>
istream& operator>>(istream& i, vector<T> &v) {
    for (T& e: v) i >> e;
    return i;
}

template <typename T>
ostream& operator<<(ostream& o, vector<T> &v) {
    for (T& e: v) o << e << " ";
    return o;
}

struct pair_hash {
    template <typename T>
    size_t operator()(const pair<T, T> &p) const{
        hash<T> hasher;
        return (hasher(p.first) << 16) ^ hasher(p.second);
    }
};

template <typename T, typename H>
using hash_table = __gnu_pbds::cc_hash_table<T, __gnu_pbds::null_type,
    H>;

hash_table<pair<ll, ll>, pair_hash> possible;
hash_table<pair<ll, ll>, pair_hash> ideal;
hash_table<pair<ll, ll>, pair_hash> temp;
ll maxa = 0, maxb = 0;

void update(ll a, ll b) {
    if (a > maxa || b > maxb) return;
    if (ideal.find({a, b}) != ideal.end()) return;
    if (possible.find({a, b}) == possible.end()) return;
    if (a != 0 && ideal.find({a-1, b}) == ideal.end()) return;
    if (b != 0 && ideal.find({a, b-1}) == ideal.end()) return;
    ideal.insert({a, b});
    update(a+1, b);
    update(a, b+1);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    debug.open("debug.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<ll> weights(n);
    cin >> weights;
    std::sort(weights.begin(), weights.end());
    vector<tuple<ll, ll, ll, int>> queries(q);
    int z;
    cin >> z;
    for (int i = 0; i < q; i++) {
        auto &[k, a, b, ind] = queries[i];
        cin >> k >> a >> b;
        maxa = max(maxa, a);
        maxb = max(maxb, b);
        ind = i;
    }
    vector<bool> answers(q);
    std::sort(queries.begin(), queries.end());
    ideal.insert({0, 0});
    possible.insert({0, 0});
    int nxt = 0;
    for (auto [k, a, b, i]: queries) {
        while (nxt < n && weights[nxt] <= k) {
            for (auto [x, y]: possible) {
                if (x + weights[nxt] <= maxa)
                    temp.insert({x + weights[nxt], y});
                if (y + weights[nxt] <= maxb)
                    temp.insert({x, y + weights[nxt]});
            }
            for (auto [x, y]: temp) {
                if (possible.find({x, y}) == possible.end()) {
                    possible.insert({x, y});
                    update(x, y);
                }
            }
            temp.clear();
            nxt++;
        }
        if (ideal.find({a, b}) == ideal.end()) answers[i] = false;
        else answers[i] = true;
    }
    for (bool b: answers) {
        if (b) cout << "Yes\n";
        else cout << "No\n";
    }
    return 0;
}
