#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
ofstream debug;

template <typename T>
istream& operator>>(istream& i, vector<T> &v) {
    for (T& e: v) i >> e;
    return i;
}

template <typename T>
ostream& operator<<(ostream& o, vector<T> &v) {
    for (T& e: v) o << e << " ";
    return o;
}

vector<vector<int>> edges;
vector<pair<ll, ll>> workers;
unordered_map<int, ll> part_map;
unordered_map<int, ll> any_map;

ll dfs_any(int, int);

ll dfs_parts(int v, int p=-1) {
    if (part_map.find(v) != part_map.end()) return part_map[v];
    ll ans = 0;
    for (int u: edges[v]) {
        if (u != p) {
            ans += dfs_any(u, v);
        }
    }
    part_map[v] = ans;
    return ans;
}

ll dfs_any(int v, int p=-1) {
    if (any_map.find(v) != any_map.end()) return any_map[v];
    ll ans1 = workers[v].first;
    ll ans2 = 0;
    for (int u: edges[v]) {
        if (u != p) {
            ans2 += dfs_any(u, v);
            ans1 += dfs_parts(u, v);
        }
    }
    any_map[v] = max(ans1, ans2);
    return any_map[v];
}

int main() {
#ifdef LOCAL
    debug.open("debug.txt");
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;
        edges.resize(n);
        ll x, y, m;
        cin >> x >> y >> m;
        for (int i = 1; i < n; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            edges[u].push_back(v);
            edges[v].push_back(u);
        }
        workers.resize(n);
        for (auto &[l, r]: workers) cin >> l >> r;
        ll ans = dfs_any(0, -1);
        ll cert = 0;
        for (int i = 0; i < n; i++) {
            cert ^= (x * (i+1) % m + y * (workers[i].first * workers[i].first % m)) % m;
        }
        vector<ll> queries(q);
        for (int i = 0; i < q; i++) {
            ll v;
            cin >> v;
            queries[i] = v;
            if (v == ans) cout << cert << " ";
            else cout << "-1 ";
        }
        cout << endl;
        int v;
        while (cin >> v && v != 0) {
            v--;
            if (queries[v] == ans) {
                for (auto [l, r]: workers) cout << l << " ";
            }
            else {
                cout << -1;
            }
            cout << endl;
        }
    }
    return 0;
}
