#include <bits/stdc++.h>

using namespace std;

#define sz(a) int((a).size())

typedef long long ll;

struct Segment {
    int l, r, idx;
};

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<Segment> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].idx = i;
    }

    sort(a.begin(), a.end(), [] (auto a, auto b) {
        return a.r < b.r;
    });

    vector<int> pr(n);
    {
        set<pair<int, int>> s = {{0, 0}};
        for (int i = 0; i < n; ++i) {
            pr[i] = (--s.lower_bound({a[i].l, 0}))->second;
            s.emplace(a[i].r, i + 1);
        }
    }

    int m;
    {
        vector<int> pref(n + 1, 0);
        for (int j = 0; j < n; ++j) {
            pref[j + 1] = max(pref[j], pref[pr[j]] + 1);
        }
        m = pref[n];
    }

    mt19937 rnd(987654321);
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    shuffle(order.begin(), order.end(), rnd);
    for (int i : order) {
        vector<int> not_mcs;
        vector<int> mcs = {i};
        int cur = 1;
        vector<int> pref(n + 1, -INF);
        pref[i + 1] = 1;
        for (int j = i + 1; j < n; ++j) {
            if (pref[pr[j]] + 1 <= m / 2) {
                pref[j + 1] = max(pref[j], pref[pr[j]] + 1);
                if (pref[pr[j]] + 1 == cur + 1) {
                    mcs.push_back(j);
                    cur++;
                } else {
                    not_mcs.push_back(j);
                }
            } else {
                pref[j + 1] = pref[j];
            }
        }
        if (sz(not_mcs) + sz(mcs) >= n / 2 && cur == m / 2) {
            vector<int> ans;
            for (auto idx : mcs) {
                ans.push_back(a[idx].idx);
            }
            for (auto idx : not_mcs) {
                if (sz(ans) == n / 2) break;
                ans.push_back(a[idx].idx);
            }
            for (auto el : ans) {
                cout << el + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
    exit(1);
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}