#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 1e18;

struct Node {
    ll val, it;
    Node() {}
    Node(ll val) : val(val) {}
};

Node operator+ (Node A, Node B) {
    Node res;
    res.val = max(A.val, B.val);
    return res;
}

class segtree {
public:
    segtree(int N) {
        sz = 1;
        while (sz < N) {
            sz *= 2;
        }
        n = sz * 2 - 1;
        tree.assign(n, 0);
    }

    ll get(int l, int r) {
        return get(0, l, r, 0, sz).val;
    }

    void set(int i, ll x) {
        set(0, i, x, 0, sz);
    }

private:
    ll n, sz;
    vector<Node> tree;

    Node get(int v, int l, int r, int tl, int tr) {
        if (tr <= l || tl >= r) {
            return {0};
        }
        if (tr - tl == 1) {
            return tree[v];
        }
        int tm = (tr + tl) / 2;
        return get(2 * v + 1, l, r, tl, tm) + get(2 * v + 2, l, r, tm, tr);
    }

    void set(int v, int i, ll x, int tl, int tr) {
        if (tr - tl == 1) {
            tree[v].val = x;
            return;
        }
        int tm = (tr + tl) / 2;
        if (i < tm) {
            set(2 * v + 1, i, x, tl, tm);
        } else {
            set(2 * v + 2, i, x, tm, tr);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }
};


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<ll> a(n);
        for (auto &el : a) {
            cin >> el;
        }
        vector<pair<ll, ll>> key(n);
        for (ll i = 0; i < n; ++i) {
            key[i] = {a[i], i};
        }
        std::sort(key.begin(), key.end());
        segtree dp(n);
        for (auto [el, it] : key) {
            cout << dp.get(0, it) + 1 << " " << it<< "\n";
            dp.set(it, dp.get(0, it) + 1);
        }

        ll bestnvp = dp.get(0, n);
        if (bestnvp == n) {
            cout << n << "\n";
        } else {
            cout << bestnvp + 1<< "\n";
        }
    }

    return 0;
}