#include <bits/stdc++.h>
#include <ostream>

using namespace std;

typedef long long ll;
const ll INF = 1e18;


struct event {
    ll l, r, it;

    event() = default;

    event(ll l, ll r, ll it) : l(l), r(r), it(it) {}
};

bool operator<(event A, event B) {
    if (A.r == B.r) {
        if (A.l == B.l) {
            return A.it < B.it;
        }
        return A.l < B.l;
    }
    return A.r < B.r;
}

ll n, m;
vector<event> a;
vector<event> b;
vector<event> ans;
vector<ll> key;



int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t;
    cin >> t;
    while (t--) {
        cin >> n;
        a.clear();
        b.clear();
        ans.clear();
        a.resize(n);
        for (ll i = 0; i < n; ++i) {
            cin >> a[i].l >> a[i].r;
            key.emplace_back(a[i].l);
            key.emplace_back(a[i].r);
            a[i].it = i;
        }

        vector<vector<ll>> per(n);
        vector<bool> flag(n, false);
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < n; ++j) {
                if (flag[i]) continue;
                if (i != j) {
                    if (a[j].l <= a[i].l && a[i].r <= a[j].r) {
                        per[i].push_back(j);
                        flag[j] = true;
                        per[j].clear();
                    }
                }
            }
        }
        vector<pair<ll, ll>> del(n);
        for (ll i = 0; i < n; ++i) {
            del[i] = {per[i].size(), i};
        }
        std::sort(del.begin(), del.end());



        std::sort(key.begin(), key.end());
        key.resize(std::unique(key.begin(), key.end()) - key.begin());
        for (ll i = 0; i < n; ++i) {
            a[i].l = lower_bound(key.begin(), key.end(), a[i].l) - key.begin();
            a[i].r = lower_bound(key.begin(), key.end(), a[i].r) - key.begin();
        }
        std::sort(a.begin(), a.end());

//        for (auto el : a) {
//            cout << el.l << " " << el.r << " " << el.it << "\n";
//        }

        vector<ll> dp(key.size(), 0);
        ll prev = 1;
        for (auto [l, r, it] : a) {
            while (prev <= r) {
                dp[prev] = dp[prev - 1];
                prev++;
            }
            if (l == 0) {
                dp[r] = max(dp[r], 1ll);
            } else {
                dp[r] = max(dp[r], dp[l - 1] + 1);
            }
        }

//        for (auto el : dp) {
//            cout << el << " ";
//        }

        m = *std::max_element(dp.begin(), dp.end());
//        cout << m << "\n";

        ll curm = m, curn = n;
        set<ll> s;
        for (ll i = 0; i < n; ++i) {
            s.insert(i);
        }
        for (ll i = 0; i < n; ++i) {
            ll it = del[i].second;
            if (curm > m / 2) {
                s.erase(it);
                curm--;
            }
            while ((!per[it].empty()) && curn > n / 2) {
                curn--;
                s.erase(per[i].back());
            }
        }


        for (auto el : s) {
            cout << el.it + 1 << " ";
        }
        cout << endl;
    }


    return 0;
}
