#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
}


template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
};

class DSU {
private:
    vector <int> p;
    vector <int> r;

public:
    int comp;

    explicit DSU(int n) : p(n), r(n), comp(n) {
        iota(all(p), 0);
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) {
            return;
        }
        --comp;
        if (r[a] > r[b]) {
            swap(a, b);
        }
        p[a] = b;
        r[b] += (r[a] == r[b]);
    }
};

using Segment = tuple <int, int, int>;

void solve() {
    int n;
    cin >> n;
    assert(n % 2 == 0);
    vector<Segment> v(n);
    {
        int id = 0;
        for (auto &[l, r, i]: v) {
            cin >> l >> r;
            i = id++;
        }
    }
    sort(all(v), [](Segment a, Segment b) {
        if (get<1>(a) != get<1>(b)) {
            return get<1>(a) < get<1>(b);
        }
        return get<0>(a) > get<0>(b);
    });
    vector<int> connect(n + 1);
    vector <int> rs;
    for (int i = 0; i < n; ++i) {
        rs.push_back(get<1>(v[i]));
    }
    auto rr = rs;
    for (auto [l, r, i] : v) {
        rr.push_back(l);
    }
    sort(all(rr));
    rr.resize(unique(all(rr)) - rr.begin());
    unordered_map <int, int> prikol;
    for (int i = 0; i < sz(rr); ++i) {
        prikol[rr[i]] = i;
    }
    vector <int> dp(sz(rr) + 1, 0);
    for (int i = 0; i < n; ++i) {
        auto [l, r, id] = v[i];
        l = prikol[l] + 1;
        r = prikol[r] + 1;
        dp[r] = max(dp[l - 1] + 1, dp[r - 1]);
    }
    cerr << dp.back();
    DSU dsu(n);
    assert(dp.back() % 2 == 0);
    for (int i = 0; i < n; ++i) {
        auto [l1, r1, id1] = v[i];
        for (int j = 0; j < n; ++j) {
            auto [l2, r2, id2] = v[j];
            if (l1 <= l2 && r2 <= r1) {
                dsu.unite(i, j);
                continue;
            }
            if (l2 <= l1 && r1 <= r2) {
                dsu.unite(i, j);
                continue;
            }
            if ((l1 <= l2 && l2 <= r1) ||
                (l1 <= r2 && r2 <= r1) ||
                (l2 <= l1 && l1 <= r2) ||
                (l2 <= r1 && r1 <= r2)) {
//                assert(false);
            }
        }
//        auto [l, r, id] = v[i];
//        auto it1 = lower_bound(all(rs), l);
//        auto it2 = --upper_bound(all(rs), r);
//        int li = it1 - rs.begin();
//        int ri = it2 - rs.begin();
//        if (ri != i) {
//            dsu.unite(i, ri);
//        } else if (li != ri) {
//            dsu.unite(i, ri - 1);
//        }
//        connect[ri + 1]--;
//        connect[li + 1]++;
//        if (li != ri) {
//            dsu.unite(i, ri - 1);
//        }
//        if (ri != i) {
//            dsu.unite(i, ri);
//        }
    }
//    for (int i = 1; i < n; ++i) {
//        connect[i] += connect[i - 1];
//        if (connect[i]) {
//            dsu.unite(i, i - 1);
//        }
//    }
    vector <vector <int> > compseg(n);
    vector <pii> comps(n);
    for (int i = 0; i < n; ++i) {
        compseg[dsu.get(i)].push_back(i);
        comps[dsu.get(i)].ff++;
        comps[i].ss = i;
    }
    {
        vector <pii> comps2;
        for (auto [a, b] : comps) {
            if (a) {
                comps2.emplace_back(a, b);
            }
        }
        comps = comps2;
    }
//    assert(dp.back() % 2 == 0);
//    assert(sz(comps) % 2 == 0);
    sort(all(comps));
    vector <int> res;
    for (int i = 0; i < sz(comps) / 2; ++i) {
        for (auto j : compseg[comps[i].ss]) {
            res.push_back(j);
        }
    }
    int offset = n / 2 - sz(res);
    for (int i = sz(comps) / 2; i < sz(comps); ++i) {
        for (int j = 0; j < sz(compseg[comps[i].ss]) - 1 && offset; ++j, --offset) {
            res.push_back(compseg[comps[i].ss][j]);
        }
    }
    sort(all(res));
    for (auto i : res) {
        cout << get<2>(v[i]) + 1 << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}