#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

struct segtree {
	int size;
	vector<vector<int>> t;
	segtree(vector<int> &a) {
		size = 1;
		while (size < sz(a)) size *= 2;
		t.resize(2 * size);
		build(a, 1, 0, size);
	}

	void build(vector<int>& a, int x, int lx, int rx) {
		if (rx - lx == 1) {
			if (lx < sz(a))
				t[x] = { a[lx] };
			return;
		}

		int mx = (lx + rx) / 2;
		build(a, 2 * x, lx, mx);
		build(a, 2 * x + 1, mx, rx);
		merge(all(t[2 * x]), all(t[2 * x + 1]), back_inserter(t[x]));
	}

	int get(int l, int r, int k, int x, int lx, int rx) { // <= k
		if (lx >= r || rx <= l)
			return 0;
		if (l <= lx && rx <= r)
			return upper_bound(all(t[x]), k) - t[x].begin();
		int mx = (lx + rx) / 2;
		return get(l, r, k, 2 * x, lx, mx) + get(l, r, k, 2 * x + 1, mx, rx);
	}
	int get(int l, int r, int k) {
		return get(l, r, k, 1, 0, size);
	}
};

void solve_case() {
	int n, k, q; cin >> n >> k >> q;
	vector<vector<int>> g(n);
	for (int i = 0; i < n; i++) {
		int c; cin >> c;
		g[i].resize(c);
		for (int& x : g[i])
			cin >> x, x--;
	}

	int T = 0;
	vector<int> tin(n, 0), tout(n, 0);
	vector<int> cnt(n, 0);

	function<void(int, int)> dfs = [&](int v, int from) {
		tin[v] = T++;
		if (sz(g[v])) {
			cnt[g[v][0]] = cnt[v] + (from == 1);
			dfs(g[v][0], 0);
			cnt[g[v][1]] = cnt[v] + (from == 0);
			dfs(g[v][1], 1);
		}
		tout[v] = T;
	};
	dfs(0, -1);

	for (int i = 0; i < n; i++)
		if (sz(g[i]) == 0)
			cnt[i] = 1e9;

	segtree st(cnt);

	while (q--) {
		int v; cin >> v;
		v--;

		int cnt = st.get(tin[v], tout[v] + 1, k);
		cout << cnt << "\n";
	}

}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif


	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
