#include "bits/stdc++.h"
#include <array>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

void solve_case() {
	int n; cin >> n;
	vector<pair<int, int>> a(n);
	for (auto& [x, y] : a)
		cin >> x >> y;

	auto get = [&](vector<pair<int, int>> a) {
		sort(all(a), [](pair<int, int> x, pair<int, int> y) {
			return x.second < y.second;
			});

		int max_took = -1;
		int res = 0;

		for (auto& [l, r] : a) {
			if (l > max_took) {
				max_took = r;
				res++;
			}
		}

		return res;
	};

	int m = get(a);
	vector<array<int, 4>> events;
	for (int i = 0; i < n; i++) {
		events.push_back({ a[i].first, 1, -a[i].second, i });
		events.push_back({ a[i].second, 0, -a[i].first, -i });
	}
	sort(all(events));

	vector<vector<int>> g(n);
	vector<int> deg(n, 0);
	vector<int> p(n, -1);

	vector<int> opened;
	for (auto& [x, t, _, idx] : events) {
		if (t == 0) idx *= -1;
		if (t == 1) {
			opened.push_back(idx);
		} else {
			opened.pop_back();
			if (sz(opened) && a[idx].second > a[opened.back()].first && a[opened.back()].second > a[idx].first) {
				p[idx] = opened.back();
				deg[opened.back()]++;
				g[opened.back()].push_back(idx);
			}
		}
	}

	vector<int> took(n, 1);
	int rem = n / 2;
	for (int _ = 0; _ < m / 2; _++, rem--) {
		int best = 1e9, bestI = -1;
		for (int i = 0; i < n; i++) {
			if (took[i] && deg[i] == 0) {
				int need = 0;

				int v = i;
				while (p[v] >= 0 && deg[p[v]] == 1) {
					need++;
					v = p[i];
				}

				if (v != i && v < 0) {
					need = 1e8;
				}

				if (need < best) {
					best = need;
					bestI = i;
				}
			}
		}

		took[bestI] = 0;
		if (p[bestI] >= 0) {
			deg[p[bestI]]--;
		}
	}

	while (rem) {
		for (int i = 0; i < n; i++) {
			if (p[i] == -1 && took[i]) {
				took[i] = 0;
				for (int v : g[i])
					p[v] = -1;
				rem--;

				break;
			}
		}
	}

	for (int i = 0; i < n; i++)
		if (took[i])
			cout << i + 1 << " ";
	cout << "\n";
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif


	int T = 1;
	cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
