#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <iomanip>
#include <random>

using namespace std;

#define int long long

int h, w, k;

pair<int, int> solve_1d(vector<int> v, int d_sz) {
    int ans = v.back() - v[0] + 1;
    int ans_cnt = 0;
    for (int i = 0; i < k - 1; ++i) {
        int cur_ans = d_sz - (v[i + 1] - v[i] + 1) + 2;
        int cur_cnt = min(v[i], d_sz - v[i + 1] + 1);
        if (cur_ans < ans) {
            ans = cur_ans;
            ans_cnt = cur_cnt;
        } else if (cur_ans == ans) {
            ans_cnt = min(ans_cnt, cur_cnt);
        }
    }
    return {ans, ans_cnt};
}

void solve() {
    vector<int> x(k), y(k);
    for (int i = 0; i < k; ++i) {
        cin >> x[i] >> y[i];
    }
    sort(x.begin(), x.end());
    sort(y.begin(), y.end());
    auto ax = solve_1d(x, h);
    auto ay = solve_1d(y, w);
    cout << ax.first * ay.first << " " << ax.second + ay.second;
}

signed main() {
#ifdef BENTSA
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    while (cin >> h >> w >> k) {
        solve();
        cout << "\n";
    }
}
