#include <iostream>
#include <algorithm>

using namespace std;

typedef long long ll;
constexpr ll N = 700;

bool solve_small(ll* arr, ll n, ll a, ll b)
{
	if (a == 0 && b == 0) return true;
	if (a < 0 || b < 0 || n == 0) return false;
	return solve_small(arr, n - 1, a, b) || solve_small(arr, n - 1, a - arr[n - 1], b) || solve_small(arr, n - 1, a, b - arr[n - 1]);
}

int main()
{
	ll n, q, k, a, b;
	cin >> n >> q;
	auto arr = new ll[n];
	for (ll i = 0; i < n; i++)
	{
		cin >> arr[i];
	}
	sort(arr, arr + n);
	cin >> k; // Skip z

	if (n <= 10 && q <= 10)
	{
		for (int t = 0; t < q; t++)
		{
			cin >> k >> a >> b;
			cout << (solve_small(arr, upper_bound(arr, arr + n, k) - arr, a, b) ? "Yes" : "No") << endl;
		}
		return 0;
	}

	auto good = new bool**[n + 1];
	for (ll i = 0; i <= n; i++)
	{
		good[i] = new bool*[N];
		for (ll j = 0; j < N; j++)
		{
			good[i][j] = new bool[N];
			for (ll k = 0; k < N; k++)
			{
				if (i == 0)
				{
					good[i][j][k] = false;
					continue;
				}
				good[i][j][k] = good[i - 1][j][k];
				if (j >= arr[i - 1]) good[i][j][k] |= good[i - 1][j - arr[i - 1]][k];
				if (k >= arr[i - 1]) good[i][j][k] |= good[i - 1][j][k - arr[i - 1]];
			}
		}
		good[i][0][0] = true;
	}
	auto ideal = new ll*[n + 1];
	for (ll i = 0; i <= n; i++)
	{
		ideal[i] = new ll[N];
		for (ll j = 0; j < N; j++)
		{
			ideal[i][j] = -1;
			for (ll k = 0; k < N && good[i][j][k]; k++)
			{
				ideal[i][j]++;
			}
			if (j != 0 && ideal[i][j] > ideal[i][j - 1]) ideal[i][j] = ideal[i][j - 1];
		}
	}

	for (ll t = 0; t < q; t++)
	{
		cin >> k >> a >> b;
		cout << (ideal[upper_bound(arr, arr + n, k) - arr][b] >= a ? "Yes" : "No") << endl;
	}
	return 0;
}
