#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

pair<ll, ll> dfs(vector<ll>* arr, ll* eff, ll current, ll prev)
{
	auto sum1 = eff[current];
	auto sum2 = 0;
	for (auto v : arr[current])
	{
		if (v != prev)
		{
			auto p = dfs(arr, eff, v, current);
			sum1 += p.second;
			sum2 += p.first;
		}
	}
	if (sum1 < sum2) sum1 = sum2;
	return pair<ll, ll>(sum1, sum2);
}

void solve()
{
	ll n, q, x, y, m, s, f, sum, cert = 0;
	cin >> n >> q >> x >> y >> m;
	auto arr = new vector<ll>[n];
	for (ll i = 0; i < n - 1; i++)
	{
		cin >> s >> f;
		s--;
		f--;
		arr[s].push_back(f);
		arr[f].push_back(s);
	}
	auto eff = new ll[n];
	for (ll i = 0; i < n; i++)
	{
		cin >> eff[i] >> eff[i]; // l = r
		cert ^= (x * i + x + y * eff[i] * eff[i]) % m;
	}

	sum = dfs(arr, eff, 0, -1).first;

	auto suc = new bool[q];
	for (ll i = 0; i < q; i++)
	{
		cin >> s;
		suc[i] = s == sum;
		if (i != 0) cout << " ";
		cout << (suc[i] ? cert : -1);
	}
	cout << endl;
	
	for (cin >> s; s != 0; cin >> s)
	{
		if (suc[s - 1])
		{
			for (int i = 0; i < n; i++)
			{
				if (i != 0) cout << " ";
				cout << eff[i];
			}
			cout << endl;
		}
		else cout << -1 << endl;
	}
}

int main()
{
	ll t;
	cin >> t;
	for (ll i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}
