#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2e5;

int w[N], wL[N], wR[N], MOD;
ll kX = 0, kY = 0;
ll dp[N][2];

vector<int> adj[N], ord;

void dfs(int v, int par) {
    dp[v][0] = 0, dp[v][1] = w[v];

    for (int to : adj[v]) {
        if (to != par) {
            dfs(to, v);

            dp[v][1] += dp[to][0];
            dp[v][0] += max(dp[to][0], dp[to][1]);
        }
    }
}

void getOrd(int v, int par) {
    for (int to : adj[v]) {
        if (to != par) {
            getOrd(to, v);
        }
    }

    ord.push_back(v);
}

ll getBest() {
    dfs(0, -1);
    return max(dp[0][0], dp[0][1]);
}

int fM(int i) {
    return (kX * (i + 1) + kY * w[i] % MOD * w[i]) % MOD;
}

int ff(int i, int ww) {
    return (kX * (i + 1) + kY * ww % MOD * ww) % MOD;
}

bool inAns[N];

void restore(int v, int t, int par) {
    inAns[v] = false;

    if (t == 1 && dp[v][1] < dp[v][0]) {
        t = 0;
    }

    inAns[v] = t;

    for (int to : adj[v]) {
        if (to != par) {
            restore(to, t ^ 1, v);
        }
    }
}

//x * j + y * a[j]**2 % mod

void solve() {
    int n, q;
    cin >> n >> q;
    cin >> kX >> kY >> MOD;

    for (int i = 0; i < n; ++i) {
        adj[i].clear();
        inAns[i] = false;
    }

    ord.clear();


    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        a -= 1, b -= 1;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }

//    getOrd(0, -1);

    for (int i = 0; i < n; ++i) {
        cin >> wL[i] >> wR[i];
        w[i] = wL[i];
    }

    vector<ll> qv(q);

    for (int i = 0; i < q; ++i) {
        cin >> qv[i];
    }

    vector<int> certificate(q);

    const ll least = getBest();

    for (int i = 0; i < n; ++i) {
        w[i] = wR[i];
    }

    int none = 0;

    for (int i = 0; i < n; ++i) {
        none ^= ff(i, 0);
    }

    const ll most = getBest();

    restore(0, 1, -1);

    vector<int> prefF(n), sufF(n);

    for (int i = 0; i < n; ++i) {
        w[i] = inAns[i] * wR[i];
    }

    vector<int> aa;

    for (int i = 0; i < n; ++i) {
        if (inAns[i]) {
            aa.push_back(i);
        }
    }

    int cer = 0;

    for (int i = 0; i < n; ++i) {
        cer ^= fM(i);
    }

    vector<int> prefaa(aa.size() + 1), sufaa(aa.size() + 1);
    vector<ll> weightaa(aa.size() + 1);

    for (int i = 0; i < aa.size(); ++i) {
        int init = fM(aa[i]);
        sufaa[i] = init;

        w[aa[i]] = 0;
        prefaa[i + 1] = prefaa[i] ^ init ^ fM(aa[i]);
        w[aa[i]] = wR[aa[i]];

        weightaa[i + 1] = weightaa[i] + wR[aa[i]];
    }

    for (int i = int(aa.size()) - 1; i >= 0; --i) {
        sufaa[i] ^= sufaa[i + 1];
    }

    for (int i = 0; i < q; ++i) {
        if (qv[i] < least || qv[i] > most) {
            certificate[i] = -1;
            continue;
        }

        if (qv[i] == most) {
            certificate[i] = cer;
            continue;
        }

        if (qv[i] == 0) {
            certificate[i] = none;
            continue;
        }

        int lo = 0, hi = aa.size() + 1;

        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;

            if (weightaa.back() - weightaa[mid] > qv[i]) {
                lo = mid;
            } else {
                hi = mid;
            }
        }

        assert(lo < aa.size());

        int c = cer ^ prefaa[lo] ^ sufaa[lo + 2];

        ll need = weightaa.back() - weightaa[lo] - qv[i];

        c ^= ff(aa[lo], wR[aa[lo]] - need);

        certificate[i] = c;
    }

    for (int i = 0; i < q; ++i) {
        cout << certificate[i] << " ";
    }

//    cout << '\n';

    cout << endl;

    int i;

    while (true) {
        cin >> i;

        if (i == 0) {
            break;
        }

        i -= 1;

        if (certificate[i] == -1) {
            cout << -1;
            cout << endl;
            continue;
        }

        vector<int> ans(n);

        auto print = [&]() {
            for (int x : ans) {
                cout << x << " ";
            }

            cout << endl;
        };

        if (qv[i] == most) {
            for (int j : aa) {
                ans[j] = wR[j];
            }

            print();
            continue;
        }

        if (qv[i] == 0) {
            print();

            continue;
        }

        int lo = 0, hi = aa.size() + 1;

        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;

            if (weightaa.back() - weightaa[mid] > qv[i]) {
                lo = mid;
            } else {
                hi = mid;
            }
        }

        assert(lo < aa.size());

        int c = cer ^ prefaa[lo] ^ sufaa[lo + 2];

        for (int j : aa) {
            ans[j] = wR[j];
        }

        for (int j = 0; j < lo; ++j) {
            ans[aa[j]] = 0;
        }

        ll need = weightaa.back() - weightaa[lo] - qv[i];

        ans[aa[lo]] -= need;

//        c ^= ff(aa[lo], wR[aa[lo]] - need);
//
//        certificate[i] = c;

        print();
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }


    return 0;
}
