#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2e5 + 1;

int w[N], wL[N], wR[N], MOD;
ll kX = 0, kY = 0;
ll dp[N][2];

vector<int> adj[N], ord;

void dfs(int v, int par) {
    dp[v][0] = 0, dp[v][1] = w[v];

    for (int to: adj[v]) {
        if (to != par) {
            dfs(to, v);

            dp[v][1] += dp[to][0];
            dp[v][0] += max(dp[to][0], dp[to][1]);
        }
    }
}

void getOrd(int v, int par) {
    for (int to: adj[v]) {
        if (to != par) {
            getOrd(to, v);
        }
    }

    ord.push_back(v);
}

ll getBest() {
    dfs(0, -1);
    return max(dp[0][0], dp[0][1]);
}

int fM(int i) {
    return (kX * (i + 1) + kY * w[i] % MOD * w[i]) % MOD;
}

int ff(int i, int ww) {
    return (kX * (i + 1) + kY * ww % MOD * ww) % MOD;
}

//x * j + y * a[j]**2 % mod

ll sumRoot = 0;
ll sumo = 0;

void modify(int i, int x) {
    if (i == 0) {
        sumRoot -= w[i];
    } else {
        sumo -= w[i];
    }

    w[i] = x;

    if (i == 0) {
        sumRoot += w[i];
    } else {
        sumo += w[i];
    }
}

ll Best() {
    return max(sumRoot, sumo);
}

void solve() {
    int n, q;
    cin >> n >> q;
    cin >> kX >> kY >> MOD;

    sumRoot = sumo = 0;

    for (int i = 0; i < n; ++i) {
        adj[i].clear();
    }

    ord.clear();


    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        a -= 1, b -= 1;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }

//    getOrd(0, -1);

    for (int i = 0; i < n; ++i) {
        cin >> wL[i] >> wR[i];
        w[i] = wL[i];
    }

    vector<ll> qv(q);

    for (int i = 0; i < q; ++i) {
        cin >> qv[i];
    }

    vector<int> certificate(q);

    const ll least = getBest();

    int cc = 0;

    for (int i = 0; i < n; ++i) {
        w[i] = wR[i];

        cc ^= fM(i);
    }

    const ll most = getBest();

    vector<ll> val(n);
    vector<int> prefF(n + 1), sufF(n + 1);

    ord.assign(n, 0);

    iota(ord.begin(), ord.end(), 0);

    for (int i = 0; i < n; ++i) {
        sufF[i] = fM(ord[i]);

        modify(w[ord[i]], wL[ord[i]]);

        prefF[i + 1] = prefF[i] ^ fM(ord[i]);

        ll now = Best();
        val[i] = now;
    }

    for (int i = n - 1; i >= 0; --i) {
        sufF[i] ^= sufF[i + 1];
    }

    assert(is_sorted(val.rbegin(), val.rend()));

    assert(val.back() == least);

    auto search = [&](ll x) {
        if (val[0] <= x) {
            return 0;
        }

        int lo = 0, hi = n - 1;

        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;

            if (val[mid] <= x) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        return hi;
    };

    for (int i = 0; i < q; ++i) {
        if (qv[i] < least || qv[i] > most) {
            certificate[i] = -1;
            continue;
        }

        int j = search(qv[i]);

        int nw = (j == 0 ? most : val[j - 1]) - qv[i];
        nw = wR[ord[j]] - nw;

//                assert(nw == wR[ord[j]]);

        int k = prefF[j] ^ sufF[j + 1] ^ ff(ord[j], nw);
        certificate[i] = k;
    }

    for (int i = 0; i < q; ++i) {
        cout << certificate[i] << " ";
    }

//    cout << '\n';

    cout << endl;

    int i;

    while (true) {
        cin >> i;

        if (i == 0) {
            break;
        }

        i -= 1;

        if (certificate[i] == -1) {
            cout << -1;
            cout << endl;
            continue;
        }

        if (qv[i] < least || qv[i] > most) {
            assert(false);
        }

        bool printed = false;

        int j = search(qv[i]);

        int nw = (j == 0 ? most : val[j - 1]) - qv[i];
        nw = wR[ord[j]] - nw;

//                assert(nw == wR[ord[j]]);

        vector<int> ans(n);

        for (int k = 0; k < j; ++k) {
            ans[ord[k]] = wL[ord[k]];
        }

        ans[j] = nw;

        for (int k = j + 1; k < n; ++k) {
            ans[ord[k]] = wR[ord[k]];
        }

        for (int x: ans) {
            cout << x << " ";
        }

        cout << endl;

        printed = true;

        assert(printed);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }


    return 0;
}