#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(v) v.begin(), v.end()
#define pii pair<int, int>

struct seg_tree {
    vector<int> tree;
    int n;

    seg_tree(int i) {
        n = 1;
        while (n < i) n *= 2;
        tree.resize(n * 2, -1e9);
    }

    void change(int i, int x) {
        i += n;
        tree[i] = x;
        i /= 2;
        while (i > 0) {
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
            i /= 2;
        }
    }

    int get(int i) {
        i += n;
        return tree[i];
    }

    int get(int l, int r) {
        l += n, r += n;
        int ret = 0;
        while (l <= r) {
            if (l & 1) ret = max(ret, tree[l++]);
            if (!(r & 1)) ret += max(ret, tree[r--]);
            l /= 2;
            r /= 2;
        }
        return ret;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    vector<seg_tree> byK = vector<seg_tree>(n + 2, seg_tree(n + 2)),
            byJ = vector<seg_tree>(n + 2, seg_tree(n + 2));
    byJ[0].change(n + 1, 0);
    byK[n + 1].change(0, 0);
    for (int i = 0; i < n; ++i) {
        vector<pair<int, pii>> change;
        int pi1 = 0, pi2 = n + 1;
        if (i > 0) pi1 = p[i - 1] + 1, pi2 = p[i - 1] - 1;
        for (int k = pi1; k <= n + 1; ++k) {
            int th = byK[k].get(0, p[i] - 1) + 1;
            if (byK[k].get(p[i]) < th) change.push_back({th, {p[i], k}});
        }
        for (int j = 0; j <= pi2; ++j) {
            int th = byJ[j].get(p[i] + 1, n + 1) + 1;
            if (byJ[j].get(p[i]) < th) change.push_back({th, {j, p[i]}});
        }
        for (auto cur: change) {
            byJ[cur.second.first].change(cur.second.second, cur.first);
            byK[cur.second.second].change(cur.second.first, cur.first);
        }
    }
    int ans = 0;
    for (int i = 0; i <= n + 1; ++i) {
        ans = max(ans, byJ[i].get(0, n + 1));
    }
    cout << ans << endl;
}

signed main() {
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

/*
1
4
8 4
1 2 3 4
5 6 7 8
8 4
1 4 5 7
2 3 6 8
8 3
2 5 6
3 7 8
8 3
2 6 7
1 3 8

 */