#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<vector<int>> fen1;
vector<vector<int>> fen2;

int get1(int i, int j) {
    int mx = -1e9;
    for (; i > -1; i = (i & (i + 1)) - 1) {
        mx = max(mx, fen1[i][j]);
    }
    return mx;
}

int get2(int i, int j) {
    j = fen2[0].size() - j - 1;
    int mx = -1e9;
    for (; j > -1; j = (j & (j + 1)) - 1) {
        mx = max(mx, fen2[i][j]);
    }
    return mx;
}

void upd(int i, int j, int r) {
    for (int i1 = i; i1 < fen1.size(); i1 = i1 | (i1 + 1)) {
        fen1[i1][j] = max(fen1[i1][j], r);
    }
    j = fen2[0].size() - j - 1;
    for (int j1 = j; j1 < fen2[0].size(); j1 = j1 | (j1 + 1)) {
        fen2[i][j1] = max(fen2[i][j1], r);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    set<int> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b.insert(a[i]);
    }
    map<int, int> ind;
    int ii = 0;
    for (auto elem: b) {
        ind[elem] = ++ii;
    }
    for (auto &i: a) {
        i = ind[i];
    }
    fen1.assign(ii + 2, vector<int>(ii + 2, -1e9));
    fen2.assign(ii + 2, vector<int>(ii + 2, -1e9));
    upd(0, ii + 1, 0);
    for (int i = 0; i < n; ++i) {
        vector<vector<int>> nx;
        for (int j1 = 0; j1 < ii + 2; ++j1) {
            nx.push_back({a[i] - 1, j1, get1(a[i] - 1, j1) + 1});
        }
        for (int j2 = 0; j2 < ii + 2; ++j2) {
            nx.push_back({j2, a[i] + 1, get2(j2, a[i] + 1) + 1});
        }
        for (auto elem: nx) {
            upd(elem[0], elem[1], elem[2]);
        }
    }
    int ans = 0;
    for (auto i: fen1) {
        for (auto j: i) {
            ans = max(ans, j);
        }
    }
    cout << ans << "\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}