#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <set>

using namespace std;

vector<int> fen;

int get(int r) {
    int ans = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        ans = max(ans, fen[r]);
    }
    return ans;
}

void upd(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(fen[i], x);
    }
}

int get(vector<pair<pair<int, int>, int>> a) {
    int n = a.size();
    vector<int> al;
    for (auto i: a) {
        al.push_back(i.first.first);
        al.push_back(i.first.second);
    }
    sort(al.begin(), al.end());
    fen.assign(al.size(), 0);
    for (int i = 0; i < n; ++i) {
        auto ind = lower_bound(al.begin(), al.end(), a[i].first.first) - al.begin();
        --ind;
        int res = get(ind);
        ++res;
        ind = lower_bound(al.begin(), al.end(), a[i].first.second) - al.begin();
        upd(ind, res);
    }
    return *max_element(fen.begin(), fen.end());
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    int cnt = get(a);
    for (int i = 0; i <= n / 2; ++i) {
        vector<pair<pair<int, int>, int>> now;
        for (int j = i; j < i + n / 2; ++j) {
            now.push_back(a[j]);
        }
        if (get(now) == cnt / 2 && now.size() == n / 2) {
            for (auto elem: now) {
                cout << elem.second + 1 << " ";
            }
            cout << endl;
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}