#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <set>

using namespace std;

vector<int> fen;

int get(int r) {
    int ans = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        ans = max(ans, fen[r]);
    }
    return ans;
}

void upd(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(fen[i], x);
    }
}

int get(vector<pair<pair<int, int>, int>> a) {
    sort(a.begin(), a.end());
    int n = a.size();
    vector<int> al;
    for (auto i: a) {
        al.push_back(i.first.first);
        al.push_back(i.first.second);
    }
    sort(al.begin(), al.end());
    fen.assign(al.size(), 0);
    for (int i = 0; i < n; ++i) {
        auto ind = lower_bound(al.begin(), al.end(), a[i].first.first) - al.begin();
        --ind;
        int res = get(ind);
        ++res;
        ind = lower_bound(al.begin(), al.end(), a[i].first.second) - al.begin();
        upd(ind, res);
    }
    return *max_element(fen.begin(), fen.end());
}

bool cmp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.second - a.first.first > b.first.second - b.first.first;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    sort(a.begin(), a.end(), cmp);
    int cnt = get(a);
    int l = 0;
    int r = n / 2 + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        vector<pair<pair<int, int>, int>> b;
        for (int i = m; i < m + n / 2; ++i) {
            b.push_back(a[i]);
        }
        if (get(b) < cnt / 2) {
            r = m;
        } else {
            l = m;
        }
    }
    for (int i = l; i < l + n / 2; ++i) {
        cout << a[i].second + 1 << " ";
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}