#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <set>

using namespace std;

int get(vector<pair<pair<int, int>, int>> a) {
    int n = a.size();
    vector<int> dp(n, 1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[j].first.second < a[i].first.first) {
                if (dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    return *max_element(dp.begin(), dp.end());
}

vector<int> get1(vector<pair<pair<int, int>, int>> a) {
    int n = a.size();
    vector<int> dp(n);
    vector<int> pr(n, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[j].first.second < a[i].first.first) {
                if (dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                    pr[i] = j;
                }
            }
        }
    }
    vector<set<int>> p;
    auto pos = max_element(dp.begin(), dp.end()) - dp.begin();
    vector<int> an;
    while (pos != -1) {
        an.push_back(pos);
        pos = pr[pos];
    }
    return an;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    int cnt = get(a);
    for (int i = 0; i < n; ++i) {
        vector<pair<pair<int, int>, int>> now;
        for (int j = i; j < n; ++j) {
            now.push_back(a[j]);
            if (get(now) == cnt / 2 && now.size() == n / 2) {
                for (auto elem : now){
                    cout << elem.second + 1 << " ";
                }
                cout << endl;
                return;
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}