#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

vector<int> SM, left_ch, right_ch;

void create(int i, int l, int r) {
	if (left_ch[i] != -1) {
		return;
	}
	int mid = (l + r) / 2;
	left_ch[i] = SM.size();
	SM.push_back(mid - l);
	left_ch.push_back(-1);
	right_ch.push_back(-1);
	right_ch[i] = SM.size();
	SM.push_back(r - mid);
	left_ch.push_back(-1);
	right_ch.push_back(-1);
}

void set0(int i, int l, int r, int q) {
	--SM[i];
	if (l + 1 == r) {
		return;
	}
	create(i, l, r);
	int mid = (l + r) / 2;
	if (q < mid) {
		set0(left_ch[i], l, mid, q);
	} else {
		set0(right_ch[i], mid, r, q);
	}
}

int gtr(int i, int l, int r, int lq) {
	if (r <= lq) {
		return -1;
	}
	if (i == -1) {
		return max(lq, l);
	}
	if (SM[i] == 0) {
		return -1;
	}
	if (l + 1 == r) {
		return l;
	}
	int mid = (l + r) / 2;
	int ns = gtr(left_ch[i], l, mid, lq);
	if (ns == -1) {
		return gtr(right_ch[i], mid, r, lq);
	}
	return ns;
}

int gtl(int i, int l, int r, int rq) {
	if (rq <= l) {
		return -1;
	}
	if (i == -1) {
		return min(rq, r) - 1;
	}
	if (SM[i] == 0) {
		return -1;
	}
	if (l + 1 == r) {
		return l;
	}
	int mid = (l + r) / 2;
	int ns = gtl(right_ch[i], mid, r, rq);
	if (ns == -1) {
		return gtl(left_ch[i], l, mid, rq);
	}
	return ns;
}

void solve1() {
	SM.clear();
	left_ch.clear();
	right_ch.clear();
	int n, k; cin >> n >> k;
	SM.push_back(n);
	left_ch.push_back(-1);
	right_ch.push_back(-1);
	vector<int> a(k), b;
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		a[i] %= n;
		set0(0, 0, n, a[i]);
	}
	for (int i = 0; i < k; ++i) {
		int nw = a[i];
		int ns = gtr(0, 0, n, nw);
		if (ns == -1) {
			nw = gtr(0, 0, n, 0);
		} else {
			nw = ns;
		}
		if (nw == 0) {
			b.push_back(n);
		} else {
			b.push_back(nw);
		}
		set0(0, 0, n, nw);
	}
	sort(all(b));
	for (int i = 0; i < k; ++i) {
		cout << b[i] << ' ';
	}
	cout << '\n'; cout.flush();
}

void solve2() {
	SM.clear();
	left_ch.clear();
	right_ch.clear();
	int n, k; cin >> n >> k;
	SM.push_back(n);
	left_ch.push_back(-1);
	right_ch.push_back(-1);
	vector<int> a(k), b;
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		a[i] %= n;
		set0(0, 0, n, a[i]);
	}
	for (int i = 0; i < k; ++i) {
		int nw = a[i];
		int ns = gtl(0, 0, n, nw);
		if (ns == -1) {
			nw = gtl(0, 0, n, n);
		} else {
			nw = ns;
		}
		if (nw == 0) {
			b.push_back(n);
		} else {
			b.push_back(nw);
		}
		set0(0, 0, n, nw);
	}
	sort(all(b));
	for (int i = 0; i < k; ++i) {
		cout << b[i] << ' ';
	}
	cout << '\n'; cout.flush();
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int tp; cin >> tp;
	int t = 1; cin >> t;
	while (t--) {
		if (tp == 1) {
			solve1();
		} else {
			solve2();
		}
	}
}
