#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()

vector<int> L, R, cnt;

void dfs(int u, int last, int hm, int k) {
	if (L[u] == -1) {
		if (hm <= k) {
			cnt[u] = 1;
		}
		return;
	}
	if (last == 0 || last == -1) {
		dfs(L[u], 0, hm, k);
	} else {
		dfs(L[u], 0, hm + 1, k);
	}
	if (last == 1 || last == -1) {
		dfs(R[u], 1, hm, k);
	} else {
		dfs(R[u], 1, hm + 1, k);
	}
	cnt[u] = cnt[L[u]] + cnt[R[u]];
}

void solve() {
	int n, k, q;
	cin >> n >> k >> q;
	L.resize(n, -1);
	R.resize(n, -1);
	for (int i = 0; i < n; ++i) {
		int t; cin >> t;
		if (t == 2) {
			cin >> L[i] >> R[i];
			--L[i]; --R[i];
		}
	}
	cnt.resize(n, 0);
	dfs(0, -1, 0, k);
	for (int i = 0; i < q; ++i) {
		int u; cin >> u;
		cout << cnt[u - 1] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
