#include <bits/stdc++.h>
using namespace std;

const int inf = 2e9;

struct segment {
    int l, r, i;
    segment() {}
};

struct event {
    int pos, type, par, i;
    event(int pos, int type, int par, int i) : pos(pos), type(type), par(par), i(i) {}
};

bool cmp_events(event a, event b) {
    if (a.pos == b.pos) return a.type < b.type;
    return a.pos < b.pos;
}

bool cmp_r(segment a, segment b) {
    return a.r < b.r;
}

bool cmp_l(segment a, segment b) {
    return a.l < b.l;
}

void solve() {
    int n;
    cin >> n;
    vector<segment> segments(n);
    for (int i = 0; i < n; i++) {
        cin >> segments[i].l >> segments[i].r;
        segments[i].i = i;
    }
    vector<event> events;
    for (int i = 0; i < n; i++) {
        events.push_back(event(segments[i].l, 0, segments[i].r, i));
        events.push_back(event(segments[i].r, 1, segments[i].l, i));
    }

    sort(events.begin(), events.end(), cmp_events);

    vector<int> nearest_r(n, -1), nearest_l(n, -1);

    int mn_in_closed = -1;

    for (int i = 2 * n - 1; i >= 0; i--) {
        if (events[i].type == 1) {
            nearest_r[events[i].i] = mn_in_closed;
        } else {
            if (mn_in_closed == -1) mn_in_closed = events[i].i;
            else if (events[i].par < segments[mn_in_closed].r) mn_in_closed = events[i].i;
        }
    }

    int mx_in_closed = -1;

    for (int i = 0; i < 2 * n; i++) {
        if (events[i].type == 0) {
            nearest_l[events[i].i] = mx_in_closed;
        } else {
            if (mx_in_closed == -1 || events[i].par > segments[mx_in_closed].l) {
                mx_in_closed = events[i].i;
            } 
        }
    }

    // for (int i : nearest_l) cout << i << " ";
    // cout << "\n";
    // for (int i : nearest_r) cout << i << " ";
    // cout << "\n";

    sort(segments.begin(), segments.end(), cmp_r);
    vector<int> rev_i(n);
    for (int i = 0; i < n; i++) {
        rev_i[segments[i].i] = i;
    }

    vector<int> dp_r(n), dp_l(n);
    for (int i = n - 1; i >= 0; i--) {
        if (nearest_r[segments[i].i] == -1) dp_r[i] = 1;
        else dp_r[i] = dp_r[rev_i[nearest_r[segments[i].i]]] + 1;
    }

    // for (int i : dp_r) cout << i << " ";
    // cout << "\n";

    int m = dp_r[0];
    int first_half = -1;
    for (int i = 0; i < n; i++) {
        if (dp_r[i] == m / 2) {
            first_half = i;
            break;
        }
    }

    if (first_half <= (n / 2)) {
        reverse(segments.begin(), segments.end());
        for (int i = 0; i < first_half; i++) {
            segments.pop_back();
        }
        reverse(segments.begin(), segments.end());

        vector<int> ans;
        int curr = 0;
        vector<bool> used(n, false);
        for (int i = 0; i < (m / 2); i++) {
            ans.push_back(segments[curr].i);
            used[segments[curr].i] = true;
            curr = rev_i[nearest_r[segments[curr].i]];
        }
        // for (auto s : segments) {
        //     cout << s.l << " " << s.r << "\n";
        // }

        for (auto s : segments) {
            if (ans.size() == n / 2) break;
            if (!used[s.i]) {
                ans.push_back(s.i);
                used[s.i] = true;
            }
        }

        for (int i : ans) cout << i + 1 << " ";
        cout << "\n";
    } else {
        // cout << "CRINGE\n";
        sort(segments.begin(), segments.end(), cmp_l);
        // for (auto s : segments) {
        //     cout << s.l << " " << s.r << "\n";
        // }
        vector<int> rev_i(n);
        for (int i = 0; i < n; i++) {
            rev_i[segments[i].i] = i;
        }
        for (int i = 0; i < n; i++) {
            if (nearest_l[segments[i].i] == -1) dp_l[i] = 1;
            else dp_l[i] = dp_l[rev_i[nearest_l[segments[i].i]]] + 1;
        }
        for (int i = n - 1; i >= 0; i--) {
            if (dp_l[i] == m / 2) {
                first_half = i;
                break;
            }
        }
        for (int i = 0; i < n - first_half - 1; i++) {
            segments.pop_back();
        }
        vector<int> ans;
        int curr = (int)segments.size() - 1;
        vector<bool> used(n, false);
        for (int i = 0; i < (m / 2); i++) {
            ans.push_back(segments[curr].i);
            used[segments[curr].i] = true;
            curr = rev_i[nearest_r[segments[curr].i]];
        }
        for (auto s : segments) {
            if (ans.size() == n / 2) break;
            if (!used[s.i]) {
                ans.push_back(s.i);
                used[s.i] = true;
            }
        }

        for (int i : ans) cout << i + 1 << " ";
        cout << "\n";
    }
}

int main() {
    #ifdef GEOMA
        freopen("input", "r", stdin);
        freopen("output", "w", stdout);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif
    int t;
    cin >> t;
    for (int _ = 0; _ < t; _++) {
        solve();
    }
}