#include <bits/stdc++.h>
using namespace std;

#define int long long

struct segment {
    int l, r, i;
    segment() {}
};

struct event {
    int pos, type, par, i;
    event(int pos, int type, int par, int i) : pos(pos), type(type), par(par), i(i) {}
};

bool cmp_events(event a, event b) {
    if (a.pos == b.pos) return a.type < b.type;
    return a.pos < b.pos;
}

bool cmp_r(segment a, segment b) {
    return a.r < b.r;
}

void solve() {
    int n;
    cin >> n;
    vector<segment> segments(n);
    for (int i = 0; i < n; i++) {
        cin >> segments[i].l >> segments[i].r;
        segments[i].i = i;
    }
    
    sort(segments.begin(), segments.end(), cmp_r);

    int m = 0;
    int mx_r = 0;
    for (auto s : segments) {
        if (s.l > mx_r) {
            m++;
            mx_r = s.r;
        }
    }

    int curr_m = 0;
    int half = -1;
    mx_r = 0;

    for (auto s : segments) {
        if (s.l > mx_r) {
            curr_m++;
            mx_r = s.r;
        }
        if (curr_m == m / 2 + 1) {
            half = s.i;
            break;
        }
    }

    int half_pos;
    for (int i = 0; i < n; i++) {
        if (segments[i].i == half) {
            half_pos = i;
            break;
        }
    }
    // cout << half_pos << "\n";
    if (half_pos <= n / 2) {
        reverse(segments.begin(), segments.end());
        for (int i = 0; i < half_pos; i++) segments.pop_back();
        reverse(segments.begin(), segments.end());
    } else{
        for (int i = 0; i < n - half_pos; i++) segments.pop_back();
    }

    // for (auto s : segments) {
    //     cout << s.l << " " << s.r << "\n";
    // }

    vector<int> ans;
    vector<bool> used(n, false);
    mx_r = 0;
    for (auto s : segments) {
        if (s.l > mx_r) {
            ans.push_back(s.i);
            used[s.i] = true;
            mx_r = s.r;
        }
    }
    for (auto s : segments) {
        if (ans.size() == n / 2) break;
        if (!used[s.i]) {
            ans.push_back(s.i);
            used[s.i] = true;
        }
    }

    for (int i : ans) cout << i + 1 << " ";
    cout << "\n";
}

signed main() {
    #ifdef GEOMA
        freopen("input", "r", stdin);
        freopen("output", "w", stdout);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif
    int t;
    cin >> t;
    for (int _ = 0; _ < t; _++) {
        solve();
    }
}