#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int> 
vector<pair<pi, int>> segs;
vector<pair<pi, int>> sgs;
vector<vector<pair<pi, int>>> chep;
vector<int> sz;
bool cmp1(int a, int b) {
	return chep[a].size() < chep[b].size();
}
map<pair<int, int>, vector<int>> m;
void solve() {
	m.clear();
	sgs.clear();
	segs.clear();
	chep.clear();
	int dn = 0;
	int N = 0; cin >> N;
	for (int i = 0; i < N; ++i) {
		int l = 0, r = 0; cin >> l >> r;
		segs.push_back({ { l,r }, i });
		m[{l, r}].push_back(i);
	}
	sort(segs.begin(), segs.end());
	vector<bool> used; used.assign(N, false);
	for (int i = 0; i < N; ++i) {
		for (int j = i + 1; j < N; ++j) {
			if (segs[j].first.second <= segs[i].first.second) used[i] = true;
		}
	}
	for (int i = 0; i < N; ++i) {
		if (!used[i]) sgs.push_back(segs[i]);
	}
	int cit = 0;
	while (cit < sgs.size()) {
		vector<pair<pi, int>> curchain;
		curchain.push_back(sgs[cit]);
		int nit = cit + 1;
		while (nit < sgs.size() && sgs[nit].first.first <= sgs[cit].first.second) {
			curchain.push_back(sgs[nit++]);
		}
		cit = nit;
		chep.push_back(curchain);
	}
	vector<int> tot;
	vector<int> toc;
	toc.assign(chep.size(), 0);
	for (int i = 0; i < chep.size(); ++i) toc[i] = i;
	for (int i = 0; i < chep.size(); ++i) {
		vector<pair<pi, int>> nw;
		for (auto x : chep[i]) {
			for (auto y : m[x.first]) {
				nw.push_back({ x.first, y });
			}
		}
		swap(nw, chep[i]);
	}
	sort(toc.begin(), toc.end(), cmp1);
	vector<int> ans;
	ans.assign(N, 0);
	for (int i = 0; i < toc.size() / 2; ++i) {
		for (auto x : chep[i]) {
			ans[x.second] = 1;
			tot.push_back(x.second);
		}
		dn += chep[i].size();
	}
	assert(toc.size() % 2 == 0);
	for (int i = toc.size() / 2; i < toc.size(); ++i) {
		for (auto x : chep[i]) {
			ans[x.second] = 2;
		}
	}
	for (int i = 0; i < N; ++i) {
		if (dn == N / 2) break;
		if (ans[i] != 0) continue;
		dn++;
		tot.push_back(i);
	}
	for (auto x : tot) {
		cout << x + 1 << " ";
	}
	cout << "\n";
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 0; cin >> T;
	while (T--) {
		solve();
	}
	return 0;
}