#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int>
#define vi vector<int> 
const int INF = 1e18 + 10;
int gt(vi& a) {
	int cur = 0;
	for (int j = 0; j < a.size(); ++j) {
		if (a[j] - 1 > cur) return cur;
		cur += a[j];
	}
	return cur;
}
bool isKthBitSet(int num, int k) {
	return num & (1ll << k);
}
const int AMAX = 5001;
void solve() {
	int N = 0, Q = 0; cin >> N >> Q;
	vector<int> w; w.assign(N, 0);
	for (auto& x : w) cin >> x;
	sort(w.begin(), w.end());
	vector<int> rch; rch.push_back(0);
	for (int i = 0; i < N; ++i) {
		if (rch.back() < w[i] - 1) rch.push_back(rch.back());
		else rch.push_back(rch.back() + w[i]);
	}
	int z = 0; cin >> z;
	vector<vector<int>> dp;
	dp.assign(N + 1, vi(AMAX, -1));
	dp[0][0] = 0;
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < AMAX; ++j) {
			if (dp[i][j] == -1) continue;
			dp[i + 1][j] = max(dp[i + 1][j], dp[i][j]);
			dp[i + 1][min(AMAX - 1, j + w[i])] = max(dp[i + 1][min(AMAX - 1, j + w[i])], dp[i][j]);
			if (w[i] - 1 <= dp[i][j]) {
				dp[i + 1][j] = max(dp[i + 1][j], min(AMAX - 1, dp[i][j] + w[i]));
			}
		}
	}
	vector<vector<int>> mn;
	mn.assign(AMAX, vi());
	for (int i = 0; i < AMAX; ++i) {
		for (int n = 0; n <= N; ++n) {
			mn[i].push_back(dp[n][i]);
		}
	}
	while (Q--) {
		int jj = 0, c = 0, d = 0; cin >> jj >> c >> d;
		if (d == 0) {
			int ps = upper_bound(w.begin(), w.end(), jj) - w.begin();
			if (rch[ps] >= c) cout << "Yes\n";
			else cout << "No\n";
			continue;
		}
		int t = lower_bound(mn[c].begin(), mn[c].end(), d) - mn[c].begin();
		if (t == mn[c].size()) {
			cout << "No\n";
			continue;
		}
		if (t == 0 || w[t - 1] <= jj) {
			cout << "Yes\n";
			continue;
		}
		cout << "No\n";
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1; //cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
	return 0;
}
