#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int>
#define vi vector<int> 

int gt(vi& a) {
	int cur = 0;
	for (int j = 0; j < a.size(); ++j) {
		if (a[j] - 1 > cur) return cur;
		cur += a[j];
	}
	return cur;
}
bool isKthBitSet(int num, int k) {
	return num & (1ll << k);
}

void solve() {
	int N = 0, Q = 0; cin >> N >> Q;
	vector<int> w; w.assign(N, 0);
	for (auto& x : w) cin >> x;
	sort(w.begin(), w.end());
	vector<int> rch; rch.push_back(0);
	for (int i = 0; i < N; ++i) {
		if (rch.back() < w[i] - 1) rch.push_back(rch.back());
		else rch.push_back(rch.back() + w[i]);
	}
	int z = 0; cin >> z;
	while (Q--) {
		int jj = 0, c = 0, d = 0; cin >> jj >> c >> d;
		if (d == 0) {
			int ps = upper_bound(w.begin(), w.end(), jj) - w.begin();
			if (rch[ps] >= c) cout << "Yes\n";
			else cout << "No\n"; 
			continue;
		}
		bool brk = false;
		map<pair<int, int>, int> a;
		for (int msk = 0; msk < (1ll << N); ++msk) {
			vi fir; vi sec;
			for (int j = 0; j < N; ++j) {
				if (w[j] > jj) continue;
				if (isKthBitSet(msk, j)) fir.push_back(w[j]);
			}
			for (int secmsk = 0; secmsk < (1ll << fir.size()); ++secmsk) {
				int s1 = 0; int s2 = 0;
				for (int j = 0; j < fir.size(); ++j) {
					if (isKthBitSet(secmsk, j)) s1 += fir[j];
					else s2 += fir[j];
				}
				a[{s1, s2}]++;
			}
			bool allc = true;
			for (int i = 0; i <= c; ++i) {
				if (!allc) {
					break;
				}
				for (int j = 0; j <= d; ++j) {
					if (!a.count({ i, j })) {
						allc = false;
						break;
					}
				}
			}
			if (allc) {
				brk = true;
				cout << "Yes\n";
				break;
			}
		}
		if (!brk) {
			cout << "No\n";
		}
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1; //cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
	return 0;
}
