#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(2e18) + 13;

ll h, w;
int k;

template<typename T> inline bool smin(T&a, T b) {
  if (b < a) {
    a = b;
    return true;
  }
  return false;
}
template<typename T> inline bool smax(T&a, T b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

//struct MinQueue {
//  deque<ll> dq;
//  MinQueue() {}
//  void Push(ll x) {
//    while (!dq.empty() && dq.back() > x)
//      dq.pop_back();
//    dq.push_back(x);
//  }
//  void Pop(ll x) {
//    if (dq.front() == x)
//      dq.pop_front();
//  }
//  ll Min() const {
//    return dq.front();
//  }
//};

vector<pair<pair<ll, ll>, ll>> qs[2];
void set_max(ll l, ll r, ll val, bool left) {
  qs[left].emplace_back(make_pair(l, r), val);
}
pair<ll, ll> apply(ll C) {
  vector<ll> vals;
  for (int i = 0; i < qs[0].size(); ++i) {
    vals.push_back(qs[0][i].first.first);
    vals.push_back(qs[0][i].first.second);
  }
  for (int i = 0; i < qs[1].size(); ++i) {
    vals.push_back(qs[1][i].first.first);
    vals.push_back(qs[1][i].first.second);
  }
  sort(vals.begin(), vals.end());
  vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
  vector<vector<pair<ll, bool>>> add(vals.size()), rem(vals.size());
  ll ans = LLINF, shift = 0;
  multiset<ll> lt, rt;
  for (auto & [p, val] : qs[0]) {
    int x = lower_bound(vals.begin(), vals.end(), p.first) - vals.begin();
    int y = lower_bound(vals.begin(), vals.end(), p.second) - vals.begin();
    add[x].emplace_back(val, 0);
    rem[y].emplace_back(val, 0);
  }
  for (auto & [p, val] : qs[1]) {
    int x = lower_bound(vals.begin(), vals.end(), p.first) - vals.begin();
    int y = lower_bound(vals.begin(), vals.end(), p.second) - vals.begin();
    add[x].emplace_back(val, 1);
    rem[y].emplace_back(val, 1);
  }
  for (int i = 0; i < (int)vals.size(); ++i) {
    if (vals[i] == C) continue;
    for (auto & [x, fl] : rem[i]) {
      multiset<ll> & ms = fl ? rt : lt;
      ms.erase(ms.find(x));
    }
    for (auto & [x, fl] : add[i]) {
      multiset<ll> & ms = fl ? rt : lt;
      ms.insert(x);
    }

    ll opt_l = lt.empty() ? 0 : *lt.rbegin();
    ll opt_r = rt.empty() ? 0 : *rt.rbegin();
    if (smin(ans, opt_l + opt_r + 1) || (opt_l + opt_r + 1 == ans &&
          min(vals[i], C - vals[i]) < min(shift, C - shift))) {
      shift = vals[i];
    }
  }
  return { ans, shift };
}

void run(ll C, const vector<ll> & crd/*, vector<ll> & lt, vector<ll> & rt*/) {

//  function<void(ll, ll, ll, bool)> set_max = [&set_max, &lt, &rt, &C](ll l, ll r, ll val, bool left) {
//    if (r < l) {
//      set_max(l, C, val, left);
//      set_max(0, r, val, left);
//      return;
//    }
//    if (left) {
//      for (ll i = l; i < r; ++i) {
//        lt[i] = max(lt[i], val);
//      }
//    } else {
//      for (ll i = l; i < r; ++i) {
//        rt[i] = max(rt[i], val);
//      }
//    }
//  };

  for (int i = 1; i < k; ++i) {
    int x = i, y = 0;
    if (crd[x] > crd[y]) swap(x, y);
    ll dx = crd[y] - crd[x];
    ll dx2 = crd[x] + C - crd[y];
    set_max(0, C - crd[y], dx, y == 0);
    set_max(C - crd[y], C - crd[x], dx2, x == 0);
    set_max(C - crd[x], C, dx, y == 0);
  }

}

int main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  cin >> h >> w >> k;
  vector<pair<ll, ll>> a(k);
  vector<ll> r(k), c(k);
  for (int i = 0; i < k; ++i) {
    cin >> r[i] >> c[i]; --r[i], --c[i];
  }

//  vector<ll> lt(w), rt(w);
  run(w, c/*, lt, rt*/);
  auto [ans_x, shift_x] = apply(w);
  qs[0].clear();
  qs[1].clear();
//  ll ans_x = LLINF, shift_x;
//  for (int i = 0; i < w; ++i) {
//    if (lt[i] + rt[i] + 1 < ans_x || (lt[i] + rt[i] + 1 == ans_x
//              && min(shift_x, w - shift_x) > min(1ll * i, w - i))) {
//      ans_x = lt[i] + rt[i] + 1;
//      shift_x = i;
//    }
//  }
//  lt.assign(h, 0);
//  rt.assign(h, 0);
  run(h, r/*, lt, rt*/);
  auto [ans_y, shift_y] = apply(h);
//  ll ans_y = LLINF, shift_y;
//  for (int i = 0; i < h; ++i) {
//    if (lt[i] + rt[i] + 1 < ans_y || (lt[i] + rt[i] + 1 == ans_y
//              && min(shift_y, h - shift_y) > min(1ll * i, h - i))) {
//      ans_y = lt[i] + rt[i] + 1;
//      shift_y = i;
//    }
//  }
  cout << ans_x * ans_y << ' ' << min(shift_x, w - shift_x) + min(shift_y, h - shift_y) << endl;

  return 0;
}
