#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

int n;
int tv = 1;
vector <vector <int>> gr;
vector <int> pr;
vector <int> used;

bool dfs(int v) {
    used[v] = tv;
    for (int& u : gr[v]) {
        if (pr[u] == -1) {
            pr[u] = v;
            return true;
        }
    }
    return false;
}

void findMaximalMatching() {
    pr.assign(n, -1);
    used.assign(n, 0);
    tv = 1;

    for (int v = 0; v < n; v++) {
        if (dfs(v)) {
            tv++;
        }
    }
    cout << "";
}

struct DSU {
    vector <int> pr;
    vector <vector <int>> comp;

    DSU(int n) {
        pr.resize(n);
        iota(all(pr), 0);
        comp.resize(n);
        for (int i = 0; i < n; i++)
            comp[i].push_back(i);
    }

    int getPr(int v) {
        if (v == pr[v]) return v;
        pr[v] = getPr(pr[v]);
        return pr[v];
    }

    void unionSets(int u, int v) {
        u = getPr(u);
        v = getPr(v);

        if (u == v) return;

        if (comp[u].size() > comp[v].size()) {
            pr[v] = u;
            for (int& i : comp[v])
                comp[u].push_back(i);
            comp[v].clear();
        } else {
            pr[u] = v;
            for (int& i : comp[u])
                comp[v].push_back(i);
            comp[u].clear();
        }
    }
};

void solve() {
    cin >> n;

    vector <int> nums;
    vector <int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        nums.push_back(l[i]);
        nums.push_back(r[i]);
    }

    sort(all(nums));
    nums.erase(unique(all(nums)), nums.end());

    for (int i = 0; i < n; i++) {
        l[i] = lower_bound(all(nums), l[i]) - nums.begin();
        r[i] = lower_bound(all(nums), r[i]) - nums.begin();
    }

//    for (int i = 0; i < n; i++) {
//        cout << l[i] << " " << r[i] << "\n";
//    }

    gr.assign(n, vector <int> ());

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;

            if (r[i] < l[j]) {
                gr[i].push_back(j);
            }
        }
    }

    findMaximalMatching();

    DSU dsu(n);
    for (int i = 0; i < n; i++) {
        if (pr[i] == -1) continue;
        dsu.unionSets(pr[i], i);
    }

    vector <vector <int>> comp;
    for (auto& v : dsu.comp) {
        sort(all(v), [&](int i, int j) {
            return r[i] < l[j];
        });
        if (!v.empty())
            comp.push_back(v);
    }

    int m = 0;
    for (auto& v : comp)
        m = max(m, (int)v.size());

    if (m % 2)
        cout << "BRUH\n";

    int need = m / 2;

    set <int> st;
    for (int i = 0; i < n; i++)
        st.insert(i);

    set <pair <int, int>> rm;
    for (int i = 0; i < comp.size(); i++)
        rm.insert({-(int)comp[i].size(), i});

    int rem = n / 2;
    while (true) {
        int v = rm.begin()->second;
        if (comp[v].size() == need) break;
        st.erase(comp[v].back());
        comp[v].pop_back();
        bool found = false;
        for (int i = 0; i < comp.size(); i++) {
            if (r[comp[v].back()] < l[comp[i].back()]) {
                comp[v].push_back(comp[i].back());
                comp[i].pop_back();
                rm.erase({-(comp[i].size() + 1), i});
                if (!comp[i].empty()) {
                    rm.insert({-comp[i].size(), i});
                }
                found = true;
                break;
            }
        }

        if (!found) {
            rm.erase({-(comp[v].size() + 1), v});
            rm.insert({-comp[v].size(), v});
        }
        rem--;
        if (rem == 0) break;
    }

    if (!rem) {
        for (int i : st) {
            cout << i + 1 << " ";
        }
        cout << "\n";
        return;
    }

    rm.clear();
    for (int i = 0; i < comp.size(); i++) {
        if (!comp[i].empty())
            rm.insert({(int)comp[i].size(), i});
    }

    while (rem--) {
        int v = rm.begin()->second;
        st.erase(comp[v].back());
        comp[v].pop_back();
        rm.erase({comp[v].size() + 1, v});
        if (!comp[v].empty())
            rm.insert({comp[v].size(), v});
    }

    for (int i : st) {
        cout << i + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}
