
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = (int)1e5 + 10;
const int mod = (int)1e9 + 7;

#define all(x) begin(x), end(x)

int nxt(int x, int n) {
	return x % n + 1;
}

int prv(int x, int n) {
	if (x == 1) return n;
	return x - 1;
}

vector<int> encode(int n, vector<int>& a) {
	int k = a.size();
	set<int> val;
	for (int i = 0; i < k; i++) {
		val.insert(a[i]);
	}
	vector<int> out;
	if (k == 1) {
		out.push_back(nxt(a[0], n));
	} else if (k == 2) {
		int st = -1;
		if (nxt(a[0], n) == a[1]) st = 1;
		if (nxt(a[1], n) == a[0]) st = 0;
		if (st != -1) {
			out.push_back(nxt(a[st], n));
			out.push_back(nxt(nxt(a[st], n), n));
		} else {
			out.push_back(nxt(a[0], n));
			out.push_back(nxt(a[1], n));
		}
	} else if (k == n / 2 && n % 2 == 0) {
		for (int i = 1; i <= n; i++) {
			if (val.find(i) == val.end()) {
				out.push_back(i);
			}
		}
	} else {
		for (auto x : a) {
			out.push_back(nxt(x, n));
		}
	}
	sort(out.begin(), out.end());
	return out;
}

vector<int> decode(int n, vector<int> &a) {
	int k = a.size();
	set<int> val;
	for (int i = 0; i < k; i++) {
		val.insert(a[i]);
	}
	vector<int> out;
	if (k == 1) {
		out.push_back(prv(a[0], n));
	} else if (k == 2) {
		int st = -1;
		if (nxt(a[0], n) == a[1]) st = 0;
		if (nxt(a[1], n) == a[0]) st = 1; 
		if (st != -1) {
			out.push_back(prv(a[st], n));
			out.push_back(prv(prv(a[st], n), n));
		} else {
			out.push_back(prv(a[0], n));
			out.push_back(prv(a[1], n));
		}
	} else if (k == n / 2) {
		for (int i = 1; i <= n; i++) {
			if (val.find(i) == val.end()) {
				out.push_back(i);
			}
		}
	} else {
		for (auto x : a) {
			out.push_back(prv(x, n));
		}
	}
	sort(out.begin(), out.end());
	return out; 
	
}

void solve() {

}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int ty;
	int t = 1;
	cin >> ty >> t;
	mt19937 rnd;
	while (t--) {
		vector<int> out;
		int n, k = 3;
		cin >> n >> k;
		vector<int> a(k);// = { 1 };
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		if (ty == 1) {
			out = encode(n, a);
			if (a != decode(n, out)) {
				cout << ":(";
			}
		} else {
			out = decode(n, a);
		}
		for (auto& x : out) {
			cout << x << " ";
		}
		cout << endl;
	}
	return 0;
}