#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mxn = (int)10010;
const int inf = (int)1e6 + 7;

#define all(x) begin(x), end(x)

struct BIT {
	vector<int> t;
	void init(int n) {
		t.assign(n + 10, -inf);
	}
	void upd(int r, int x) {
		r += 1;
		for (; r < t.size(); r += r & -r) {
			t[r] = max(t[r], x);
		}
	}
	int get(int r) {
		r += 1;
		int res = -inf;
		for (; r > 0; r -= r & -r) {
			res = max(res, t[r]);
		}
		return res;
	}
};

BIT hor[mxn];
BIT ver[mxn];

void solve() {
	int n;
	cin >> n;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i <= n + 1; i++) {
		hor[i].init(n + 2);
		ver[i].init(n + 2);
	}
	hor[0].upd(0, 0);
	ver[n + 1].upd(0, 0);
	for (int i = 0; i < n; i++) {
		int cur = a[i + 1];
		vector<pair<int, pair<int, int>>> val;
		for (int mx = n + 1; mx >= 0; mx--) {
			int opt = hor[mx].get(cur - 1) + 1;
			val.push_back({ opt, {mx, cur} });
		}
		for (int mn = 0; mn <= n + 1; mn++) {
			int opt = ver[mn].get(cur - 1) + 1;
			val.push_back({ opt, {cur, mn} });
		}
		for (auto [opt, coord] : val) {
			hor[coord.first].upd(n + 1 - coord.second, opt);
			ver[coord.second].upd(coord.first, opt);
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans = max(ans, hor[i].get(n));
		ans = max(ans, ver[i].get(n));
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}