#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include  <set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)2e5;

struct seg {
	int l = 0, r = 0;
	int idx = -1;
};

bool operator<(const seg& a, const seg& b) {
	if (a.r != b.r) return a.r < b.r;
	return a.l < b.l;
}

int get(vector<seg> a) {
	int n = (int)a.size() - 1;
	sort(a.begin() + 1, a.end());
	vector<int> dp(n + 1);
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		seg find; find.l = 0, find.r = curL;
		int it = lower_bound(a.begin(), a.end(), find) - a.begin();
		while (it < i && a[it].r < curL) it++;
		dp[i] = max(dp[i - 1], dp[it - 1] + 1);
	}
	return dp[n];
}


void solve() {
	int n;
	cin >> n;
	vector<seg> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i].l >> a[i].r;
		a[i].idx = i;
	}
	int omega = get(a);
	for (int mask = 0; mask < (1 << n); mask++) {
		int cnt = 0;
		vector<seg> b;
		b.push_back({ 0, 0 });
		for (int j = 0; j < n; j++) {
			if (mask >> j & 1) {
				b.push_back(a[j + 1]);
				cnt++;
			}
		}
		if (cnt * 2 != n) continue;
		int kek = get(b);
		if (kek * 2 != omega) continue;
		for (int i = 1; i < b.size(); i++) {
			cout << b[i].idx << " ";
		}
		cout << '\n';
		return;

	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}