#include <iostream>
#include <vector>
#include <iomanip>
#include <assert.h>
#include <map>
#include  <set>
#include  <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)510;

struct seg {
	int l = 0, r = 0;
	int idx = -1;
};

bool operator<(const seg& a, const seg& b) {
	if (a.r != b.r) return a.r < b.r;
	return a.l < b.l;
}

int get(vector<seg> a) {
	int n = (int)a.size() - 1;
	sort(a.begin() + 1, a.end());
	vector<int> dp(n + 1);
	int j = 0;
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		seg find; find.l = 0, find.r = curL;
		int it = lower_bound(a.begin(), a.end(), find) - a.begin();
		while (it < i && a[it].r < curL) it++;
		dp[i] = max(dp[i - 1], dp[it - 1] + 1);
	}
	return dp[n];
}

bool intersect(seg a, seg b) {
	return max(a.l, b.l) <= min(a.r, b.r);

}
bool cmp(vector<seg>& a, vector<seg>& b) {
	return a.size() < b.size();
}
int dp[maxn][maxn][maxn];
int iter[maxn];
mt19937 rnd;
void solve() {
	int n = 4;
	cin >> n;
	vector<seg> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i].l >> a[i].r;
		a[i].idx = i;
	}
	/*for (int i = 1; i <= n; i++) {
		a[i].l = rnd() % 5 + 1;
		a[i].r = a[i].l + 1 + rnd() % 5;
		a[i].idx = i;
	}*/
	int m = get(a);
	if (m % 2 != 0) return;
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int k = 0; k <= n; k++) {
				dp[i][j][k] = 0;
				iter[i] = 0;
			}
		}
	}
	sort(a.begin() + 1, a.end());
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		seg find; find.l = 0, find.r = curL;
		int it = lower_bound(a.begin(), a.end(), find) - a.begin();
		while (it < i && a[it].r < curL) it++;
		iter[i] = it;
		for (int j = 0; j <= n / 2; j++) {
			for (int k = 0; k <= m / 2; k++) {
				if (j > 0 && dp[i - 1][j - 1][k]) {
					dp[i][j][k] = 1;
					continue;
				}
				if (k > 0) {
					for (int p = 0; p <= i - it; p++) {
						if (j - p < 0) break;
						dp[i][j][k] |= dp[it - 1][j - p][k - 1];
					}
				}
			}
		}
	}
	vector<seg> ans(1);
	int cur = n, skip = n / 2, pe = m / 2;

	while (cur != 0) {
		int it = iter[cur];
		if (skip > 0 && dp[cur - 1][skip - 1][pe]) {
			cur -= 1;
			skip -= 1;
		} else {
			vector<seg> add(1);
			for (int i = cur; i >= it; i--) {
				add.push_back(a[i]);
			}
			for (int p = 0; p <= cur - it; p++) {
				if (skip - p < 0) break;
				if (dp[it - 1][skip - p][pe - 1]) {
					cur = it - 1;
					skip -= p;
					pe -= 1;
					break;
				}
				add.pop_back();
			}
			for (int i = 1; i < add.size(); i++) {
				for (int j = i + 1; j < add.size(); j++) {
					if (!intersect(add[i], add[j])) {
						assert(0);
					}
				}
			}
			for (int i = 1; i < add.size(); i++) {
				ans.push_back(add[i]);
			}
		}
	}
	if (get(ans) != m / 2) {
		assert(0);
	}
	for (int i = 1; i < ans.size(); i++) {
		cout << ans[i].idx << " ";
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}