#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include  <set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)50;

struct seg {
	int l = 0, r = 0;
	int idx = -1;
};

bool operator<(const seg& a, const seg& b) {
	if (a.r != b.r) return a.r < b.r;
	return a.l < b.l;
}

int get(vector<seg> a) {
	int n = (int)a.size() - 1;
	sort(a.begin() + 1, a.end());
	vector<int> dp(n + 1);
	int j = 0;
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		while (j < i && a[j].r < curL) j++;
		dp[i] = max(dp[i - 1], dp[j - 1] + 1);
	}
	return dp[n];
}

int dp[maxn][maxn][maxn];
int iter[maxn];
void solve() {
	int n;
	cin >> n;
	vector<seg> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i].l >> a[i].r;
		a[i].idx = i;
	}
	int m = get(a);
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int k = 0; k <= n; k++) {
				dp[i][j][k] = 0;
				iter[i] = 0;
			}
		}
	}
	sort(a.begin() + 1, a.end());
	dp[0][0][0] = 1;
	int it = 0;
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		while (it < i && a[it].r < curL) it++;
		iter[i] = it;
		for (int j = 0; j <= n / 2; j++) {
			for (int k = 0; k <= m / 2; k++) {
				if (dp[i - 1][j - 1][k]) {
					dp[i][j][k] = 1;
					continue;
				}
				for (int p = 0; p <= i - it; p++) {
					if (j - p < 0) break;
					dp[i][j][k] |= dp[it - 1][j - p][k - 1];
				}
			}
		}
	}
	vector<seg> ans(1);
	int cur = n, skip = n / 2, pe = m / 2;

	while (cur != 0) {
		int it = iter[cur];
		if (dp[cur - 1][skip - 1][pe]) {
			cur -= 1;
			skip -= 1;
		} else {
			for (int i = cur; i >= it; i--) {
				ans.push_back(a[i]);
			}
			for (int p = 0; p <= cur - it; p++) {
				if (skip - p < 0) break;
				if (dp[it - 1][skip - p][pe - 1]) {
					cur = it - 1;
					skip -= p;
					pe -= 1;
					break;
				}
				ans.pop_back();
			}
		}
	}
	if (get(ans) != m / 2) {
		assert(0)
	}
	for (int i = 1; i < ans.size(); i++) {
		cout << ans[i].idx << " ";
	}
	cout << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
