#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

struct Node {
	int summ = 0;
	Node* l = nullptr;
	Node* r = nullptr;

	Node() {

	}

	Node(int x) {
		summ = x;
	}
};

int get_sum(Node* v, int l, int r, int a, int b) {
	if (!v || b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		return v->summ;
	}
	int mid = (l + r) / 2;
	return get_sum(v->l, l, mid, a, b) + get_sum(v->r, mid, r, a, b);
}

void update(Node* v, int l, int r, int idx) {
	if (l + 1 == r) {
		v->summ = 1;
		return;
	}
	int mid = (l + r) / 2;
	if (idx < mid) {
		v->summ++;
		if (v->l == nullptr) {
			v->l = new Node();
		}
		update(v->l, l, mid, idx);
	} else{
		v->summ++;
		if (v->r == nullptr) {
			v->r = new Node();
		}
		update(v->r, mid, r, idx);
	}
}

int find_right(Node* v, int l, int r, int a) {
	if (r <= a || v && v->summ == r - l) {
		return -1;
	}
	if (!v) {
		if (l + 1 == r) {
			return l;
		}
		int mid = (l + r) / 2;
		int idx = find_right(nullptr, l, mid, a);
		if (idx == -1) {
			return find_right(nullptr, mid, r, a);
		}
		else {
			return idx;
		}
	}
	if (a <= l) {
		if (!v) {
			return l;
		}
		int mid = (l + r) / 2;
		if (v->l == nullptr || mid - l != v->l->summ) {
			return find_right(v->l, l, mid, a);
		}
		else {
			return find_right(v->r, mid, r, a);
		}
	}
	int mid = (l + r) / 2;
	int idx = find_right(v->l, l, mid, a);
	if (idx == -1) {
		return find_right(v->r, mid, r, a);
	}
	else {
		return idx;
	}
}

/*int find_left(Node* v, int l, int r, int a) {
	if (l >= a || v && v->summ == r - l) {
		return -1;
	}
	if (!v) {
		return min(a - 1, r - 1);
	}
	if (r <= a) {
		int mid = (l + r) / 2;
		if (v->r == nullptr || r - mid != v->r->summ) {
			return find_left(v->r, mid, r, a);
		}
		else {
			return find_left(v->l, l, mid, a);
		}
	}
	int mid = (l + r) / 2;
	int idx = find_left(v->r, mid, r, a);
	if (idx == -1) {
		return find_left(v->l, l, mid, a);
	}
	else {
		return idx;
	}
}*/

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	/*int n = 9;
	vector<int> arr(n);
	arr[0] = arr[1] = arr[3] = arr[8] = 1;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << arr[(i + j) % n];
		}
		cout << '\n';
	}*/
	int type;
	cin >> type;
	if (type == 1) {
		int t;
		cin >> t;
		while (t--) {
			int n, k;
			cin >> n >> k;
			Node* root = new Node();
			vector<int> arr(k);
			for (int i = 0; i < k; i++) {
				cin >> arr[i];
				arr[i]--;
				update(root, 0, n, arr[i]);
			}
			vector<int> bbb;
			for (int i = 0; i < k; i++) {
				if (get_sum(root, 0, n, arr[i], n) == n - arr[i]) {
					int j = find_right(root, 0, n, 0);
					update(root, 0, n, j);
					bbb.push_back(j);
				}
				else {
					int j = find_right(root, 0, n, arr[i]);
					update(root, 0, n, j);
					bbb.push_back(j);
				}
			}
			sort(bbb.begin(), bbb.end());
			for (auto el : bbb) {
				cout << el + 1 << ' ';
			}
			cout << endl;
		}
	} else {
		int t;
		cin >> t;
		while (t--) {
			int n, k;
			cin >> n >> k;
			vector<bool> used(n);
			vector<int> arr(k);
			for (int i = 0; i < k; i++) {
				cin >> arr[i];
				arr[i]--;
				used[arr[i]] = true;
			}
			vector<int> bbb;
			for (int i = 0; i < k; i++) {
				int j = arr[i];
				while (used[j]) {
					j--;
					j += n;
					j %= n;
				}
				bbb.push_back(j);
				used[j] = true;
			}
			sort(bbb.begin(), bbb.end());
			for (auto el : bbb) {
				cout << el + 1 << ' ';
			}
			cout << endl;
			/*int n, k;
			cin >> n >> k;
			Node* root = new Node();
			vector<int> arr(k);
			for (int i = 0; i < k; i++) {
				cin >> arr[i];
				arr[i]--;
				update(root, 0, n, arr[i]);
			}
			vector<int> bbb;
			for (int i = 0; i < k; i++) {
				// cout << '!' << get_sum(root, 0, n, 0, arr[i] + 1) << '\n';
				if (get_sum(root, 0, n, 0, arr[i] + 1) != arr[i] + 1) {
					int j = find_left(root, 0, n, arr[i] + 1);
					
					update(root, 0, n, j);
					bbb.push_back(j);
				}
				else {
					int j = find_left(root, 0, n, n);
					update(root, 0, n, j);
					bbb.push_back(j);
				}
			}
			sort(bbb.begin(), bbb.end());
			for (auto el : bbb) {
				cout << el + 1 << ' ';
			}
			cout << endl;*/
		}
	/*if (type == 1) {
		int t;
		cin >> t;
		while (t--) {
			int n, k;
			cin >> n >> k;
			vector<int> arr(k);
			for (int i = 0; i < k; i++) {
				cin >> arr[i];
				arr[i]--;
			}
			sort(arr.begin(), arr.end());
			if (arr.back() - arr.front() <= n / 2 - 1) {
				vector<int> aaa = arr;
				for (auto& el : aaa) {
					el += n / 2;
					el += n;
					el %= n;
				}
				sort(aaa.begin(), aaa.end());
				for (auto el : aaa) {
					cout << el + 1 << ' ';
				}
				cout << endl;
				continue;
			}
			if (k == n / 2 && n % 2 == 0) {
				set<int> ss;
				for (int i = 0; i < n; i++) {
					ss.insert(i);
				}
				for (auto el : arr) {
					ss.erase(el);
				}
				for (auto el : ss) {
					cout << el + 1 << ' ';
				}
				cout << endl;
				continue;
			}
			for (int i = 0; i < n; i++) {
				vector<int> aaa = arr;
				for (auto& el : aaa) {
					el += i;
					el += n;
					el %= n;
				}
				bool f = 1;
				for (auto el : aaa) {
					if (binary_search(arr.begin(), arr.end(), el)) {
						f = 0;
					}
				}
				if (f) {
					sort(aaa.begin(), aaa.end());
					for (auto el : aaa) {
						cout << el + 1 << ' ';
					}
					cout << endl;
					break;
				}
			}

		}
	}
	else {
		int t;
		cin >> t;
		while (t--) {
			int n, k;
			cin >> n >> k;
			vector<int> arr(k);
			for (int i = 0; i < k; i++) {
				cin >> arr[i];
				arr[i]--;
			}
			sort(arr.begin(), arr.end());
			if (arr.back() - arr.front() <= n / 2 - 1) {
				vector<int> aaa = arr;
				for (auto &el : aaa) {
					el -= n / 2;
					el += n;
					el %= n;
				}
				sort(aaa.begin(), aaa.end());
				for (auto el : aaa) {
					cout << el + 1 << ' ';
				}
				cout << endl;
				continue;
			}
			if (k == n / 2 && n % 2 == 0) {
				set<int> ss;
				for (int i = 0; i < n; i++) {
					ss.insert(i);
				}
				for (auto el : arr) {
					ss.erase(el);
				}
				for (auto el : ss) {
					cout << el + 1 << ' ';
				}
				cout << endl;
				continue;
			}
			for (int i = 0; i < n; i++) {
				vector<int> aaa = arr;
				for (auto& el : aaa) {
					el -= i;
					el += n;
					el %= n;
				}
				bool f = 1;
				for (auto el : aaa) {
					if (binary_search(arr.begin(), arr.end(), el)) {
						f = 0;
					}
				}
				if (f) {
					sort(aaa.begin(), aaa.end());
					for (auto el : aaa) {
						cout << el + 1 << ' ';
					}
					cout << endl;
					break;
				}
			}
		}*/
	}
}