#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

int dp[2002][2002];
int dp1[2002][2002];
pair<int, int> segs[(int)5000000], new_segs[(int)5000000], eee[(int)5000000];

vector<vector<int>> t1;
vector<vector<int>> t2;


int get_max1(int j, int v, int l, int r, int a, int b) {
	if (b <= l || r <= a) {
		return -1;
	}
	if (a <= l && r <= b) {
		return t1[j][v];
	}
	int mid = (l + r) / 2;
	return max(get_max1(j, 2 * v + 1, l, mid, a, b), get_max1(j, 2 * v + 2, mid, r, a, b));
}

int get_max2(int j, int v, int l, int r, int a, int b) {
	if (b <= l || r <= a) {
		return -1;
	}
	if (a <= l && r <= b) {
		return t2[j][v];
	}
	int mid = (l + r) / 2;
	return max(get_max2(j, 2 * v + 1, l, mid, a, b), get_max2(j, 2 * v + 2, mid, r, a, b));
}

void update1(int j, int v, int l, int r, int idx, int x) {
	if (l + 1 == r) {
		t1[j][v] = max(t1[j][v], x);
		return;
	}
	int mid = (l + r) / 2;
	if (idx < mid) {
		update1(j, 2 * v + 1, l, mid, idx, x);
	}
	else {
		update1(j, 2 * v + 2, mid, r, idx, x);
	}
	t1[j][v] = max(t1[j][2 * v + +1], t1[j][2 * v + 2]);
}

void update2(int j, int v, int l, int r, int idx, int x) {
	if (l + 1 == r) {
		t2[j][v] = max(t2[j][v], x);
		return;
	}
	int mid = (l + r) / 2;
	if (idx < mid) {
		update2(j, 2 * v + 1, l, mid, idx, x);
	}
	else {
		update2(j, 2 * v + 2, mid, r, idx, x);
	}
	t2[j][v] = max(t2[j][2 * v + 1], t2[j][2 * v + 2]);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> arr(n);
		for (int i = 0; i < n; i++) {
			cin >> arr[i];
		}
		t1.clear();
		t2.clear();
		t1.resize(n + 2, vector<int>(4 * (n + 2), -1));
		t2.resize(n + 2, vector<int>(4 * (n + 2), -1));
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				dp[i][j] = -1;
			}
		}
		// dp[n + 1][0] = 0;
		update1(n + 1, 0, 0, n + 2,  0, 0);
		update2(0, 0, 0, n + 2, n + 1, 0);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < arr[i]; j++) {
				dp[j][arr[i]] = get_max1(j, 0, 0, n + 2, 0, arr[i]) + 1;
				if (dp[arr[i]][j] == 0) {
					dp[arr[i]][j] = -1;
				}
			}
			dp[n + 1][arr[i]] = get_max1(n + 1, 0, 0, n + 2, 0, arr[i] + 1);
			for (int j = arr[i] + 1; j <= n + 1; j++) {
				dp[arr[i]][j] = get_max2(j, 0, 0, n + 2, arr[i] + 1, n + 2) + 1;
				if (dp[arr[i]][j] == 0) {
					dp[arr[i]][j] = -1;
				}
			}
			dp[arr[i]][0] = get_max2(0, 0, 0, n + 2, arr[i] + 1, n + 2) + 1;
			for (int j = 0; j < arr[i]; j++) {
				update1(j, 0, 0, n + 2, arr[i], dp[j][arr[i]]);
				update2(arr[i], 0, 0, n + 2, j, dp[j][arr[i]]);
			}
			if (true) {
				update1(n + 1, 0, 0, n + 2, arr[i], dp[n + 1][arr[i]]);
				update2(arr[i], 0, 0, n + 2, n + 1, dp[n + 1][arr[i]]);
			}
			for (int j = arr[i] + 1; j <= n + 1; j++) {
				update2(j, 0, 0, n + 2, arr[i], dp[arr[i]][j]);
				update1(arr[i], 0, 0, n + 2, j, dp[arr[i]][j]);
			}
			if (true) {
				update2(0, 0, 0, n + 2, arr[i], dp[arr[i]][0]);
				update1(arr[i], 0, 0, n + 2, 0, dp[arr[i]][0]);
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				ans = max(dp[i][j], ans);
			}
		}
		cout << ans << '\n';
		/*if (NUP(n, arr) == 1) {
			cout << n << '\n';
			continue;
		}
		if (NUP(n, arr) == 2) {
			::t.assign(4 * (n + 1), 0);
			vector<int> dp1(n);
			for (int i = 0; i < n; i++) {
				dp1[i] = get_max(0, 0, n + 1, 0, arr[i]) + 1;
				update(0, 0, n + 1, arr[i], dp[i]);
			}
			::t.assign(4 * (n + 1, 0);
			vector<int> dp2(n);
			for (int i = n - 1; i >= 0; i--) {
				dp2[i] = get_max(0, 0, n + 1, arr[i] + 1, n) + 1;
				update(0, 0, n + 1, arr[i], dp[i]);
			}

			int ans = get_max(0, 0, n, 0, n) + 1;
			for (int i = 0; i < n; i++) {

			}
			continue;
		}


		for (int i = 0; i <= n + 1; i++) {
			for (int j = 0; j <= n + 1; j++) {
				dp[i][j] = 0;
			}
		}
		dp[n + 1][arr[0]] = 1;
		dp[arr[0]][0] = 1;
		int IDX = 2;
		segs[0] = { n + 1, arr[0] };
		segs[1] = { arr[0], 0 };
		for (int i = 1; i < n; i++) {
			int NEW_IDX = 0;
			for (int j = 0; j < IDX; j++) {
				auto el = segs[j];
				if (true) {
					pair<int, int> new_seg = el;
					if (el.first > arr[i]) {
						new_seg.first = arr[i];
						if (dp1[new_seg.first][new_seg.second] < dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] > el.second) {
						new_seg.second = arr[i];
						if (dp1[new_seg.first][new_seg.second] < dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] < el.second || arr[i] > el.first) {
						if (dp1[new_seg.first][new_seg.second] < dp[el.first][el.second]) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second];
						}
					}
				}
			}
			for (int j = 0; j < IDX; j++) {
				auto el = segs[j];
				if (true) {
					pair<int, int> new_seg = el;
					if (el.first > arr[i]) {
						new_seg.first = arr[i];
						if (dp1[new_seg.first][new_seg.second] == dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
							// new_segs.push_back(new_seg);
							new_segs[NEW_IDX++] = new_seg;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] > el.second) {
						new_seg.second = arr[i];
						if (dp1[new_seg.first][new_seg.second] == dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
							// new_segs.push_back(new_seg);
							new_segs[NEW_IDX++] = new_seg;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] < el.second || arr[i] > el.first) {
						if (dp1[new_seg.first][new_seg.second] == dp[el.first][el.second]) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second];
							// new_segs.push_back(new_seg);
							new_segs[NEW_IDX++] = new_seg;
						}
					}
				}
			}
			int NEW_NEW_IDX = 0;
			for (int j = 0; j < NEW_IDX; j++) {
				auto el = new_segs[j];
				if (dp1[el.first][el.second] != 0) {
					dp[el.first][el.second] = dp1[el.first][el.second];
					dp1[el.first][el.second] = 0;
					eee[NEW_NEW_IDX++] = el;
				}
			}
			IDX = NEW_NEW_IDX;
			for (int j = 0; j < NEW_NEW_IDX; j++) {
				segs[j] = eee[j];
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				ans = max(dp[i][j], ans);
			}
		}
		cout << ans << '\n';*/
	}
}