#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

vector<pair<int, pair<int, int>>>arr;
vector<int>dp, used;
int max_value, need, all, score;

bool comp(pair<int, pair<int, int>>a, pair<int, pair<int, int>>b) {
	return a.second.second < b.second.second || (a.second.second == b.second.second && a.second.first < b.second.first);
}

int get_best(int x, int have) {
	int l = -1, r = have;
	while (l + 1 != r) {
		int m = (l + r) / 2;
		if (arr[used[m]].second.second <= arr[x].second.first)
			l = m;
		else
			r = m;
	}
	return l;
}

bool brute(int i = 0, int have = 0) {
	if (have == need) {
		if (max_value == score) {
			for (auto i : used)
				cout << arr[i].first + 1 << ' ';
			return true;
		}
		return false;
	}
	if (all - i == need - have) {
		used.push_back(i);
		int ind = get_best(i, have), save_max = max_value;
		if (ind == -1)
			dp.push_back(1), max_value = max(max_value, 1);
		else
			dp.push_back(dp[ind] + 1), max_value = max(max_value, dp[ind] + 1);
		bool res = brute(i + 1, have + 1);
		if (res)
			return true;
		dp.pop_back();
		used.pop_back();
		max_value = save_max;
		return false;
	}
	if (brute(i + 1, have))
		return true;
	used.push_back(i);
	int ind = get_best(i, have), save_max = max_value;
	if (ind == -1)
		dp.push_back(1), max_value = max(max_value, 1);
	else
		dp.push_back(dp[ind] + 1), max_value = max(max_value, dp[ind] + 1);
	bool res = brute(i + 1, have + 1);
	if (res)
		return true;
	dp.pop_back();
	used.pop_back();
	max_value = save_max;
	return false;
}

void solve() {
	dp.clear();
	arr.clear();
	used.clear();
	int n;
	cin >> n;
	arr.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> arr[i].second.first >> arr[i].second.second;
		arr[i].first = i;
	}
	need = n / 2;
	all = n;
	sort(arr.begin(), arr.end(), comp);
	dp.resize(n, 1);
	for (int i = 0; i < n; i++) {
		for (int j = i - 1; j >= 0; j--) {
			if (arr[j].second.second <= arr[i].second.first)
				dp[i] = max(dp[i], dp[j] + 1);
		}
	}
	score = *max_element(dp.begin(), dp.end()) / 2;
	dp.clear();
	max_value = 0;
	brute();
	cout << '\n';
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}