#include <bits/stdc++.h>

// struct Cum {
//     int64_t l0;
//     int64_t l1, r1;
//     Cum() : l0(0), l1(0), r1(0) {
//         ;
//     }
//     Cum(int l, int r) : l0(0), l1(l), r1(r) {
//         ;
//     }
// };
//
// Cum merge(const Cum& a, const Cum& b) {
//     Cum c;
//     c.l0 = a.l0 + b.l0;
// }

using dp_t = std::array<int64_t, 2>;

dp_t add_to(dp_t a, const dp_t& b) {
    a[1] += b[0];
    a[0] += std::max(b[0], b[1]);
    return a;
}

dp_t r_add_to(dp_t a, const dp_t& b) {
    a[1] -= b[0];
    a[0] -= std::max(b[0], b[1]);
    return a;
}

void solve() {
    int n, q;
    int x, y, m;
    std::cin >> n >> q;
    std::cin >> x >> y >> m;

    auto cert = [&](int i, int val) -> int {
        int res = (x * int64_t(i + 1) + y * (int64_t(val) * val % m)) % m;
        return res;
    };

    std::vector<std::vector<int>> gr(n);
    std::vector<std::pair<int, int>> cntr(n);
    std::vector<int64_t> quer(q);

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        std::cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    for (auto& [l, r] : cntr) {
        std::cin >> l >> r;
    }
    for (auto& i : quer) {
        std::cin >> i;
    }

    std::vector<int> a(n);
    std::vector<int> ord;
    std::vector<int> crt_l(n), crt_r(n);

    auto dfs0 = [&](auto dfs0, int v, int f) -> void {
        crt_l[v] = cert(v, cntr[v].first);
        crt_r[v] = cert(v, cntr[v].second);

        auto it = std::find(gr[v].begin(), gr[v].end(), f);
        if (it != gr[v].end()) {
            gr[v].erase(it);
        }
        for (int t : gr[v]) {
            dfs0(dfs0, t, v);
            crt_l[v] ^= crt_l[t];
            crt_r[v] ^= crt_r[t];
        }
        ord.push_back(v);
    };
    dfs0(dfs0, 0, -1);

    std::vector<dp_t> dp(n);
    std::vector<dp_t> dp_min(n);
    std::vector<dp_t> dp_max(n);

    auto count_cum = [&](const std::vector<int>& a) {
        for (int v : ord) {
            dp[v].fill(0);
            dp[v][1] = a[v];

            for (int t : gr[v]) {
                dp[v] = add_to(dp[v], dp[t]);
            }
        }
        int64_t res = std::max(dp[0][1], dp[0][0]);
        return res;
    };

    for (int i = 0; i < n; i++) {
        a[i] = cntr[i].second;
    }
    int64_t max_ans = count_cum(a);
    dp_max = dp;

    for (int i = 0; i < n; i++) {
        a[i] = cntr[i].first;
    }
    int64_t min_ans = count_cum(a);
    dp_min = dp;

    std::map<int64_t, int> map;
    for (int i = 0; i < q; i++) {
        if (quer[i] < min_ans || quer[i] > max_ans) {
            continue;
        }
        map[quer[i]] = i;
    }

    std::vector<std::pair<int, std::vector<int>>> ans(q);
    for (int i = 0; i < q; i++) {
        ans[i].first = -1;
    }

    std::vector<int> spec(q, -1);
    std::vector<int> crap;

    auto dfs = [&](auto dfs, int v, int crt, dp_t ar_f) -> void {
        crap.push_back(v);
        int m = gr[v].size();

        dp_t ar = {0, cntr[v].first};
        ar = add_to(ar, ar_f);

        for (int e = 0; e < m; e++) {
            int t = gr[v][e];
            ar = add_to(ar, dp_min[t]);
            crt ^= crt_l[t];
        }

        // ar[1] += cntr[v].first;

        if (ar[0] > ar[1]) {
            auto it = map.find(ar[0]);
            if (it != map.end()) {
                ans[it->second].first = crt ^ cert(v, cntr[v].first);
                spec[it->second] = v;
                map.erase(it);
            }
        }
        int64_t min = std::max(ar[0], ar[1]);
        int64_t max = ar[1] + (cntr[v].second - cntr[v].first);

        if (min <= max) {
            auto it = map.lower_bound(min);
            while (it != map.end() && it->first <= max) {
                ans[it->second].first = crt ^ cert(v, cntr[v].first + (it->first - ar[1]));
                it = std::next(it);
                map.erase(std::prev(it));
            }
        }

        ar[1] += (cntr[v].second - cntr[v].first);
        crt ^= cert(v, cntr[v].second);

        for (int e = 0; e < m; e++) {
            int t = gr[v][e];

            ar = r_add_to(ar, dp_min[t]);
            crt ^= crt_l[t];

            if (e > 0) {
                crt ^= crt_r[gr[v][e - 1]];
                ar = add_to(ar, dp_max[gr[v][e - 1]]);
            }

            dfs(dfs, t, crt, ar);
        }
    };
    dfs(dfs, 0, 0, {0, 0});

    std::vector<int> r_crap(n);
    for (int i = 0; i < n; i++) {
        r_crap[crap[i]] = i;
    }

    std::vector<int64_t> var(n);
    for (int i = 0; i < n; i++) {
        var[i] = cntr[crap[i]].second - cntr[crap[i]].first;
    }
    std::vector<int64_t> prf(n + 1);
    std::partial_sum(var.begin(), var.end(), prf.begin() + 1);
    std::vector<int> vec(n);

    auto cum = [&](int64_t dest) {
        assert(min_ans <= dest && dest <= max_ans);

        int64_t beg = -1, end = prf.back();
        auto shit = [&](int64_t p) -> int64_t {
            int it = std::upper_bound(prf.begin(), prf.end(), p) - prf.begin();
            it--;
            for (int i = 0; i < it; i++) {
                vec[r_crap[i]] = cntr[r_crap[i]].second;
            }
            if (it != n)
                vec[r_crap[it]] = cntr[r_crap[it]].first + (p - prf[it]);
            for (int i = it + 1; i < n; i++) {
                vec[r_crap[i]] = cntr[r_crap[i]].first;
            }
            int64_t res = count_cum(vec);
            return res;
        };
        while (beg + 1 < end) {
            int64_t mid = (beg + end) / 2;
            if (shit(mid) < dest) {
                beg = mid;
            } else {
                end = mid;
            }
        }
        if (shit(end) == dest) {
            return vec;
        }
        return std::vector<int>{};
    };

    // for (auto& [vl, id] : map) {
    //     auto vc = cum(vl);
    //     if (vc.size() != 0) {
    //         int crt = 0;
    //         for (int i = 0; i < n; i++) {
    //             crt ^= cert(i, vc[i]);
    //         }
    //         ans[id] = {crt, vc};
    //     }
    // }

    for (int i = 0; i < q; i++) {
        std::cout << ans[i].first << " \n"[i == q - 1];
    }
    std::cout << std::endl;

    int id;
    while (true) {
        std::cin >> id;
        if (id == 0) {
            break;
        }
        id--;
        if (ans[id].first == -1) {
            std::cout << "-1\n";
            std::cout.flush();
        } else {
            auto a = ans[id].second;

            if (spec[id] == -1) {
                a = cum(quer[id]);
            } else {
                a.resize(n);
                int crt = 0;
                bool sh = false;

                for (int v : crap) {
                    if (!sh) {
                        a[v] = cntr[v].second;
                        crt ^= cert(v, cntr[v].second);
                    } else {
                        a[v] = cntr[v].first;
                        crt ^= cert(v, cntr[v].first);
                    }
                    if (v == spec[id]) {
                        sh = true;
                    }
                }
            }
            int crt = 0;
            for (int i = 0; i < n; i++) {
                crt ^= cert(i, a[i]);
            }
            assert(crt == ans[id].first);
            assert(count_cum(a) == quer[id]);

            for (int i = 0; i < n; i++) {
                std::cout << a[i] << " \n"[i == n - 1];
            }
            std::cout.flush();
        }
    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
