#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <bitset>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>
#include <iomanip>
#include <string>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

struct nseg {
	struct node {
		ll l, r;
		pll val;

		node(pll val) : val(val) {
			l = r = -1;
		}
	};

	v<node> tree;

	ll newNode(pll val) {
		tree.push_back(node(val));
		return tree.size() - 1;
	}

	ll root;

	nseg(ll n) {
		root = newNode({ 0, 0 });
	}

	pll get(ll l_find, ll r_find, ll l, ll r, ll i) {
		if (l >= r_find || r <= l_find) return { Max, Max };
		if (l >= l_find && r <= r_find) return tree[i].val;
		ll mid = l + (r - l) / 2;
		if (tree[i].l == -1) {
			tree[i].l = newNode({ 0, l });
		}
		if (tree[i].r == -1) {
			tree[i].r = newNode({ 0, mid });
		}
		return std::min(get(l_find, r_find, l, mid, tree[i].l), get(l_find, r_find, mid, r, tree[i].r));
	}

	void set(ll pos, ll l, ll r, ll i) {
		if (l > pos || r <= pos) return;
		if (r - l == 1) {
			tree[i].val = { 1, pos };
			return;
		}
		ll mid = l + (r - l) / 2;
		if (tree[i].l == -1) {
			tree[i].l = newNode({ 0, l });
		}
		if (tree[i].r == -1) {
			tree[i].r = newNode({ 0, mid });
		}
		set(pos, l, mid, tree[i].l);
		set(pos, mid, r, tree[i].r);
		tree[i].val = std::min(tree[tree[i].l].val, tree[tree[i].r].val);
	}
};

void solve() {
	ll a, m;
	std::cin >> a >> m;
	if (a == 1) {
		for (int t = 0; t < m; ++t) {
			ll n, k;
			std::cin >> n >> k;
			v<ll> list(k);
			nseg tree(n);
			for (int i = 0; i < k; ++i) {
				ll cnt;
				std::cin >> cnt;
				--cnt;
				list[i] = cnt;
				tree.set(cnt, 1, n, tree.root);
			}
			ll first = 0;
			for (int i = k - 1; i >= 0; --i) {
				if ((list[i] + 1) % n != (list[(i + 1) % k])) {
					first = i;
					break;
				}
			}
			v<ll> ans;
			for (int i = first; i >= 0; --i) {
				pll now = tree.get(list[i] + 1, n, 0, n, tree.root);
				if (now.first != 0) {
					now = tree.get(0, n, 0, n, tree.root);
				}
				ans.push_back(now.second);
				tree.set(now.second, 0, n, tree.root);
			}
			for (int i = k - 1; i > first; --i) {
				pll now = tree.get(list[i] + 1, n, 0, n, tree.root);
				if (now.first != 0) {
					now = tree.get(0, n, 0, n, tree.root);
				}
				ans.push_back(now.second);
				tree.set(now.second, 0, n, tree.root);
			}
			std::sort(all(ans));
			for (auto i : ans) {
				std::cout << i + 1 << ' ';
			}
			std::cout << '\n';
		}
	}
	else if (a == 2) {
		for (int t = 0; t < m; ++t) {
			ll n, k;
			std::cin >> n >> k;
			v<ll> list(k);
			nseg tree(n);
			for (int i = 0; i < k; ++i) {
				ll cnt;
				std::cin >> cnt;
				--cnt;
				list[i] = n - cnt - 1;
				tree.set(n - cnt - 1, 1, n, tree.root);
			}
			std::sort(all(list));
			ll first = 0;
			for (int i = k - 1; i >= 0; --i) {
				if ((list[i] + 1) % n != (list[(i + 1) % k])) {
					first = i;
					break;
				}
			}
			v<ll> ans;
			for (int i = first; i >= 0; --i) {
				pll now = tree.get(list[i] + 1, n, 0, n, tree.root);
				if (now.first != 0) {
					now = tree.get(0, n, 0, n, tree.root);
				}
				ans.push_back(n - now.second - 1);
				tree.set(now.second, 0, n, tree.root);
			}
			for (int i = k - 1; i > first; --i) {
				pll now = tree.get(list[i] + 1, n, 0, n, tree.root);
				if (now.first != 0) {
					now = tree.get(0, n, 0, n, tree.root);
				}
				ans.push_back(n - now.second - 1);
				tree.set(now.second, 0, n, tree.root);
			}
			std::sort(all(ans));
			for (auto i : ans) {
				std::cout << i + 1 << ' ';
			}
			std::cout << '\n';
		}
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}