#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#include <iomanip>
#include <random>
#include <chrono>
#include <queue>
#include <deque>
#include <utility>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

v<ll> dp;
v<ll> count;

void dfs(v<v<pll>>& gr, ll i, ll type, ll k) {
	if (gr[i].size() == 0 && count[i] <= k) {
		dp[i] = 1;
		return;
	}
	for (auto j : gr[i]) {
		count[j.first] = count[i];
		if (j.second != type && type != -1) {
			++count[j.first];
		}
		dfs(gr, j.first, j.second, k);
		dp[i] += dp[j.first];
	}
}

void solve() {
	ll n, k, q;
	std::cin >> n >> k >> q;
	v<v<pll>> gr(n);
	for (int i = 0; i < n; ++i) {
		ll t;
		std::cin >> t;
		if (t == 0) {
			continue;
		}
		ll l, r;
		std::cin >> l >> r;
		--l, --r;
		gr[i].push_back({ l, 0 });
		gr[i].push_back({ r, 1 });
	}
	dp.resize(n, 0);
	count.resize(n, 0);
	dfs(gr, 0, -1, k);
	for (int i = 0; i < q; ++i) {
		ll a;
		std::cin >> a;
		--a;
		std::cout << dp[a] << '\n';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}