#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ui unsigned int
#define mp make_pair
#define ff first
#define ss second
#define pii pair<int, int>
#define pil pair<int, long long>
#define pli pair<long long, int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define uset unordered_set
#define umap unordered_map

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,bmi,bmi2")

struct DSU {
    map<int, int> p, r;
    map<int, int> mx, mn;
    int n;

    DSU() {
        if (!p.empty()) {
            p.clear();
            r.clear();
            mn.clear();
            mx.clear();
        }
    }

    void init(int _n) {
        n = _n;
        if (!p.empty()) {
            p.clear();
            r.clear();
            mn.clear();
            mx.clear();
        }
    }

    int get(int a) {
        if (p.find(a) == p.end()) {
            p[a] = a;
            mx[a] = mn[a] = a;
            r[a] = 1;
            return a;
        }
        return p[a] = (p[a] == a ? a : get(p[a]));
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b)
            return false;
        if (r[a] < r[b])
            swap(a, b);
        r[a] += r[b];
        p[b] = a;
        mn[a] = min(mn[a], mn[b]);
        mx[a] = max(mx[a], mx[b]);
        return true;
    }

    void add(int i) {
        i = get(i);
        int nx = i + 1;
        if (nx == n)
            return;
        if (p.find(nx) == p.end())
            return;
        unite(i, nx);
        int pr = i - 1;
        if (pr == -1)
            return;
        if (p.find(pr) == p.end())
            return;
        unite(i, pr);
    }

    int nxt(int a) {
        while (p.find(a) != p.end()) {
            a = get(a);
            int nx = mx[a] + 1;
            if (nx == n)
                nx = 0;
            if (p.find(nx) != p.end() && nx > a)
                unite(nx, a);
            a = nx;
        }
        return a;
    }

    int prv(int a) {
        while (p.find(a) != p.end()) {
            a = get(a);
            int pr = mn[a] - 1;
            if (pr == -1)
                pr = n - 1;
            if (p.find(pr) != p.end() && pr < a)
                unite(pr, a);
            a = pr;
        }
        return a;
    }
};

DSU dsu;

void add(int i) {
    dsu.add(i);
}

void init(int n) {
    dsu.init(n);
}

int nxt(int i) {
    return dsu.nxt(i);
}

int prv(int i) {
    return dsu.prv(i);
}

inline void solve1() {
    int n, k;
    cin >> n >> k;
    init(n);
    vector<int> a(k);
    vector<int> b(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i : a)
        add(i);
    for (int i = 0; i < k; i++) {
        int j = nxt(a[i]);
        add(j);
        b[i] = j;
    }
    sort(all(b));
    for (int i : b)
        cout << i + 1 << ' ';
    cout << '\n';
}

inline void solve2() {
    int n, k;
    cin >> n >> k;
    init(n);
    vector<int> a(k);
    vector<int> b(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i : a)
        add(i);
    for (int i = 0; i < k; i++) {
        int j = prv(a[i]);
        add(j);
        b[i] = j;
    }
    sort(all(b));
    for (int i : b)
        cout << i + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int run;
    cin >> run;
    int tt = 1;
    cin >> tt;
    while (tt--) {
#ifdef DEBUG
        cout << "Test Case#\n";
#endif
        if (run == 1)
            solve1();
        else
            solve2();
    }
    return 0;
}