#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include "random"

using namespace std;
typedef long long ll;

#define all(a) a.begin(), a.end()

void solve();

bool pop = 0;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        if (pop)
            return 1;
    }

}

struct node {
    int l = 0, r = 2e9;
    int mx = 0, ndx = -1;
    node *l_c = nullptr, *r_c = nullptr;

    node() = default;

    node(int l, int r) : l(l), r(r) {}

    void upd() {
        if (r_c == nullptr)
            r_c = new node(l, (r + l) / 2);
        if (l_c == nullptr)
            l_c = new node((r + l) / 2, r);
    }

    void set(int x, int val) {
        if (x < l || x >= r)
            return;
        if (x == l && l + 1 == r) {
            mx = val;
            ndx = l;
            return;
        }
        upd();
        r_c->set(x, val);
        l_c->set(x, val);
        if (l_c->mx > r_c->mx) {
            mx = l_c->mx;
            ndx = l_c->ndx;
        } else {
            mx = r_c->mx;
            ndx = r_c->ndx;
        }
    }

    pair<int, int> get(int L, int R) {
        if (l >= R || L >= r)
            return {0, -1};
        if (L <= l && r <= R)
            return {mx, ndx};
        upd();
        auto a = r_c->get(L, R);
        auto b = l_c->get(L, R);
        if (a.first != b.first)
            return max(a, b);
        return min(a, b);
    }

};

int find(int n, vector<pair<int, int>> &v) {
    node *t = new node(0, 2e9);
    sort(all(v));
    int i = 0;
    int m = 0;
    for (auto [l, r]: v) {
        auto p = t->get(0, l + 1);
        if (p.first + 1 > m) {
            m = p.first + 1;
        }
        t->set(r + 1, p.first + 1);
    }
    delete t;
    return m;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    map<pair<int, int>, vector<int>> c;
    for (auto &[a, b]: v)
        cin >> a >> b;
    for (int i = 0; i < n; i++)
        c[v[i]].push_back(i + 1);
    node *t = new node(0, 2e9);
    sort(all(v));
    vector<int> dp(n, 0);
    int q = 0;
    int m = 0, ndx = 0;
    map<int, int> val, j;
    for (auto [l, r]: v) {
        auto p = t->get(0, l + 1);
        if (p.first + 1 >= m) {
            m = p.first + 1;
            ndx = q;
        }
        if (val[r + 1] <= p.first + 1) {
            val[r + 1] = p.first + 1;
            j[r + 1] = q;
        }
        dp[q++] = p.second;
        t->set(r + 1, p.first + 1);
    }
    vector<pair<int, int>> v1{v[ndx]};
    set<pair<int, int>> s{v[ndx]};
    while (dp[ndx] != -1) {
        v1.push_back(v[j[dp[ndx]]]);
        s.insert(v[j[dp[ndx]]]);
        ndx = j[dp[ndx]];
    }
    sort(all(v1));
    vector<pair<int, int>> v2, v3;
    for (int i = 0; i < v1.size() / 2; i++) {
        v2.push_back(v1[i]);
    }
    for (int i = v1.size() / 2; i < v1.size(); i++) {
        v3.push_back(v1[i]);
    }
    for (auto [l, r]: v) {
        if (s.find({l, r}) != s.end())
            continue;
        if (l <= v2.back().second)
            v2.push_back({l, r});
        if (r >= v3[0].first)
            v3.push_back({l, r});
    }
    if (v2.size() >= n / 2) {
        while (v2.size() > n / 2)
            v2.pop_back();
        if (find(n / 2, v2) == m / 2) {
            for (auto [l, r]: v2) {
                cout << c[{l, r}].back() << ' ';
                c[{l, r}].pop_back();
            }
            cout << '\n';
            return;
        }
    }
    if (v3.size() >= n / 2) {
        while (v3.size() > n / 2)
            v3.pop_back();
        if (find(n / 2, v3) == m / 2) {
            for (auto [l, r]: v3) {
                cout << c[{l, r}].back() << ' ';
                c[{l, r}].pop_back();
            }
            cout << '\n';
            return;
        }
    }
    pop = 1;
}