#include <bits/stdc++.h>
using namespace std;

struct fenwick {
    int n;
    vector<int> f;

    fenwick(int n) : n(n), f(n + 1) {}

    void update(int i, int v) {
        for (i++; i <= n; i += i & -i) {
            f[i] = max(f[i], v);
        }
    }

    int query(int r) {
        int ans = 0;
        for (; r > 0; r -= r & -r) {
            ans = max(ans, f[r]);
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &v : a) {
        cin >> v;
        v--;
    }
    fenwick tree(n);
    int LIS = 0;
    for (int v : a) {
        int cur = tree.query(v) + 1;
        LIS = max(LIS, cur);
        tree.update(v, cur);
    }
    cout << min(LIS + 2, n) << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}