#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())

void solve() {
    ll n;
    cin >> n;
    vector<tuple<ll, ll, ll>> a;
    vector<pair<ll, ll>> b;
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        b.push_back({l, r});
        a.push_back({r, l, i});
    }
    sort(a.begin(), a.end());
    ll cnt = 0;
    ll last_r = 0;
    vector<bool> used(n);
    vector<ll> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        l[i] = get<1>(a[i]);
        r[i] = get<0>(a[i]);
        if (l[i] > last_r) {
            ++cnt;
            used[i] = true;
            last_r = r[i];
        }
        l[i] = b[i].first;
        r[i] = b[i].second;
    }
    vector<set<ll>> down(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                if (l[j] <= l[i] && r[i] <= r[j]) {
                    down[j].insert(i);
                }
            }
        }
    }
    vector<ll> ccnt(n);
    for (int j = 0; j < n; ++j) {
        for (auto i : down[j]) {
            ccnt[i]++;
        }
    }
    vector<pair<ll, ll>> c;
    for (int i = 0; i < n; ++i) {
        c.emplace_back(ccnt[i], i);
    }
    sort(c.rbegin(), c.rend());
    vector<ll> ans;
    for (int i = 0; i < cnt / 2; ++i) {
        ans.push_back(c[i].second);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < cnt / 2 && sz(ans) < n / 2; ++j) {
            if (down[i].count(ans[j])) {
                ans.push_back(i);
                break;
            }
        }
    }
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
}

vector<ll> solve(ll n, vector<pair<ll, ll>> b) {
    vector<tuple<ll, ll, ll>> a;
    for (int i = 0; i < n; ++i) {
        auto [l, r] = b[i];
        b.push_back({l, r});
        a.push_back({r, l, i});
    }
    sort(a.begin(), a.end());
    ll cnt = 0;
    ll last_r = 0;
    vector<bool> used(n);
    vector<ll> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        l[i] = get<1>(a[i]);
        r[i] = get<0>(a[i]);
        if (l[i] > last_r) {
            ++cnt;
            used[i] = true;
            last_r = r[i];
        }
        l[i] = b[i].first;
        r[i] = b[i].second;
    }
    vector<set<ll>> down(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                if (l[j] <= l[i] && r[i] <= r[j]) {
                    down[j].insert(i);
                }
            }
        }
    }
    vector<ll> ccnt(n);
    for (int j = 0; j < n; ++j) {
        for (auto i : down[j]) {
            ccnt[i]++;
        }
    }
    vector<pair<ll, ll>> c;
    for (int i = 0; i < n; ++i) {
        c.emplace_back(ccnt[i], i);
    }
    sort(c.rbegin(), c.rend());
    vector<ll> ans;
    for (int i = 0; i < cnt / 2; ++i) {
        ans.push_back(c[i].second);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < cnt / 2 && sz(ans) < n / 2; ++j) {
            if (down[i].count(ans[j])) {
                ans.push_back(i);
                break;
            }
        }
    }
    for (int i = 0; i < n / 2; ++i) {
        ++ans[i];
    }
    return ans;
}

void stress() {
    mt19937 rnd(1234);
    while (true) {
        ll n = rnd() % 10 + 1;
        if (n & 1) {
            ++n;
        }
        vector<pair<ll, ll>> a, h;
//        for (int i = 0; i < n; ++i) {
//            ll l = rnd() % 10 + 1, r = l + rnd() % 1000 + 1;
//
//            a[i] = {l, r};
//            h[i] = {r, l};
//        }
        while (sz(a) < n) {
            ll l = rnd() % 10 + 1, r = l + rnd() % 1000 + 1;
            bool flag = false;
            for (int i = 0; i < sz(a); ++i) {
                auto [l1, r1] = a[i];
                if (l > r1 || l1 > r) {
                    continue;
                }
                if ((l1 <= l && r <= r1) || (l <= l1 && r1 <= r)) {
                    continue;
                }
                flag = true;
                break;
            }
            if (!flag) {
                a.push_back({l, r});
                h.push_back({r, l});
            }
        }
        sort(h.begin(), h.end());
        ll cnt_fst = 0;
        ll last_r = 0;
        for (int i = 0; i < n; ++i) {
            if (h[i].second > last_r) {
                ++cnt_fst;
                last_r = h[i].first;
            }
        }
        if (cnt_fst & 1) {
            continue;
        }
        auto x = solve(n, a);
        vector<pair<ll, ll>> b;
        for (int i : x) {
            b.push_back({a[i - 1].second, a[i - 1].first});
        }
        sort(b.begin(), b.end());
        ll cnt = 0;
        last_r = 0;
        for (int i = 0; i < sz(b); ++i) {
            if (b[i].second > last_r) {
                ++cnt;
                last_r = b[i].first;
            }
        }
        if (sz(x) != n / 2 || cnt != cnt_fst / 2) {
            cout << n << '\n';
            for (int i = 0; i < n; ++i) {
                cout << a[i].first << ' ' << a[i].second << '\n';
            }
            break;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int times = 1;
    cin >> times;
    while (times--) {
        solve(), cout << '\n';
#ifdef LOCAL
        cout << "-------\n";
        stress();
#endif
    }
    return 0;
}
