#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a));
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename T>
void chmin(T& a, const T& b) {
  if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

vector<i32> transform(i32 n, const vector<i32>& a) {
  i32 k = ssize(a);
  set<i32> next_range_start;
  next_range_start.insert(1);
  for (int i = 0; i < k; ++i) {
    if (next_range_start.count(a[i]))
      next_range_start.erase(a[i]);
    next_range_start.insert(a[i] + 1);
  }
  if (next_range_start.count(n + 1))
    next_range_start.erase(n + 1);
  vector<i32> res;
  for (int i = 0; i < k; ++i) {
    auto it = next_range_start.upper_bound(a[i]);
    if (it == next_range_start.end())
      it = next_range_start.begin();
    res.push_back(*it);
    if (*it + 1 <= n && !binary_search(ALL(a), *it + 1))
      next_range_start.insert(*it + 1);
    next_range_start.erase(it);
  }
  sort(ALL(res));
  return res;
}

vector<i32> reverse_transform(i32 n, const vector<i32>& a) {
  i32 k = ssize(a);
  set<i32> next_range_start;
  next_range_start.insert(-n);
  for (int i = 0; i < k; ++i) {
    if (next_range_start.count(-a[i]))
      next_range_start.erase(-a[i]);
    next_range_start.insert(-a[i] + 1);
  }
  if (next_range_start.count(0))
    next_range_start.erase(0);
  vector<i32> res;
  for (int i = 0; i < k; ++i) {
    auto it = next_range_start.upper_bound(-a[i]);
    if (it == next_range_start.end())
      it = next_range_start.begin();
    res.push_back(*it);
    if (*it + 1 != 0 && !binary_search(RALL(a), *it + 1))
      next_range_start.insert(*it + 1);
    next_range_start.erase(it);
  }
  for (auto& e : res) e = -e;
  sort(ALL(res));
  return res;
}

void run1() {
  i32 n, k;
  cin >> n >> k;
  vector<i32> a(k);
  for (auto& e : a) cin >> e;
  sort(ALL(a));
  auto res = transform(n, a);
  for (auto& e : res) cout << e << " ";
  cout << "\n";
}

void run2() {
  i32 n, k;
  cin >> n >> k;
  vector<i32> a(k);
  for (auto& e : a) cin >> e;
  sort(RALL(a));
  auto res = reverse_transform(n, a);
  for (auto& e : res) cout << e << " ";
  cout << "\n";
}

void solve() {
  i32 op, t;
  cin >> op >> t;
  while (t--)
    if (op == 1)
      run1();
    else
      run2();
}
