#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a))
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  i32 t;
  cin >> t;
  while (t--) solve();
  return 0;
}

void solve() {
  i32 n;
  cin >> n;
  vector<pair<i32, i32>> a(n);
  for (auto& e : a) {
    cin >> e.first >> e.second;
  }
  vector<pair<i32, bool>> points(n * 2);
  for (int i = 0; i < n; ++i) {
    points.emplace_back(i, true);
    points.emplace_back(i, false);
  }
  sort(ALL(points), [&](auto x1, auto x2) {
    return make_pair(x1.second ? a[x1.first].first : a[x1.first].second + 1,
                     x1.second) <
           make_pair(x2.second ? a[x2.first].first : a[x2.first].second + 1,
                     x2.second);
  });
  vector<pair<i32, vector<i32>>> intersects;
  stack<i32> cur_open;
  bool is_open = false;
  for (auto e : points) {
    if (!e.second && is_open) {
      intersects.push_back({e.first, {}});
      while (!cur_open.empty()) {
        if (cur_open.top() != e.first)
          intersects.back().second.push_back(cur_open.top());
        cur_open.pop();
      }
    }
    is_open = e.second;
    if (is_open) {
      cur_open.push(e.first);
    }
  }
  sort(ALL(intersects), [](const auto& x1, const auto& x2) {
    return ssize(x1.second) > ssize(x2.second);
  });
  vector<i32> free_add_pool;
  vector<i32> ans;
  for (int i = 0; i < ssize(intersects) / 2; ++i) {
    ans.push_back(intersects[i].first);
    free_add_pool.insert(free_add_pool.end(), ALL(intersects[i].second));
  }
  for (int i = 0; i < ssize(free_add_pool) && ssize(ans) < n / 2; ++i) {
    ans.push_back(free_add_pool[i]);
  }
  assert(ssize(ans) == n / 2);
  for (i32 x : ans) cout << x + 1 << " ";
  cout << "\n";
}
