#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,tune=native")

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<int>> graph;
vector<pair<int, int>> limits;
vector<vector<int>> dp;
vector<int> in_now;
vector<vector<int>> answer;

void dfs(int v=1, int p=-1) {
    for (auto x : graph[v]) {
        if (x != p) {
            dfs(x, v);
        }
    }

    // 1 - берем v
    dp[v][1] = in_now[v];
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][1] += dp[x][0];
        }
    }

    // 2 - не берем v
    dp[v][0] = 0;
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][0] += max(dp[x][0], dp[x][1]);
        }
    }
}

int x, y, m;
int gen_cert(vector<int>& ans) {
    int cert = 0;
    for (int i = 1; i < ans.size(); ++i) {
        int cert_now = (x * i + y * ans[i] * ans[i]) % m;
        cert ^= cert_now;
    }

    return cert;
}

int find_now = 0;
int n, q;
bool rt = false;

void brute(int i=1) {
    if (i == n + 1) {
        dp.assign(n + 1, vector<int>(2, 0));
        dfs();
        int res = max(dp[1][0], dp[1][1]);
        if (res == find_now) {
            answer[find_now] = in_now;
            rt = true;
        }

        return;
    }

    for (int j = limits[i].first; j <= limits[i].second; ++j) {
        in_now[i] = j;
        brute(i + 1);
        if (rt) {
            return;
        }
    }
}

void solve() {
    cin >> n >> q;
    cin >> x >> y >> m;

    graph.assign(n + 1, vector<int>());
    limits.assign(n + 1, {0, 0});
    in_now.assign(n + 1, 0);
    answer.assign(101, vector<int>());

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    for (int i = 1; i <= n; ++i) {
        cin >> limits[i].first >> limits[i].second;
    }

    vector<int> need(q + 1);
    for (int i = 1; i <= q; ++i) {
        cin >> need[i];
        if (need[i] > 100) {
            cout << -1 << " ";
            continue;
        }
        find_now = need[i];
        rt = false;
        brute();
        if (answer[need[i]].empty()) {
            cout << -1 << " ";
        } else {
            cout << gen_cert(answer[need[i]]) << " ";
        }
    }
    cout << endl;

    int i;
    cin >> i;
    while (i != 0) {
        if (need[i] > 100) {
            cout << -1 << " ";
            continue;
        }

        if (answer[need[i]].empty()) {
            cout << -1 << " ";
        } else {
            vector<int> out(n + 1);
            for (int j = 1; j <= n; ++j) {
                cout << answer[need[i]][j] << " ";
            }
        }
        cout << endl;
        cin >> i;
    }
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
