#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> dp;
vector<vector<ll>> graph;
vector<pair<ll, ll>> limits;

void dfs(ll v=1, ll p=-1) {
    for (auto x : graph[v]) {
        if (x != p) {
            dfs(x, v);
        }
    }

    // 1 - берем v
    dp[v][1] = limits[v].first;
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][1] += dp[x][0];
        }
    }

    // 2 - не берем v
    dp[v][0] = 0;
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][0] += max(dp[x][0], dp[x][1]);
        }
    }
}

ll x, y, m;
ll gen_cert(vector<ll>& ans) {
    ll cert = 0;
    for (ll i = 1; i < ans.size(); ++i) {
        ll cert_now = (((x * i) % m) + (y * ((ans[i] * ans[i]) % m) % m)) % m;
        cert ^= cert_now;
    }

    return cert;
}

void solve() {
    ll n, q;
    cin >> n >> q;
    cin >> x >> y >> m;

    graph.assign(n + 1, vector<ll>());
    limits.assign(n + 1, {0, 0});
    dp.assign(n + 1, vector<ll>(2, 0));

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    for (ll i = 1; i <= n; ++i) {
        cin >> limits[i].first >> limits[i].second;
    }

    dfs();
    vector<ll> corr(n + 1);
    for (ll i = 1; i <= n; ++i) {
        corr[i] = limits[i].first;
    }

    ll cor_cert = gen_cert(corr);
    ll best = max(dp[1][0], dp[1][1]);

    vector<ll> need(q + 1);
    for (ll i = 1; i <= q; ++i) {
        cin >> need[i];

        if (need[i] == best) {
            cout << cor_cert << " ";
        } else {
            cout << -1 << " ";
        }
    }
    cout << endl;

    ll i;
    cin >> i;
    while (i != 0) {
        if (need[i] != best) {
            cout << -1 << " ";
        } else {
            for (ll j = 1; j <= n; ++j) {
                cout << corr[j] << " ";
            }
        }
        cout << endl;
        cin >> i;
    }

}

int main() {
    ll t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}