#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> graph;
vector<pair<ll, ll>> limits;
vector<vector<ll>> dp;
vector<ll> ans;
vector<ll> in_now;
map<ll, vector<ll>> answer;

void dfs(ll v=1, ll p=-1) {
    for (auto x : graph[v]) {
        if (x != p) {
            dfs(x, v);
        }
    }

    // 1 - берем v
    dp[v][1] = in_now[v];
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][1] += dp[x][0];
        }
    }

    // 2 - не берем v
    dp[v][0] = 0;
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][0] += max(dp[x][0], dp[x][1]);
        }
    }
}

ll x, y, m;
ll gen_cert(vector<ll>& ans) {
    ll cert = 0;
    for (ll i = 0; i < ans.size(); ++i) {
        ll cert_now = (x * ans[i] + y * 1 * 1) % m;
        cert += cert_now;
    }

    return cert;
}

ll find_now = 0;
ll n, q;

void brute(ll i=1) {
    if (i == n + 1) {
        dp.assign(n + 1, vector<ll>(2, 0));
        dfs();
        ll res = max(dp[1][0], dp[1][1]);
        if (res == find_now) {
            answer[find_now] = in_now;
        }

        return;
    }

    for (ll j = limits[i].first; j <= limits[i].second; ++j) {
        in_now[i] = j;
        brute(i + 1);
    }
}

void solve() {
    cin >> n >> q;
    cin >> x >> y >> m;

    graph.assign(n + 1, vector<ll>());
    limits.assign(n + 1, {0, 0});
    in_now.assign(n + 1, 0);

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    for (ll i = 1; i <= n; ++i) {
        cin >> limits[i].first >> limits[i].second;
    }

    vector<ll> need(q + 1);
    for (ll i = 1; i <= q; ++i) {
        cin >> need[i];
        find_now = need[i];
        brute();
        if (answer[need[i]].empty()) {
            cout << -1 << " ";
        } else {
            cout << gen_cert(answer[need[i]]) << " ";
        }
    }
    cout << endl;

    ll i;
    cin >> i;
    while (i != 0) {
        if (answer[need[i]].empty()) {
            cout << -1 << " ";
        } else {
            vector<ll> out(n + 1);
            for (ll j = 1; j <= n; ++j) {
                cout << answer[need[i]][j] << " ";
            }
        }
        cout << endl;
        cin >> i;
    }
}

int main() {
    ll t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
