#include<bits/stdc++.h>

#define girlfriend friend
#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
void inpud(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

using namespace std;
const int inf = 1e18, MAXN = 2e5;
vector<int> tree(4*MAXN), cnt;

void build(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v] = 0;
        return;
    }
    int tm = (tl+tr)/2;
    build(2*v, tl, tm);
    build(2*v+1, tm+1, tr);
    tree[v] = 0;
}

void upd(int v, int pos, int tl, int tr) {
    if (tl == tr) {
        tree[v]++;
        return;
    }
    int tm = (tl+tr)/2;
    if (pos <= tm) upd(2*v, pos, tl, tm);
    else upd(2*v+1, pos, tm+1, tr);
    tree[v] = tree[2*v]+tree[2*v+1];
}

int get_sum(int v, int l, int r, int tl, int tr) {
    if (l > tr || r < tl) return 0;
    if (l <= tl && tr <= r) return tree[v];
    int tm = (tl+tr)/2;
    return get_sum(2*v, l, r, tl, tm)+get_sum(2*v+1, l, r, tm+1, tr);
}

struct seg {
    int l, r, num;

    seg() = default;

    seg(int a, int b, int c) : l(a), r(b), num(c) {}
};

bool cmp(seg &a, seg &b) {
    return a.l < b.l;
}

bool cmp2(int a, int b) {
    return cnt[a] > cnt[b];
}

void solve() {
    int n; cin >> n;
    cnt.resize(n);
    for (int i = 0; i<n; ++i) cnt[i] = 0;
    int N = 2*n+1;
    build(1, 0, N);
    vector<seg> a(n);
    vector<int> srt;
    for (int i = 0; i<n; ++i) {
        cin >> a[i].l >> a[i].r; a[i].num = i;
        srt.emplace_back(a[i].l);
        srt.emplace_back(a[i].r);
    }
    sort(all(srt)); srt.erase(unique(all(srt)), srt.end());
    for (int i = 0; i<n; ++i) {
        a[i].l = lower_bound(all(srt), a[i].l)-srt.begin();
        a[i].r = lower_bound(all(srt), a[i].r)-srt.begin();
    }
    sort(all(a), cmp);
    vector<pair<int, int>> suf(n);
    suf[n-1] = {a[n-1].r, n-1};
    for (int i = n-2; i>=0; --i) {
        suf[i] = suf[i+1];
        if (a[i].r <= suf[i].first) suf[i] = {a[i].r, i};
    }
    int m = 0;
    int ind = suf[0].second;
    vector<int> segs;
    while (ind < n) {
        m++;
        segs.emplace_back(ind);
        int l = ind, r = n;
        while (l+1 < r) {
            int mid = (l+r)/2;
            if (a[mid].l > a[ind].r) r = mid;
            else l = mid;
        }
        if (r == n) break;
        ind = suf[r].second;
    }
    if (m&1) assert(0);
    vector<vector<int>> need(n);
    for (int i = 0; i<n; ++i) {
        int l = i, r = n;
        while (l+1 < r) {
            int mid = (l+r)/2;
            if (a[mid].l > a[i].r) r = mid;
            else l = mid;
        }
        int l2 = -1, r2 = i;
        while (l2+1 < r2) {
            int mid = (l2+r2)/2;
            if (a[mid].l < a[i].l) l2 = mid;
            else r2 = mid;
        }
        cnt[i] = r-l2-2;
        if (l2 != -1) {
            need[l2].emplace_back(i);
        }
    }
    for (int i = 0; i<n; ++i) {
        upd(1, a[i].r, 0, N);
        for (auto j : need[i]) {
            cnt[j] += get_sum(1, a[j].l, N, 0, N);
        }
    }
//    cout << endl;
//    for (int i = 0; i<n; ++i) {
//        cout << cnt[i] << " " << a[i].num << endl;
//    }
    sort(all(segs), cmp2);
    vector<int> usd(n);
    int res = 0;
    for (int i = 0; i<(m >> 1); ++i) {
        usd[a[segs[i]].num] = 2;
        res++;
    }
    for (int i = 0; i<n && res < n/2; ++i) {
        if (usd[a[i].num]) continue;
        bool fl = false;
        for (int j = 0; j<n; ++j) {
            if (usd[j] != 2) continue;
            if (a[j].r < a[i].l || a[j].l > a[i].r) continue;
            fl = true;
            break;
        }
        if (fl) {
            usd[a[i].num] = 1;
            res++;
        }
    }
    assert(res == n/2);
    for (int i = 0; i<n; ++i) {
        if (usd[i]) cout << i+1 << " ";
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
