#ifndef DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

template<class K, class V>
#if defined(DEBUG)
using umap = unordered_map<K, V>;
#else
using umap = __gnu_pbds::cc_hash_table<K, V>;
#endif

void solve();
bool bsolve();

ll mod;
vi fact;

ll modpow(ll base, ll exp) {
  ll ret = 1;
  while (exp) {
    if (exp & 1) {
      ret = ret * base % mod;
    }
    base = base * base % mod;
    exp >>= 1;
  }

  return ret;
}

ll inv(ll x) {
  return modpow(x, mod - 2);
}

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  cin >> mod;
  ll t;
  cin >> t;

  fact.resize(1000000);
  fact[0] = 1;
  for (int i = 1; i < fact.size(); ++i) {
    fact[i] = fact[i - 1] * i % mod;
  }

//  solve();
  while (bsolve());
}

#ifdef DEBUG
bool debug = true;
#else
bool debug = false;
#endif

vvi gensets(ll n, ll k, const vi& pre, ll exclude = -1) {
  if (n == pre.size()) return {pre};
  auto sets = gensets(n - 1, k, pre);
  vvi ret;
  for (auto set : sets) {
    for (ll i = set.back() + 1; i < (1ll << k); ++i) {
      if (i == exclude) continue;
      set.emplace_back(i);
      ret.emplace_back(set);
      set.pop_back();
    }
  }
  return ret;
}

ll mex(const vi& s) {
  for (ll i = 0; i < s.size(); ++i) {
    if (s[i] != i) return i;
  }
  return s.size();
}

ll k, n, p;

ll setsolve(vi s) {
  ll ans = 0;
  ll last_m = -1;
  while (true) {
    ll m = mex(s);
    if (m == last_m) {
      if (m == p) {
        ans += 1;
        ans %= mod;
      }
      break;
    }
    last_m = m;
    for (auto& e : s) {
      e ^= m - 1;
    }
    sort(s.begin(), s.end());
  }

  return ans;
}

ll comb(ll K, ll N) {
  return fact[N] * inv(fact[K]) % mod * inv(fact[N - K]) % mod;
}

bool bsolve() {
  if (!(cin >> k >> n >> p)) return false;

  ll ans = 0;
  if (p == 1) {
    if (n - 1 <= (1ll << k) - 2) {
      ans += comb(n - 1, (1ll << k) - 2);
      ans %= mod;
    }
  }
  if (p == 2) {
    if (n - 3 <= (1ll << k) - 4) {
      ans += comb(n - 3, (1ll << k) - 4);
      ans %= mod;
    }
  }

  if (n >= 3) {
    vvi sets = gensets(n, k, vi{0, 1, 3});

    for (const auto& s : sets) {
      ans += setsolve(s);
      ans %= mod;
    }

    sets = gensets(n, k, vi{0, 1, 2}, 3);

    for (const auto& s : sets) {
      ans += setsolve(s);
      ans %= mod;
    }
  }

  cout << ans << endl;

#ifdef DEBUG
  ll ans2 = 0;
  vvi sets = gensets(n, k, {0});

  for (auto s : sets) {
    ll last_m = -1;
    while (true) {
      ll m = mex(s);
      if (m == last_m) {
        if (m == p) {
          ans2 += 1;
          ans2 %= mod;
        }
        break;
      }
      last_m = m;
      for (auto& e : s) {
        e ^= m - 1;
      }
      sort(s.begin(), s.end());
    }
  }

  assert(ans2 == ans);
#endif

  return true;
}



//void solve() {}