#ifndef DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

template<class K, class V>
#if defined(DEBUG)
using umap = unordered_map<K, V>;
#else
using umap = __gnu_pbds::cc_hash_table<K, V>;
#endif

void solve();
bool bsolve();

ll mod;

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  cin >> mod;
  ll t;
  cin >> t;

//  solve();
  while (bsolve());
}

#ifdef DEBUG
bool debug = true;
#else
bool debug = false;
#endif

vvi gensets(ll n, ll k) {
  if (n == 0) return {};
  if (n == 1) return {{0}};
  auto sets = gensets(n - 1, k);
  vvi ret;
  for (auto set : sets) {
    for (ll i = 0; i < (1ll << k); ++i) {
      set.emplace_back(i);
      ret.emplace_back(set);
      set.pop_back();
    }
  }
  return ret;
}

ll mex(const vi& s) {
  for (ll i = 0; i < s.size(); ++i) {
    if (s[i] != i) return i;
  }
  abort();
}

bool bsolve() {
  ll k, n, p;
  if (!(cin >> k >> n >> p)) return false;

  vvi sets = gensets(n, k);

  ll last_m = -1;
  ll ans = 0;
  for (auto s : sets) {
    while (true) {
      ll m = mex(s);
      if (m == last_m) {
        if (m == p) {
          ans += 1;
          ans %= mod;
        }
        break;
      }
      for (auto& e : s) {
        e ^= m - 1;
      }
    }
  }

  cout << ans << endl;

  return true;
}



//void solve() {}