#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vb = vector<bool>;
using vc = vector<char>;
using vvc = vector<vc>;
using vvb = vector<vb>;

#ifndef DEBUG
#define endl '\n'
#endif

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  ll t;
  cin >> t;

  while (bsolve());
}

ll calc_m(vector<pair<ii, ll>> a) {
  sort(a.begin(), a.end(), [&](const auto& x, const auto& y) -> bool {
    if (x.first.second != y.first.second) return x.first.second < y.first.second;
    return x.first.first > y.first.first;
  });

  ll last = -1e18;
  ll cnt = 0;
  for (const auto& [lr, i] : a) {
    auto [l, r] = lr;
    if (last < l) {
      cnt += 1;
      last = r;
    }
  }

  return cnt;
}

using pi = pair<ii, ll>;

vvi gr;
vi par;
vi depth;
vi caps;
vii leafs;

void dfs(ll v, ll d) {
  depth[v] = d;

  if (gr[v].empty()) {
    ll du = caps.back();
    caps.pop_back();

    leafs.emplace_back(v, d - du);

    return;
  }
  for (int i = 0; i < (ll) gr[v].size() - 1; ++i) {
    caps.emplace_back(d);
  }
  for (auto u : gr[v]) {
    dfs(u, d + 1);
  }
}

constexpr bool debug =
#ifdef DEBUG
    true;
#else
false;
#endif

bool bsolve() {
  ll n;
  if (!(cin >> n)) return false;

  vector<pair<ii, ll>> a(n);
  for (int i = 0; i < n; ++i) {
    ll x, y;
    cin >> x >> y;
    a[i].first = {x, y};
    a[i].second = i;
  }

  sort(a.begin(), a.end());
  if (!debug) {
    bool ok = true;
    ll last = -1e18;
    for (auto [lr, i] : a) {
      auto [l, r] = lr;
      if (l <= last) {
        ok = false;
        break;
      }
      last = r;
    }
    if (ok) {
      for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << ' ';
      }
      cout << endl;
      return true;
    }
  }

  ll m = calc_m(a);

  if (n <= 30 && !debug) {
    for (ull mask = 0; mask < (1ull << n); ++mask) {
      vi keep;
      for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1ull) {
          keep.emplace_back(i);
        }
      }
      if (keep.size() != n / 2) continue;

      vector<pair<ii, ll>> b;
      for (auto i : keep) {
        b.emplace_back(a[i]);
      }

      if (calc_m(b) == m / 2) {
        for (auto [lr, i] : b) cout << i + 1 << ' ';
        cout << endl;
        return true;
      }
    }
  }

  sort(a.begin(), a.end(), [&](const auto& x, const auto& y) -> bool {
    if (x.first.second != y.first.second) return x.first.second < y.first.second;
    return x.first.first < y.first.first;
  });

  vi roots;
  gr.assign(n, {});
  par.assign(n, -1);
  depth.assign(n, -1e18);
  leafs.clear();
  caps.clear();

  {
    vector<pi> suf;
    for (auto [lr, i] : a) {
      auto [l, r] = lr;

      while (!suf.empty() && suf.back().first.first >= l) {
        ll j = suf.back().second;
        gr[i].emplace_back(j);
        par[j] = i;
        suf.pop_back();
      }

      suf.emplace_back(lr, i);
    }
    for (auto [lr, i] : suf) roots.emplace_back(i);
  }

  for (auto v : roots) {
    caps.clear();
    caps.emplace_back(0);
    dfs(v, 1);
  }

  vb leaf(n);
  for (auto [v, d] : leafs) leaf[v] = true;

  sort(leafs.begin(), leafs.end(), [&](ii a, ii b) {
    return a.second < b.second;
  });
  assert(leafs.size() == m);
  leafs.resize(leafs.size() / 2);

  vb mark(n, true);

  ll k = n / 2;

  for (auto [v, d] : leafs) {
    while (d--) {
      mark[v] = false;
      v = par[v];
      if (v >= 0) leaf[v] = true;
      k -= 1;
    }
  }

  for (int i = 0; i < n && k > 0; ++i) {
    if (mark[i] && !leaf[i]) {
      mark[i] = false;
      k -= 1;
    }
  }

  vi ans;
  for (int i = 0; i < n; ++i) {
    if (mark[i]) ans.emplace_back(i + 1);
  }
  cout << ans << endl;

  vector<pi> b;
  for (auto e : ans) {
    b.emplace_back(a[e - 1]);
  }
//  assert(calc_m(b) == m / 2);
//  assert(ans.size() == n / 2);

  return true;
}