#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vb = vector<bool>;
using vc = vector<char>;
using vvc = vector<vc>;
using vvb = vector<vb>;

#ifndef DEBUG
#define endl '\n'
#endif

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  ll t;
  cin >> t;

  while (bsolve());
}

ll calc_m(vector<pair<ii, ll>> a) {
  sort(a.begin(), a.end(), [&](const auto& x, const auto& y) -> bool {
    if (x.first.second != y.first.second) return x.first.second < y.first.second;
    return x.first.first > y.first.first;
  });

  ll last = -1e18;
  ll cnt = 0;
  for (const auto& [lr, i] : a) {
    auto [l, r] = lr;
    if (last < l) {
      cnt += 1;
      last = r;
    }
  }

  return cnt;
}

bool bsolve() {
  ll n;
  if (!(cin >> n)) return false;

  vector<pair<ii, ll>> a(n);
  for (int i = 0; i < n; ++i) {
    ll x, y;
    cin >> x >> y;
    a[i].first = {x, y};
    a[i].second = i;
  }

  sort(a.begin(), a.end());
  {
    bool ok = true;
    ll last = -1e18;
    for (auto [lr, i] : a) {
      auto [l, r] = lr;
      if (l <= last) {
        ok = false;
        break;
      }
      last = r;
    }
    if (ok) {
      for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << ' ';
      }
      cout << endl;
      return true;
    }
  }

  ll m = calc_m(a);
  if (m % 2) abort();

  for (ull mask = 0; mask < (1ull << n); ++mask) {
    vi keep;
    for (int i = 0; i < n; ++i) {
      if ((mask >> i) & 1ull) {
        keep.emplace_back(i);
      }
    }
    if (keep.size() != n / 2) continue;

    vector<pair<ii, ll>> b;
    for (auto i : keep) {
      b.emplace_back(a[i]);
    }

    if (calc_m(b) == m / 2) {
      for (auto [lr, i] : b) cout << i + 1 << ' ';
      cout << endl;
      return true;
    }
  }

  abort();

  return true;
}