#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2")
#endif

#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vb = vector<bool>;
using vc = vector<char>;
using vvc = vector<vc>;
using vvb = vector<vb>;

#ifndef DEBUG
#define endl '\n'
#endif

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

//  ll t;
//  cin >> t;

  while (bsolve()) cout << endl;
}

using __gnu_pbds::gp_hash_table;
using __gnu_pbds::cc_hash_table;

struct pairhash {
  ull operator()(ii a) const {
    return a.first * 32 ^ a.second;
  }
};

ll n, q;
vii w;
ll z;
cc_hash_table<ii, pair<ii, ii>, pairhash> cache;

bool calc(ll a, ll b, ii k) {
  if (a == 0 && b == 0) return true;

  ii ab = ii{a, b};

  if (cache.find(ab) == cache.end()) {
    cache[ab] = {{numeric_limits<ll>::min(), numeric_limits<ll>::min()},
                 {numeric_limits<ll>::max(), numeric_limits<ll>::max()}};
  }

  if (k <= cache[ab].first) return false;
  if (k >= cache[ab].second) return true;

  for (auto it
      = upper_bound(w.begin(), w.end(), k, greater<>());
       it != w.end();
       ++it) {
    ll e = it->first;

    if ((a >= e && calc(a - e, b, *it)) || (b >= e && calc(a, b - e, *it))) {
      cache[ab].second = min(cache[ab].second, k);
      return true;
    }
  }

  cache[ab].first = max(cache[ab].first, k);
  return false;
}

cc_hash_table<ll, pair<ii, ii>> check_cache;
bool check(ll a, ii k) {
  if (check_cache.find(a) == check_cache.end()) {
    check_cache[a] = {{numeric_limits<ll>::min(), numeric_limits<ll>::min()},
                      {numeric_limits<ll>::max(), numeric_limits<ll>::max()}};
  }
  if (check_cache[a].second <= k) return true;
  if (check_cache[a].first >= k) return false;
  auto it = upper_bound(w.begin(), w.end(), k, greater<>());
  if (it == w.end()) return false;
  ll e = it->first;
  if (a - e < e) return true;
  while (it != w.end()) {
    if (check(a - e, *it)) {
      check_cache[a].second = k;
      return true;
    }
    ++it;
  }

  check_cache[a].first = k;

  return false;
}

bool bsolve() {
  if (!(cin >> n >> q)) return false;

  cache.clear();
  w.clear();

  map<ll, ll> cnt;
  for (int i = 0; i < n; ++i) {
    ll v;
    cin >> v;
    w.emplace_back(v, cnt[v]);
    cnt[v] += 1;
  }
  sort(w.rbegin(), w.rend());
  cin >> z;

  ll lastok = 0;

  for (int qq = 0; qq < q; ++qq) {
    ll k, a, b;
    cin >> k >> a >> b;

    if (b == 0 && k >= (ll) 1e18) {
      while (check(lastok, {1e18, 1e18})) lastok += 1;
      cout << (a <= lastok ? "Yes" : "No") << endl;
    } else {
      ll ts = 100;
      ll sc = 10;

      mt19937 rnd(1337);

      bool all_ok = true;
      for (ll aa = 0; aa <= a && all_ok; ++aa) {
//      if (aa < a - ts && aa > ts && rnd() % 100 <= sc) continue;
        for (ll bb = 0; bb <= b && all_ok; ++bb) {
//        if (bb < b - ts && bb > ts && rnd() % 100 <= sc) continue;
          if (!calc(aa, bb, {k, 1e18 + 10}))
            all_ok = false;
        }
      }
      cout << (all_ok ? "Yes" : "No") << endl;
    }
  }

  return true;
}