#include <bits/stdc++.h>

using namespace std;

const int C = 500000;

struct E {
    int l, r, id;
};

struct SegTree {
    vector<int> t;
    int n;

    SegTree(int n) : n(n) {
        t.resize(n * 4 + 5);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (r < tl || l > tr) return 0;
        int m = (l + r) / 2;
        return max(get(v + v, l, m, tl, tr), get(v + v + 1, m + 1, r, tl, tr));
    }

    int get(int l, int r) {
        return get(1, 0, n - 1, l, r);
    }

    void upd(int v, int l, int r, int i, int x) {
        if (l == r) {
            t[v] = max(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            upd(v + v, l, m, i, x);
        } else {
            upd(v + v + 1, m + 1, r, i, x);
        }
        t[v] = max(t[v + v], t[v + v + 1]);
    }

    void upd(int i, int x) {
        upd(1, 0, n - 1, i, x);
    }
};

int get(vector<E> &a) {
    int n = (int) a.size();
    vector<int> dp(n + 1);
    SegTree t(n * 4 + 4);
    for (int i = 1; i <= n; i++) {
        dp[i] = 1 + t.get(0, a[i - 1].l - 1);
        t.upd(a[i - 1].r, dp[i]);
    }
    return *max_element(dp.begin(), dp.end());
}

mt19937 rnd(228);

void solve() {
    int n;
    cin >> n;
    vector<E> a(n);
    vector<int> all;
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].r;
        all.push_back(a[i].l);
        all.push_back(a[i].r);
        a[i].id = i;
    }
    sort(all.begin(), all.end());
    map<int, int> val;
    int now = 1;
    val[all[0]] = 0;
    for (int i = 1; i < n * 2; i++) {
        if (all[i] == all[i - 1]) continue;
        val[all[i]] = now++;
    }
    for (auto &x : a) {
        x.l = val[x.l];
        x.r = val[x.r];
    }
    auto cmp = [&](E x, E y) {
        return x.r < y.r;
    };
    sort(a.begin(), a.end(), cmp);
    vector<int> r;
    for (int i = 0; i < n / 2; i++) {
        r.push_back(1);
        r.push_back(0);
    }
    int e = get(a);
    for (int _ = 0; _ < C; _++) {
        vector<E> a_;
        shuffle(r.begin(), r.end(), rnd);
        for (int i = 0; i < n; i++) {
            if (r[i]) {
                a_.push_back(a[i]);
            }
        }
        int m = get(a_);
        if (m * 2 == e) {
            for (int i = 0; i < n; i++) {
                if (r[i]) {
                    cout << a[i].id + 1 << " ";
                }
            }
            cout << "\n";
            return;
        }
    }
}

signed main() {
    int T = 1;
    cin >> T;
    while (T--) solve();
}
