#include <bits/stdc++.h>

using namespace std;

struct sub {
    int l, r, ind;

    void input(int i) {
        cin >> l >> r;
        ind = i;
    }

    int operator<(sub a) {
        return r < a.r;
    }
};

struct tree_max {
    vector<pair<int, int>> tree;

    tree_max(int n) {
        tree.resize(4 * n + 2, {0, -1});
    }

    pair<int, int> get_max(int v, int l, int r, int ql, int qr) {
        if (l >= qr || ql >= r) return {0, -1};
        if (ql <= l && r <= qr) return tree[v];
        int mid = (l + r) / 2;
        return max(get_max(2 * v, l, mid, ql, qr), get_max(2 * v + 1, mid, r, ql, qr));
    }

    void upd(int v, int l, int r, int ind, pair<int, int> val) {
        if (ind >= r || ind < l) return;
        if (l + 1 == r) {
            tree[v] = max(tree[v], val);
            return;
        }
        int mid = (l + r) / 2;
        upd(2 * v, l, mid, ind, val);
        upd(2 * v + 1, mid, r, ind, val);
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
};

vector<sub> calc_m(vector<sub> a, int MX) {
    vector<int> dp(MX + 1), prev(a.size()), dp_i(a.size());
    tree_max ufo(MX + 5);
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        sub x = a[i];
        pair<int, int> p = ufo.get_max(1, 0, MX, 0, x.l);
        p.first += 1;
        prev[i] = p.second;
        dp_i[i] = p.first;
        dp[x.r] = max(dp[x.r], p.first);
        ufo.upd(1, 0, MX, x.r, {p.first, i});
        ans = max(ans, dp[x.r]);
    }
    ufo.tree.clear();
    vector<sub> res;
    int start = -1;
    for (int i = 0; i < a.size(); ++i) {
        if (dp_i[i] == ans) start = i;
    }
    while (start != -1) {
        res.push_back(a[start]);
        start = prev[start];
    }
    reverse(res.begin(), res.end());
    return res;
}

vector<vector<int>> g;

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<sub> a(n);
    set<int> all_b;
    for (int i = 0; i < n; ++i) {
        a[i].input(i);
        all_b.insert(a[i].l);
        all_b.insert(a[i].r);
    }
    int IND_Z = 0;
    map<int, int> transl;
    for (int i: all_b) {
        transl[i] = IND_Z++;
    }
    for (int i = 0; i < n; ++i) {
        a[i].l = transl[a[i].l];
        a[i].r = transl[a[i].r];
    }
    sort(a.begin(), a.end());
    int MX = IND_Z + 100;
    vector<sub> w = calc_m(a, MX);
    vector<int> ans;
    sort(w.begin(), w.end());
    for (int j = 0; j < n; ++j) {
        if (a[j].l <= w[(int) w.size() / 2 - 1].r) {
            ans.push_back(a[j].ind);
        }
    }
    if (ans.size() >= n / 2) {
        vector<int> used(n);
        int e = (int) ans.size() - n / 2;
        for (int i = 0; i < n; ++i) {
            if (e == 0) break;
            if (a[i].l <= w[(int) w.size() / 2 - 1].r) {
                int flag = 1;
                for (int j = 0; j < w.size() / 2; ++j) {
                    if (w[j].ind == a[i].ind) flag = 0;
                }
                if (flag) used[a[i].ind] = 1, e--;
            }
        }
        vector<int> answer;
        for (int i: ans) {
            if (!used[i]) answer.push_back(i);
        }
        assert(answer.size() == n / 2);
        for (int i: ans) {
            if (!used[i]) cout << i + 1 << " ";
        }
        cout << endl;
        return;
    }
    ans.clear();
    for (int j = 0; j < n; ++j) {
        if (a[j].r >= w[(int) w.size() / 2].l) {
            ans.push_back(a[j].ind);
        }
    }
    vector<int> used(n);
    int e = (int) ans.size() - n / 2;
    for (int i = 0; i < n; ++i) {
        if (e == 0) break;
        if (a[i].r >= w[(int) w.size() / 2].l) {
            int flag = 1;
            for (int j = (int) w.size() / 2; j < w.size(); ++j) {
                if (w[j].ind == a[i].ind) flag = 0;
            }
            if (flag) used[a[i].ind] = 1, e--;
        }
    }
    vector<int> answer;
    for (int i: ans) {
        if (!used[i]) answer.push_back(i);
    }
    assert(answer.size() == n / 2);
    for (int i: ans) {
        if (!used[i]) cout << i + 1 << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}