#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int INF = 2e9;
const ll LL_INF = 2e18;
const ld EPS = 1e-7;

const int TR_SZ = 20;

struct segment_tree {
    vector < int > tr;

    segment_tree(): tr(vector < int >(1 << TR_SZ)) {}

    void upd(int pos, int x) {
        pos += (1 << (TR_SZ - 1));
        tr[pos] = x;
        pos /= 2;
        while (pos > 0) {
            tr[pos] = max(tr[pos * 2], tr[pos * 2 + 1]);
            pos /= 2;
        }
    }

    int get(int l, int r) {
        l += (1 << (TR_SZ - 1));
        r += (1 << (TR_SZ - 1));
        int ret = 0;
        while (l <= r) {
            if (l % 2)
                ret = max(ret, tr[l++]);
            if (r % 2 == 0)
                ret = max(ret, tr[r--]);
            l /= 2;
            r /= 2;
        }
        return ret;
    }
};

int n;
vector < int > nvp;



void solve() {
    cin >> n;

    nvp.resize(n);

    vector < int > p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
//        --p[i];
    }

    nvp[0] = 1;

    segment_tree tr;
    tr.upd(p[0], 1);

    for (int i = 1; i < n; ++i) {
        nvp[i] = tr.get(0, p[i] - 1) + 1;
        tr.upd(p[i], nvp[i]);
    }

    int mx = 0;
    vector < int > v;
    for (int i = 0; i < n; ++i) {
        if (mx < nvp[i]) {
            mx = nvp[i];
            v = {i};
        }
        else if (mx == nvp[i])
            v.push_back(i);
    }

    if (mx < n)
        ++mx;
    cout << mx;
}

int main() {
//    freopen("../input.txt", "r", stdin);
    ios::sync_with_stdio(false), cin.tie(nullptr);
//    cout.tie(nullptr);

    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}

