#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;

using ll = long long;
using ld =  long double;
using ull = unsigned long long;

const int INF = 2e9;
const ll LL_INF = 2e18;
const ld EPS = 1e-7;

const int TR_SZ = 20;

struct segment {
    int l, r, num;

    bool operator<(const segment other) const {
        return r < other.r;
    }
};

struct segment_tree {
    vector < int > tr;

    segment_tree() {
        tr.resize(1 << TR_SZ);
    }

    void upd(int v, int x) {
        v += (1 << (TR_SZ - 1));
        tr[v] = max(tr[v], x);
        v /= 2;
        while (v > 0) {
            tr[v] = max(tr[v * 2], tr[v * 2 + 1]);
            v /= 2;
        }
    }

    int get(int l, int r) {
        l += (1 << (TR_SZ - 1));
        r += (1 << (TR_SZ - 1));
        int ret = 0;
        while (l <= r) {
            if (l % 2)
                ret = max(ret, tr[l++]);
            if (r % 2 == 0)
                ret = max(ret, tr[r--]);
            l /= 2;
            r /= 2;
        }
        return ret;
    }
};

int n;
vector < segment > a;

void gen_test(int seed) {
    mt19937 rnd(seed);

    n = 10;
    a.resize(n);

    while (true) {
        for (int i = 0; i < n; ++i) {
            a[i].l = rnd() % 15 + 1;
            a[i].r = rnd() % 15 + 1;
            while (a[i].r == a[i].l)
                a[i].r = rnd() % 15 + 1;
            if (a[i].l > a[i].r)
                swap(a[i].l, a[i].r);
            a[i].num = i;
        }
        sort(a.begin(), a.end());
        segment_tree tr;
        vector < int > dp(n);
        int m = 0;
        for (int i = 0; i < n; ++i) {
            dp[i] = tr.get(0, a[i].l - 1) + 1;
            tr.upd(a[i].r, dp[i]);
            m = max(m, dp[i]);
        }

//        cout << m << "\n";

        if (m % 2 == 0)
            break;
    }
}

bool solve() {
    cin >> n;

    vector < int > b;

    a.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
//        --a[i].l, --a[i].r;
        a[i].num = i;
        b.push_back(a[i].l);
        b.push_back(a[i].r);
    }

    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());

    for (int i = 0; i < n; ++i) {
        int x = lower_bound(b.begin(), b.end(), a[i].l) - b.begin();
//        a[i].l = x + 1;
        x = lower_bound(b.begin(), b.end(), a[i].r) - b.begin();
//        a[i].r = x + 1;
    }

    sort(a.begin(), a.end());

    vector < int > dp(n);
    segment_tree tr;

    int m = 0;

    for (int i = 0; i < n; ++i) {
        dp[i] = tr.get(0, a[i].l - 1) + 1;
        tr.upd(a[i].r, dp[i]);
        m = max(m, dp[i]);
    }

    vector < vector < int > > v(m + 1);
    for (int i = 0; i < n; ++i)
        v[dp[i]].push_back(i);

    int n2 = n / 2, m2 = m / 2;

    auto cmp = [&](const int& q, const int& w) {
        return a[q].l < a[w].l;
    };

    set < int > ans;
    for (int i = 0; i < n; ++i)
        ans.insert(i);

    for (int i = 0; i <= m; ++i)
        sort(v[i].begin(), v[i].end(), cmp);

    for (int i = m; i >= m2 && n > n2; --i) {
        for (int j = 0; j < (int)v[i].size() - (i == m2) && n > n2; ++j) {
            ans.erase(a[v[i][j]].num);
            --n;
        }
    }

    int prev = v[m2].back();

    if (n > n2) {
        for (int i = m2 - 1; i >= 0 && n > n2; --i) {
            int new_prev = -1, mxl = 0;
            for (int j = 0; j < (int)v[i].size(); ++j) {
                if (a[v[i][j]].r < a[prev].l) {
                    new_prev = v[i][j];
                }
            }

            for (int j = 0; j < (int)v[i].size() && n > n2; ++j) {
                if (v[i][j] == new_prev)
                    continue;
                ans.erase(a[v[i][j]].num);
                --n;
            }

            prev = new_prev;
        }
    }

//    assert(n == n2);

    segment_tree tr1;
    vector < int > dp1(n2 * 2);
    int m1 = 0;
    for (int i = 0; i < n2 * 2; ++i) {
//        cout << a[i].num + 1 << "\n";
        if (ans.find(a[i].num) == ans.end())
            continue;
        dp1[i] = tr1.get(0, a[i].l - 1) + 1;
        tr1.upd(a[i].r, dp1[i]);
        m1 = max(m1, dp1[i]);

//        cout << a[i].l << ' ' << a[i].r << ' ' << dp1[i] << "\n";
    }

//    cout << n << ' ' << n2 << "\n";
//    cout << m << ' ' << m1 << ' ' << m2 << "\n";

//    assert(m1 == m2);

//    return m1 == m2 && n == n2;

    if (m1 != m2 || n != n2) {
        n = n2 * 2;
        for (int i = 0; i < n; ++i)
            ans.insert(i);

        for (int i = 0; i <= m; ++i)
            sort(v[i].rbegin(), v[i].rend());

        for (int i = 0; i <= m2 && n > n2; ++i) {
            for (int j = 0; j < (int)v[i].size() - (i == m2) && n > n2; ++j) {
                ans.erase(a[v[i][j]].num);
                --n;
            }
        }

        prev = v[m2].back();

        if (n > n2) {
            for (int i = m2 + 1; i <= m && n > n2; ++i) {
                int new_prev = -1;
                for (int j = 0; j < (int)v[i].size(); ++j) {
                    if (a[v[i][j]].l > a[prev].r) {
                        new_prev = v[i][j];
                    }
                }

                for (int j = 0; j < (int)v[i].size() && n > n2; ++j) {
                    if (v[i][j] == new_prev)
                        continue;
                    ans.erase(a[v[i][j]].num);
                    --n;
                }

                prev = new_prev;
            }
        }
    }

    for (int elem: ans)
        cout << elem + 1 << ' ';
    cout << "\n";
}

int main() {
//    freopen("../input.txt", "r", stdin);
    ios::sync_with_stdio(false), cin.tie(nullptr);
//    cout.tie(nullptr);

//    for (int test = 1;; ++test) {
//        gen_test(test);
//        cout << "TEST " << test << ' ';
//        bool ans = solve();
//        if (!ans) {
//            cout << "FAILED\nTEST:\n" << a.size() << "\n";
//            for (int i = 0; i < a.size(); ++i)
//                cout << a[i].l << ' ' << a[i].r << "\n";
//            return 0;
//        }
//        cout << "PASSED\n";
//    }

    int tt = 1;
    cin >> tt;
    while (tt--) {
        a.clear();
        solve();
    }
}
