#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")
#include <iostream>
#include <random>
#include <vector>
#include <algorithm>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(228);

#define int long long

class SegmentTree {
private:
	struct Node {
		Node* ch[2] = { nullptr, nullptr };
		int sm = 0;
	};

	int get(int ql, int qr, int nl, int nr, Node* node) {
		if (ql >= nr || nl >= qr || node == nullptr) return 0;
		if (ql <= nl && nr <= qr) return node->sm;
		return get(ql, qr, nl, (nl + nr) / 2, node->ch[0]) + get(ql, qr, (nl + nr) / 2, nr, node->ch[1]);
	}

	Node* root = nullptr;
	int lg = 0;

public:
	SegmentTree(int n) {
		while ((1ll << lg) < n) ++lg;
		root = new Node;
	}

	int get(int l, int r) {
		return get(l, r, 0, (1 << lg), root);
	}

	void update(int pos) {
		Node* cur = root;
		++cur->sm;
		for (int cd = lg - 1; cd >= 0; --cd) {
			if (cur->ch[pos >> cd & 1] == nullptr) {
				cur->ch[pos >> cd & 1] = new Node;
			}
			cur = cur->ch[pos >> cd & 1];
			++cur->sm;
		}
	}
};

void solve1() {
	int n, k; cin >> n >> k;
	vector <int> v(k);
	for (auto& x : v) {
		cin >> x;
		--x;
	}

	vector <int> ans;
	SegmentTree tree(2 * n);
	for (auto x : v) {
		tree.update(x);
		tree.update(x + n);
	}
	for (auto x : v) {
		int l = x, r = x + n;
		while (l + 1 != r) {
			int m = (l + r) / 2;
			int c = 0;
			c = tree.get(x, m + 1);
			if (c == m + 1 - x) l = m;
			else r = m;
		}
		r = (r + 2 * n) % n;
		tree.update(r);
		tree.update(r + n);
		ans.push_back(r);
	}
	sort(all(ans));
	for (auto x : ans) cout << x + 1 << ' ';
}

void solve2() {
	int n, k; cin >> n >> k;
	vector <int> v(k);
	for (auto& x : v) {
		cin >> x;
		--x;
	}

	vector <int> ans;
	SegmentTree tree(2 * n);
	for (auto x : v) {
		tree.update(n - 1 - x);
		tree.update(n - 1 - x + n);
	}
	for (auto x : v) {
		int l = n - 1 - x, r = n - 1 - (x - n);
		while (l + 1 != r) {
			int m = (l + r) / 2;
			int c = 0;
			c = tree.get(n - 1 - x, m + 1);
			if (c == m + 1 - (n - 1 - x)) l = m;
			else r = m;
		}
		r = (r + 2 * n) % n;
		tree.update(r);
		tree.update(r + n);
		ans.push_back(n - 1 - r);
	}
	sort(all(ans));
	for (auto x : ans) cout << x + 1 << ' ';
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t a; cin >> a;
	int32_t t = 1;
	cin >> t;
	while (t--) {
		if (a == 1) solve1();
		else solve2();
		cout << '\n';
	}
}