#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>
#include <set>
#include <tuple>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

bool cmp(const tuple <int, int, int>& a, const tuple <int, int, int>& b) {
	if (get<1>(a) == get<1>(b)) return get<0>(a) < get<0>(b);
	return get<1>(a) < get<1>(b);
}

void solve() {
	int n; cin >> n;
	vector <tuple <int, int, int>> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> get<0>(v[i]) >> get<1>(v[i]);
		get<2>(v[i]) = i;
	}
	auto v0 = v;

	
	sort(all(v), cmp);
	vector <set <int>> g(n);
	vector <int> pr(n, -1);
	{
		vector <int> st;
		for (auto [l, r, ind] : v) {
			while (!st.empty() && get<0>(v0[st.back()]) >= l) {
				g[ind].insert(st.back());
				pr[st.back()] = ind;
				st.pop_back();
			}
			st.push_back(ind);
		}
	}
	

	set <int> st;
	set <int> st2;
	for (int i = 0; i < n; ++i) {
		if (g[i].empty()) st.insert(i);
	}
	int m0 = st.size();
	int cm = m0;
	assert(m0 % 2 == 0);
	vector <bool> alive(n, true);
	int lcnt = n;
	while (cm > m0 / 2) {
		if (!st.empty()) {
			if (pr[*st.begin()] == -1) {
				alive[*st.begin()] = false;
				--lcnt;
				--cm;
				st.erase(st.begin());
			}
			else if (g[pr[*st.begin()]].size() == 1) {
				st2.insert(*st.begin());
				st.erase(st.begin());
			}
			else {
				alive[*st.begin()] = false;
				--lcnt;
				--cm;
				g[pr[*st.begin()]].erase(*st.begin());
				st.erase(st.begin());
			}
		}
		else {
			alive[*st2.begin()] = false;
			--lcnt;
			g[pr[*st2.begin()]].erase(*st2.begin());
			st.insert(pr[*st2.begin()]);
			st2.erase(st2.begin());
		}
	}

	int ost = n / 2;
	for (int i = 0; i < n; ++i) {
		if (alive[i]) {
			if (st.count(i) || st2.count(i)) {
				cout << i + 1 << ' ';
				--ost;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (alive[i]) {
			if (ost > 0 && !st.count(i) && !st2.count(i)) {
				cout << i + 1 << ' ';
				--ost;
			}
		}
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}