#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

const int MAXN = 2e3 + 7;
const int MAXNt = (1 << 11);

struct seg_tree {
	int dp[MAXN][2 * MAXNt];
	int cnst[MAXN][2 * MAXNt];

	void push(int id, int v, int tl, int tr) {
		if (cnst[id][v] == 0)
			return;
		if (tl < tr)
			cnst[id][2 * v] = cnst[id][2 * v + 1] = cnst[id][v];
		dp[id][v] = cnst[id][v];
		cnst[id][v] = 0;
	}

	void upd(int id, int l, int r, int val, int tl = 0, int tr = MAXNt - 1, int v = 1) {
		if (tl > tr)
			return;
		if (tl > r || tr < l)
			return;
		push(id, v, tl, tr);
		if (tl >= l && tr <= r) {
			cnst[id][v] = val;
			return;
		}
		int mid = (tl + tr) / 2;
		upd(id, l, r, val, tl, mid, 2 * v);
		upd(id, l, r, val, mid + 1, tr, 2 * v + 1);
		push(id, 2 * v, tl, mid);
		push(id, 2 * v + 1, mid + 1, tr);
		dp[id][v] = max(dp[id][2 * v], dp[id][2 * v + 1]);
	}

	int get_max(int id, int l, int r, int tl = 0, int tr = MAXNt - 1, int v = 1) {
		if (tl > tr)
			return -1e9;
		if (tl > r || tr < l)
			return -1e9;
		push(id, v, tl, tr);
		if (tl >= l && tr <= r)
			return dp[id][v];
		int mid = (tl + tr) / 2;
		return max(get_max(id, l, r, tl, mid, 2 * v), get_max(id, l, r, mid + 1, tr, 2 * v + 1));
	}
};

seg_tree dp0;
seg_tree dp1;

void solve() {
	int n;
	cin >> n;
	vector <int> p(n);
	for (int i = 0; i < n; i++)
		cin >> p[i];
	for (int i = 0; i <= n + 1; i++) {
		dp0.upd(i, 0, MAXNt - 1, -1e9);
		dp1.upd(i, 0, MAXNt - 1, -1e9);
	}
	dp0.upd(p[0], n + 1, n + 1, 1);
	dp0.upd(0, p[0], p[0], 1);
	dp1.upd(n + 1, p[0], p[0], 1);
	dp1.upd(p[0], 0, 0, 1);
	for (int i = 1; i < n; i++) {
		vector <int> ndp1(n + 1);
		for (int j = 0; j <= n; j++)
			ndp1[j] = dp0.get_max(j, p[i], p[i]);
		for (int j = 0; j <= n; j++)
			ndp1[j] = max(ndp1[j], dp0.get_max(j, p[i] + 1, n + 1) + 1);
		vector <int> ndp2(n + 2);
		for (int j = 0; j <= n + 1; j++)
			ndp2[j] = dp0.get_max(p[i], j, j);
		for (int t = 0; t <= n + 1; t++)
			ndp2[t] = max(ndp2[t], dp1.get_max(t, 0, p[i] - 1) + 1);

		for (int j = 0; j <= n; j++) {
			dp0.upd(j, p[i], p[i], ndp1[j]);
			dp1.upd(p[i], j, j, ndp1[j]);
		}
		for (int j = 0; j <= n + 1; j++) {
			dp0.upd(p[i], j, j, ndp2[j]);
			dp1.upd(j, p[i], p[i], ndp2[j]);
		}
		for (int j = 0; j < p[i]; j++)
			dp0.upd(j, p[i] + 1, n + 1, -1e9);
		for (int t = p[i] + 1; t <= n + 1; t++)
			dp1.upd(t, 0, p[i] - 1, -1e9);
	}
	int ans = 0;
	for (int i = 1; i <= n; i++)
		ans = max(ans, dp0.get_max(i, 1, n));
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}