#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

bool comp(pair <pair <int, int>, int> v, pair <pair <int, int>, int> u) {
	if (v.first.second == u.first.second)
		return v.first.first < u.first.first;
	return v.first.second < u.first.second;
}

int calcm(vector <pair <pair <int, int>, int>>& a, vector <bool>& dead) {
	int sz = 0;
	int mar = -1e9;
	for (int i = 0; i < (int)a.size(); i++) {
		if (dead[i])
			continue;
		auto e = a[i];
		if (e.first.first > mar) {
			sz++;
			mar = e.first.second;
		}
	}
	return sz;
}

bool inter(pair <int, int> v, pair <int, int> u) {
	if (v.first > u.second || v.second < u.first)
		return false;
	return true;
}

vector <int> st;
int sz;

void upd(int pos, int val) {
	int v = pos + sz;
	while (v >= 1) {
		st[v] = max(st[v], val);
		v /= 2;
	}
}

int get(int l, int r) {
	int vl = l + sz;
	int vr = r + sz;
	int res = 0;
	while (vl <= vr) {
		if (vl & 1) {
			res = max(res, st[vl]);
			vl++;
		}
		if ((vr & 1) == 0) {
			res = max(res, st[vr]);
			vr--;
		}
		vl /= 2;
		vr /= 2;
	}
	return res;
}

int l2[400007];
int get_min(int l, int r, vector <vector <int>>& sparse) {
	int lvl = l2[r - l + 1];
	return min(sparse[lvl][l], sparse[lvl][r - (1 << lvl) + 1]);
}

void solve() {
	int n;
	cin >> n;
	vector <bool> dead(n, false);
	vector <pair <pair <int, int>, int>> a(n);
	vector <int> xs;
	for (int i = 0; i < n; i++) {
		cin >> a[i].first.first >> a[i].first.second;
		xs.push_back(a[i].first.first);
		xs.push_back(a[i].first.second);
		a[i].second = i;
	}
	sort(xs.begin(), xs.end());
	xs.erase(unique(xs.begin(), xs.end()), xs.end());
	map <int, int> newval;
	for (int i = 0; i < (int)xs.size(); i++)
		newval[xs[i]] = i;
	for (auto& e : a) {
		e.first.first = newval[e.first.first];
		e.first.second = newval[e.first.second];
	}
	sz = 1;
	while (sz <= 2 * n)
		sz *= 2;
	st.assign(2 * sz, 0);
	sort(a.begin(), a.end(), comp);
	int m0 = calcm(a, dead);
	vector <int> dp(n, 1);
	upd(a.back().first.first, 1);
	for (int i = n - 2; i >= 0; i--) {
		dp[i] = get(a[i].first.second + 1, sz - 1) + 1;
		upd(a[i].first.first, dp[i]);
	}
	vector <vector <int>> sparse(20, vector <int>(n, 1e9));
	for (int i = 0; i < n; i++)
		sparse[0][i] = a[i].first.first;
	for (int lvl = 1; lvl < 20; lvl++)
		for (int i = 0; i < n; i++)
			if (i + (1 << (lvl - 1)) < n)
				sparse[lvl][i] = min(sparse[lvl - 1][i], sparse[lvl - 1][i + (1 << (lvl - 1))]);
	int dppref = 0;
	int mar = -1e9;
	for (int i = 0; i < n / 2; i++)
		dead[i] = true;
	for (int l = 0; l + n / 2 - 1 < n; l++) {
		int r = l + n / 2 - 1;
		dead[r] = true;
		int ll = r + 1, rr = n - 1;
		while (ll < rr) {
			int mid = (ll + rr) / 2;
			if (get_min(r + 1, mid, sparse) > mar) {
				rr = mid;
			}
			else {
				ll = mid + 1;
			}
		}
		int dpsuf = 0;
		for (int i = r + 1; i < n; i++)
			if (a[i].first.first > mar)
				dpsuf = max(dpsuf, dp[i]);
		int m = dppref + dpsuf;
		if (m == m0 / 2) {
			for (int i = 0; i < l; i++)
				cout << a[i].second + 1 << " ";
			for (int i = r + 1; i < n; i++)
				cout << a[i].second + 1 << " ";
			cout << "\n";
			return;
		}
		dead[l] = false;
		if (a[l].first.first > mar) {
			mar = a[l].first.second;
			dppref++;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	l2[1] = 0;
	for (int i = 2; i < 400007; i++) {
		l2[i] = l2[i - 1];
		if ((1 << (l2[i] + 1)) <= i)
			l2[i]++;
	}

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}