#include <iostream>
#include <vector>

#define MAX(a, b) ((a) < (b) ? (b) : (a))

using namespace std;

class fenwick {
public:
    int n = 1;
    vector <int> t;

    fenwick(int s) {
        while (n < s) n += n;
        t.resize(n + 1);
    }

    void mset(int k, int x) {
        ++k;
        while (k <= n) {
            t[k] = MAX(t[k], x);
            k += k & -k;
        }
    }

    int mget(int k) {
        int m = -1;
        ++k;
        while (k > 0) {
            m = MAX(m, t[k]);
            k -= k & -k;
        }
        return m;
    }

    void show() {
        for (int k = 0; k < n; ++k) {
            cout << mget(k) << ' ';
        }
        cout << '\n';
    }
};

void one() {
    int n;
    cin >> n;
    vector <int> p(n);
    for (int &x : p) cin >> x;

    // vector <vector <int>> d(n + 1, vector <int> (n + 1, 0));
    vector <fenwick> w(n + 1, fenwick(n + 1)), h(n + 1, fenwick(n + 1));

    vector <int> u(n + 1), v(n + 1);

    for (int x : p) {
        // cout << "x=" << x << "\n";
        for (int j = 0; j <= n; ++j) {
            u[j] = w[j].mget(n - x);
            // cout << "  j=" << j << "\n";
        }
        for (int j = 0; j <= n; ++j) {
            v[j] = h[j].mget(x - 1);
            // cout << "  j=" << j << "\n";
        }

        for (int j = 0; j <= n; ++j) {
            w[j].mset(n + 1 - x, u[j] + 1);
            h[n + 1 - x].mset(j, u[j] + 1);
        }
        for (int j = 0; j <= n; ++j) {
            h[j].mset(x, v[j] + 1);
            w[x].mset(j, v[j] + 1);
        }
    }

    int a = -1, b = -1;
    for (int j = 0; j <= n; ++j) {
        int e = w[j].mget(n);
        int f = h[j].mget(n);
        a = MAX(a, e);
        b = MAX(b, f);
    }

    if (a != b) exit(13);

    cout << a << '\n';
}

int main() {
    int t;
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #else
        ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #endif // LOCAL
    cin >> t;
    while (t--) {
        one();
        cout << endl;
    }
    return 0;
}

int test() {
    fenwick f(8);
    f.show();
    f.mset(1, 1);
    f.show();
    f.mset(3, 5);
    f.show();
    f.mset(5, 2);
    f.show();
    f.mset(6, 7);
    f.show();
    return 0;
}
