#include <iostream>
#include <vector>

using namespace std;

void printv(vector <int> &v) {
    cout << "[";
    for (int x : v) cout << x << ", ";
    cout << "]\n";
}

void dfs(vector <pair <int, int>> &t, int u, int s, int g, vector <int> &h, vector <int> &f, vector <int> &w, vector <int> &d) {
    w[u] = h.size();
    h.push_back(u);
    f[w[u]] = s;
    if (t[u].first != -1) {
        dfs(t, t[u].first,  s + (g == 1), 0, h, f, w, d);
        dfs(t, t[u].second, s + (g == 0), 1, h, f, w, d);
        d[u] += d[t[u].first] + d[t[u].second];
    }
}

void one() {
    int n, k, q, x, a, b;
    cin >> n >> k >> q;
    vector <pair <int, int>> t(n, {-1, -1});
    for (int i = 0; i < n; ++i) {
        cin >> x;
        if (x == 0) continue;
        cin >> a >> b;
        t[i] = {a - 1, b - 1};
    }

    vector <int> h, f(n), w(n), d(n, 1);
    dfs(t, 0, 0, -1, h, f, w, d);
    // printv(h); printv(f); printv(w); printv(d);

    vector <int> p(n + 1);
    for (int i = 0; i < n; ++i) {
        p[i + 1] = p[i];
        if (d[i] == 1 && f[i] <= k) ++p[i + 1];
    }
    // printv(p);

    for (int i = 0; i < q; ++i) {
        cin >> x;
        --x;
        cout << p[w[x] + d[x]] - p[w[x]] << '\n';
    }
}

int main() {
    int t;
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        cin >> t;
    #else
        ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
        t = 1;
    #endif // LOCAL
    while (t--) {
        one();
        cout << endl;
    }
    return 0;
}
