#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
using namespace std;

struct node {
	int sm = 0;
	int l = -1, r = -1;
};
vector <node> tree;
int summ(int v, int l, int r, int ql, int qr) {
	if (v == -1) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree[v].sm;
	}
	if (qr <= l || ql >= r) {
		return 0;
	}
	int mid = (r + l) / 2;
	return summ(tree[v].l, l, mid, ql, qr) + summ(tree[v].r, mid, r, ql, qr);
}
int gtsum(int v) {
	if (v == -1) {
		return 0;
	}
	return tree[v].sm;
}

void update(int v, int l, int r, int ql) {
	if (r - l == 1) {
		tree[v].sm = 1;
		return;
	}
	int mid = (r + l) / 2;
	if (ql < mid) {
		if (tree[v].l == -1) {
			tree[v].l = tree.size();
			tree.emplace_back();
		}
		update(tree[v].l, l, mid, ql);
	}
	else {
		if (tree[v].r == -1) {
			tree[v].r = tree.size();
			tree.emplace_back();
		}
		update(tree[v].r, mid, r, ql);
	}
	tree[v].sm = gtsum(tree[v].l) + gtsum(tree[v].r);
}



signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int c;
	cin >> c;
	if (c == 1) {
		int m;
		cin >> m;
		for (int q = 0; q < m; ++q) {
			int n, k;
			cin >> n >> k;
			tree.clear();
			tree.resize(1);
			vector <int> a(k);

			for (int i = 0; i < k; ++i) {
				cin >> a[i];
				update(0, 0, n + 1, a[i]);
			}
			vector <int> ans;
			for (int i = 0; i < k; ++i) {
				int ind = a[i];
				int suf_sum = summ(0, 0, n + 1, a[i], n + 1);
				int l = ind, r = n + 1;
				int st = ind;
				if (suf_sum == n + 1 - a[i]) {
					l = 0;
					r = ind;
					st = 1;
				}
				while (r - l > 1) {
					int mid = (r + l) / 2;
					int sm = summ(0, 0, n + 1, st, mid + 1);
					if (sm == mid - st + 1) {
						l = mid;
					}
					else {
						r = mid;
					}
				}
				
				ans.push_back(r);
				update(0, 0, n + 1, r);
			}
			sort(ans.begin(), ans.end());
			for (auto x : ans) {
				cout << x << " ";
			}
			cout << endl;
		}
	}
	else {
		int m;
		cin >> m;
		for (int q = 0; q < m; ++q) {
			int n, k;
			cin >> n >> k;

			tree.clear();
			tree.resize(1);
			vector <int> a(k);

			for (int i = 0; i < k; ++i) {
				cin >> a[i];
				update(0, 0, n + 1, a[i]);
			}
			vector <int> ans;
			for (int i = 0; i < k; ++i) {
				int ind = a[i];
				int pref_sum = summ(0, 0, n + 1, 1, ind + 1);
				int l = 1, r = ind;
				int st = ind;
				if (pref_sum == ind) {
					l = ind + 1;
					r = n + 1;
					st = n + 1;
				}
				while (r - l > 1) {
					int mid = (r + l) / 2;
					int smm = summ(0, 0, n + 1, mid, st);
					if (smm == st - mid) {
						r = mid;
					}
					else {
						l = mid;
					}
				}
				ans.push_back(l);
				update(0, 0, n + 1, l);
			}
			sort(ans.begin(), ans.end());
			for (auto x : ans) {
				cout << x << " ";
			}
			cout << endl;
		}
	}
}