#include <bits/stdc++.h>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

const int MAX_N = 2e5;

int type[MAX_N];

vector<int> graph[MAX_N];

int dp[MAX_N];

void dfs(int v) {
    if (graph[v].empty()) {
        return;
    }
    int l = graph[v][0];
    int r = graph[v][1];

    dp[l] = dp[v] + (type[v] == 1);
    dp[r] = dp[v] + (type[v] == 0);
    dfs(l);
    dfs(r);
}

int ans_dfs;

void dfs_ans(int v, int cur_k, int k) {
    if (graph[v].empty()) {
        ans_dfs += cur_k <= k;
        return;
    }
    int l = graph[v][0];
    int r = graph[v][1];
    dfs_ans(l, cur_k + (type[v] == 1), k);
    dfs_ans(r, cur_k + (type[v] == 0), k);
}

int request(int v, int k) {
    if (k < 0) {
        return 0;
    }
    ans_dfs = 0;
    dfs_ans(v, 0, k);
    return ans_dfs;
}

int n, k;

void solve() {
    int v;
    cin >> v;
    --v;
    int cur_k = k - dp[v];
    if (cur_k < 0) {
        cout << 0 << '\n';
        return;
    }
    if (graph[v].empty()) {
        cout << 1 << '\n';
        return;
    }
    int l = graph[v][0];
    int r = graph[v][1];
    int ans_l = request(l, cur_k - (type[v] == 1));
    int ans_r = request(r, cur_k - (type[v] == 0));
    int ans = ans_l + ans_r;
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q;
    cin >> n >> k >> q;
    type[0] = -1;
    for (int v = 0; v < n; ++v) {
        int t;
        cin >> t;
        if (t) {
            int l, r;
            cin >> l >> r;
            --l;
            --r;
            graph[v] = {l, r};
            type[l] = 0;
            type[r] = 1;
        }
    }
    dfs(0);

    for (int i = 0; i < q; ++i) {
        solve();
    }
}