#include <bits/stdc++.h>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

struct Segment {
    int l;
    int r;
    int ind;

    Segment() {}
    Segment(int l, int r, int ind) : l(l), r(r), ind(ind) {}
};

int n, m;

bool run(const vector<Segment>& a, vector<int>& index) {
    set<int> index_s(all(index));
    vector<int> need;
    vector<int> trash;
    for (auto [l, r, ind] : a) {
        if (index_s.find(ind) == index_s.end()) {
            auto lambda_l = [](const Segment& a, const Segment& b) {
                return a.l < b.l;
            };
            auto lambda_r = [](const Segment& a, const Segment& b) {
                return a.r < b.r;
            };
            int L = lower_bound(all(a), Segment(0, l, 0), lambda_r) - a.begin();
            int R = upper_bound(all(a), Segment(r, 0, 0), lambda_l) - a.begin();
            --R;
//            if (L > R) {
//                for (int x : index) {
//                    cerr << x << ' ';
//                }
//                cerr << endl;
//            }
            assert(L <= R);
            if (L == R) {
                if (index_s.find(L) == index_s.end()) {
                    need.push_back(ind);
                } else {
                    trash.push_back(ind);
                }
            } else {
                trash.push_back(ind);
            }
        }
    }
    if (need.size() > n - m / 2) {
        return false;
    }
    vector<int> ans = index;
    ans.insert(ans.end(), all(need));

    int len_trash = (int)trash.size();

    int len_add = n / 2 - (int)ans.size();
    assert(0 <= len_add && len_add <= len_trash);
    for (int i = 0; i < len_add; ++i) {
        ans.push_back(trash[i]);
    }
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
    return true;
}

void solve() {
    cin >> n;
    vector<Segment> segments(n);
    for (int i = 0; i < n; ++i) {
        segments[i].ind = i;
        cin >> segments[i].l >> segments[i].r;
    }
    auto lambda = [&](const Segment& a, const Segment& b) {
        return a.r < b.r;
    };
    sort(all(segments), lambda);
    int x = 0;

    vector<int> index;
    for (auto [l, r, ind] : segments) {
        if (l > x) {
            index.push_back(ind);
            x = r;
        }
    }
    m = (int)index.size();
    assert(m % 2 == 0);

    vector<int> ind_l;
    for (int i = 0; i < m; i += 2) {
        ind_l.push_back(index[i]);
    }
    vector<int> ind_r;
    for (int i = 1; i < m; i += 2) {
        ind_r.push_back(index[i]);
    }
//    for (int x : ind_l) {
//        cerr << x + 1 << ' ';
//    }
//    cerr << '\n';
//    for (int x : ind_r) {
//        cerr << x + 1 << ' ';
//    }
//    cerr << '\n';
    if (!run(segments, ind_l)) {
        assert(run(segments, ind_r));
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}