#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

pair<int, int> solve_k1(const vector<int> &as, int w) {
    int k = as.size();
    int mx_delta = 0;
    for (int i = 0; i < k - 1; i++) {
        mx_delta = max(mx_delta, as[i + 1] - as[i]);
    }
    mx_delta = max(mx_delta, as[0] + w - as[k - 1]);
    int mn_buttons = w;
    for (int i = 0; i < k - 1; i++) {
        if (as[i + 1] - as[i] == mx_delta) {
            mn_buttons = min(mn_buttons, as[i]);
            mn_buttons = min(mn_buttons, w + 1 - as[i + 1]);
        }
    }
    if (as[0] + w - as[k - 1] == mx_delta) {
        mn_buttons = 0;
    }
    return {w - mx_delta + 1, mn_buttons};
}

int main() {
    int h, w, k; cin >> h >> w >> k;
    vector<int> hs(k), ws(k);
    for (int i = 0; i < k; i++) {
        cin >> hs[i] >> ws[i];
    }
    sort(hs.begin(), hs.end());
    sort(ws.begin(), ws.end());
    auto tmp1 = solve_k1(hs, h);
    auto tmp2 = solve_k1(ws, w);
    cout << tmp1.first * 1ll * tmp2.first << ' ' << tmp1.second + tmp2.second << endl;
}
