#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct Block {
    int start, length;
    explicit Block() = default;
    Block(int start_, int length_) : start(start_), length(length_) {

    }

    const bool operator<(const Block &other) const {
        return start < other.start;
    }
};

void encode() {
    int n, k; cin >> n >> k;
    vector<int> as;
    for (int i = 0; i < k; i++) {
        int x; cin >> x; x--;
        as.push_back(x);
    }
    sort(as.begin(), as.end());
    set<Block> free_blocks;
    for (int i = 0; i < k; i++) {
        int b = as[(i + 1) % k];
        int a = as[i];
        free_blocks.insert(Block((a + 1) % n, ((b > a ? b - a - 1 : b + n - a - 1))));
    }
    vector<int> bs;
    for (int a : as) {
        while (true) {
            auto it = free_blocks.lower_bound(Block(a, 0));
            if (it == free_blocks.end()) {
                it = free_blocks.begin();
            }
            Block block = *it;
            free_blocks.erase(block);
            if (block.length != 0) {
                bs.push_back(block.start);
                block.start = (block.start + 1) % n;
                block.length--;
                free_blocks.insert(block);
                break;
            }
        }
    }
    for (int i : bs) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}

void decode() {
    int n, k; cin >> n >> k;
    vector<int> as;
    for (int i = 0; i < k; i++) {
        int x; cin >> x; x--;
        as.push_back(n - 1 - x);
    }
    sort(as.begin(), as.end());
    set<Block> free_blocks;
    for (int i = 0; i < k; i++) {
        int b = as[(i + 1) % k];
        int a = as[i];
        free_blocks.insert(Block((a + 1) % n, ((b > a ? b - a - 1 : b + n - a - 1))));
    }
    vector<int> bs;
    for (int a : as) {
        while (true) {
            auto it = free_blocks.lower_bound(Block(a, 0));
            if (it == free_blocks.end()) {
                it = free_blocks.begin();
            }
            Block block = *it;
            free_blocks.erase(block);
            if (block.length != 0) {
                bs.push_back(block.start);
                block.start = (block.start + 1) % n;
                block.length--;
                free_blocks.insert(block);
                break;
            }
        }
    }
    for (int i : bs) {
        cout << n - i << ' ';
    }
    cout << endl;
}

int main() {
    int t, m; cin >> t >> m;
    while (m--) {
        if (t == 1) {
            encode();
        } else if (t == 2) {
            decode();
        }
    }
}
