#include <iostream>
#include <vector>

using namespace std;
using Graph = vector<vector<int>>;

void calc_dp(const Graph &tree, int v, int p, vector<int> &values, vector<int64_t> &dp_take, vector<int64_t> &dp_no_take) {
    dp_take[v] = values[v];
    for (int u : tree[v]) {
        if (u != p) {
            calc_dp(tree, u, v, values, dp_take, dp_no_take);
            dp_no_take[v] += max(dp_take[u], dp_no_take[u]);
            dp_take[v] += dp_no_take[u];
        }
    }
}

int modmul(int x, int y, int m) {
    return (x * 1ll * y) % m;
}

void solve() {
    int n, q; cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    Graph tree(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u; cin >> v >> u; v--; u--;
        tree[v].push_back(u);
        tree[u].push_back(v);
    }
    vector<int> values(n);
    for (int i = 0; i < n; i++) {
        int l, r; cin >> l >> r;
        values[i] = l;
    }
    vector<int> vs(q);
    for (int &i : vs) {
        cin >> i;
    }
    vector<int64_t> dp_take(n), dp_no_take(n);
    calc_dp(tree, 0, -1, values, dp_take, dp_no_take);
    int64_t z = max(dp_take[0], dp_no_take[0]);
    int certificate = 0;
    for (int i = 0; i < n; i++) {
        certificate ^= (modmul(x, i + 1, m) + modmul(y, modmul(values[i], values[i], m), m)) % m;
    }
    for (int v : vs) {
        cout << (v == z ? certificate : -1) << endl;
    }
    int check; cin >> check;
    while (check != 0) {
        check--;
        if (vs[check] == z) {
            for (int v : values) {
                cout << v << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> check;
    }
}

int main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
