#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;

template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}

const int INF = 1e9 + 1;

si s;
vi a;
int n, k;
vi ans;

tuple<int, int, int, int> get(int l, int r) {
	int l1 = INF, r1 = -1, l0 = INF, r0 = -1;
	for (int i = l; i <= r; ++i) {
		if (a[i] == 1) {
			minravno(l1, i);
			maxravno(r1, i);
		}
		if (a[i] == 0) {
			minravno(l0, i);
			maxravno(r0, i);
		}
	}
	return { l0, r0, l1, r1 };
}

void find_pair1(int i) {
	auto [l0, r0, l1, r1] = get(0, i - 1);
	if (r0 == -1 && r1 == -1) {
		auto [t1, t2, t3, t4] = get(i + 1, n - 1);
		r0 = t2;
		r1 = t4;
		if (r1 > r0) {
			find_pair1(r1);
			find_pair1(i);
			return;
		}
		ans.push_back(r0);
		a[i] = 2;
		a[r0] = 2;
		s.erase(i);
		return;
	}
	if (r1 > r0) {
		find_pair1(r1);
		find_pair1(i);
		return;
	}
	ans.push_back(r0);
	a[i] = 2;
	a[r0] = 2;
	s.erase(i);
	return;
}

void find_pair2(int i) {
	auto [l0, r0, l1, r1] = get(i + 1, n - 1);
	if (l0 == INF && l1 == INF) {
		auto [t1, t2, t3, t4] = get(0, i - 1);
		l0 = t1;
		l1 = t3;
		if (l1 < l0) {
			find_pair2(l1);
			find_pair2(i);
			return;
		}
		ans.push_back(l0);
		a[i] = 2;
		a[l0] = 2;
		s.erase(i);
		return;
	}
	if (l1 < l0) {
		find_pair2(l1);
		find_pair2(i);
		return;
	}
	ans.push_back(l0);
	a[i] = 2;
	a[l0] = 2;
	s.erase(i);
	return;
}

void solve1() {
	cin >> n >> k;
	s.clear();
	a.assign(n, 0);
	ans.clear();
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		x--;
		s.insert(x);
		a[x] = 1;
	}
	while (s.size()) {
		find_pair1(*s.begin());
	}
	sort(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}

void solve2() {
	cin >> n >> k;
	s.clear();
	a.assign(n, 0);
	ans.clear();
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		x--;
		s.insert(x);
		a[x] = 1;
	}
	while (s.size()) {
		find_pair2(*s.begin());
	}
	sort(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int a;
	cin >> a;
	int t;
	cin >> t;
	while (t--) {
		if (a == 1)
			solve1();
		else
			solve2();
	}

	return 0;
}