#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;

template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}

const int INF = 1e9 + 1;

si s;
int n, k;
vi ans;
struct node {
	int l0, r0, l1, r1;
	node* l, * r;
	node(int l0_, int r0_, int l1_, int r1_) {
		l0 = l0_;
		r0 = r0_;
		r1 = r1_;
		l1 = l1_;
		l = r = nullptr;
	}
};

void update(node* v, int tl, int tr, int i, int x) {
	if (tr - tl == 1) {
		if (x == 1)
			v->l0 = INF, v->r0 = -1, v->l1 = v->r1 = i;
		else if (x == 0)
			v->l1 = INF, v->r1 = -1, v->l0 = v->r0 = i;
		else
			v->l0 = INF, v->r0 = -1, v->l1 = INF, v->r1 = -1;
	}
	else {
		int m = (tr + tl) / 2;
		if (!v->l)
			v->l = new node(tl, m - 1, INF, -1);
		if (!v->r)
			v->r = new node(m, tr - 1, INF, -1);
		if (i < m)
			update(v->l, tl, m, i, x);
		else
			update(v->r, m, tr, i, x);
		v->l0 = min(v->l->l0, v->r->l0);
		v->l1 = min(v->l->l1, v->r->l1);
		v->r0 = max(v->l->r0, v->r->r0);
		v->r1 = max(v->l->r1, v->r->r1);
	}
}

tuple<int, int, int, int> get(node* v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l)
		return { INF, -1, INF, -1 };
	if (l <= tl && r >= tr)
		return { v->l0, v->r0, v->l1, v->r1 };
	int m = (tr + tl) / 2;
	if (!v->l)
		v->l = new node(tl, m - 1, INF, -1);
	if (!v->r)
		v->r = new node(m, tr - 1, INF, -1);
	auto [ll0, lr0, ll1, lr1] = get(v->l, tl, m, l, r);
	auto [rl0, rr0, rl1, rr1] = get(v->r, m, tr, l, r);
	return { min(ll0, rl0), max(lr0, rr0), min(ll1, rl1), max(lr1, rr1) };
}
node* root = nullptr;

void find_pair1(int i) {
	auto [l0, r0, l1, r1] = get(root, 0, INF, 0, i);
	if (r0 == -1 && r1 == -1) {
		auto [t1, t2, t3, t4] = get(root, 0, INF, i + 1, n);
		r0 = t2;
		r1 = t4;
		if (r1 > r0) {
			find_pair1(r1);
			find_pair1(i);
			return;
		}
		ans.push_back(r0);
		update(root, 0, INF, i, 2);
		update(root, 0, INF, r0, 2);
		s.erase(i);
		return;
	}
	if (r1 > r0) {
		find_pair1(r1);
		find_pair1(i);
		return;
	}
	ans.push_back(r0);
	update(root, 0, INF, i, 2);
	update(root, 0, INF, r0, 2);
	s.erase(i);
	return;
}

void find_pair2(int i) {
	auto [l0, r0, l1, r1] = get(root, 0, INF, i + 1, n);
	if (l0 == INF && l1 == INF) {
		auto [t1, t2, t3, t4] = get(root, 0, INF, 0, i);
		l0 = t1;
		l1 = t3;
		if (l1 < l0) {
			find_pair2(l1);
			find_pair2(i);
			return;
		}
		ans.push_back(l0);
		update(root, 0, INF, i, 2);
		update(root, 0, INF, l0, 2);
		s.erase(i);
		return;
	}
	if (l1 < l0) {
		find_pair2(l1);
		find_pair2(i);
		return;
	}
	ans.push_back(l0);
	update(root, 0, INF, i, 2);
	update(root, 0, INF, l0, 2);
	s.erase(i);
	return;
}

void solve1() {
	cin >> n >> k;
	s.clear();
	ans.clear();
	root = new node(INF, -1, INF, -1);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		x--;
		s.insert(x);
		update(root, 0, INF, x, 1);
	}
	while (s.size()) {
		find_pair1(*s.begin());
	}
	sort(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}

void solve2() {
	cin >> n >> k;
	s.clear();
	ans.clear();
	root = new node(INF, -1, INF, -1);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		x--;
		s.insert(x);
		update(root, 0, INF, x, 1);
	}
	while (s.size()) {
		find_pair2(*s.begin());
	}
	sort(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int a;
	cin >> a;
	int t;
	cin >> t;
	while (t--) {
		if (a == 1)
			solve1();
		else
			solve2();
	}

	return 0;
}