#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;

mt19937 rnd(123);

template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}

const int INF = 1e9 + 1, MAXN = 1e4 + 10;

int dp[MAXN][MAXN];

struct fenvik {
	int n;
	vi a;

	fenvik(int n_ = 0) {
		n = n_;
		a.resize(n + 1, -INF);
	}

	void update(int i, int x) {
		if (!i)
			maxravno(a[i], x);
		else {
			for (; i <= n; i += i & -i)
				maxravno(a[i], x);
		}
	}

	int get(int i) {
		int res = -INF;
		for (; i >= 1; i -= i & -i)
			maxravno(res, a[i]);
		return max(res, a[0]);
	}
};

fenvik f1[MAXN], f2[MAXN];

int solve(int n, vi a) {
	for (int i = 0; i <= n + 1; ++i) {
		f1[i] = f2[i] = fenvik(n + 1);
		for (int j = 0; j <= n + 1; ++j)
			dp[i][j] = -INF;
	}
	dp[0][n + 1] = 0;
	f1[n + 1].update(0, 0);
	f2[0].update(0, 0);
	int mx = 0;
	for (auto i : a) {
		for (int j = 0; j <= n + 1; ++j) {
			if (j == i)
				continue;
			for (int k = 0; k < i; ++k)
				maxravno(dp[i][j], dp[k][j] + 1);
			for (int k = i + 1; k <= n + 1; ++k)
				maxravno(dp[j][i], dp[j][k] + 1);
		}
		for (int j = 0; j < i; ++j) {
			for (int k = i + 1; k <= n + 1; ++k)
				dp[i][j] = -INF;
		}
		for (int j = 0; j <= n + 1; ++j) {
			maxravno(mx, dp[i][j]);
			maxravno(mx, dp[j][i]);
		}
	}
	return mx;
}

int stupid(int n, vi a) {
	int ans = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		vi b, c;
		for (int i = 0; i < n; ++i) {
			if (mask >> i & 1)
				b.push_back(a[i]);
			else
				c.push_back(a[i]);
		}
		int mx = -1, mn = INF;
		int now = 0;
		for (auto i : b)
			if (maxravno(mx, i))
				now++;
		for (auto i : c)
			if (minravno(mn, i))
				now++;
		maxravno(ans, now);
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		if (0) {
			int n = rnd() % 7 + 1;
			vi a(n);
			iota(all(a), 1);
			shuffle(all(a), rnd);
			if (solve(n, a) != stupid(n, a)) {
				cout << n << ' ';
				print(a);
				return 0;
			}
		}
		else {
			int n;
			cin >> n;
			vi a(n);
			input(a);
			cout << solve(n, a) << '\n';
		}
	}

	return 0;
}