#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;

template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}

const int INF = 1e9 + 1, MAXN = 1e4 + 10;

int dp[MAXN][MAXN];

struct fenvik {
	int n;
	vi a;

	fenvik(int n_ = 0) {
		n = n_;
		a.resize(n + 1, 0);
	}

	void update(int i, int x) {
		for (; i <= n; i += i & -i)
			maxravno(a[i], x);
	}

	int get(int i) {
		int res = 0;
		for (; i >= 1; i -= i & -i)
			maxravno(res, a[i]);
		return res;
	}
};

fenvik f1[MAXN], f2[MAXN];

void solve() {
	int n;
	cin >> n;
	vi a(n);
	input(a);
	for (int i = 1; i <= n; ++i) {
		f1[i] = f2[i] = fenvik(n);
		for (int j = 1; j <= n; ++j)
			dp[i][j] = 0;
	}
	int mx = 0;
	for (auto i : a) {
		for (int j = 1; j <= n; ++j) {
			maxravno(dp[i][j], f1[j].get(i) + 1);
			maxravno(dp[j][i], f2[j].get(n - i + 1) + 1);
		}
		for (int j = 1; j <= n; ++j) {
			f1[j].update(i, dp[i][j]);
			f2[i].update(n - j + 1, dp[i][j]);
			f2[j].update(n - i + 1, dp[j][i]);
			f1[i].update(j, dp[j][i]);
			maxravno(mx, dp[i][j]);
			maxravno(mx, dp[j][i]);
		}
	}
	cout << mx << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}