#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <random>

using namespace std;

mt19937 rnd(228);


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;

template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}
template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

int get(vpi a) {
	int n = a.size();
	vi dp(4 * n + 1, 0);
	vvi b(4 * n + 1);
	for (auto [l, r] : a)
		b[r].push_back(l);
	for (int i = 1; i <= 4 * n; ++i) {
		dp[i] = dp[i - 1];
		for (auto j : b[i])
			maxravno(dp[i], dp[j - 1] + 1);
	}
	return dp[4 * n];
}

void solve() {
	int n;
	cin >> n;
	vpi a, a1;
	vi c = { 0 };
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		a1.push_back({ l, r });
		c.push_back(l);
		c.push_back(r);
	}
	sort(all(c));
	c.erase(unique(all(c)), c.end());
	map<int, int> m;
	for (int i = 0; i < c.size(); ++i)
		m[c[i]] = i;
	for (auto [l, r] : a1)
		a.push_back({ m[l], m[r] });
	int x = get(a);
	while (true) {
		vb used(n, false);
		for (int i = 0; i < n / 2; ++i) {
			int j = rnd() % n;
			while (used[j])
				j = rnd() % n;
			used[j] = true;
		}
		vpi na;
		for (int i = 0; i < n; ++i)
			if (!used[i])
				na.push_back(a[i]);
		if (get(na) == x / 2) {
			for (int i = 0; i < n; ++i)
				if (!used[i])
					cout << i + 1 << ' ';
			cout << '\n';
			return;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}