#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef tuple<int, int, int> ti;
typedef set<ti> sti;

template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}
template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const int MAXN = 2e5 + 10, INF = 1e18;

vi g[MAXN];
int dp[MAXN][2];
vi a;

void dfs(int v, int p = -1) {
	dp[v][1] = a[v];
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v);
			dp[v][0] += max(dp[u][0], dp[u][1]);
			dp[v][1] += dp[u][0];
		}
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	a.assign(n + 1, 0);
	int x, y, m;
	cin >> x >> y >> m;
	for (int i = 1; i <= n; ++i)
		cin >> a[i] >> a[i];
	int k = 0;
	for (int i = 1; i <= n; ++i)
		k ^= ((x * i + y * a[i] * a[i]) % m);
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	vi v(q);
	input(v);
	for (auto i : v)
		if (i == max(dp[1][0], dp[1][1]))
			cout << k << ' ';
		else
			cout << -1 << ' ';
	cout << endl;
	int i;
	cin >> i;
	while (i) {
		if (v[i] == max(dp[1][0], dp[1][1])) {
			for (int j = 1; j <= n; ++j)
				cout << a[j] << ' ';
			cout << endl;
		}
		else
			cout << -1 << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}