#include <bits/stdc++.h>
using namespace std;

typedef pair<int, int> STinput;
typedef vector<STinput> ST;

STinput add(STinput a, STinput b) {
    return max(a, b);
}

const STinput zero({0, 0});

int powround(int x) {
    int y(1);
    while (y < x) {
        y *= 2;
    }
    return y;
}

void build(ST& tree, int n) {
    tree.assign(powround(n) * 2, zero);
}

void add(ST& tree, int pos, STinput v) {
    int x(pos + tree.size() / 2);
    tree[x] = add(tree[x], v);
    while (x > 1) {
        x /= 2;
        tree[x] = add(tree[2 * x], tree[2 * x + 1]);
    }
}

STinput isum(ST& tree, int lq, int rq, int l, int r, int x) {
    //cout << lq << " " << rq << " " << l << " " << r << endl;
    if ((lq >= r) || (l >= rq)) {
        return zero;
    }
    if ((lq <= l) && (r <= rq)) {
        return tree[x];
    }
    int m((l + r) / 2);
    return add(isum(tree, lq, rq, l, m, 2 * x), isum(tree, lq, rq, m, r, 2 * x + 1));
}

STinput sum(ST& tree, int lq, int rq) {
    return isum(tree, lq, rq, 0, tree.size() / 2, 1);
}

vector<int> records(vector<int>& p, int n) {
    ST tree;
    build(tree, n);
    vector<int> res(n);
    for (int i = n - 1; i >= 0; i--) {
        int restree(sum(tree, p[i], n).first);
        res[i] = restree + 1;
        //cout << restree << endl;
        add(tree, p[i], {restree + 1, 0}); //time *2, code /2
    }
    return res;
}

vector<int> antirecords(vector<int>& p, int n) {
    ST tree;
    build(tree, n);
    vector<int> res(n);
    for (int i = n - 1; i >= 0; i--) {
        int restree(sum(tree, 0, p[i]).first);
        res[i] = restree + 1;
        add(tree, p[i], {restree + 1, 0}); //time *2, code /2
    }
    return res;
}

vector<pair<int, int>> grecords(vector<int>& q, int n) {
    ST tree;
    build(tree, n);
    vector<pair<int, int>> res(n);
    for (int i = 0; i < n; i++) {
        pair<int, int> restree(sum(tree, 0, q[i]));
        res[i] = {restree.first - 1, restree.second + 1};
        add(tree, q[i], {i + 1, restree.second + 1});
    }
    return res;
}

vector<pair<int, int>> gantirecords(vector<int>& q, int n) {
    ST tree;
    build(tree, n);
    vector<pair<int, int>> res(n);
    for (int i = n - 1; i >= 0; i--) {
        pair<int, int> restree(sum(tree, 0, q[i]));
        res[i] = {n - restree.first, restree.second + 1};
        add(tree, q[i], {n - i, restree.second + 1});
    }
    return res;
}

int result(vector<int>& p, int n) {
    vector<int> q(n);
    for (int i = 0; i < n; i++) {
        q[p[i]] = i;
    }
    vector<int> recs(records(p, n)), antirecs(antirecords(p, n));
    vector<pair<int, int>> grecs(grecords(q, n)), gantirecs(gantirecords(q, n));
    /*for (auto i : recs) {
        cout << i << " ";
    }
    cout << endl;
    for (auto i : antirecs) {
        cout << i << " ";
    }
    cout << endl;
    for (auto i : grecs) {
        cout << i.first << " " << i.second << " ";
    }
    cout << endl;
    for (auto i : gantirecs) {
        cout << i.first << " " << i.second << " ";
    }
    cout << endl;*/
    int res(0);
    for (int i = 0; i < n; i++) {
        pair<int, int> rec(grecs[p[i]]);
        pair<int, int> arec(gantirecs[p[i]]);
        //record rec.first, antirecord i
        //cout << i << " " << rec.second << " " << arec.second << " " << recs[i] << " " << antirecs[i] << endl;
        int restmp(rec.second + arec.second + recs[i] + antirecs[i] - 3);
        res = max(res, restmp);
    }
    return res;
}

int main() {
    int t, q;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            cin >> q;
            q--;
            p[i] = q;
        }
        cout << result(p, n) << endl;
    }
}
