#include <bits/stdc++.h>
using namespace std;

typedef pair<int, int> STinput;
typedef vector<STinput> ST;

STinput add(STinput a, STinput b) {
    return max(a, b);
}

const STinput zero({0, 0});

int powround(int x) {
    int y(1);
    while (y < x) {
        y *= 2;
    }
    return y;
}

void build(ST& tree, int n) {
    tree.assign(powround(n) * 2, zero);
}

void add(ST& tree, int pos, STinput v) {
    int x(pos + tree.size() / 2);
    tree[x] = add(tree[x], v);
    while (x > 1) {
        x /= 2;
        tree[x] = add(tree[2 * x], tree[2 * x + 1]);
    }
}

STinput isum(ST& tree, int lq, int rq, int l, int r, int x) {
    //cout << lq << " " << rq << " " << l << " " << r << endl;
    if ((lq >= r) || (l >= rq)) {
        return zero;
    }
    if ((lq <= l) && (r <= rq)) {
        return tree[x];
    }
    int m((l + r) / 2);
    return add(isum(tree, lq, rq, l, m, 2 * x), isum(tree, lq, rq, m, r, 2 * x + 1));
}

STinput sum(ST& tree, int lq, int rq) {
    return isum(tree, lq, rq, 0, tree.size() / 2, 1);
}

void records(vector<int>& p, int n, vector<vector<int>>& questions) {
    ST tree;
    build(tree, n);
    vector<int> res(n);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < questions[i].size(); j++) {
            //cout << i << " " << j << " " << questions[i][j] << "!" << endl;
            if (questions[i][j] >= 0) {
                questions[i][j] = sum(tree, questions[i][j], n).first;
                //cout << i << " " << j << " " << questions[i][j] << "!!" << endl;
            } else {
                questions[i][j] = -1000000;
            }
        }
        int restree(sum(tree, p[i], n).first);
        res[i] = restree + 1;
        add(tree, p[i], {restree + 1, 0}); //time *2, code /2
    }
}

void antirecords(vector<int>& p, int n, vector<vector<int>>& questions) {
    ST tree;
    build(tree, n);
    vector<int> res(n);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < questions[i].size(); j++) {
            if (questions[i][j] < n) {
                questions[i][j] = sum(tree, 0, questions[i][j] + 1).first;
            } else {
                questions[i][j] = -1000000;
            }
        }
        int restree(sum(tree, 0, p[i]).first);
        res[i] = restree + 1;
        add(tree, p[i], {restree + 1, 0}); //time *2, code /2
    }
}

vector<pair<int, int>> grecords(vector<int>& q, int n) {
    ST tree;
    build(tree, n);
    vector<pair<int, int>> res(n);
    for (int i = 0; i < n; i++) {
        pair<int, int> restree(sum(tree, 0, q[i]));
        res[i] = {restree.first - 1, restree.second + 1};
        add(tree, q[i], {i + 1, restree.second + 1});
    }
    return res;
}

vector<pair<int, int>> gantirecords(vector<int>& q, int n) {
    ST tree;
    build(tree, n);
    vector<pair<int, int>> res(n);
    for (int i = n - 1; i >= 0; i--) {
        pair<int, int> restree(sum(tree, 0, q[i]));
        res[i] = {n - restree.first, restree.second + 1};
        add(tree, q[i], {n - i, restree.second + 1});
    }
    return res;
}

int result(vector<int>& p, int n) {
    vector<int> q(n);
    for (int i = 0; i < n; i++) {
        q[p[i]] = i;
    }
    //vector<int> recs(records(p, n)), antirecs(antirecords(p, n));
    vector<vector<int>> questions(n, vector<int>(0)), antiquestions(n, vector<int>(0));
    vector<pair<int, int>> grecs(grecords(q, n)), gantirecs(gantirecords(q, n));
    /*for (auto i : recs) {
        cout << i << " ";
    }
    cout << endl;
    for (auto i : antirecs) {
        cout << i << " ";
    }
    cout << endl;
    for (auto i : grecs) {
        cout << i.first << " " << i.second << " ";
    }
    cout << endl;
    for (auto i : gantirecs) {
        cout << i.first << " " << i.second << " ";
    }
    cout << endl;*/
    int res(0);
    for (int i = 0; i < n; i++) {
        pair<int, int> rec(grecs[p[i]]);
        pair<int, int> arec(gantirecs[p[i]]);
        //cout << i << " " << rec.second << " " << arec.second << " " << recs[i] << " " << antirecs[i] << endl;
        //cout << p[i] << " " << rec.first << " " << arec.first << endl;
        questions[i].push_back(p[i]);
        antiquestions[i].push_back(p[i]);
        questions[i].push_back(rec.first);
        antiquestions[i].push_back(rec.first);
        questions[i].push_back(arec.first);
        antiquestions[i].push_back(arec.first);
    }
    records(p, n, questions);
    antirecords(p, n, antiquestions);
    for (int i = 0; i < n; i++) {
        pair<int, int> rec(grecs[p[i]]);
        pair<int, int> arec(gantirecs[p[i]]);
        //cout << i << " " << rec.second << " " << arec.second << endl;
        int res2(-10000000);
        //cout << questions[i][0] << " " << questions[i][1] << " " << questions[i][2] << endl;
        //cout << antiquestions[i][0] << " " << antiquestions[i][1] << " " << antiquestions[i][2] << endl;
        res2 = max(res2, questions[i][0] + antiquestions[i][0]);
        res2 = max(res2, questions[i][1] + antiquestions[i][1]);
        res2 = max(res2, questions[i][2] + antiquestions[i][2]);
        res = max(res, res2 + rec.second + arec.second - 1);
    }
    return res;
}

int main() {
    int t, q;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            cin >> q;
            q--;
            p[i] = q;
        }
        cout << result(p, n) << endl;
    }
}
