#include<bits/stdc++.h>

#define ll lon long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

using namespace std;

mt19937 rnd(51);

const int INF = 1e9;

struct SegTree {
    vector<int> t;
    int n;
    SegTree(int n_) {
        n = 1;
        while (n < n_) {
            n *= 2;
        }
        t.resize(2 * n, -INF);
    }
    void upd(int i, int val) {
        i += n;
        t[i] = val;
        for (; i > 1; i /= 2) {
            t[i / 2] = max(t[i], t[i ^ 1]);
        }
    }
    int get(int l, int r) {
        int ans = -INF;
        l += n, r += n;
        while (l < r) {
            if (l & 1) {
                ans = max(ans, t[l++]);
            }
            if (r & 1) {
                ans = max(ans, t[--r]);
            }
            l /= 2, r /= 2;
        }
        return ans;
    }
};

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            cin >> p[i];
        }
        vector<vector<int>> dp(n + 2, vector<int>(n + 2, -INF));
        dp[0][n + 1] = 0;
        for (int i = 0; i < n; i++) {
            vector<array<int, 3>> upd;
            for (int r = 0; r <= n + 1; r++) {
                int mx = -INF;
                for (int l = 0; l < p[i]; l++) {
                    mx = max(mx, dp[l][r]);
                }
                upd.pb({p[i], r, mx + 1});
            }
            for (int l = 0; l <= n + 1; l++) {
                int mx = -INF;
                for (int r = n + 1; r > p[i]; r--) {
                    mx = max(mx, dp[l][r]);
                }
                upd.pb({l, p[i], mx + 1});
            }
            for (auto [l, r, val] : upd) {
                dp[l][r] = val;
            }
            for (int l = 0; l <= n + 1; l++) {
                for (int r = 0; r <= n + 1; r++) {
                    if (l < p[i] && p[i] < r) {
                        dp[l][r] = -INF;
                    }
                }
            }
        }
        int mx = 0;
        for (int i = 0; i <= n + 1; i++) {
            for (int j = 0; j <= n + 1; j++) {
                mx = max(mx, dp[i][j]);
            }
        }
        cout << mx << endl;
    }
    return 0;
}
