#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define ld long double

using namespace std;

const int INF = 1e9;

mt19937 rnd(51);

int get_ans(vector<array<int, 3>> u) {
    sort(all(u));
    int n = u.size();
    vector<int> dp(n), par(n, -1);
    for (int i = 0; i < n; i++) {
        dp[i] = 1;
        for (int j = 0; j < i; j++) {
            if (u[j][1] < u[i][0]) {
                if (dp[j] + 1 > dp[i]) {
                    par[i] = j;
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    return *max_element(all(dp));
}

vector<int> stupid_solve(int n, vector<array<int, 3>> u) {
    int m = get_ans(u);
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) != n / 2) continue;
        vector<array<int, 3>> s;
        vector<int> mas;
        for (int b = 0; b < n; b++) {
            if (mask & (1 << b)) {
                s.pb(u[b]);
                mas.pb(b);
            }
        }
        if (get_ans(s) == m / 2) {
            return mas;
        }
    }
    assert(0);
}

vector<int> get_mas(vector<array<int, 3>> u, int need) {
    sort(all(u));
    int n = u.size();
    vector<int> dp(n), par(n, -1);
    for (int i = 0; i < n; i++) {
        dp[i] = 1;
        for (int j = 0; j < i; j++) {
            if (u[j][1] < u[i][0]) {
                if (dp[j] + 1 > dp[i]) {
                    par[i] = j;
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    int j = 0;
    for (int i = 0; i < n; i++) {
        if (dp[i] > dp[j]) {
            j = i;
        }
    }
    vector<bool> used(n);
    vector<int> mas;
    while (j >= 0) {
        mas.pb(u[j][2]);
        used[j] = 1;
        j = par[j];
    }
    for (int i = 0; i < n && mas.size() < need; i++) {
        if (!used[i]) {
            mas.pb(u[i][2]);
        }
    }
    return mas;
}

const ll big_INF = 1e18;

vector<int> smart_solve(int n, vector<array<int, 3>> u) {
    int m = get_ans(u);
    u.pb({-1, -1, -1});
    n++;
    sort(all(u), [&](array<int, 3> a, array<int, 3> b){return a[1] < b[1];});
    vector<int> arr;
    auto solve = [&](ld dec, bool need) -> pair<ll, ll> {
        vector<ld> dp(n + 1, big_INF);
        vector<int> cnt(n + 1, INF), par(n, -1);
        dp[0] = cnt[0] = 0;
        vector<int> val(n);
        ld bst = big_INF;
        int cnt_bst = -1, pos = -1;
        for (int i = 1; i < n; i++) {
            if (i > 0 && u[i - 1][1] < u[i][1]) {
                for (int j = i - 1; j >= 0 && u[i - 1][1] == u[j][1]; j--) {
                    for (int k = 0; k < i; k++) {
                        if (u[k][1] < u[j][0]) {
                            val[k]++;
                        }
                    }
                }
            }
            for (int k = 0; k < i; k++) {
                if (u[k][1] >= u[i][0]) continue;
                if (dp[k] + dec + val[k] + 0.0000001 < dp[i] || (dp[k] + dec + val[k] + 0.0000001 == dp[i] && cnt[k] + 1 > cnt[i])) {
                    dp[i] = dp[k] + dec + val[k] + 0.0000001;
                    cnt[i] = cnt[k] + 1;
                    par[i] = k;
                }
            }
            int kek = 0;
            for (int j = 0; j < n; j++) {
                if (u[j][0] > u[i][1]) {
                    kek++;
                }
            }
            if (dp[i] + kek < bst || (bst == dp[i] + kek && cnt[i] > cnt_bst)) {
                bst = dp[i] + kek;
                cnt_bst = cnt[i];
                pos = i;
            }
        }
        if (need) {
            while (pos >= 0) {
                arr.pb(pos);
                pos = par[pos];
            }
        }
        return {bst, cnt_bst};
    };
    ld l = 0, r = INF;
    for (int i = 0; i < 100; i++) {
        ld mid = (r + l) / 2;
        if (solve(mid, 0).second >= m / 2) {
            l = mid;
        } else {
            r = mid;
        }
    }
    solve(l, 1).first;
    reverse(all(arr));
    vector<bool> used(n);
    for (int j = 0; j + 1 < arr.size(); j++) {
        for (int k = 0; k < n; k++) {
            if (u[arr[j]][1] < u[k][0] && u[k][1] < u[arr[j + 1]][1]) {
                used[k] = 1;
            }
        }
    }
    vector<array<int, 3>> s;
    for (int k = 1; k < n; k++) {
        if (u[k][0] > u[arr.back()][1]) continue;
        if (!used[k]) {
            s.pb(u[k]);
        }
    }
    return get_mas(s, n / 2);
    assert(0);
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    while (0) {
        int n = rnd() % 6 + 1;
        if (n % 2 == 1) {
            continue;
        }
        vector<array<int, 3>> u;
        for (int i = 0; i < n; i++) {
            int l = rnd() % n, r = rnd() % n;
            if (l > r) swap(l, r);
            u.pb({l, r, i});
        }
        int m = get_ans(u);
        if (m % 2 == 1 || m == 2) continue;
        cout << n << ' '  << m << endl;
        for (auto to : u) {
            cout << to[0] << ' ' << to[1] << ' ' << to[2] << endl;
        }
        vector<int> arr = smart_solve(n, u);
        cout << "KEk" << arr.size() << endl;
        assert(arr.size() == n / 2);
        vector<array<int, 3>> kek;
        for (auto i : arr) {
            kek.pb(u[i]);
        }
        cout << "Ind" << endl;
        for (auto to : arr) {
            cout << to << ' ';
        }
        cout << endl;
        cout << "need " << get_ans(kek) << ' ' << m / 2 << endl;
        assert(get_ans(kek) == m / 2);
    }
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<array<int, 3>> u(n);
        for (int i = 0; i < n; i++) {
            cin >> u[i][0] >> u[i][1];
            u[i][2] = i;
        }
        auto arr = smart_solve(n, u);
        for (auto to : arr) {
            cout << to + 1 << ' ';
        }
        cout << endl;
    }
    return 0;
}
