#pragma GCC optimize("Ofast,inline,unroll-loops")
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native,popcnt,fma")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int int_fast32_t
#define all(a) (a).begin(), (a).end()

const ll INF64 = 2'000'000'000'000'000'228;
const int INF = 2'000'000'228;

struct point {
    bool open;
    int x, ind;
};

bool operator<(point a, point b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.open > b.open;
}

pair<vector<int>, vector<int>> scanline(const vector<pair<int, int>> &segs, const vector<bool> &used) {
    vector<point> p;
    for (int i = 0; i < segs.size(); ++i) {
        if (!used[i]) {
            p.push_back({true, segs[i].first, i});
            p.push_back({false, segs[i].second, i});
        }
    }
    sort(all(p));
    int best = 0, ind = -1;
    vector<int> parent(segs.size(), -1), ans(segs.size(), -1);
    for (auto &i: p) {
        if (i.open) {
            ans[i.ind] = best + 1;
            parent[i.ind] = ind;
        } else if (ans[i.ind] > best) {
            best = ans[i.ind];
            ind = i.ind;
        }
    }
    return {ans, parent};
}

pair<int, int> check1(const vector<int> &ans, const vector<bool> &used) {
    int m = 0, ind = -1;
    for (int i = 0; i < ans.size(); ++i) {
        if (m <= ans[i] && !used[i]) {
            m = ans[i];
            ind = i;
        }
    }
    return {m, ind};
}

bool solve_1(const vector<pair<int, int>> &segs) {
    int n = segs.size();
    vector<bool> used(n, false);
    auto q = scanline(segs, used);
    auto ans = q.first, parent = q.second;
    auto h = check1(ans, used);
    auto m_need = h.first, ind = h.second;
    int m_now = m_need, del = 0;
    m_need /= 2;
    while (m_now > m_need && del < n / 2) {
        used[ind] = true;
        q = scanline(segs, used), ans = q.first, parent = q.second;
        h = check1(ans, used), m_now = h.first, ind = h.second;
        ++del;
    }
    if (del < n / 2) {
        vector<bool> in_ans(n, false);
        int i = ind;
        while (i != -1) {
            in_ans[i] = true;
            i = parent[i];
        }
        for (int j = 0; j < n && del < n / 2; ++j) {
            if (!used[j] && !in_ans[j]) {
                used[j] = true;
                ++del;
            }
        }
    }
    q = scanline(segs, used), ans = q.first, parent = q.second;
    h = check1(ans, used), m_now = h.first, ind = h.second;
    if (m_now == m_need) {
        for (int i = 0; i < n; ++i)
            if (!used[i])
                cout << i + 1 << ' ';
        cout << '\n';
        return true;
    }
    return false;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<int, int>> segs(n);
        for (auto &i : segs)
            cin >> i.first >> i.second;
        if (solve_1(segs))
            continue;
        for (auto &i : segs) {
            auto p = i;
            i.first = INF - p.second, i.second = INF - p.first;
        }
        solve_1(segs);
    }
    return 0;
}
