﻿#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

struct CartTree {
	vector<int> elems;
	void take(vector<int>& a) {
		a = elems;
	}
	void insert(int x) {
		elems.push_back(x);
	}
	int count_less(int x) {
		int res = 0;
		for (int y : elems) res += y < x;
		return res;
	}
	int size() {
		return elems.size();
	}
};

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, k, q;
	cin >> n >> k >> q; 
	vector<int> turns(n);
	vector<vector<int>> g(n);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		for (int j = 0; j < t; ++j) {
			int v;
			cin >> v, --v;
			g[i].push_back(v);
		}
	}
	function<void(int, int)> Dfs = [&](int v, int d) {
		if (g[v].empty()) {
			return;
		}
		for (int j = 0; j < 2; ++j) {
			int u = g[v][j];
			turns[u] = turns[v] + (j != d && d != -1);
			Dfs(u, j);
		}
	};
	Dfs(0, -1);
	for (int x : turns) cout << x << ' ';
	cout << endl;
	vector<vector<int>> qries(n);
	for (int g = 0; g < q; ++g) {
		int v;
		cin >> v, --v;
		qries[v].emplace_back(g);
	}
	vector<int> answers(q);
	vector<int> id(n);
	vector<int> delta(n);
	vector<CartTree> cts(n);
 	function<void(int, int)> Dfs1 = [&](int v, int d) {
		id[v] = v;
		if (g[v].empty()) {
			cts[id[v]].insert(0);
			delta[id[v]] = 0;
			return;
		}
		for (int j = 0; j < 2; ++j) {
			int u = g[v][j];
			Dfs1(u, j);
			if (j != d && d != -1) {
				delta[id[u]] += 1;
			}
	  /*	if (cts[id[u]].size() > cts[id[v]].size()) {
	  		swap(id[u], id[v]);
	  	} */
	  	vector<int> vals;
	  	cts[id[u]].take(vals);
	  	for (int x : vals) {
	  		cts[id[v]].insert(x + delta[id[u]] - delta[id[v]]);
	  	}	
		}
		vector<int> vals;
		cts[id[v]].take(vals);
		cout << v << ": ";
		for (int x : vals) cout << x + delta[id[v]] << ' ';
		cout << endl;
		for (int q_id : qries[v]) {
			answers[q_id] = cts[id[v]].count_less(k - turns[v] - delta[id[v]] + 1);
		}
	};
	Dfs1(0, -1);
	for (int i = 0; i < q; ++i) {
		cout << answers[i] << ' ';
	}
	cout << '\n';
	return 0;
}	