#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;

void input(int& n, int& k, vi& a) {
    cin >> n >> k;
    a.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
}

ostream& operator<<(ostream& out, const vi& a) {
    for (int i : a) {
        out << i << ' ';
    }
    return out;
}

void gr1_5() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int i = 0; i < k; ++i) {
        cout << a[i] + 1 << ' ';
    }
    cout << endl;
}

void gr2_5() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int i = 0; i < k; ++i) {
        cout << a[i] - 1 << ' ';
    }
    cout << endl;
}

void gr3() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int i = 1; i < a[0]; ++i) {
        cout << i << ' ';
    }
    for (int i = 1; i < k; ++i) {
        for (int j = a[i - 1] + 1; j < a[i]; ++j) {
            cout << j << ' ';
        }
    }
    for (int i = a.back() + 1; i <= n; ++i) {
        cout << i << ' ';
    }
    cout << endl;
}

int congruent(int r, int mod) {
    r %= mod;
    if (r == 0) {
        r = mod;
    }
    return r;
}

void gr1_6() {
    int n, k;
    vi a;
    input(n, k, a);

    int d = n / 2;

    for (int i = 0; i < k; ++i) {
        a[i] = congruent(a[i] + d, n);
    }
    sort(a.begin(), a.end());
    cout << a;
    cout << endl;
}

void gr2_6() {
    int n, k;
    vi a;
    input(n, k, a);

    int d = n / 2;

    for (int i = 0; i < k; ++i) {
        a[i] = congruent(a[i] + n - d, n);
    }
    sort(a.begin(), a.end());
    cout << a;
    cout << endl;
}

vi p(int n, const vi& a) {
    vi c(n + 1, 0), res;
    for (int i : a) {
        c[i] = 1;
    }
    int sum = 0;
    for (int i = 1; i <= n; ++i) {
        if (c[i] == 1) {
            ++sum;
        } else if (sum != 0) {
            c[i] = -1;
            --sum;
            res.push_back(i);
        }
    }
    return res;
}

void gr1_7() {
    int n, k;
    vi a;
    input(n, k, a);

    cout << p(n, a);
    cout << endl;
}

void gr2_7() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int& i : a) {
        i = n + 1 - i;
    }
    reverse(a.begin(), a.end());
    vi b = p(n, a);
    for (int& i : b) {
        i = n + 1 - i;
    }
    reverse(b.begin(), b.end());
    cout << b;
    cout << endl;
}

void solve1() {
    int m;
    cin >> m;
    for (; m; --m) {
        gr1_7();
    }
}

void solve2() {
    int m;
    cin >> m;
    for (; m; --m) {
        gr2_7();
    }
}

int main() {
    int a;
    cin >> a;
    if (a == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}
