#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vi = vector<int>;
using vvi = vector<vi>;

const int A = 300, B = 300, MAXN = 100;
const string yes = "Yes\n", no = "No\n";

int dp[MAXN + 1][A + 1][B + 1];
void precalc(int n, const vll& w) {
    for (int i0 = 0; i0 < MAXN; ++i0) {
        for (int i = 0; i <= A; ++i) {
            for (int j = 0; j <= B; ++j) {
                dp[i0][i][j] = 0;
            }
        }
    }

    dp[0][0][0] = 1;
    for (int i0 = 1; i0 <= n; ++i0) {
        ll apple = w[i0 - 1];
        for (int i = 0; i <= A; ++i) {
            for (int j = 0; j <= B; ++j) {
                dp[i0][i][j] = dp[i0 - 1][i][j];
                if (apple <= i) {
                    dp[i0][i][j] = max(dp[i0][i][j], dp[i0 - 1][i - apple][j]);
                }
                if (apple <= j) {
                    dp[i0][i][j] = max(dp[i0][i][j], dp[i0 - 1][i][j - apple]);
                }
            }
        }
    }

    for (int i0 = 1; i0 <= n; ++i0) {
        for (int i = 0; i <= A; ++i) {
            for (int j = 0; j <= B; ++j) {
                if (i > 0) {
                    dp[i0][i][j] = min(dp[i0][i - 1][j], dp[i0][i][j]);
                }
                if (j > 0) {
                    dp[i0][i][j] = min(dp[i0][i][j], dp[i0][i][j - 1]);
                }
            }
        }
    }
}

bool query(ll k, ll a, ll b, const vll& w) {
    int ind = upper_bound(w.begin(), w.end(), k) - w.begin();
    return dp[ind][a][b];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q, z;
    ll j, c, d;
    cin >> n >> q;
    vll w(n);
    for (ll& i : w) {
        cin >> i;
    }
    sort(w.begin(), w.end());
    cin >> z;

    precalc(n, w);

    ll v = 0;
    for (int it = 1; it <= q; ++it) {
        cin >> j >> c >> d;
        ;
        if (query(j - v * z, c - v * z, d - v * z, w)) {
            v += it;
            cout << yes;
        } else {
            cout << no;
        }
    }

    return 0;
}
