#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <iostream>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
vector<ll> b;

ll get(ll a) {
	return lower_bound(b.begin(), b.end(), a) - b.begin();
}

struct segtree {
	vector<ll> tree;
	ll size = 1;
	void init(ll n) {
		while (size < n) size *= 2;
		tree.assign(size * 2 - 1, 0);
	}
	void upd(ll ind, ll val, ll x, ll lx, ll rx) {
		if (rx - lx == 1) {
			tree[x] = val;
			return;
		}
		ll m = (lx + rx) / 2;
		if (ind < m) upd(ind, val, x * 2 + 1, lx, m);
		else upd(ind, val, x * 2 + 2, m, rx);
		tree[x] = max(tree[x * 2 + 1], tree[x * 2 + 2]);
	}
	void upd(ll ind, ll val) {
		upd(ind, val, 0, 0, size);
	}
	ll qry(ll l, ll r, ll x, ll lx, ll rx) {
		if (l >= rx || r <= lx) return 0;
		if (l <= lx && rx <= r) return tree[x];
		ll m = (lx + rx) / 2;
		return  max(qry(l, r, x * 2 + 1, lx, m), qry(l, r, x * 2 + 2, m, rx));
	}
	ll qry(ll l, ll r) {
		return qry(l, r, 0, 0, size);
	}
};

void solve() {
	ll n; cin >> n;
	vector<pair<pair<ll, ll>, ll>> a(n);
	b.clear();
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first.first >> a[i].first.second; 
		a[i].second = i;
		b.push_back(a[i].first.first);
		b.push_back(a[i].first.second);
	}
	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	segtree st;
	st.init(2  * n);
	ll res = 0;
	for (int i = 0; i < n; ++i) {
		ll ind = get(a[i].first.first);
		ll ind2 = get(a[i].first.second);
		ll mx = st.qry(0, ind);
		st.upd(ind2, mx + 1);
		res = max(res, mx + 1);
	}
	if (res == n) {
		for (int i = 0; i < n / 2; ++i) cout << i + 1 << " ";
		cout << '\n';
		return;
	}
	res /= 2;
	for (int i = 0; i < n; ++i) swap(a[i].first.first, a[i].first.second);
	sort(a.begin(), a.end());
	vector<vector<ll>> cnt(n, vector<ll>(n, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (a[i].first.first >= a[j].first.second) {
				cnt[i][j] = 1;
				cnt[j][i] = 1;
			}
		}
	}
	vector<ll> dp(n, 1);
	vector<ll> prf(n, -1);
	vector<vector<ll>> w = cnt;
	for (int i = 0; i < n; ++i) {
		ll now = 0;
		for (int c = 0; c < n; ++c) if (cnt[i][c]) ++now;
		ll mx = 0;
		for (int j = 0; j < i; ++j) {
			if (a[j].first.first >= a[i].first.second) break;
			if (dp[j] == res) continue;
			ll count = 0;
			for (int c = 0; c < n; ++c) {
				if (cnt[i][c] || w[j][c]) ++count;
			}
			if (dp[j] + 1 > dp[i] || (dp[j] + 1 == dp[i] && now < count)) {
				dp[i] = dp[j] + 1;
				prf[i] = j;
				now = 0;
				for (int c = 0; c < n; ++c) {
					if (cnt[i][c] || w[j][c]) {
						++now;
						w[i][c] = 1;
					}
					else w[i][c] = 0;
				}
			}
		}
	}
	vector<ll> ans;
	ll tk = res;
	for (int i = 0; i < n; ++i) {
		if (dp[i] < res) continue;
		ll count = 0;
		for (int j = 0; j < n; ++j) count += w[i][j];
		if (count >= n / 2 - res) {
			ll now = i;
			while (now != -1) {
				ans.push_back(a[now].second + 1);
				now = prf[now];
			}
			for (int j = 0; j < n; ++j) {
				if (w[i][j] && tk < n / 2) {
					ans.push_back(a[j].second + 1);
					++tk;
				}
			}
			break;
		}
	}
	for (ll w : ans) cout << w << " ";
	cout << '\n';
}

int main(){
	ios::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	ll tc;
	cin >> tc;
	while (tc--) {
		solve();
	}
}
