// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2")
  
#include <bits/stdc++.h>
   
#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#define showTest(x) cout << "_____TEST #" << x << "_____\n";
#else
#define dbg(x)
#define showTest(x)
#endif
   
using namespace std;
   
using ll = long long;
using ld = long double;
   
template <class A> 
inline bool umin(A& x, const A&y) {
    if (x <= y) return false;
    x = y;
    return true;
}
   
template <class A>
inline bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}
   
// #define int ll
#define sz(x) int((x).size())
  
mt19937 rnd(101);

int pw(int a, int n) {
    int res = 1;
    for (int i = 0; i < n; ++i) {
        res *= a;
    }
    return res;
}

void gen(int n, int i, vector<char> cur, vector<int>& l, vector<int>& r, vector<vector<char>>& res) {
    if (sz(cur) == n) {
        res.push_back(cur);
    } else {
        for (int j = l[i]; j <= r[i]; ++j) {
            cur.push_back(j);
            gen(n, i + 1, cur, l, r, res);
            cur.pop_back();
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;

    ll x, y, m;
    cin >> x >> y >> m;

    auto calc = [&](vector<char> a) -> ll {
        ll k = 0;
        for (int i = 0; i < n; ++i) {
            k ^= ((x * (i + 1) % m + y * a[i] % m * a[i] % m) % m);
        }
        return k;
    };

    vector con(n, vector<bool>(n));
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        con[u][v] = con[v][u] = true;
    }

    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }

    vector<vector<char>> plans;
    vector<int> cur;
    gen(n, 0, cur, l, r, plans);
    vector<int> best(sz(plans));

    dbg(plans);

    map<int, int> mp;

    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> act;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) {
                act.push_back(i);
            }
        }

        bool ok = true;
        for (int i : act) {
            for (int j : act) {
                if (i == j) continue;
                ok &= !con[i][j];
            }
        }

        if (!ok) continue;

        for (int i = 0; i < sz(plans); ++i) {
            int sum = 0;
            for (int j : act) {
                sum += plans[i][j];
            }
            umax(best[i], sum);
        }
    }

    for (int i = 0; i < sz(plans); ++i) {
        mp[best[i]] = i;
    }

    vector<int> eff(q);
    for (int i = 0; i < q; ++i) {
        cin >> eff[i];
    }

    for (int i = 0; i < q; ++i) {
        if (mp.count(eff[i])) {
            cout << calc(plans[mp[eff[i]]]) << endl;
        } else {
            cout << -1 << endl;
        }
    }

    while (true) {
        int i;
        cin >> i;
        if (i == 0) break;

        --i;
        if (mp.count(eff[i])) {
            for (int j : plans[mp[eff[i]]]) {
                cout << j << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}
   
signed main() {
    // ios::sync_with_stdio(false);
    // cin.tie(nullptr);
   
    int T = 1;
    cin >> T;
   
    for (int t = 1; t <= T; ++t) {
        showTest(t);
        solve();
    }
}