#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;

#define int ll

struct Coord
{
	int x;
	int y;
};

struct CmpX
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		if (c1.x == c2.x)
			return c1.y < c2.y;
		return c1.x < c2.x;
	}
};

struct CmpY
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		if (c1.y == c2.y)
			return c1.x < c2.x;
		return c1.y < c2.y;
	}
};

struct UnX
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		return c1.x == c2.x;
	}
};

struct UnY
{
	bool operator()(const Coord& c1, const Coord& c2) const
	{
		return c1.y == c2.y;
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int h, w, k;
	cin >> h >> w >> k;
	CmpX xc;
	CmpY yc;
	UnX unx;
	UnY uny;
	vector<Coord> images(k);
	for (int i = 0; i < k; ++i)
	{
		cin >> images[i].x >> images[i].y;
	}
	vector<Coord> imcx = images, imcy = images;
	sort(imcx.begin(), imcx.end(), xc);
	imcx.resize(unique(imcx.begin(), imcx.end(), unx) - imcx.begin());
	sort(imcy.begin(), imcy.end(), yc);
	imcy.resize(unique(imcy.begin(), imcy.end(), uny) - imcy.begin());
	int xactions = 0;
	int xmin = INT32_MAX;
	int tekst = imcx[0].x;
	int tekfn = imcx.back().x;
	for (int i = 0; i < imcx.size(); ++i)
	{
		if (tekfn - tekst < xmin)
		{
			xmin = tekfn - tekst;
			if (i == 0)
				xactions = 0;
			else
				xactions = imcx[i - 1].x;
		}
		if (i != imcx.size() - 1)
		{
			tekst = imcx[i + 1].x;
			tekfn = h + imcx[i].x;
		}
	}
	int yactions = 0;
	int ymin = INT32_MAX;
	tekst = imcy[0].y;
	tekfn = imcy.back().y;
	for (int i = 0; i < imcy.size(); ++i)
	{
		if (tekfn - tekst < ymin)
		{
			ymin = tekfn - tekst;
			if (i == 0)
				yactions = 0;
			else
				yactions = imcy[i - 1].y;
		}
		if (i != imcy.size() - 1)
		{
			tekst = imcy[i + 1].y;
			tekfn = w + imcy[i].y;
		}
	}
	int resactions = xactions + yactions;
	ll result = ll(xmin + 1) * ll(ymin + 1);
	cout << result << ' ' << resactions << '\n';
	return 0;
}
