#include <iostream>
#include <vector>

using namespace std;

vector<vector<int>> graph;
vector<int> tou;
vector<int> dp;

void toudfs(int me, int tome, bool lastleft)
{
	tou[me] = tome;
	if (graph[me].size() > 1)
	{
		if (lastleft)
		{
			toudfs(graph[me][0], tome, true);
			toudfs(graph[me][1], tome + 1, false);
		}
		else
		{
			toudfs(graph[me][0], tome + 1, true);
			toudfs(graph[me][1], tome, false);
		}
	}
}

int dfs(int me, int k)
{
	if (graph[me].size() == 0)
	{
		if (tou[me] <= k)
			return dp[me] = 1;
		else
			return dp[me] = 0;
	}
	dp[me] = dfs(graph[me][0], k) + dfs(graph[me][1], k);
	return dp[me];
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, k, q;
	cin >> n >> k >> q;
	graph.resize(n);
	for (int i = 0; i < n; ++i)
	{
		int t;
		cin >> t;
		if (t == 2)
		{
			graph[i].resize(2);
			cin >> graph[i][0] >> graph[i][1];
			--graph[i][0];
			--graph[i][1];
		}
	}
	tou.resize(n);
	dp.resize(n);
	if (graph[0].size() > 1)
	{
		toudfs(graph[0][0], 0, true);
		toudfs(graph[0][1], 0, false);
	}
	dfs(0, k);
	for (int i = 0; i < q; ++i)
	{
		int u;
		cin >> u;
		--u;
		cout << dp[u] << '\n';
	}
	return 0;
}
