#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

const int maxn = 3e5;
vector <int> g[maxn];
int l[maxn], r[maxn];
int a[maxn];

int dp[maxn][2];

void dfs(int v, int p) {
    dp[v][0] = 0; dp[v][1] = a[v];
    for (auto u : g[v]) {
        if (p != u) {
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
}

void solve() {
    int n, q; cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; ++i) {
        int v, u; cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        a[i] = l[i];
    }
    dfs(0, -1);
    int res = max(dp[0][0], dp[0][1]);
    int k = 0;
    for (int i = 0; i < n; ++i) {
        k = k ^ (((x * (i + 1) + (y * a[i] % m) * a[i] % m)) % m);
    }
    vector <int> v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < q; ++i) {
        if (v[i] == res) {
            cout << k << ' ';
        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    int id;
    while (cin >> id) {
        if (id == 0) return;
        if (v[id - 1] == res) {
            for (int i = 0; i < n; ++i) {
                cout << a[i] << ' ';
            }
            cout << endl;
        } else {
            cout << "-1" << endl;
        }
    }
    
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
