#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

const int inf = 1e18;

void solve() {
  int n;
  cin >> n;
  vector<array<int, 2>> a(n);
  for (auto &[l, r] : a) {
    cin >> l >> r;
  }

  vector<int> p(n);
  for (int i = 0; i < n; i++) {
    p[i] = i;
  }
  sort(all(p), [&] (const int& i, const int& j) {
    return make_pair(a[i][1], a[i][0]) < make_pair(a[j][1], a[j][0]);
  });

  auto new_a = a;
  for (int i = 0; i < n; i++) {
    new_a[i] = a[p[i]];
  }
  a.swap(new_a);

  vector<int> ban(n);

  auto calc = [&] () {
    int cur_r = -1, res = 0;
    for (int i = 0; i < n; i++) {
      if (ban[i]) {
        continue;
      }
      auto [l, r] = a[i];
      if (l > cur_r) {
        cur_r = r;
        res++;
      }
    }
    return res;
  };

  vector<int> suf(n);
  for (int i = n - 1; i >= 0; i--) {
    if (ban[i]) {
      continue;
    }
    suf[i] = 1;
    for (int j = i + 1; j < n; j++) {
      if (ban[j]) {
        continue;
      }
      if (a[j][0] > a[i][1]) {
        suf[i] = max(suf[i], suf[j] + 1);
      }
    }
  }

  int rem = n / 2;
  int need = calc() / 2;
  while (calc() > need) {

    vector<int> ind;
    int cur_r = -1;
    for (int i = 0; i < n; i++) {
      if (ban[i]) {
        continue;
      }
      if (a[i][0] > cur_r) {
        cur_r = a[i][1];
        ind.push_back(i);
      }
    }

    int cnt = inf;
    vector<int> pos;
    for (int i = 0; i < sz(ind); i++) {
      int prev_r = (i == 0 ? -1 : a[ind[i - 1]][1]);
      int suffix = sz(ind) - i;
      vector<int> need_del;
      for (int j = ind[i]; j < n; j++) {
        if (ban[j]) {
          continue;
        }
        if (a[j][0] > prev_r && suf[j] == suf[ind[i]]) {
          need_del.push_back(j);
        }
      }
      if (sz(need_del) < cnt) {
        cnt = sz(need_del);
        pos = need_del;
      }
    }

    for (auto &i : pos) {
      ban[i] = 1;
    }
    rem -= sz(pos);
  }

  vector<int> in(n);
  int cur_r = -1;
  for (int i = 0; i < n; i++) {
    if (ban[i]) {
      continue;
    }
    auto [l, r] = a[i];
    if (l > cur_r) {
      cur_r = r;
      in[i] = 1;
    }
  }

  for (int i = 0; i < n; i++) {
    if (!ban[i] && !in[i] && rem > 0) {
      rem -= 1;
      ban[i] = 1;
    }
    if (!ban[i]) {
      cout << p[i] + 1 << ' ';
    }
  }

  cout << '\n';

  assert(rem == 0);
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}
