#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

const int inf = 1e18;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
  int n, q;
  cin >> n >> q;
  vector<int> ar(n);
  for (auto &x : ar) {
    cin >> x;
  }
  sort(all(ar));

  int ympa;
  cin >> ympa;

  int cur = 0;
  vector<int> ans(n);
  for (int i = 0; i < n; i++) {
    int x = ar[i];
    if (cur + 1 - x >= 0) {
      cur += x;
    }
    ans[i] = cur;
  }

  for (int w = 0; w < q; w++) {
    int k, a, b;
    cin >> k >> a >> b;
    if (b == 0) {
      int pos = upper_bound(all(ar), k) - ar.begin() - 1;
      int mx = (pos >= 0 ? ans[pos] : 0);
      if (mx >= a) {
        cout << "Yes\n";
      } else {
        cout << "No\n";
      }
    }
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}