#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

#define int long long
#define endl '\n'

int binpow(int x, int y)
{
	if (y == 0) return 1;
	if (y == 1) return x;

	int k = binpow(x, y / 2);
	if (y % 2 == 0) return k * k;
	else return k * k * x;
}

struct Node
{
	vector<int> to;
	int l, r;
	int p;

	int dp0 = 0;
	int dp1 = 0;
};

vector<Node> graph;

void dfs(int v, int p)
{
	graph[v].dp1 = graph[v].p;
	for (int u : graph[v].to)
	{
		if (u == p) continue;
		dfs(u, v);
		graph[v].dp1 += graph[u].dp0;
		graph[v].dp0 += max(graph[u].dp0, graph[u].dp1);
	}
}

int n, q;
int x, y, m;

vector<int> cur;
unordered_map<int, int> umk;
unordered_map<int, vector<int>> um;
vector<int> take;

void put(int v, int p)
{
	if (take[v] == 0)
	{
		for (int u : graph[v].to)
		{
			if (u == p) continue;
			if (graph[u].dp0 >= graph[u].dp1) take[u] = 0;
			else take[u] = 1;
			put(u, v);
		}
	}
	else if (take[v] == 1)
	{
		for (int u : graph[v].to)
		{
			if (u == p) continue;
			take[u] = 0;
			put(u, v);
		}
	}
}

void task()
{
	graph.clear();
	um.clear();
	umk.clear();
	cur.clear();
	take.clear();
	cin >> n >> q;
	graph.resize(n);
	take.resize(n, -1);
	cin >> x >> y >> m;

	for (int i = 0; i < n - 1; i++)
	{
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		graph[v].to.push_back(u);
		graph[u].to.push_back(v);
	}
	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;
		graph[i].l = l;
		graph[i].r = r;
	}

	for (int i = 0; i < n; i++)
	{
		graph[i].p = graph[i].r;
	}
	dfs(0, -1);
	int r = max(graph[0].dp0, graph[0].dp1);
	if (graph[0].dp0 >= graph[0].dp1) take[0] = 0;
	else take[0] = 1;

	put(0, -1);

	vector<int> qs(q);
	for (int i = 0; i < q; i++)
	{
		cin >> qs[i];
		
		if (qs[i] > r)
		{
			cout << -1 << ' ';
			continue;
		}

		int ost = qs[i];
		vector<int> cur(n);
		for (int j = 0; j < n; j++)
		{
			if (!take[j]) cur[j] = 0;
			else
			{
				if (graph[j].r >= ost)
				{
					cur[j] = ost;
					ost = 0;
				}
				else
				{
					ost -= graph[j].r;
					cur[j] = graph[j].r;
				}
			}
		}

		um[qs[i]] = cur;

		int c = 0;
		for (int i = 0; i < n; i++)
		{
			c ^= ((x * (i + 1)) % m + ((((y * cur[i]) % m) % m) * cur[i]) % m) % m;
		}
		umk[qs[i]] = c;

		cout << c << ' ';
	}
	cout << endl;
	cout.flush();

	int c = -1;
	while (true)
	{
		cin >> c;
		if (c == 0) break;
		c--;

		int b = qs[c];

		if (um.find(b) == um.end())
		{
			um.erase(b);
			cout << -1 << endl;
			cout.flush();
		}
		else
		{
			for (int j = 0; j < um[b].size(); j++)
			{
				cout << um[b][j] << ' ';
			}
			cout << endl;
			cout.flush();
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 1;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}