#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

#define int long long
#define endl '\n'

int binpow(int x, int y)
{
	if (y == 0) return 1;
	if (y == 1) return x;

	int k = binpow(x, y / 2);
	if (y % 2 == 0) return k * k;
	else return k * k * x;
}

struct Node
{
	vector<int> to;
	int l, r;
	int p;

	int dp0 = 0;
	int dp1 = 0;
};

vector<Node> graph;

void dfs(int v, int p)
{
	graph[v].dp1 = graph[v].p;
	for (int u : graph[v].to)
	{
		if (u == p) continue;
		dfs(u, v);
		graph[v].dp1 += graph[u].dp0;
		graph[v].dp0 += max(graph[u].dp0, graph[u].dp1);
	}
}

int n, q;
int x, y, m;

vector<int> cur;
unordered_map<int, int> umk;
unordered_map<int, vector<int>> um;

void rec()
{
	if (cur.size() == n)
	{
		for (int i = 0; i < n; i++)
		{
			graph[i].p = cur[i];
			graph[i].dp0 = 0;
			graph[i].dp1 = 0;
		}

		dfs(0, -1);
		int k = max(graph[0].dp0, graph[0].dp1);
		um[k] = cur;
		int c = 0;
		for (int i = 0; i < n; i++)
		{
			c ^= (x * (i + 1) + y * cur[i] * cur[i]) % m;
		}
		umk[k] = c;
	}
	else
	{
		int ind = cur.size();
		for (int i = graph[ind].l; i <= graph[ind].r; i++)
		{
			cur.push_back(i);
			rec();
			cur.pop_back();
		}
	}
}

void task()
{
	graph.clear();
	um.clear();
	cin >> n >> q;
	graph.resize(n);
	cin >> x >> y >> m;

	for (int i = 0; i < n - 1; i++)
	{
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		graph[v].to.push_back(u);
		graph[u].to.push_back(v);
	}
	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;
		graph[i].l = l;
		graph[i].r = r;
	}

	rec();

	vector<int> qs(q);
	for (int i = 0; i < q; i++)
	{
		cin >> qs[i];
		if (umk.find(qs[i]) != umk.end())
		{
			cout << umk[qs[i]] << ' ';
		}
		else
		{
			cout << -1 << ' ';
			umk.erase(qs[i]);
		}
		cout.flush();
	}

	int c = -1;
	while (true)
	{
		cin >> c;
		if (c == 0) break;
		c--;

		if (um.find(c) == um.end())
		{
			um.erase(c);
			cout << -1 << endl;
			cout.flush();
		}
		else
		{
			for (int j = 0; j < um[c].size(); j++)
			{
				cout << um[c][j] << ' ';
			}
			cout << endl;
			cout.flush();
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 1;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}