#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace  std;
#define int long long


int prev(int x, int n) {
    if (x == 1) {
        return n;
    }
    return x - 1;
}

int next(int x, int n) {
    if (x == n) {
        return 1;
    }
    return x + 1;
}

int dst(int x, int y, int n) {
    if (x <= y) {
        return y - x - 1;
    }
    return n - x + y - 1;
}

void decode() {
    int n, k;
    cin >> n >> k;
    set<int> was;
    vector<int> v(k);
    for (int i = 0; i < k; i++) {
        cin >> v[i];
        was.insert(v[i]);
    }
    if (2 * k == n) {
        for (int i = 1; i <= n; i++) {
            if (was.find(i) == was.end()) {
                cout << i << ' ';
            }
        }
        cout << endl;
        return;
    }
    sort(v.begin(), v.end());
    vector<pair<int, int>> blocks;
    map<int, int> used;
    for (auto x : was) {
        if (!used[x]) {
            used[x] = 1;
            int l = x;
            int r = x;
            while (was.find(prev(l, n)) != was.end()) {
                l = prev(l,n);
                used[l] = 1;
            }
            while (was.find(next(r, n)) != was.end()) {
                r = next(r,n);
                used[r] = 1;
            }
            blocks.emplace_back(l, r);
        }
    }
    sort(blocks.begin(), blocks.end());
    int fb = 0;
    int mxs = 0;
    for (int i = 0; i < blocks.size(); i++) {
        int prev = i - 1;
        if (i == 0) {
            prev = blocks.size() - 1;
        }
        if (mxs < dst(blocks[prev].second, blocks[i].first, n)) {
            mxs = dst(blocks[prev].second, blocks[i].first, n);
            fb = i;
        }
    }
    int wass = 0;
    vector<int> res;
    for (int i = fb; i < fb + blocks.size(); i++) {
        int j = i % blocks.size();
        int nx = (j + 1) % blocks.size();
        wass += dst(blocks[j].first, blocks[j].second, n) + 2;
        int start = next(blocks[j].second, n);
        if (nx == fb) {
            while (res.size() < wass) {
                res.push_back(start);
                start = next(start, n);
            }
        } else {
            while (res.size() < wass && start != blocks[nx].first) {
                res.push_back(start);
                start = next(start, n);
            }
        }
    }
    sort(res.begin(), res.end());
    for (auto x : res) {
        cout << x << ' ';
    }
    cout << endl;
}

vector<int> tryy(vector<int> v, int n, int k) {

    vector<int> res;
    int now = v.back();
    v.pop_back();
    int cnt = 1;
    while (true) {
        if (v.size() > 0 && v.back() == prev(now, n)) {
            v.pop_back();
            now = prev(now, n);
            cnt++;
        }
        if (v.size() == 0) {
            while (res.size() < k) {
                now = prev(now, n);
                res.push_back(now);
            }
            break;
        }
        int pr = v.back();
        now = prev(now, n);
        while (res.size() < cnt && now != pr) {
            res.push_back(now);
            now = prev(now, n);
        }
        now = pr;
        cnt++;
        v.pop_back();
    }
    sort(res.begin(), res.end());
    return res;
}

void encode() {
    int n, k;
    cin >> n >> k;
    set<int> was;
    vector<int> v(k);
    for (int i = 0; i < k; i++) {
        cin >> v[i];
        was.insert(v[i]);
    }
    if (2 * k == n) {
        for (int i = 1; i <= n; i++) {
            if (was.find(i) == was.end()) {
                cout << i << ' ';
            }
        }
        cout << endl;
        return;
    }
    for (int i = 0; i < k; i++) {
        vector<int> w;
        for (int j = i; j < i + k; j++) {
            w.push_back(v[j % k]);
        }
        auto r = tryy(w, n, k);

        bool ok = false;
        set<int> now;
        for (auto x : r) {
            if (was.find(x) != was.end() || now.find(x) != now.end()) {
                ok = true;
            }
            now.insert(x);
        }
        if (!ok) {
            sort(r.begin(), r.end());
            for (auto x : r) {
                cout << x << ' ';
            }
            cout << endl;
            return;
        }
    }
    exit(103);
}


signed main() {

    int t;
    cin >> t;
    if (t == 1) {
        int m;
        cin >> m;
        for (int _i = 0; _i < m; _i++) {
            decode();

        }
    } else {
        int m;
        cin >> m;
        for (int _i = 0; _i < m; _i++) {
            encode();
        }
    }
}
/*
 1
 21
 7 2
1 2
7 2
1 3
7 2
1 4
7 2
1 5
7 2
1 6
7 2
1 7
7 2
2 3
7 2
2 4
7 2
2 5
7 2
2 6
7 2
2 7
7 2
3 4
7 2
3 5
7 2
3 6
7 2
3 7
7 2
4 5
7 2
4 6
7 2
4 7
7 2
5 6
7 2
5 7
7 2
6 7


 1
 10
 5 2 1 2
 5 2 1 3
 5 2 1 4
 5 2 1 5
 5 2 2 3
 5 2 2 4
 5 2 2 5
 5 2 3 4
 5 2 3 5
 5 2 4 5

 2
 10
 5 2
 3 4
 5 2
2 4
 5 2
2 5
 5 2
2 3
 5 2
4 5
 5 2
3 5
 5 2
1 3 5 2
1 5
 5 2
1 4
5 2
1 2


7 3
1 2 3
7 3
1 2 4
7 3
1 2 5
7 3
1 2 6
7 3
1 2 7
7 3
1 3 4
7 3
1 3 5
7 3
1 3 6
7 3
1 3 7
7 3
1 4 5
7 3
1 4 6
7 3
1 4 7
7 3
1 5 6
7 3
1 5 7
7 3
1 6 7
7 3
2 3 4
7 3
2 3 5
7 3
2 3 6
7 3
2 3 7
7 3
2 4 5
7 3
2 4 6
7 3
2 4 7
7 3
2 5 6
7 3
2 5 7
7 3
2 6 7
7 3
3 4 5
7 3
3 4 6
7 3
3 4 7
7 3
3 5 6
7 3
3 5 7
7 3
3 6 7
7 3
4 5 6
7 3
4 5 7
7 3
4 6 7
7 3
5 6 7

 */