#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace  std;
#define int long long
const int maxn = 2e5 + 1;

vector<int> g[maxn];
int a[maxn];
pair<int, int> dp[maxn];

void dfs(int v, int p) {
    dp[v] = {0, a[v]};

    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    for (auto u : g[v]) {
        if (u != p) {
            dp[v].first += max(dp[u].second, dp[u].first);
            dp[v].second += dp[u].first;
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i <= n; i++) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; i++) {
        int s, f;
        cin >> s >> f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        a[i + 1] = l;
    }
    dfs(1, 1);
    int e = max(dp[1].first, dp[1].second);
    int k = 0;
    for (int i = 1; i <= n; i++) {
        k ^= (i * x + y * a[i] % m * a[i]) % m;
    }
    vector<int> qs;
    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        qs.push_back(u);
        if (u != e) {
            cout << -1 << ' ';
        } else {
            cout << k << ' ';
        }
    }
    cout << endl;
    while (true) {
        int i;
        cin >> i;
        if (i == 0) {
            break;
        }
        i--;
        if (qs[i] != e) {
            cout << -1 << endl;
        } else {
            for (int i = 1; i <= n; i++) {
                cout << a[i] << ' ';
            }
            cout << endl;
        }
    }
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
