#include <bits/stdc++.h>

using namespace std;

struct ST {
	int n;
	vector<int> vec;

	struct node {
		int x, i;
		node() {};
		node(int x, int i): x(x), i(i) {}
		node(node a, node b) {
			if (a.x < b.x) {
				x = a.x;
				i = a.i;
			}
			else {
				x = b.x;
				i = b.i;
			}
		}
	};

	vector<node> st;

	void build(int v, int l, int r) {
		if (r - l == 1) {
			st[v] = node(vec[l], l);
			return;
		}
		int m = (l + r) / 2;
		build(v * 2 + 1, l, m);
		build(v * 2 + 2, m, r);
		st[v] = node(st[v * 2 + 1], st[v * 2 + 2]);
	}

	ST(int n, vector<int> vec): n(n), vec(vec) {
		st.resize(n * 4);
		build(0, 0, n);
	}

	node ask(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return node(-1e9, -1);
		if (ql <= l && r <= qr) return st[v];
		int m = (l + r) / 2;
		return node(ask(v * 2 + 1, l, m, ql, qr), ask(v * 2 + 2, m, r, ql, qr));
	}

	void upd(int v, int l, int r, int qi, int x, int i) {
		if (qi < l || r <= qi) return;
		if (r - l == 1) {
			st[v] = node(x, i);
			return;
		}
		int m = (l + r) / 2;
		upd(v * 2 + 1, l, m, qi, x, i);
		upd(v * 2 + 2, m, r, qi, x, i);
		st[v] = node(st[v * 2 + 1], st[v * 2 + 2]);
	}
};

void solve() {
	int n;
	cin >> n;
	vector<int> vec(n);
	for (int &x: vec) cin >> x;
	vector<int> nuller(n + 1, 0);
	ST st(n, nuller);
	vector<int> dp(n), p(n);
	for (int i = 0; i < n; ++i) {
		ST::node q = st.ask(0, 0, n, 0, vec[i]);
		if (q.x < 0) {
			q = ST::node(0, -1);
		}
		dp[i] = q.x + 1;
		p[i] = q.i;
		st.upd(0, 0, n, vec[i], dp[i], i);
	}
	int best = 0;
	for (int i = 0; i < n; ++i) {
		if (dp[best] < dp[i]) best = i;
	}
	int ans = dp[best] + 1;
	vector<int> used(n);
	while (best != -1) {
		used[best] = 1;
		best = p[best];
	}
	vector<int> diff;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) diff.push_back(vec[i]);
	}
	bool ok = 1;
	for (int i = 1; i < diff.size() && ok; ++i) {
		if (diff[i] - diff[i - 1] < 0) ok = 0;
	}
	if (!ok) ++ans;
	cout << ans << endl;
}

int main() {
	int t;
	cin >> t;
	while (t--) solve();
}