#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll INF = 1e18 + 21;
const ll M = 1e9 + 7;
const double PI = acos(-1);

struct node {
	ll l, r, i;
};

int n, m;
vector<node> a;
vector<int> cur;
bool ok = false;

void rec(int sz, int i) {
	if (ok) return;
	if (sz == n / 2) {
		int curm = 0;
		pair<ll, ll> lst = { 0, 0 };
		for (auto& e : cur) {
			if (a[e].l > lst.second) {
				++curm;
				lst = { a[e].l, a[e].r };
			}
		}
		if (curm * 2 == m) {
			for (auto& e : cur) cout << a[e].i + 1 << ' ';
			cout << '\n';
			ok = 1;
			return;
		}
	}
	if (i == n) return;
	cur.push_back(i);
	rec(sz + 1, i + 1);
	cur.pop_back();
	rec(sz, i + 1);
}

struct vert {
	int min, max;
};

void solve() {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].l >> a[i].r;
		a[i].i = i;
	}
	sort(a.begin(), a.end(), [&](node& f, node& s) {
		if (f.r == s.r) return f.l < s.l;
		return f.r < s.r;
	});
	m = 0;
	pair<ll, ll> lst = { 0, 0 };
	for (int i = 0; i < n; ++i) {
		if (a[i].l > lst.second) {
			++m;
			lst = { a[i].l, a[i].r };
		}
	}
	// ok = 0;
	// rec(0, 0);
	a.insert(a.begin(), { 0, 0 });
	vector<vector<vert>> dp(n / 2 + 1, vector<vert>(n + 1, { inf, -inf }));
	dp[0][0] = { 0, inf };
	for (int i = 1; i <= n / 2; ++i) {
		for (int lst = 1; lst <= n; ++lst) {
			for (int lst1 = 0; lst1 < lst; ++lst1) {
				int no_inters = a[lst].l > a[lst1].r;
				dp[i][lst].min = min(dp[i][lst].min, dp[i - 1][lst1].min + no_inters);
				dp[i][lst].max = max(dp[i][lst].max, dp[i - 1][lst1].max + no_inters);
			}
		}
	}
	int l = n + 1, sub = 0;
	for (int layer = n / 2; layer > 0; --layer) {
		for (int i = l - 1; i > 0; --i) {
			if (dp[layer][i].min <= m / 2 - sub && dp[layer][i].max >= m / 2 - sub) {
				if (l <= n && a[l].l > a[i].r) ++sub;
				l = i;
				cout << a[i].i + 1 << ' ';
				break;
			}
		}
	}
	cout << '\n';
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}