#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

bool check_no_twos(vector<int>& a) {
	for (int i = 0; i < a.size() - 1; ++i) {
		if (a[i] + 1 == a[i + 1])
			return false;
	}
	return true;
}

void solve_for_2k_is_n(vector<int>& a, int n, int k) {
	vector<bool> used(n);
	for (int i = 0; i < k; ++i) {
		used[a[i] - 1] = true;
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i])
			cout << i + 1 << " ";
	}
	cout << endl;
	return;
}

void solve_for_no_twos(vector<int>& a, int n, int k, int plus) {
	vector<int> res;
	for (int i = 0; i < k; ++i) {
		int x = a[i] + plus;
		if (x < 1) x += n;
		if (x > n) x -= n;
		res.push_back(x);
	}
	sort(res.begin(), res.end());
	for (auto x : res)
		cout << x << " ";
	cout << endl;
}

void solve1() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
	}
	if (k == n / 2 && n % 2 == 0) {
		solve_for_2k_is_n(a, n, k);
		return;
	}
	if (k == 1) {
		int x = a[0] - 1;
		if (x < 1) x += n;
		cout << x << endl;
		return;
	}
	if (k == 2) {
		if (a[0] + 1 == a[1] || (a[0] == 1 && a[1] == n)) {
			int x1 = a[0] - 2;
			int x2 = a[1] - 2;
			if (x1 < 1) x1 += n;
			if (x2 < 1) x2 += n;
			cout << min(x1, x2) << " " << max(x1, x2) << endl;
			return;
		} else {
			int x1 = a[0] - 1;
			int x2 = a[1] - 1;
			if (x1 < 1) x1 += n;
			if (x2 < 1) x2 += n;
			cout << min(x1, x2) << " " << max(x1, x2) << endl;
			return;
		}
	}
	if (check_no_twos(a)) {
		solve_for_no_twos(a, n, k, -1);
		return;
	}
	vector<int> res;
	for (int i = 0; i < k; ++i) {
		int x = a[i] - a[0] + a[k - 1] + 1;
		if (x > n) x -= n;
		res.push_back(x);
	}
	sort(res.begin(), res.end());
	for (auto x : res)
		cout << x << " ";
	cout << endl;
	return;
}

void solve2() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
	}
	if (k == n / 2 && n % 2 == 0) {
		solve_for_2k_is_n(a, n, k);
		return;
	}
	if (k == 1) {
		int x = a[0] + 1;
		if (x > n) x -= n;
		cout << x << endl;
		return;
	}
	if (k == 2) {
		if (a[0] + 1 == a[1] || (a[0] == 1 && a[1] == n)) {
			int x1 = a[0] + 2;
			int x2 = a[1] + 2;
			if (x1 > n) x1 -= n;
			if (x2 > n) x2 -= n;
			cout << min(x1, x2) << " " << max(x1, x2) << endl;
			return;
		} else {
			int x1 = a[0] + 1;
			int x2 = a[1] + 1;
			if (x1 > n) x1 -= n;
			if (x2 > n) x2 -= n;
			cout << min(x1, x2) << " " << max(x1, x2) << endl;
			return;
		}
	}
	if (check_no_twos(a)) {
		solve_for_no_twos(a, n, k, 1);
		return;
	}
	int first = 0;
	for (int i = 1; i < k; ++i) {
		if (a[i] - a[i - 1] >= (n + 1) / 2)
			first = i;
	}
	int last = first - 1;
	if (first == 0) last = k - 1;
	int diff = (last < first) ? a[last] + n - a[first] : a[last] - a[first];
	vector<int> res;
	for (int i = 0; i < k; ++i) {
		int x = a[i] - diff - 1;
		if (x < 1) x += n;
		res.push_back(x);
	}
	sort(res.begin(), res.end());
	for (auto x : res)
		cout << x << " ";
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int f;
	cin >> f;
	int t;
	cin >> t;
	while (t--) {
		if (f == 1)
			solve1();
		else
			solve2();
	}
}