#include <bits/stdc++.h>

using namespace std;

int n;
vector<pair<int, int>> lr;

struct seg {
    int l, r, i;
    seg() = default;
    seg(int l, int r, int i): l(l), r(r), i(i) {}
};

bool operator< (seg a1, seg a2) {
    return a1.l < a2.l or a1.l == a2.l and a1.r > a2.r or a1.l == a2.l and a1.r == a2.r and a1.i < a2.i;
}

struct el {
    int x, t, i;
    el() = default;
    el(int x, int t, int i): x(x), t(t), i(i) {}
};

bool operator< (el a1, el b1) {
    if (a1.x != b1.x) return a1.x < b1.x;
    else {
        if (a1.t != b1.t) assert(0);
        else if (a1.t == 1) {
            if (lr[a1.i].second == lr[b1.i].second) return a1.i > b1.i;
            else return lr[a1.i].second > lr[b1.i].second;
        } else {
            if (lr[a1.i].first == lr[b1.i].first) return a1.i < b1.i;
            else return lr[a1.i].first > lr[b1.i].first;
        }
    }
}

vector<vector<int>> g;
vector<int> pred;
vector<int> sz;
vector<bool> used;

pair<int, int> up(int v) {
    if (v == -1 or g[v].size() > 1) return {0, v};
    else {
        auto [x, y] = up(pred[v]);
        return {x + 1, y};
    }
}

void paint(int v) {
    if (v == -1 or g[v].size() > 1) return;
    used[v] = true;
    paint(pred[v]);
}

void resizes() {
    g.clear();
    g.resize(n);
    pred.assign(n, -1);
    sz.assign(n, 0);
    used.resize(n, false);
}

bool check(int i, int j) {
    return lr[i].first <= lr[j].first && lr[j].second <= lr[i].second;
}

bool isIntersect(int i) {
    for (int j = 0; j < n; j++) {
        if (check(i, j)) return false;
    }
    return true;
}

vector<int> solve() {
    vector<el> scan(2 * n);
    vector<seg> segs(n);
    for (int i = 0; i < n; i++) {
        segs[i] = {lr[i].first, lr[i].second, i};
        scan[2 * i] = {lr[i].first, 1, i};
        scan[2 * i + 1] = {lr[i].second, -1, i};
    }
    resizes();

//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++) {
//            if (i != j) {
//                if (check(i, j) && isIntersect(j)) {
//                    g[i].push_back(j);
//                    pred[j] = i;
//                    sz[i]++;
//                }
//            }
//        }
//    }
    sort(segs.begin(), segs.end());
    deque<seg> st;
    for (auto s : segs) {
        while (!st.empty() && st.back().r < s.l) st.pop_back();
        if (!st.empty()) {
            pred[s.i] = st.back().i;
            sz[st.back().i]++;
        }
        for (auto q : st) {
            g[q.i].push_back(s.i);
        }
        st.push_back(s);
    }
//    sort(scan.begin(), scan.end());
//    stack<int> st;
//    for (auto e : scan) {
//        //cout << e.x << " " << e.t << " " << e.i << endl;
//        if (e.t == -1) {
//            st.pop();
//        } else {
//            if (!st.empty()) {
//                g[st.top()].push_back(e.i);
//                pred[e.i] = st.top();
//                sz[st.top()]++;
//            }
//            st.push(e.i);
//        }
//    }
//    for (int i = 0; i < n; i++) {
//        for (int j : g[i]) cout << j << " ";
//        cout << endl;
//    }
//    cout << endl;
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) m++;
    }
    vector<int> closestup(n, -1);
    vector<pair<int, int>> l;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) {
            auto [x, y] = up(i);
            closestup[i] = y;
            l.emplace_back(x, i);
        }
    }
    sort(l.begin(), l.end());
    int c = 0, list = 0;
    for (auto [x, y] : l) {
        if (list == m / 2) break;
//        if (closestup[y] == -1 || sz[closestup[y]] > 1) {
            paint(y);
            c += x;
            list += 1;
            if (closestup[y] != -1) sz[closestup[y]]--;
        //}
    }
    for (int i = 0; i < n; i++) {
        if (c == n / 2) break;
        if (!g[i].empty()) {
            used[i] = true;
            c++;
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) ans.push_back(i + 1);
    }
    return ans;
}

//mt19937 rnd(179);
//
////void gen() {
////    n = rnd() % 10 + 1;
////    vector<
////}

void input() {
    cin >> n;
    lr.resize(n);
    for (auto& i : lr) cin >> i.first >> i.second;
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        input();
        auto ans = solve();
        for (int i : ans) cout << i << " ";
        cout << endl;
    }
}
