#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-9;

struct DSU {
    vector<ll> p, sz;

    explicit DSU(ll n) {
        p.assign(n, 0);
        for (ll i = 0; i < n; i++) p[i] = i;
        sz.assign(n, 1);
    }

    ll get(ll v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }

    void merge(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        sz[a] += sz[b];
        p[b] = a;
    }
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        vector<ll> a(n);
        for (ll i = 0; i < n; i++) cin >> a[i];

        vector<vector<pair<ll, ll>>> dp(n + 2);
        for (ll i = 0; i <= n; i++) dp[i].push_back({INF, -1});
        dp[0][0].first = -INF;

        for (ll i = 1; i <= n; i++) {
            ll L = 0, R = n;
            while (R - L > 1) {
                ll m = L + (R - L) / 2;

                if (dp[m].back().first < a[i-1])
                    L = m;
                else
                    R = m;
            }
            dp[R].push_back({a[i - 1], dp[L].size() - 1});
        }

        ll ans = 0;
        for (ll i = 0; i <= n; i++)
            if (dp[i].back().first < INF)
                ans = i;

        set<ll> seq;
        ll p = (ll)dp[ans].size() - 1;
        while (ans > 0) {
            seq.insert(dp[ans][p].first);
            p = dp[ans][p].second;
            ans--;
        }

        vector<ll> p2;
        for (ll i = 0; i < n; i++) {
            if (seq.find(a[i]) == seq.end()) {
                p2.push_back(a[i]);
            }
        }

        ans = seq.size() + !p2.empty();
        if (!p2.empty()) {
            ll p2mx = p2[0];
            for (ll i = 1; i < p2.size(); i++) {
                ans += p2[i] > p2mx;
                p2mx = max(p2mx, p2[i]);
            }
        }

        cout << ans << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}