#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<ll>> g;

vector<ll> ans, nxt, e;
vector<pair<ll, ll>> seg;

ll INF = 1e18;

vector<bool> can;

void dfs(ll v) {
    ans[v] = 1;
    e[v] = seg[v].second;
    for (ll to : g[v]) {
        if (!can[to]) continue;
        if (ans[to] == -1) {
            dfs(to);
        }
        if (ans[to] + 1 > ans[v] || ans[to] + 1 == ans[v] && e[to] > e[v]) {
            ans[v] = ans[to] + 1;
            nxt[v] = to;
            e[v] = e[to];
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        g.assign(n, {});
        e.assign(n, -INF);

        seg.assign(n, {});
        for (ll i = 0; i < n; i++) cin >> seg[i].first >> seg[i].second;

        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {

                if (seg[i].second < seg[j].first) {
                    g[i].push_back(j);
                }
            }
        }

        ans.assign(n, -1);
        nxt.assign(n, -1);
        e.assign(n, -INF);
        can.assign(n, true);
        for (ll i = 0; i < n; i++) {
            if (ans[i] == -1) {
                dfs(i);
            }
        }
        ll ind = max_element(ans.begin(), ans.end()) - ans.begin();
        ll m = ans[ind] / 2;

        vector<ll> pth;
        ll v = ind;
        for (ll i = 0; i < 2 * m; i++) {
            pth.push_back(ind);
            v = nxt[v];
        }

        vector<vector<ll>> inter(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                if (seg[j].first <= seg[i].first && seg[i].second <= seg[j].second) {
                    inter[i].push_back(j);
                }
            }
        }

        stable_sort(pth.begin(), pth.end(), [&] (const ll a, const ll b) {
            return inter[a].size() > inter[b].size();
        });
        set<ll> out;
        vector<ll> pth_out;
        for (ll i = 0; i < m; i++) {
            for (ll w : inter[pth[i]]) out.insert(w);
            pth_out.push_back(pth[i]);
        }

        while (pth_out.size() < n / 2) {
            pth_out.push_back(*out.begin());
            out.erase(out.begin());
        }

        for (ll w : pth_out) cout << w + 1 << " ";
        cout << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}