#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
typedef long long ll;
vector<vector<ll>> t1, t2;
ll Max1(ll i, ll v, ll l, ll r, ll a, ll b) {
	if (l >= b || r <= a) return -1e18;
	if (l >= a && r <= b) return t1[i][v];
	ll m = (l + r) / 2;
	return max(Max1(i, 2 * v + 1, l, m, a, b), Max1(i, 2 * v + 2, m, r, a, b));
}
ll Set1(ll i, ll v, ll l, ll r, ll a, ll b) {
	if (l > a || r <= a) return t1[i][v];
	if (r - l == 1) return t1[i][v] = b;
	ll m = (l + r) / 2;
	return t1[i][v] = max(Set1(i, 2 * v + 1, l, m, a, b), Set1(i, 2 * v + 2, m, r, a, b));
}
ll Max2(ll i, ll v, ll l, ll r, ll a, ll b) {
	if (l >= b || r <= a) return -1e18;
	if (l >= a && r <= b) return t2[i][v];
	ll m = (l + r) / 2;
	return max(Max2(i, 2 * v + 1, l, m, a, b), Max2(i, 2 * v + 2, m, r, a, b));
}
ll Set2(ll i, ll v, ll l, ll r, ll a, ll b) {
	if (l > a || r <= a) return t2[i][v];
	if (r - l == 1) return t2[i][v] = b;
	ll m = (l + r) / 2;
	return t2[i][v] = max(Set2(i, 2 * v + 1, l, m, a, b), Set2(i, 2 * v + 2, m, r, a, b));
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll q;
	cin >> q;
	while (q--) {
		ll n;
		cin >> n;
		vector<ll> a(n);
		for (ll i = 0; i < n; ++i) cin >> a[i];
		vector<vector<ll>> dp(n + 1, vector<ll>(n + 2, -1e18));
		t1.assign(n + 2, vector<ll>(4 * n + 4, -1e18));
		t2.assign(n + 1, vector<ll>(4 * n + 8, -1e18));
		dp[0][n + 1] = 0;
		Set1(n + 1, 0, 0, n + 1, 0, 0);
		Set2(0, 0, 0, n + 2, n + 1, 0);
		for (ll i = 0; i < n; ++i) {
			for (ll k = 1; k < n + 2; ++k) {
				dp[a[i]][k] = max(Max1(k, 0, 0, n + 1, 0, a[i]) + 1, dp[a[i]][k]);
			}
			for (ll j = 0; j < n + 1; ++j) {
				dp[j][a[i]] = max(Max2(j, 0, 0, n + 2, a[i] + 1, n + 2) + 1, dp[j][a[i]]);
			}
			for (ll k = 1; k < n + 2; ++k) {
				Set1(k, 0, 0, n + 1, a[i], dp[a[i]][k]);
				Set2(a[i], 0, 0, n + 2, k, dp[a[i]][k]);
			}
			for (ll j = 0; j < n + 1; ++j) {
				Set1(a[i], 0, 0, n + 1, j, dp[j][a[i]]);
				Set2(j, 0, 0, n + 2, a[i], dp[j][a[i]]);
			}
		}
		ll ans = 0;
		for (ll i = 1; i < n + 1; ++i) {
			for (ll j = 1; j < n + 1; ++j) ans = max(ans, dp[i][j]);
		}
		cout << ans << "\n";
	}
	cout << endl;
	return 0;
}