#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>> (n + 1, {1e9, -1e9}));
    dp[0][0] = {0, 0};

    vector<pair<pair<int, int>, int>> segs(n);
    for (int i = 0; i < n; i++) {
        cin >> segs[i].first.first >> segs[i].first.second;
        segs[i].second = i;
    }

    sort(segs.begin(), segs.end(), [&](pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
        return a.first.second < b.first.second;
    });

    vector<vector<pair<int, int>>> p(n + 1, vector<pair<int, int>>(n + 1, {-1, -1})) ;

    for (int i = 0; i < n; i++) {
        // delete
        for (int j = 1; j < n; j++) {
            dp[i + 1][j] = dp[i][j - 1];
            p[i + 1][j] = {i, j - 1};
        }

        // pick
        auto it = i - (lower_bound(segs.begin(), segs.end(), segs[i].first.first, [](pair<pair<int, int>, int> b, int a) {
            return b.first.second < a;
        }) - segs.begin());

        for (int j = 0; j < n; j++) {
            int can_delete = min(j, (int)it);

            int l = max({dp[i - it][j - can_delete].first + 1, dp[i][j].first});
            int r = max({dp[i - it][j - can_delete].second + 1, dp[i][j].second});

            if (l < dp[i + 1][j].first) {
                p[i + 1][j] = {i, j};
            }

            dp[i + 1][j] = {min(dp[i + 1][j].first, l), max(dp[i + 1][j].second, r)};
        }
    }

    int m = dp[n][0].second;
    if (dp[n][n / 2].first > m / 2) exit(1);
    
    vector<int> ans;
    int i = n;
    int j = n / 2;

    while (i != 0 || j != 0) {
        int toj = p[i][j].second;
        int toi = p[i][j].first;

        if (p[i][j].second != j) {
            for (;j > toj; j--,i--) {
                ;
            }
        }
        
        for (; i > toi; i--) {
            ans.push_back(segs[i - 1].second + 1);
        }
    }

    for (auto i : ans) {
        cout << i << ' ' ;
    }

    cout << endl;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}