#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

namespace KN2 {
    void encdec(int n, int k, const vector<int>& nums) {
        vector<bool> used(n + 1, false);
        for (int i = 0; i < k; i++) {
            used[nums[i]] = true;
        }
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                cout << i << " ";
            }
        }
        cout << endl;
    }
} // namespace KN2

namespace K2 {
    void enc(int n, int k, const vector<int>& nums) {
        int num1 = nums[0];
        int num2 = nums[1];
        if (num2 == num1 + 1 || (num1 == 1 && num2 == n)) {
            num1 += 2;
            num2 += 2;
            if (num1 > n) {
                num1 -= n;
            }
            if (num2 > n) {
                num2 -= n;
            }
            if (num1 > num2) {
                swap(num1, num2);
            }
            cout << num1 << " " << num2 << endl;
        } else {
            num1 += 1;
            num2 += 1;
            if (num1 > n) {
                num1 -= n;
            }
            if (num2 > n) {
                num2 -= n;
            }
            if (num1 > num2) {
                swap(num1, num2);
            }
            cout << num1 << " " << num2 << endl;
        }
    }
    void dec(int n, int k, const vector<int>& nums) {
        int num1 = nums[0];
        int num2 = nums[1];
        if (num2 == num1 + 1 || (num1 == 1 && num2 == n)) {
            num1 -= 2;
            num2 -= 2;
            if (num1 < 1) {
                num1 += n;
            }
            if (num2 < 1) {
                num2 += n;
            }
            if (num1 > num2) {
                swap(num1, num2);
            }
            cout << num1 << " " << num2 << endl;
        } else {
            num1 -= 1;
            num2 -= 1;
            if (num1 < 1) {
                num1 += n;
            }
            if (num2 < 1) {
                num2 += n;
            }
            if (num1 > num2) {
                swap(num1, num2);
            }
            cout << num1 << " " << num2 << endl;
        }
    }
} // namespace K2

namespace DIF1 {
    void enc(int n, int k, const vector<int>& nums) {
        vector<int> resnums(k);
        for (int i = 0; i < k; i++) {
            resnums[i] = nums[i] + 1;
            if (resnums[i] > n) {
                resnums[i] -= n;
            }
        }
        sort(resnums.begin(), resnums.end());
        for (int i = 0; i < k; i++) {
            cout << resnums[i] << " ";
        }
        cout << endl;
    }
    void dec(int n, int k, const vector<int>& nums) {
        vector<int> resnums(k);
        for (int i = 0; i < k; i++) {
            resnums[i] = nums[i] - 1;
            if (resnums[i] < 1) {
                resnums[i] += n;
            }
        }
        sort(resnums.begin(), resnums.end());
        for (int i = 0; i < k; i++) {
            cout << resnums[i] << " ";
        }
        cout << endl;
    }
} // namespace DIF1

namespace ADDN2 {
    void enc(int n, int k, const vector<int>& nums) {
        vector<int> resnums(k);
        for (int i = 0; i < k; i++) {
            resnums[i] = nums[i] + n / 2;
            if (resnums[i] > n) {
                resnums[i] -= n;
            }
        }
        sort(resnums.begin(), resnums.end());
        for (int i = 0; i < k; i++) {
            cout << resnums[i] << " ";
        }
        cout << endl;
    }
    void dec(int n, int k, const vector<int>& nums) {
        vector<int> resnums(k);
        for (int i = 0; i < k; i++) {
            resnums[i] = nums[i] - n / 2;
            if (resnums[i] < 1) {
                resnums[i] += n;
            }
        }
        sort(resnums.begin(), resnums.end());
        for (int i = 0; i < k; i++) {
            cout << resnums[i] << " ";
        }
        cout << endl;
    }
} // namespace ADDN2

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> nums(k);
    for (int i = 0; i < k; i++) {
        cin >> nums[i];
    }

    if (k * 2 == n) {
        KN2::encdec(n, k, nums);
        return;
    } else if (k == 2) {
        K2::enc(n, k, nums);
    } else if ((nums.back() - nums.front() + 1) * 2 <= n) {
        ADDN2::enc(n, k, nums);
    } else {
        DIF1::enc(n, k, nums);
    }
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> nums(k);
    for (int i = 0; i < k; i++) {
        cin >> nums[i];
    }

    if (k * 2 == n) {
        KN2::encdec(n, k, nums);
        return;
    } else if (k == 2) {
        K2::dec(n, k, nums);
    } else if ((nums.back() - nums.front() + 1) * 2 <= n) {
        ADDN2::dec(n, k, nums);
    } else {
        DIF1::dec(n, k, nums);
    }
}

int main() {
    int run;
    cin >> run;
    int cnt;
    cin >> cnt;
    if (run == 1) {
        for (int i = 0; i < cnt; i++) {
            solve1();
        }
    } else {
        for (int i = 0; i < cnt; i++) {
            solve2();
        }
    }
    return 0;
}