#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

int calcdp(const vector<pair<int, int>>& a, int cntcrd) {
    int n = (int)a.size();
    vector<int> dp(cntcrd);

    vector<vector<int>> ind(cntcrd);
    for (int i = 0; i < n; i++) {
        ind[a[i].second].emplace_back(i);
    }

    for (int i = 1; i < cntcrd; i++) {
        dp[i] = dp[i - 1];
        for (auto cind : ind[i]) {
            dp[i] = max(dp[i], dp[a[cind].first - 1] + 1);
        }
    }

    return dp[cntcrd - 1];
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> coords(2 * n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        coords[2 * i] = a[i].first;
        coords[2 * i + 1] = a[i].second;
    }

    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());

    for (int i = 0; i < n; i++) {
        a[i].first = lower_bound(coords.begin(), coords.end(), a[i].first) - coords.begin();
        a[i].second = lower_bound(coords.begin(), coords.end(), a[i].second) - coords.begin();
    }

    sort(a.begin(), a.end(), [](const pair<int, int>& p1, const pair<int, int>& p2) {
        return p1.second < p2.second;
    });

    int cm = calcdp(a, coords.size());

    for (unsigned mask = 0; mask < (1u << n); mask++) {
        if (__builtin_popcount(mask) != n / 2) {
            continue;
        }
        vector<pair<int, int>> cur;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                cur.emplace_back(a[i]);
            }
        }

        int curm = calcdp(cur, coords.size());
        if (curm == cm / 2) {
            for (int i = 0; i < n; i++) {
                if ((mask >> i) & 1) {
                    cout << i + 1 << " ";
                }
            }
            cout << "\n";
            return;
        }
    }

    assert(false);
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}