#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

void solve(long long n, const vector<long long>& w, long long k, long long a, long long b) {
    vector<vector<bool>> dp(a + 1, vector<bool>(b + 1));
    dp[0][0] = true;
    for (long long i = 0; i < n; i++) {
        if (w[i] <= k) {
            for (long long j = a; j >= 0; j--) {
                for (long long k = b; k >= 0; k--) {
                    if (j - w[i] >= 0) {
                        dp[j][k] = dp[j][k] || dp[j - w[i]][k];
                    }
                    if (k - w[i] >= 0) {
                        dp[j][k] = dp[j][k] || dp[j][k - w[i]];
                    }
                }
            }
        }
    }

    bool good = true;
    for (long long i = 0; i <= a; i++) {
        for (long long j = 0; j <= b; j++) {
            good &= dp[i][j];
        }
    }

    if (good) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}

int main() {
    long long n, q;
    cin >> n >> q;
    vector<long long> a(n);
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
    }

    long long z;
    cin >> z;
    assert(z == 0);

    for (long long i = 0; i < q; i++) {
        long long j, c, d;
        cin >> j >> c >> d;
        solve(n, a, j, c, d);
    }

    return 0;
}