#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

void solve(long long n, const vector<long long>& w, long long k, long long a, long long b, const vector<vector<bool>>& dp) {
    bool good = true;
    for (long long i = 0; i <= a; i++) {
        for (long long j = 0; j <= b; j++) {
            good &= dp[i][j];
        }
    }

    if (good) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}

int main() {
    long long n, q;
    cin >> n >> q;
    vector<long long> a(n);
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
    }

    long long z;
    cin >> z;
    assert(z == 0);

    vector<vector<bool>> dp(301, vector<bool>(301));
    dp[0][0] = true;
    for (long long i = 0; i < n; i++) {
        if (a[i] <= 300) {
            for (long long j = 300; j >= 0; j--) {
                for (long long k = 300; k >= 0; k--) {
                    if (j - a[i] >= 0) {
                        dp[j][k] = dp[j][k] || dp[j - a[i]][k];
                    }
                    if (k - a[i] >= 0) {
                        dp[j][k] = dp[j][k] || dp[j][k - a[i]];
                    }
                }
            }
        }
    }

    for (long long i = 0; i < q; i++) {
        long long j, c, d;
        cin >> j >> c >> d;
        solve(n, a, j, c, d, dp);
    }

    return 0;
}