/*
 * 9-57 Begin!
 * 10-10 I have some ideas and probably a full solution for A2~!
 */


#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;


int n, k, q;
vector<pair<int, int>> g;
vector<int> tin, tout;
vector<int> rot;
int timer = 0;

void dfs(int v, int p = -1, int rt = 0) {
    if (v == p) return;

    ++timer;
    tin[v] = timer;

    int le = g[v].first;
    int ri = g[v].second;
    if (le == -1) {
        rot[v] = rt;
    } else {
        int rt_left = (p != -1 and g[p].second == v);
        int rt_right = (p != -1 and g[p].first == v);

        dfs(le, v, rt + rt_left);
        dfs(ri, v, rt + rt_right);
    }

    ++timer;
    tout[v] = timer;
}

struct ev {
    int type = -1;  // -2 del(id) | -1 add(id) | 0 open | 1 close
    int x;
    int id;
    ev(int type, int x, int id) : type(type), x(x), id(id) {}
    bool operator<(const ev &o) {
        if (x != o.x) return x < o.x;
        if (type != o.type) return type < o.type;
        if (id != o.id) return id < o.id;
    }
};
vector<ev> evs;

vector<int> fen;
int _n;
void add(int i, int x) {
    for (; i < _n; i += i & -i) {
        fen[i] += x;
    }
}
int get(int i) {
    int r = 0;
    for (; i > 0; i -= i & -i) {
        r += fen[i];
    }
    return r;
}

int add_value(int v) {
    add(1 + v, 1);
}
int del_value(int v) {
    add(1 + v, -1);
}
int count_less_eq(int v) {
    return get(1 + v);
}

int main() {
#ifndef WIN32
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    // Task A2
    cin >> n >> k >> q;
    // Input tree
    g.resize(n, {-1, -1});
    tin.resize(n);
    tout.resize(n);
    rot.resize(n, n + 1);
    for (int i = 0; i < n; ++i) {
        int cc;
        cin >> cc;
        if (cc == 2) {
            int le, ri;
            cin >> le >> ri;
            --le, --ri;
            g[i] = {le, ri};
        }
    }
    // Calc tin, tout
    // Count rotations for each vertex
    // rot=Zero for non-leaf vertices
    dfs(0);
    //cout << "rot:"; for (auto i : rot) cout << " " << i;
    // Offline queries "count[<=k] on [tin(v)..tout(v)]"
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        --v;
        evs.emplace_back(0, tin[v] - 1, i);
        evs.emplace_back(1, tout[v], i);
    }
    for (int i = 0; i < n; ++i) {
        if (g[i].first != -1) continue;
        evs.emplace_back(-1, tin[i], rot[i]);
        evs.emplace_back(-2, tout[i], rot[i]);
    }
    sort(begin(evs), end(evs));

    fen.resize(_n = 2*n + 5);

    vector<int> ans_le(q, -1), ans_ri(q, -1);

    for (auto ev : evs) {
        int type = ev.type;
        int x = ev.x;
        int id = ev.id;
        // cout << "> ty" << type << " x" << x << " id" << id << endl;
        if (type == -1) {
            add_value(id);
        } else if (type == -2) {
            //del_value(id);
        } else if (type == 0) {
            ans_le[id] = count_less_eq(k);
        } else if (type == 1) {
            ans_ri[id] = count_less_eq(k);
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << (ans_ri[i] - ans_le[i]) << endl;
    }

    return 0;
}
