#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

//--------------------------------------

const int MAXN = 5005;

pt seg[MAXN];

const int LOG = 20;

int st[LOG][MAXN];

int getmin(int l, int r){
    int lg = 31 - __builtin_clz(r - l + 1);
    return min(st[lg][l], st[lg][r - (1 << lg) + 1]);
}

int dp[MAXN];
int d[MAXN][MAXN];
int pv[MAXN][MAXN];
vector<int> vec[MAXN];

int calc(vector<pt> &segs){
    for (int i = 0; i < 65; i++)
        vec[i].clear();
    for (int i = 0; i < sz(segs); i++)
        vec[segs[i].y].push_back(segs[i].x);
    sort(all(segs), [&](pt p, pt q){return p.x < q.x;});
    dp[0] = 0;
    for (int r = 1; r < 65; r++){
        dp[r] = dp[r - 1];
        for (auto l: vec[r]){
            dp[r] = max(dp[r], dp[l - 1] + 1);
        }
    }
    return dp[64];
}

void solve(){
    int n;
    cin >> n;
    map<int, int> coords;
    for (int i = 0; i < n; i++){
        cin >> seg[i].x >> seg[i].y;
        coords[seg[i].x] = 0, coords[seg[i].y] = 0;
    }
    int tt = 1;
    for (auto &[x, y]: coords)
        y = tt++;
    for (int i = 0; i < n; i++)
        seg[i].x = coords[seg[i].x], seg[i].y = coords[seg[i].y];
    for (int k = 0; k < LOG; k++)
        fill(st[k], st[k] + MAXN, 1e8);
    for (int i = 0; i < n; i++)
        st[0][seg[i].x] = min(st[0][seg[i].x], seg[i].y);
    for (int k = 1; k < LOG; k++){
        for (int i = 0; i < tt - (1 << k) + 1; i++)
            st[k][i] = min(st[k - 1][i], st[k - 1][i + (1 << (k - 1))]);
    }
    map<pt, int> inds;
    for (int i = 0; i < n; i++)
        inds[seg[i]] = i;
    vector<int> good;
    for (int i = 0; i < n; i++){
        auto [l, r] = seg[i];
        if (getmin(l + 1, r) > r && getmin(l, l) >= r)
            good.push_back(inds[{l, r}]);
    }
    sort(all(good));
    good.resize(unique(all(good)) - good.begin());
    sort(all(good), [&](int i, int j){return seg[i] < seg[j];});
    dp[0] = 1;
    for (int i1 = 1; i1 < sz(good); i1++){
        dp[i1] = 1;
        for (int j1 = 0; j1 < i1; j1++){
            int i = good[i1], j = good[j1];
            if (seg[j].y >= seg[i].x)
                continue;
            dp[i1] = max(dp[i1], dp[j1] + 1);
        }
    }

    int r = dp[sz(good) - 1];
    for (int mask = 0; mask < (1 << n); mask++){
        if (__builtin_popcount(mask) != n / 2)
            continue;
        vector<pt> segs;
        for (int i = 0; i < n; i++){
            if ((mask >> i) & 1)
                segs.push_back(seg[i]);
        }
        if (calc(segs) == r / 2){
            vector<int> ans;
            for (int i = 0; i < n; i++){
                if ((mask >> i) & 1)
                    cout << i + 1 << " ";
            }
            cout << '\n';
            return;
        }
    }
}

void run(){
    int t;
    cin >> t;
    while (t--)
        solve();
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    run();
    return 0;
}
