#include <bits/stdc++.h>

using namespace std;
#define int long long

struct SEGT {
    vector<pair<int, int>> tree;
    int n;

    void init(int nn) {
        n = nn;
        tree.resize(2 * n, {0, -1});
    }

    void change(int ind, pair<int, int> el, int l, int r, int x = 0) {
        if (r - l == 1) {
            tree[x] = max(tree[x], el);
            return;
        }
        int mid = (l + r) / 2;
        if (ind < mid) {
            change(ind, el, l, mid, x + 1);
        } else {
            change(ind, el, mid, r, x + 2 * (mid - l));
        }
        tree[x] = max(tree[x + 1], tree[x + 2 * (mid - l)]);
    }

    pair<int, int> get(int l, int r, int lx, int rx, int x = 0) {
        if (l >= r) {
            return {0, -1};
        }
        if (l <= lx and rx <= r) {
            return tree[x];
        }
        if (l >= rx or lx >= r) {
            return {0, -1};
        }
        int mid = (lx + rx) / 2;
        return max(get(l, r, lx, mid, x + 1), get(l, r, mid, rx, x + 2 * (mid - lx)));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> vec(n);
    vector<int> xs;
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first.first >> vec[i].first.second;
        xs.push_back(vec[i].first.second);
        xs.push_back(vec[i].first.first);
        vec[i].second = i;
    }
    sort(xs.begin(), xs.end());
    for (int i = 0; i < n; ++i) {
        vec[i].first.first = lower_bound(xs.begin(), xs.end(), vec[i].first.first) - xs.begin();
        vec[i].first.second = lower_bound(xs.begin(), xs.end(), vec[i].first.second) - xs.begin();
    }
    sort(vec.begin(), vec.end(), [&](pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
        return a.first.second < b.first.second;
    });
    vector<int> dp(n);
    int m = 0;
    map<int, vector<int>> mps;
    SEGT tt;
    tt.init(xs.size());
    for (int i = 0; i < n; ++i) {
        dp[i] = tt.get(0, vec[i].first.first, 0, tt.n).first + 1;
//        for (int j = 0; j < i; ++j) {
//            if (vec[j].first.second < vec[i].first.first) {
//                dp[i] = max(dp[i], dp[j] + 1);
//            }
//        }
        tt.change(vec[i].first.second, {dp[i], i}, 0, tt.n);
        m = max(m, dp[i]);
        mps[dp[i]].push_back(i);
    }
    if (m % 2) {
        exit(1);
    }
    map<int, vector<int>> have;
    for (int i = m; i >= 1; --i) {
        for (auto c: mps[i]) {
            have[i].push_back(c);
        }
        int mx = 0;
        for (auto c: have[i]) {
            mx = max(mx, vec[c].first.first);
        }
    }
    set<int> ans;
    for (int i = 0; i < n; ++i) {
        ans.insert(i);
    }
    vector<pair<int, int>> cand;
    for (auto c: have) {
        cand.push_back({c.second.size(), c.first});
    }
    sort(cand.begin(), cand.end());
    for (int i = 0; i < cand.size() / 2; ++i) {
        for (auto c: have[cand[i].second]) {
            ans.erase(vec[c].second);
        }
        have[cand[i].second].clear();
    }
    if (ans.size() < n / 2) exit(1);
    vector<pair<pair<int, int>, int>> vec2;
    for (auto c: have) {
        for (auto c2: c.second) {
            vec2.push_back(vec[c2]);
        }
    }

    vector<int> dp2(vec2.size(), 0);
    vector<int> pr(vec2.size(), -1);
    for (int i = 0; i < vec2.size(); ++i) {
        dp2[i] = 1;
        pr[i] = -1;
        for (int j = 0; j < i; ++j) {
            if (vec2[j].first.second >= vec2[i].first.first) continue;
            if (dp2[j] + 1 > dp2[i]) {
                dp2[i] = dp2[j] + 1;
                pr[i] = j;
            }
        }
        if (dp2[i] > m / 2) exit(1);
    }
    int ind = max_element(dp2.begin(), dp2.end()) - dp2.begin();
    if (dp2[ind] != m / 2) {
        exit(1);
    }
    set<int> mai;
    while (ind != -1) {
        mai.insert(vec2[ind].second);
        ind = pr[ind];
    }
    if (mai.size() != m / 2) exit(1);
    for (int i = 0; i < n and ans.size() > n / 2; ++i) {
        if (mai.find(i) != mai.end()) continue;
        ans.erase(i);
    }
    if (ans.size() > n / 2) exit(1);
    for (auto c: ans) {
        cout << c + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
