#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
//#define int long long
using namespace std;
using ll = long long;

constexpr int MAXN = 2048, INF = 800042927;

struct SegTree {
    vector<int> tree;
    void init(int sz) {
        tree.assign(2 * sz, -INF);
    }
    void update(int pos, int val) {
        tree[pos += tree.size() / 2] = val;
        for (pos /= 2; pos > 0; pos /= 2) {
            tree[pos] = max(tree[pos * 2], tree[pos * 2 + 1]);
        }
    }
    int get(int l, int r) {
        int mx = 0;
        for (l += tree.size() / 2, r += tree.size() / 2; l < r; l /= 2, r /= 2) {
            if (l & 1) {
                mx = max(mx, tree[l++]);
            }
            if (r & 1) {
                mx = max(mx, tree[--r]);
            }
        }
        return mx;
    }
};

SegTree sl[MAXN], sr[MAXN];

void do_update(int i, int j, int val) {
//    cerr << "POP" << i << ' ' << j << ' ' << val << '\n';
    sl[i].update(j, val);
    sr[j].update(i, val);
}

int upqx[2 * MAXN], upqy[2 * MAXN], upv[2 * MAXN], upqptr;

void run_updates() {
    while (upqptr) {
        --upqptr;
        do_update(upqx[upqptr], upqy[upqptr], upv[upqptr]);
    }
}

void update(int i, int j, int val) {
//    cerr << "PUSH" << i << ' ' << j << ' ' << val << '\n';
    upqx[upqptr] = i;
    upqy[upqptr] = j;
    upv[upqptr] = val;
    ++upqptr;
}

vector<int> still_valid[MAXN]; // [maxA][minB]

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tc;
    cin >> tc;
    while (tc --> 0) {
        int n;
        cin >> n;
        vector<int> vh;
        vh.reserve(n + 2);
        vh.push_back(0);
        vh.push_back(n + 1);
        for (int i = 0; i <= n + 1; ++i) {
            sl[i].init(n + 2);
            sr[i].init(n + 2);
            still_valid[i].resize(n + 2);
            std::iota(still_valid[i].begin(), still_valid[i].end(), 0);
        }
        do_update(0, n + 1, 0);
        for (int i = 0; i < n; ++i) {
            int p;
            cin >> p;
            for (int mx = 0; mx < p; ++mx) {
                while (!still_valid[mx].empty() && still_valid[mx].back() > p) {
                    do_update(mx, still_valid[mx].back(), -INF);
                    still_valid[mx].pop_back();
                }
            }
            // p is left
            for (int j : vh) {
                // MAX_P = p, MIN_Q = j
                update(p, j, sr[j].get(p + 1, n + 2) + 1);
                update(j, p, sl[j].get(0, p) + 1);
            }
            vh.push_back(p);
            run_updates();
        }
        int ans = 0;
        for (int i = 0; i <= n + 1; ++i) {
            ans = max<int>(ans, sl[i].get(0, n + 2));
        }
        cout << ans << '\n';
    }
    return 0;
}
