//#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
//#define int long long
using namespace std;
using ll = long long;

int last_trie = 0;

constexpr int MAXN =
#ifdef LOCAL
        100000
#else
        10111222
#endif
        ;

struct bittrie {
    int level = 0;  // 2^0
    int size = 0;
    int go0 = -1, go1 = -1;
    int get_mex();
    void xorswap(int);
    void add(int);
} tries[MAXN];

void bittrie::add(int v) {
    ++size;
    if (level == 0) return;
    if (v >> (level - 1) & 1) {
        if (go1 == -1) {
            go1 = last_trie;
            tries[go1].level = level - 1;
            ++last_trie;
        }
        tries[go1].add(v);
    } else {
        if (go0 == -1) {
            go0 = last_trie;
            tries[go0].level = level - 1;
            ++last_trie;
        }
        tries[go0].add(v);
    }
}

int bittrie::get_mex() {
    if (size == (1 << level)) {
        return size;
    }
    if (level == 0) {
        return 0;
    } else {
        if (go0 == -1) {
            return 0;
        }
        if (tries[go0].size != (1 << (tries[go0].level))) {
            return tries[go0].get_mex();
        } else {
            if (go1 == -1) {
                return 1 << (tries[go0].level);
            }
            return tries[go1].get_mex() + (1 << (tries[go0].level));
        }
    }
}

void bittrie::xorswap(int with) {
    if (with >> (level - 1) & 1) {
        swap(go1, go0);
    }
    if (go0 != -1) {
        tries[go0].xorswap(with);
    }
    if (go1 != -1) {
        tries[go1].xorswap(with);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int MOD;
    cin >> MOD;

    int tc;
    cin >> tc;
    while (tc --> 0) {
        int k, n, p;
        cin >> k >> n >> p;
        int ans = 0;
        int lt = 1 << k;
        for (int mask = 0; mask < (1 << lt); mask += 2) {
            if (__builtin_popcount(mask) != n - 1) continue;
            int root = last_trie;
            ++last_trie;
            tries[root].level = k;
            tries[root].add(0);
            for (int b = 1; b < lt; ++b) {
                if (mask >> b & 1) {
                    tries[root].add(b);
                }
            }
            int last_mex = tries[root].get_mex();
            int it = 0;
            while (true) {
                ++it;
                if (it > 4) {
                    last_mex = -1;
                    break;
                }
                 tries[root].xorswap(last_mex - 1);
                 int new_mex = tries[root].get_mex();
                 if (new_mex == last_mex) {
                     break;
                 }
                 last_mex = new_mex;
            }
            if (last_mex == p) {
                ++ans;
                if (ans == MOD) ans = 0;
            }
        }
        cout << ans << '\n';
    }

    return 0;
}
