#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);

    cin.tie(0);
    cout.tie(0);

    ll h, w, k;
    cin >> h >> w >> k;

    vector<pair<ll, ll>> cells_sorted_x(k);
    vector<pair<ll, ll>> cells_sorted_y(k);

    for (int i = 0; i < k; ++i) {
        ll x, y;
        cin >> y >> x;
        cells_sorted_x[i] = {x, y};
        cells_sorted_y[i] = {x, y};
    }

    sort(cells_sorted_x.begin(), cells_sorted_x.end(), [](pair<ll, ll> &a, pair<ll, ll> &b) {
        return a.first < b.first;
    });
    sort(cells_sorted_y.begin(), cells_sorted_y.end(), [](pair<ll, ll> &a, pair<ll, ll> &b) {
        return a.second < b.second;
    });

    // left-right move
    ll minimum_width = 1e10;
    ll minimum_width_move = -1;

    ll leftmost = 0;
    ll rightmost = k - 1;

    for (ll i = 0; i < w; ++i) {
        auto right = cells_sorted_x[rightmost];
        auto left = cells_sorted_x[leftmost];

        ll width = (right.first - left.first + w) % w + 1;

        // add check
        if (width < minimum_width) {
            minimum_width = width;
            minimum_width_move = i;
        }
        if (width == minimum_width) {
            if (min(minimum_width_move, w - minimum_width_move) > min(i, w - i)) {
                minimum_width = width;
                minimum_width_move = i;
            }
        }

        while (cells_sorted_x[rightmost].first + i == w && rightmost != 0) {
            leftmost = rightmost;
            rightmost--;
        }
    }


    ll minimum_height = 1e10;
    ll minimum_height_move = -1;

    ll topmost = 0;
    ll bottommost = k - 1;

    for (ll i = 0; i < h; ++i) {
        auto bottom = cells_sorted_y[bottommost];
        auto top = cells_sorted_y[topmost];

        ll height = (bottom.second - top.second + h) % h + 1;

//        cout << bottommost << " " << topmost << " " << height << endl;

        // add check
        if (height < minimum_height) {
            minimum_height = height;
            minimum_height_move = i;
        }
        if (height == minimum_height) {
            if (min(minimum_height_move, h - minimum_height_move) > min(i, h - i)) {
                minimum_height = height;
                minimum_height_move = i;
            }
        }

        while (cells_sorted_y[bottommost].second + i == h && bottommost != 0) {
            topmost = bottommost;
            bottommost--;
        }
    }

    cout << minimum_height * minimum_width << " " << min(minimum_height_move, h - minimum_height_move) + min(minimum_width_move, w - minimum_width_move) << endl;

    return 0;
}