#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

ll mod(ll x, ll m) {
    if (x > m)
        return x - m;

    return x;
}

int main() {
    ll h, w, k;
    cin >> h >> w >> k;

    set<ll> cells_sorted_x;
    set<ll> cells_sorted_y;

    for (int i = 0; i < k; ++i) {
        ll x, y;
        cin >> y >> x;
        cells_sorted_x.insert(x);
        cells_sorted_y.insert(y);
    }

    // minimum width
    ll minimum_width = *prev(cells_sorted_x.end()) - *cells_sorted_x.begin() + 1;
    ll minimum_width_move = 0;

    if (cells_sorted_x.size() == 1) {
        minimum_width = 1;
        minimum_width_move = 0;
    } else {
        auto rightmost = prev(cells_sorted_x.end());
        auto leftmost = cells_sorted_x.begin();

        leftmost = rightmost;
        rightmost--;

        for (ll i = 1; i < cells_sorted_x.size(); ++i) {
            ll left = *leftmost;
            ll right = *rightmost;
            ll offset = w + 1 - *next(rightmost);
            ll width = mod((right + offset), w) - mod((left + offset), w) + 1;

            ll right_border = w - right;
            ll left_border = left - 1;

            if (width < minimum_width) {
                minimum_width = width;
                minimum_width_move = min(min(right_border, w - right_border), min(left_border, w - left_border));
            } else if (width == minimum_width) {
                minimum_width_move = min(minimum_width_move,
                                         min(min(right_border, w - right_border), min(left_border, w - left_border)));
            }

            leftmost = rightmost;
            rightmost--;
        }
    }

    // minimum height
    ll minimum_height = *prev(cells_sorted_y.end()) - *cells_sorted_y.begin() + 1;
    ll minimum_height_move = 0;

    if (cells_sorted_y.size() == 1) {
        minimum_height = 1;
        minimum_height_move = 0;
    } else {
        auto rightmost = prev(cells_sorted_y.end());
        auto leftmost = cells_sorted_y.begin();

        leftmost = rightmost;
        rightmost--;

        for (ll i = 1; i < cells_sorted_y.size(); ++i) {
            ll left = *leftmost;
            ll right = *rightmost;
            ll offset = h + 1 - *next(rightmost);
            ll width = mod((right + offset), h) - mod((left + offset), h) + 1;

            ll right_border = h - right;
            ll left_border = left - 1;

            if (width < minimum_height) {
                minimum_height = width;
                minimum_height_move = min(min(right_border, h - right_border), min(left_border, h - left_border));
            } else if (width == minimum_height) {
                minimum_height_move = min(minimum_height_move,
                                         min(min(right_border, h - right_border), min(left_border, h - left_border)));
            }

            leftmost = rightmost;
            rightmost--;
        }
    }

//    cout << minimum_width << " " << minimum_width_move << endl;
//    cout << minimum_height << " " << minimum_height_move << endl;

    cout << minimum_height * minimum_width << " " << minimum_width_move + minimum_height_move << endl;

    return 0;
}