#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>

using namespace std;

using ll = long long;

struct Node {
    Node *l{nullptr}, *r{nullptr};
    ll rotations = 0;

    ll leaves_cnt{0};
};


void calc_rotations(Node *node, bool prev_left) {
    if (!node) {
        return;
    }

    if (node->l) {
        node->l->rotations = node->rotations + (prev_left ? 0 : 1);

        calc_rotations(node->l, true);
    }
    if (node->r) {
        node->r->rotations = node->rotations + (prev_left ? 1 : 0);

        calc_rotations(node->r, false);
    }
}

void calc_leaves(Node *node, ll k) {
    if (!node) {
        return;
    }

    calc_leaves(node->l, k);
    calc_leaves(node->r, k);

    if (node->l) {
        node->leaves_cnt += node->l->leaves_cnt;
    }
    if (node->r) {
        node->leaves_cnt += node->r->leaves_cnt;
    }
    if (!node->l && !node->r) {
        node->leaves_cnt = (node->rotations <= k ? 1 : 0);
    }
}

int main() {
    ll n, k, q;
    cin >> n >> k >> q;

    vector<Node *> nodes(n);

    for (int i = 0; i < n; ++i) {
        nodes[i] = new Node();
    }

    for (int i = 0; i < n; ++i) {
        ll t;
        cin >> t;

        if (t != 0) {
            ll l, r;
            cin >> l >> r;
            l--, r--;

            nodes[i]->l = nodes[l];
            nodes[i]->r = nodes[r];
        }
    }

    Node *start = nodes[0];
    calc_rotations(start->l, true);
    calc_rotations(start->r, false);

    calc_leaves(start, k);

    for (int i = 0; i < q; ++i) {
        ll u;
        cin >> u;

        cout << nodes[u - 1]->leaves_cnt << endl;
    }

    return 0;
}