//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 2'000'000'000;

mt19937 rnd(time(0));

void dfs(ll v, ll p, vector<vector<ll>>& tree, vector<ll>& dp) {
	for (auto i : tree[v]) {
		if (i != p) {
			dfs(i, v, tree, dp);
			dp[v] += dp[i];
		}
	}
}

vector<ll> solve(ll n, vector<pair<ll, ll>> arr) {
	vector<pair<pair<ll, ll>, ll>> sob;
	for (ll i = 0; i < n; i++) {
		sob.emplace_back(make_pair(arr[i].second, -arr[i].first), i);
	}
	sort(sob.begin(), sob.end());
	vector<vector<ll>> tree(n);
	set<pair<ll, ll>> open;
	for (auto[lr, i] : sob) {
		auto[x, y] = lr;
		y = -y;
		while (!open.empty() && open.rbegin()->first >= y) {
			tree[i].push_back(open.rbegin()->second);
			open.erase(*open.rbegin());
		}
		open.insert(make_pair(y, i));
	}
	vector<ll> l;
	for (ll i = 0; i < n; i++) {
		if (tree[i].size() == 0) {
			l.push_back(i);
		}
	}
	set<ll> roots;
	for (ll i = 0; i < n; i++) {
		roots.insert(i);
	}
	for (ll i = 0; i < n; i++) {
		for (auto j : tree[i]) {
			roots.erase(j);
		}
	}
	while (true) {
		shuffle(l.begin(), l.end(), rnd);
		vector<ll> fir;
		for (ll i = 0; i < l.size() / 2; i++) {
			fir.push_back(l[i]);
		}
		vector<ll> dp(n, 0);
		for (auto i : fir) {
			dp[i] = 1;
		}
		for (auto r : roots) {
			dfs(r, r, tree, dp);
		}
		ll col = 0;
		for (auto i : dp) {
			col += i > 0;
		}
		if (col >= n / 2) {
			for (ll i = 0; i < n; i++) {
				if (fir.size() < n / 2 && dp[i] > 0 && tree[i].size() > 0) {
					fir.push_back(i);
				}
			}
			for (auto& i : fir) {
				i++;
			}
			return fir;
		}
	}
}

bool rec(ll n, vector<ll>& now, vector<pair<ll, ll>>& arr, ll ans, ll na, ll l) {
	if (na > ans / 2) {
		return false;
	}
	if (na == ans / 2 && now.size() == n / 2) {
		return true;
	}
	if (now.size() == n / 2) {
		return false;
	}
	if (n - (now.empty() ? 0 : now.back()) - 1 + now.size() < n / 2) {
		return false;
	}
	now.push_back((now.empty() ? 0 : now.back() + 1));
	for (; now.back() < n; now.back()++) {
		ll nna = na, nl = l;
		if (arr[now.back()].first > nl) {
			nna++;
			nl = arr[now.back()].second;
		}
		if (rec(n, now, arr, ans, nna, nl)) {
			return true;
		}
	}
	now.pop_back();
	return false;
}

bool cmp(pair<pair<ll, ll>, ll> p1, pair<pair<ll, ll>, ll> p2) {
	return p1.first.second < p2.first.second;
}

vector<ll> stupid(ll n, vector<pair<ll, ll>> arr) {
	vector<pair<pair<ll, ll>, ll>> narr(n);
	for (ll i = 0; i < n; i++) {
		narr[i].first = arr[i];
		narr[i].second = i;
	}
	sort(narr.begin(), narr.end(), cmp);
	vector<ll> to(n);
	for (ll i = 0; i < n; i++) {
		arr[i] = narr[i].first;
		to[i] = narr[i].second;
	}
	vector<pair<ll, ll>> sob;
	for (ll i = 0; i < n; i++) {
		sob.emplace_back(arr[i].second, i);
	}
	ll l = 0, ans = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (arr[i].first > l) {
			l = x;
			ans++;
		}
	}
	vector<ll> now;
	rec(n, now, arr, ans, 0, 0);
	for (auto& i : now) {
		i = to[i];
		i++;
	}
	return now;
}

bool check(ll n, vector<pair<ll, ll>> fir, vector<ll> a) {
	vector<pair<ll, ll>> sob;
	for (ll i = 0; i < n; i++) {
		sob.emplace_back(fir[i].second, i);
	}
	ll l = 0, ans = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (fir[i].first > l) {
			l = x;
			ans++;
		}
	}
	if (ans % 2 == 1) {
		return true;
	}
	if (a.size() != n / 2) {
		return false;
	}
	vector<pair<ll, ll>> sec;
	for (auto i : a) {
		sec.push_back(fir[i - 1]);
	}
	sob.clear();
	l = 0;
	ll na = 0;
	for (ll i = 0; i < n / 2; i++) {
		sob.emplace_back(sec[i].second, i);
	}
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (sec[i].first > l) {
			l = x;
			na++;
		}
	}
	return na == ans / 2;
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	if (l) {
		for (ll t = 1;; t++) {
			ll n = 6, mx = 9;
			vector<pair<ll, ll>> arr(n);
			for (auto&[l, r] : arr) {
				l = rnd() % mx + 1;
				r = rnd() % mx + 1;
				if (r < l) {
					swap(l, r);
				}
			}
			if (!check(n, arr, solve(n, arr))) {
				cout << n << '\n';
				for (auto[l, r] : arr) {
					cout << l << ' ' << r << '\n';
				}
				break;
			}
			cout << "OK " << t << endl;
		}
	} else {
		ll t;
		cin >> t;
		while (t--) {
			ll n;
			cin >> n;
			vector<pair<ll, ll>> arr(n);
			for (auto&[l, r] : arr) {
				cin >> l >> r;
			}
			for (auto i : solve(n, arr)) {
				cout << i << ' ';
			}
			cout << '\n';
		}
	}
}
