//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll x, y, m;

void dfs(ll v, ll p, vector<ll>& dpv, vector<ll>& dp, vector<vector<ll>>& tree, vector<ll>& c) {
	dp[v] = c[v];
	for (auto i : tree[v]) {
		if (i != p) {
			dfs(i, v, dpv, dp, tree, c);
			dp[v] += dpv[i];
			dpv[v] += dp[i];
		}
	}
	assign_max(dp[v], dpv[v]);
}

pair<ll, pair<ll, vector<ll>>> count(vector<ll> c, vector<vector<ll>> tree) {
	ll n = c.size();
	vector<ll> dp(n), dpv(n);
	dfs(0, 0, dpv, dp, tree, c);
	ll ans = dp[0], aa = 0;
	for (ll i = 0; i < n; i++) {
		aa ^= (x * (i + 1) + y * c[i] * c[i]) % m;
	}
	return make_pair(ans, make_pair(aa, c));
}

void rec(vector<pair<ll, ll>>& arr, vector<ll>& now, ll nn, vector<vector<ll>>& tree, map<ll, pair<ll, vector<ll>>>& ans) {
	ll n = tree.size();
	if (nn == n) {
		auto[a, b] = count(now, tree);
		ans[a] = b;
		return;
	}
	for (now[nn] = arr[nn].first; now[nn] <= arr[nn].second; now[nn]++) {
		rec(arr, now, nn + 1, tree, ans);
	}
}

void solve() {
	ll n, q;
	cin >> n >> q;
	cin >> x >> y >> m;
	vector<vector<ll>> tree(n);
	for (ll i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		tree[a].push_back(b);
		tree[b].push_back(a);
	}
	vector<pair<ll, ll>> arr(n);
	for (auto&[l, r] : arr) {
		cin >> l >> r;
	}
	vector<ll> qs(q);
	for (ll i = 0; i < q; i++) {
		cin >> qs[i];
	}
	map<ll, pair<ll, vector<ll>>> ans;
	vector<ll> now(n);
	rec(arr, now, 0, tree, ans);
	for (auto i : qs) {
		if (ans.find(i) == ans.end()) {
			cout << -1 << ' ';
		} else {
			cout << ans[i].first << ' ';
		}
	}
	cout << endl;
	ll x;
	cin >> x;
	while (x) {
		x--;
		if (ans.find(qs[x]) == ans.end()) {
			cout << -1 << endl;
		} else {
			for (auto i : ans[qs[x]].second) {
				cout << i << ' ';
			}
			cout << endl;
		}
		cin >> x;
	}
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
