#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif

#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;


struct DebugPrint : ostream {} cnul;
template <class T>
DebugPrint& operator<<(DebugPrint& dst, const T& src) {return dst;}
#ifdef LOCAL_JUDGE
#define cdbg cout
#define dprint(x) cdbg << #x << ": " << x << endl;
#else
#define cdbg cnul
#define dprint(x)
#endif


struct Event {
  size_t x, t, seg;
  Event(size_t _x, size_t _t, size_t _seg) : x(_x), t(_t), seg(_seg) {}
};
bool operator<(const Event& a, const Event& b) {
  return tie(a.x, a.t, a.seg) < tie(b.x, b.t, b.seg);
}
vector<Event> events;
vector<size_t> segments_before;
size_t ind_segs(size_t mask) {
  size_t max_visited_segs = 0;
  for (auto& e : events) {
    if ((mask >> e.seg) & 1) continue;
    if (e.t == 0) {
      segments_before[e.seg] = max_visited_segs + 1;
    } else {
      max_visited_segs = max(max_visited_segs, segments_before[e.seg]);
    }
  }
  return max_visited_segs;
}


size_t t, n, mask, i, l, r;
int main() {
  #ifdef LOCAL_JUDGE
  freopen("/home/roi/work/0405B/test.in", "r", stdin);
  #endif

  ios_base::sync_with_stdio(false); cin.tie(NULL);

  cin >> t; while (t--) {
    cin >> n;
    events.clear(); segments_before.resize(n);
    for (i = 0; i < n; i++) {
      cin >> l >> r;
      events.emplace_back(l, 0, i);
      events.emplace_back(r, 1, i);
    }
    sort(events.begin(), events.end());

    if (n > 30) {
      for (i = 0; i < n; i += 2) cout << i + 1 << " ";
      cout << "\n";
      continue;
    }

    size_t m = ind_segs(0);

    for (mask = (1ull << (n / 2)) - 1; mask < (1ull << n); mask++) {
      if (__builtin_popcountll(mask) != n / 2) continue;
      cdbg << "mask " << mask << " -> " << ind_segs(mask) << endl;
      if (ind_segs(mask) == m / 2) {
        for (i = 0; i < n; i++) {
          if ((mask >> i) & 1) continue;
          cout << i + 1 << " ";
        }
        cout << "\n";
        break;
      }
    }

    dprint(m);
  }

  return 0;
}
