#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif

#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;


void mxz(size_t& a, const size_t& b) {
  a = max(a, b);
}
void mxz(ps& a, const ps& b) {
  mxz(a.first,  b.first);
  mxz(a.second, b.second);
}
void add(ps& a, const ps& b) {
  a.first += b.first; a.second += b.second;
}


vector<size_t> plan;
vector<vector<size_t>> edges, plans;
vector<ps> answer_no, answer_take, answer_maybe, own_range;
void calc_answer(size_t u, size_t parent) {
  answer_no[u] = answer_maybe[u] = make_pair(0, 0);
  answer_take[u] = own_range[u];

  for (auto& v : edges[u]) {
    if (v == parent) continue;

    calc_answer(v, u);
    add(answer_no[u], answer_maybe[v]);
    add(answer_take[u], answer_no[v]);
  }

  mxz(answer_maybe[u], answer_no[u]);
  mxz(answer_maybe[u], answer_take[u]);
}
void achieve_plan(size_t u, size_t parent, size_t eff, bool can_cars) {
  if (answer_take[u].first <= eff && eff <= answer_take[u].second && can_cars) {
    // this factory is producing cars

    eff -= answer_take[u].first;  // skipping mandatory efficiency; now `eff` contains additional one
    plan[u] = min(eff, own_range[u].second - own_range[u].first); eff -= plan[u]; plan[u] += own_range[u].first;

    for (auto& v : edges[u]) {
      if (v == parent) continue;

      size_t v_eff = min(eff, answer_no[v].second - answer_no[v].first);
      achieve_plan(v, u, v_eff + answer_no[v].first, false);
      eff -= v_eff;
    }
  } else {
    // this factory is NOT producing cars

    eff -= answer_no[u].first;
    plan[u] = own_range[u].first;

    for (auto& v : edges[u]) {
      if (v == parent) continue;

      size_t v_eff = min(eff, answer_maybe[v].second - answer_maybe[v].first);
      achieve_plan(v, u, v_eff + answer_maybe[v].first, true);
      eff -= v_eff;
    }
  }
}

size_t t, n, q, u, v, cert_x, cert_y, cert_m, i;
size_t certificate() {
  size_t c = 0;
  for (size_t j = 0; j < n; j++)
    c ^= (cert_x * (j + 1) + cert_y * plan[j] * plan[j]) % cert_m;
  return c;
}


int main() {
  #ifdef LOCAL_JUDGE
  freopen("/home/roi/work/0405D/test.in", "r", stdin);
  #endif

  ios_base::sync_with_stdio(false); cin.tie(NULL);

  cin >> t; while (t--) {
    cin >> n >> q >> cert_x >> cert_y >> cert_m;
    edges.clear(); edges.resize(n);
    for (i = 1; i < n; i++) {
      cin >> u >> v; --u; --v;
      edges[u].push_back(v);
      edges[v].push_back(u);
    }
    answer_no.resize(n); answer_maybe.resize(n); answer_take.resize(n);
    own_range.resize(n); for (auto& [a, b] : own_range) cin >> a >> b;

    calc_answer(0, -1ull);

    plans.clear(); plans.reserve(q); plan.resize(n);
    while (q--) {
      cin >> u;
      if (answer_maybe[0].first <= u && u <= answer_maybe[0].second) {
        achieve_plan(0, -1ull, u, true);
        cout << certificate() << " ";

        plans.emplace_back();
        swap(plans.back(), plan);
      } else {
        plans.emplace_back();
        cout << "-1 ";
      }
    }
    cout << endl;

    while (true) {
      cin >> u;
      if (!u) break;
      --u;

      if (plans[u].empty()) cout << "-1";
      for (auto& p : plans[u]) cout << p << " ";
      cout << endl;
    }
  }

  return 0;
}
