#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 21;

bool sub1(long long n, vector<long long>& v)
{
	if (n > 200)
	{
		return false;
	}

	vector<vector<long long>> dp(n + 1, vector<long long>(n + 1, -INF));
	dp[n][n] = 0;
	for (long long i = 0; i < n; i++)
	{
		vector<vector<long long>> upd(n + 1, vector<long long>(n + 1, -INF));
		for (long long mx = 0; mx < n + 1; mx++)
		{
			for (long long mn = 0; mn < n + 1; mn++)
			{
				if (dp[mx][mn] == -INF)
				{
					continue;
				}

				if (mx == n || v[i] > mx)
				{
					upd[v[i]][mn] = max(upd[v[i]][mn], dp[mx][mn] + 1);
				}
				else
				{
					upd[mx][mn] = max(upd[mx][mn], dp[mx][mn]);
				}

				if (mn == n || v[i] < mn)
				{
					upd[mx][v[i]] = max(upd[mx][v[i]], dp[mx][mn] + 1);
				}
				else
				{
					upd[mx][mn] = max(upd[mx][mn], dp[mx][mn]);
				}
			}
		}
		swap(dp, upd);
	}

	long long ans = -INF;
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < n; j++)
		{
			ans = max(ans, dp[i][j]);
		}
	}
	cout << ans << "\n";
	return true;
}

struct sparse_table
{
	long long n;
	vector<vector<long long>> t;
	vector<long long> lg;

	sparse_table(vector<long long>& in)
	{
		n = in.size();
		lg.resize(in.size() + 5);
		for (long long i = 2; i < lg.size(); i++)
		{
			lg[i] = lg[i / 2] + 1;
		}

		t.resize(LOG);
		t[0].resize(in.size());
		for (long long i = 0; i < in.size(); i++)
		{
			t[0][i] = in[i];
		}

		long long len = 1;
		for (long long i = 1; i < LOG; i++)
		{
			if (len * 2 > n)
			{
				break;
			}

			t[i].resize(in.size() - len * 2 + 1);
			for (long long j = 0; j < t[i].size(); j++)
			{
				t[i][j] = max(t[i - 1][j], t[i - 1][j + len]);
			}
			len *= 2;
		}
	}

	long long get(long long l, long long r)
	{
		long long clg = lg[r - l + 1];
		long long len = (1ll << clg);
		return max(t[clg][l], t[clg][r - len + 1]);
	}

	long long find_gt(long long l, long long r, long long val)
	{
		if (l > r || l >= n)
		{
			return -1;
		}
		if (get(l, r) <= val)
		{
			return -1;
		}

		long long left = l - 1, right = r;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			if (get(l, mid) > val)
			{
				right = mid;
			}
			else
			{
				left = mid;
			}
		}
		return right;
	}
};

pair<long long, long long> fuck(vector<vector<long long>>& binup, long long v, long long to)
{
	long long cnt = 1;
	for (long long i = LOG - 1; i > -1; i--)
	{
		if (binup[v][i] <= to)
		{
			v = binup[v][i];
			cnt += (1ll << i);
		}
	}
	return { v, cnt };
}

void solve()
{
	long long n;
	vector<long long> v;
	cin >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
		v[i]--;
	}
	if (sub1(n, v))
	{
		return;
	}
	
	vector<long long> gt(n, n);
	vector<long long> st;
	for (long long i = n - 1; i > -1; i--)
	{
		while (st.size() && v[st.back()] <= v[i])
		{
			st.pop_back();
		}
		if (st.size())
		{
			gt[i] = st.back();
		}
		st.push_back(i);
	}

	vector<long long> lw(n, n);
	st = {};
	for (long long i = n - 1; i > -1; i--)
	{
		while (st.size() && v[st.back()] >= v[i])
		{
			st.pop_back();
		}
		if (st.size())
		{
			lw[i] = st.back();
		}
		st.push_back(i);
	}

	vector<vector<long long>> binup(n + 1, vector<long long>(LOG, n));
	for (long long i = n - 1; i > -1; i--)
	{
		binup[i][0] = gt[i];
		for (long long j = 1; j < LOG; j++)
		{
			binup[i][j] = binup[binup[i][j - 1]][j - 1];
		}
	}

	long long mx = -1, cntup = 0;
	long long ans = 0;
	sparse_table sptb(v);
	for (long long i = 0; i < n; i++)
	{
		long long cur = cntup + 1;
		long long ngt = sptb.find_gt(i + 1, n - 1, mx);
		if (ngt != -1)
		{
			auto [to, add] = fuck(binup, ngt, n - 1);
			cur += add;
		}
		ans = max(ans, cur);

		if (lw[i] != n)
		{
			cur = cntup + 2;

			long long left = i, right = lw[i];
			ngt = sptb.find_gt(left + 1, right - 1, mx);
			long long nmx = mx;
			if (ngt != -1)
			{
				nmx = v[ngt];
				auto [to, add] = fuck(binup, ngt, right - 1);
				cur += add;
			}
			ngt = sptb.find_gt(right + 1, n - 1, nmx);
			if (ngt != -1)
			{
				auto [to, add] = fuck(binup, ngt, n - 1);
				cur += add;
			}
			ans = max(ans, cur);
		}

		if (v[i] > mx)
		{
			mx = v[i];
			cntup++;
		}
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*





















*/
