#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

#pragma GCC optmize("Ofast")
#pragma GCC optmize("unroll-loops")
#pragma GCC optmize("unswitch-loops")

const long long INF = 1e18, MOD = 1e9 + 7;

long long M;
long long hsh[280000];

void precalc()
{
	for (long long i = 0; i < 280000; i++)
	{
		hsh[i] = rnd();
	}
}

long long geth(vector<long long>& v)
{
	long long sum = 0;
	for (auto& i : v)
	{
		sum += hsh[i];
	}
	return sum;
}

map<long long, long long> dp, dmex;

long long getmex(vector<long long>& v)
{
	long long mx = *max_element(v.begin(), v.end());
	vector<bool> used(mx + 2);
	for (long long i = 0; i < v.size(); i++)
	{
		used[v[i]] = true;
	}
	long long mex = 0;
	while (used[mex])
	{
		mex++;
	}
	return mex;
}

long long calc(vector<long long> v, long long prev, set<long long>& path)
{
	long long h = geth(v);
	if (dp.find(h) != dp.end())
	{
		return dp[h];
	}
	if (path.find(h) != path.end())
	{
		dp[h] = -1;
		return -1;
	}

	path.insert(h);
	long long m = getmex(v);
	m--;
	for (auto& i : v)
	{
		i ^= m;
	}

	long long to = geth(v);
	if (to == prev || to == h)
	{
		dp[h] = m + 1;
		return m + 1;
	}

	dp[h] = calc(v, h, path);
	return dp[h];
}

long long gen(long long i, long long prev, long long mx, long long p, vector<long long>& v)
{
	if (i == v.size())
	{
		vector<long long> st;
		set<long long> path;
		return (calc(v, -INF, path) == p);
	}

	long long sum = 0;
	for (long long val = prev + 1; val <= mx - (v.size() - i) + 1; val++)
	{
		v[i] = val;
		sum += gen(i + 1, val, mx, p, v);
		sum %= M;
	}
	return sum;
}

void solve()
{
	long long k, n, p;
	cin >> k >> n >> p;
	vector<long long> v(n);
	cout << gen(1, 0, (1ll << k) - 1, p, v) << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> M;

	precalc();

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*





















*/
