#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct segtree {
    int size = 1;
    vector<int> tree;

    int init(int n) {
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
        return size;
    }

    void set(int x, int lx, int rx, int i, int v) {
        if (rx - lx == 1) {
            tree[x]+=v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) set(2 * x + 1, lx, m, i, v);
        else set(2 * x + 2, m, rx, i, v);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int x, int lx, int rx, int l, int r) {
        if (lx >= r or rx <= l) return 0;
        if (l <= lx and r >= rx) return tree[x];
        int m = (lx + rx) / 2;
        return get(2 * x + 1, lx, m, l, r) + get(2 * x + 2, m, rx, l, r);
    }
};


int main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        if (n>30) {
            for (int i = 1; i<=n/2; i++) cout << i << " ";
            cout << "\n";
            continue;
        }
        vector<pair<pair<int, int>, int>> a(n);
        set<int> s;
        for (int i = 0; i < n; i++) {
            cin >> a[i].first.first >> a[i].first.second;
            s.insert(a[i].first.first);
            s.insert(a[i].first.second);
            a[i].second = i;
        }
        map<int, int> d;
        int j = 0;
        while (!s.empty()) {
            int x = *s.begin();
            s.erase(s.begin());
            d[x] = j;
            j++;
        }
        for (int i = 0; i < n; i++) {
            a[i].first.first = d[a[i].first.first];
            a[i].first.second = d[a[i].first.second];
        }
        int m = 0;
        sort(a.begin(), a.end());
        vector <int> dp(4*n);
        for (int j = 0; j<n; j++) {
            for (int tm = a[j].first.second + 1; tm<4*n; tm++) {
                dp[tm] = max(dp[tm], dp[a[j].first.first] + 1);
            }
        }
        m = dp[4*n-1];
        for (int mask = 0; mask<(1<<n); mask++) {
            vector <int> idx;
            for (int i = 0; i<n; i++) {
                if (mask & (1<<i)) idx.push_back(i);
            }
            if (idx.size() != n/2) continue;

            int c = 0;
            vector <int> dp(4*n);
            for (int j = 0; j<n/2; j++) {
                for (int tm = a[idx[j]].first.second + 1; tm<4*n; tm++) {
                    dp[tm] = max(dp[tm], dp[a[idx[j]].first.first] + 1);
                }
            }
            c = dp[4*n-1];
            if (c==m/2) {
                for (auto v : idx) cout << a[v].second + 1 << " ";
                cout << "\n";
                break;
            }
        }
    }
}
