#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;


int n, sz, m;
vector <int> l, r, h;
vector<pair<pii, int>> a;


bool cmp (pii i, pii j) {
    return i.second < j.second;
}

void clear () {
    l.clear(); r.clear(); a.clear(); h.clear();
}

void solve() {
    cin >> n;
    l.resize(n); r.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        h.emplace_back(l[i]);
        h.emplace_back(r[i]);
    }
    sort(all(h));
    h.erase(unique(all(h)), h.end());
    sz = h.size();
    vector<vector<pii>> R(sz);
    // dp.assign(sz, 0); ma.assign(sz, 0);
    for (int i = 0; i < n; ++i) {
        l[i] = lower_bound(all(h), l[i]) - h.begin();
        r[i] = lower_bound(all(h), r[i]) - h.begin();
        a.pb({{l[i], r[i]}, i});
        R[r[i]].pb({l[i], i});
    }
    vector <int> dp(n, 0), ma(sz, 0), bro(sz, 0), p(n, 0);
    for (int i = 0; i < sz; ++i) {
        if (i) {
            ma[i] = ma[i - 1];
            bro[i] = bro[i - 1];
        }
        for (auto seg : R[i]) {
            if (!seg.first) {
                dp[seg.second] = 1;
                p[seg.second] = -1;
            }
            else {
                dp[seg.second] = 1 + ma[seg.first - 1];
                p[seg.second] = bro[seg.first - 1];
            }
            if (dp[seg.second] > ma[i]) {
                ma[i] = dp[seg.second];
                bro[i] = seg.second;
            }
        }
    }
    m = ma[sz - 1];
    int s = 0, b = 0;
    for (int i = 0; i < n; ++i) {
        if (dp[i] > m / 2) {
            ++b;
        }
        else {
            ++s;
        }
    }
    vector <bool> take(n, false);
    if (s > b) {
        int curr = 0;
        for (int i = 0; i < n; ++i) {
            if (dp[i] <= m / 2) {
                ++curr;
                take[i] = true;
            }
        }
        set <int> must;
        for (int i = 0; i < n; ++i) {
            if (dp[i] == m / 2) {
                int I = i;
                while (true) {
                    if (I == -1) break;
                    must.insert(I);
                    I = p[I];
                }
                break;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (must.find(i) == must.end() && take[i] && curr > n / 2) {
                --curr;
                take[i] = false;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (take[i]) {
                cout << i + 1 << ' ';
            }
        }
        cout << endl;
    }
    else {
        int curr = 0;
        for (int i = 0; i < n; ++i) {
            if (dp[i] > m / 2) {
                ++curr;
                take[i] = true;
            }
        }
        set <int> must;
        for (int i = 0; i < n; ++i) {
            if (dp[i] == m) {
                int I = i;
                while (true) {
                    if (I == -1 || dp[I] <= m / 2) break;
                    must.insert(I);
                    I = p[I];
                }
                break;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (must.find(i) == must.end() && take[i] && curr > n / 2) {
                --curr;
                take[i] = false;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (take[i]) {
                cout << i + 1 << ' ';
            }
        }
        cout << endl;
    }
}


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}

