#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
#define int ll


int n, q, x, y, m;
vector<vector<int>> g;
vector <int> l, r, dp0, dp1;
vector <pll> ask;

void clear() {
    g.clear(); l.clear(); r.clear(); ask.clear();
    dp0.clear(); dp1.clear();
}


void dfs (int i, int p) {
    dp1[i] = l[i];
    for (auto j : g[i]) {
        if (p != j) {
            dfs(j, i);
            dp1[i] += dp0[j];
            dp0[i] += max(dp0[j], dp1[j]);
        }
    }
}


void solve() {
    cin >> n >> q >> x >> y >> m;
    g.resize(n); l.resize(n); r.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    ask.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> ask[i].first;
        ask[i].second = i;
    }
    dp0.resize(n); dp1.resize(n);
    dfs(0, -1);
    int eff = max(dp0[0], dp1[0]), sert = 0;
    for (int i = 0; i < n; ++i) {
        sert ^= ((x * i % m + y * l[i] % m * l[i] % m) % m);
    }
    for (auto i : ask) {
        if (i.first == eff) {
            cout << sert << ' ';
        }
        else {
            cout << -1 << ' ';
        }
    }
    cout << endl; cout.flush();
    int c;
    while (cin >> c) {
        if (!c) break;
        --c;
        if (ask[c].first != eff) {
            cout << -1 << endl; cout.flush();
        }
        else {
            for (int i = 0; i < n; ++i) {
                cout << l[i] << ' ';
            }
            cout << endl; cout.flush();
        }
    }
    clear();
}


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}