#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
#define int ll


const int N = 1e6 + 1;
int n, q, x, y, m, ASK[N];
vector<vector<int>> g;
vector <int> l, r, dp0, dp1, ans;
vector <bool> take;
vector <pll> ask;
vector<map<int, int>> jump0;

void clear() {
    g.clear(); l.clear(); r.clear(); ask.clear();
    dp0.clear(); dp1.clear(); take.clear();
    jump0.clear();
    ans.clear();
}


void dfs (int i, int p) {
    dp0[i] = 0;
    dp1[i] = r[i];
    for (auto j : g[i]) {
        if (p != j) {
            dfs(j, i);
            if (dp0[j] > dp1[j]) {
                dp0[i] += dp0[j];
                jump0[i][j] = 0;
            }
            else {
                dp0[i] += dp1[j];
                jump0[i][j] = 1;
            }
            dp1[i] += dp0[j];
        }
    }
}

void dfs1 (int i, int p, int state) {
    if (state) {
        if (r[i]) take[i] = true;
        for (auto j : g[i]) {
            if (j != p) {
                dfs1(j, i, 0);
            }
        }
    }
    else {
        take[i] = false;
        for (auto j : g[i]) {
            if (j != p) {
                dfs1(j, i, jump0[i][j]);
            }
        }
    }
}


void solve() {
    cin >> n >> q >> x >> y >> m;
    g.resize(n); l.resize(n); r.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    jump0.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    take.assign(n, false);
    ask.resize(q); ans.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> ask[i].first;
        ASK[i] = ask[i].first;
        ask[i].second = i;
    }
    dp0.resize(n); dp1.resize(n);
    dfs(0, -1);
    if (dp0[0] > dp1[0]) {
        dfs1(0, -1, 0);
    }
    else {
        dfs1(0, -1, 1);
    }
    int MAX = 0;
    vector <int> A;
    for (int i = 0; i < n; ++i) {
        if (take[i]) {
            A.emplace_back(i);
            MAX += r[i];
        }
    }
    sort(all(ask));
    int curr_have = 0, ind = 0, base = 0;
    for (int i = 0; i < n; ++i) {
        base ^= (x * (i + 1) % m);
    }
    for (auto i : ask) {
        if (i.first > MAX) {
            ans[i.second] = -1;
        }
        else {
            while (curr_have <= i.first) {
                if (curr_have + r[A[ind]] < i.first) {
                    curr_have += r[A[ind]];
                    base ^= (x * (A[ind] + 1) % m);
                    base ^= ((x * (A[ind] + 1) % m + y * r[A[ind]] % m * r[A[ind]] % m) % m);
                    ++ind;
                }
                else {
                    ans[i.second] = base ^ (x * (A[ind] + 1) % m) ^ ((x * (A[ind] + 1) % m + y * (i.first - curr_have) % m * (i.first - curr_have) % m) % m);
                    break;
                }
            }
        }
    }
    vout(ans); cout.flush();
    int c;
    while (cin >> c) {
        if (!c) break;
        --c;
        if (ans[c] == -1) {
            cout << -1 << endl; cout.flush(); continue;
        }
        vector <int> a(n, 0);
        curr_have = 0;
        for (auto i : A) {
            if (curr_have + r[i] < ASK[c]) {
                curr_have += r[i];
                a[i] = r[i];
            }
            else {
                a[i] = ASK[c] - curr_have;
                break;
            }
        }
        vout(a); cout.flush();
    }
    clear();
}


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}