#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
#define int ll


const int N = 1e6 + 1;
int n, q, x, y, m, L, R;
vector<vector<int>> g;
vector <int> l, r, dp0, dp1, ans;
vector <bool> take;
vector <pll> ask;
vector<map<int, int>> jump0;

void clear() {
    g.clear(); l.clear(); r.clear(); ask.clear();
    dp0.clear(); dp1.clear(); take.clear();
    jump0.clear();
    ans.clear();
}


void dfs1 (int i, int p) {
    dp0[i] = 0;
    dp1[i] = l[i];
    for (auto j : g[i]) {
        if (j != p) {
            dfs1(j, i);
            dp0[i] += max(dp0[j], dp1[j]);
            dp1[i] += dp0[j];
        }
    }
}

void dfs2 (int i, int p) {
    dp0[i] = 0;
    dp1[i] = r[i];
    for (auto j : g[i]) {
        if (j != p) {
            dfs2(j, i);
            dp0[i] += max(dp0[j], dp1[j]);
            dp1[i] += dp0[j];
        }
    }
}


void solve() {
    cin >> n >> q >> x >> y >> m;
    g.resize(n); l.resize(n); r.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dp0.resize(n); dp1.resize(n);
    dfs1(0, -1); L = max(dp0[0], dp1[0]);
    dfs2(0, -1); R = max(dp0[0], dp1[0]);
    // debug(L << ' ' << R);
    // return;
    while (q--) {
        int c;
        cin >> c;
        if (c >= L && c <= R) {
            cout << 0 << ' ';
        } else {
            cout << -1 << ' ';
        }
    }
    cout << endl; cout.flush();
    int c; cin >> c;
}


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}