#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
#define int ll


int n, q, x, y, m;
vector<vector<int>> g;
vector <int> l, r, dp0, dp1;
vector <bool> take;
vector <pll> ask;
vector<map<int, int>> jump0;

void clear() {
    g.clear(); l.clear(); r.clear(); ask.clear();
    dp0.clear(); dp1.clear(); take.clear();
    jump0.clear();
}


void dfs (int i, int p) {
    dp0[i] = 0;
    dp1[i] = r[i];
    for (auto j : g[i]) {
        if (p != j) {
            dfs(j, i);
            if (dp0[j] > dp1[j]) {
                dp0[i] += dp0[j];
                jump0[i][j] = 0;
            }
            else {
                dp0[i] += dp1[j];
                jump0[i][j] = 1;
            }
            dp1[i] += dp0[j];
        }
    }
}

void dfs1 (int i, int p, int state) {
    if (state) {
        take[i] = true;
        for (auto j : g[i]) {
            if (j != p) {
                dfs1(j, i, 0);
            }
        }
    }
    else {
        take[i] = false;
        for (auto j : g[i]) {
            if (j != p) {
                dfs1(j, i, jump0[i][j]);
            }
        }
    }
}


void solve() {
    cin >> n >> q >> x >> y >> m;
    g.resize(n); l.resize(n); r.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    jump0.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    take.assign(n, false);
    ask.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> ask[i].first;
        ask[i].second = i;
    }
    dp0.resize(n); dp1.resize(n);
    dfs(0, -1);
    if (dp0[0] > dp1[0]) {
        dfs1(0, -1, 0);
    }
    else {
        dfs1(0, -1, 1);
    }
    vector <int> A;
    for (int i = 0; i < n; ++i) {
        if (take[i]) {
            A.emplace_back(i);
        }
    }
    if (A.size() != max(dp0[0], dp1[0])) exit(1);
    vector <int> pref(A.size() + 1, 0);
    int curr = 0;
    for (int i = 0; i < n; ++i) {
        curr ^= ((x * (i + 1)) % m);
    }
    pref[0] = curr;
    for (int i = 0; i < A.size(); ++i) {
        curr ^= ((x * (A[i] + 1)) % m);
        curr ^= ((x * (A[i] + 1) % m + y) % m);
        pref[i + 1] = curr;
    }
    for (auto i : ask) {
        if (i.first <= A.size()) {
            cout << pref[i.first] << ' ';
        }
        else {
            cout << -1 << ' ';
        }
    }
    cout << endl; cout.flush();
    int c;
    while (cin >> c) {
        if (!c) break;
        --c;
        if (ask[c].first > A.size()) {
            cout << -1 << endl; cout.flush();
            continue;
        }
        vector <bool> res(n, false);
        for (int i = 0; i < ask[c].first; ++i) {
            res[A[i]] = true;
        }
        for (int i = 0; i < n; ++i) {
            cout << res[i] << ' ';
        }
        cout << endl; cout.flush();
    }
    clear();
}


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}