#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int INF = 0x3f3f3f3f;

struct seg {
    int i, l, r;
};

int max_cnt(vector<seg> b) {
    sort(b.begin(), b.end(), [&](const auto &x, const auto &y) {
        return x.r < y.r;
    });

    int prev = -1, ans = 0;
    for (auto s : b) {
        if (s.l > prev) {
            prev = s.r;
            ans++;
        }
    }

    return ans;
}

void solve() {
    int n;
    cin >> n;

    vector<seg> a(n);
    vector<int> order;

    for (int i = 0; i < n; ++i) {
        a[i].i = i;
        cin >> a[i].l >> a[i].r;
        order.push_back(a[i].l);
        order.push_back(a[i].r);
    }

    order.push_back(-1);
    sort(order.begin(), order.end());
    order.resize(unique(order.begin(), order.end()) - order.begin());
    int k = (int) order.size();

    for (int i = 0; i < n; ++i) {
        a[i].l = (int) (lower_bound(order.begin(), order.end(), a[i].l) - order.begin());
        a[i].r = (int) (lower_bound(order.begin(), order.end(), a[i].r) - order.begin());
    }
    sort(a.begin(), a.end(), [&](const auto &x, const auto &y) {
        return x.r < y.r;
    });

    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(k, -INF)));
    vector<vector<vector<pair<int, int>>>> p(n + 1, vector<vector<pair<int, int>>>(n + 1, vector<pair<int, int>>(k, {-1, -1})));
    dp[0][0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int r = 0; r < k; ++r) {
                dp[i + 1][j][r] = dp[i][j][r];
                p[i + 1][j][r] = p[i][j][r];
            }
        }
        for (int j = 0; j <= i; ++j) {
            for (int r = 0; r < a[i].l; ++r) {
                if (dp[i][j][r] + 1 > dp[i + 1][j + 1][a[i].r]) {
                    dp[i + 1][j + 1][a[i].r] = dp[i + 1][j][r] + 1;
                    p[i + 1][j + 1][a[i].r] = {a[i].i, r};
                }
            }
            for (int r = a[i].l; r < k; ++r) {
                if (dp[i][j][r] > dp[i + 1][j + 1][r]) {
                    dp[i + 1][j + 1][r] = dp[i][j][r];
                    p[i + 1][j + 1][r] = {a[i].i, r};
                }
            }
        }
    }

    int m = *max_element(dp[n][n].begin(), dp[n][n].end());
    int br = -1;
    for (int r = 0; r < k; ++r) {
        if (dp[n][n / 2][r] == m / 2) {
            br = r;
            break;
        }
    }
    assert(br != -1);

    vector<int> ans;

    for (int i = n / 2, j = n; i > 0; --i, --j) {
        ans.push_back(p[j][i][br].first);
        br = p[j][i][br].second;
    }

    for (int x : ans) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
